/**
 * 统计（极光统计相关接口）
 */
var g_analytics = g_analytics || {

	/**
	 * 接口测试函数,测试接口能不能使用
	 */
	test: function() {
		return window.plus.bridge.execSync('pluginFRJanalytics', "test", []);
	},
	/**
	 * 统计的初始化。
	 */
	init: function() {
		window.plus.bridge.execSync('pluginFRJanalytics', "init", []);
	},
	/**
	 * 记录进入页面
	 * @param {String} pageName 别名 一般是userId
	 * @param {function} success function(result) 返回成功函数 result = object {code,tip} code=0一般是正常 其他相关内容请参看极光
	 * @param {function} fail function(result)
	 */
	startLogPageView: function(pageName, success, fail) {
		callbackID = window.plus.bridge.callbackId(success, fail);
		window.plus.bridge.exec('pluginFRJanalytics', "startLogPageView ", [callbackID,pageName]);
	},
	/**
	 * 记录退出页面
	 * @param {String} pageName 别名 一般是userId
	 * @param {function} success function(result) 返回成功函数 result = object {code,tip} code=0一般是正常 其他相关内容请参看极光
	 * @param {function} fail function(result)
	 */
	endLogPageView: function(pageName, success, fail) {
		callbackID = window.plus.bridge.callbackId(success, fail);
		window.plus.bridge.exec('pluginFRJanalytics', "endLogPageView ", [callbackID,pageName]);
	},
	/**
	 * 记录登录用户
	 * @param {String} loginMethod 登录方式：huohuo、qq、sina 等等
	 * @param {function} success function(result) 返回成功函数 result = object {code,tip} code=0一般是正常 其他相关内容请参看极光
	 * @param {function} fail function(result)
	 */
	logLoginEvent: function(loginMethod, success, fail) {
		callbackID = window.plus.bridge.callbackId(success, fail);
		window.plus.bridge.exec('pluginFRJanalytics', "logLoginEvent", [callbackID, loginMethod]);

	},
	/**
	 * 记录注册新用户
	 * @param {String} registerMethod 注册方式：huohuo、qq、sina 等等
	 * @param {function} success function(result) 返回成功函数 result = object {code,tip} code=0一般是正常 其他相关内容请参看极光
	 * @param {function} fail function(result)
	 */
	logRegisterEvent: function(registerMethod, success, fail) {
		callbackID = window.plus.bridge.callbackId(success, fail);
		window.plus.bridge.exec('pluginFRJanalytics', "logRegisterEvent", [callbackID, registerMethod]);

	},
	/**
	 * 记录数值修改
	 * @param {String} eventName 事件名称
	 * @param {String} keyStr 关键字
	 * @param {String} value 值
	 * @param {function} success function(result) 返回成功函数 result = object {code,tip} code=0一般是正常 其他相关内容请参看极光
	 * @param {function} fail function(result)
	 */
	logCountEvent: function(eventName, keyStr ,value , success, fail) {
		window.plus.bridge.execSync('pluginFRJanalytics', "logCountEvent", [callbackID, eventName, keyStr,value]);
	},

}