/*
 * huohuo.js为项目全局js，负责初始化引入系统常用js库
 */

//最先加载全局配置js

function getHomePath(){
	var pathName = window.document.location.pathname;

	if(pathName.indexOf('/www/') != -1) {
		return pathName.substring(0, pathName.substr(1).indexOf('/www/') + 5);
	} else {
		return pathName.substring(0, pathName.substr(1).indexOf('/') + 1);
	}
}

/**
 * 工程名
 */
var g_homePath = g_homePath || getHomePath();

//console.log(g_homePath);

//依次加载全局js文件,注意依赖关爱，加载顺序不能乱
document.write(
	'<script src="' + g_homePath + '/global/js/config.js"><\/script>'
+'<script src="' + g_homePath + '/global/js/event.js"><\/script>'
+'<script src="' + g_homePath + '/global/js/utils.js"><\/script>'
+'<script src="' + g_homePath + '/global/lib/date.js"><\/script>'
+'<script src="' + g_homePath + '/global/js/printTools.js"><\/script>'
+'<script src="' + g_homePath + '/global/js/module.js"><\/script>'
+'<script src="' + g_homePath + '/global/js/muiTools.js"><\/script>'
+'<script src="' + g_homePath + '/global/lib/myStorage.js"><\/script>'
+'<script src="' + g_homePath + '/global/js/storage.js"><\/script>'
+'<script src="' + g_homePath + '/global/js/plusInit.js"><\/script>'
);

/**
 * 系统默认初始化代码 
 */
function g_huohuoPlusReady() {
	//	g_statusbarBgInit();  //暂时取消掉自动更换状态栏背景
	//	g_headImgChangeInit();  //暂时取消掉自动更换头像
	//禁用滚动条
	//隐藏掉滚动条
	var currentWebview=plus.webview.currentWebview();
	currentWebview.setStyle({
		scrollIndicator: 'none'
	});
	//“adjustResize”- 自动调整Webview窗口大小（屏幕区域减去软键盘区域），同时自动滚动Webview保证输入框可见
//	currentWebview.setStyle({
//		softinputMode: "adjustResize"
//	});
				
}

/**
 * 监听头像更新 
 */
var g_LOGIN_USER='loginUser';  //登录用户标识
function g_headImgChangeInit(){
	document.addEventListener(g_event.HEAD_IMG_UPDATE, function(event) {
		var imgArr = document.getElementsByTagName('img');
		if(imgArr.length!=0){
			for(var i = 0; i < imgArr.length; i++) {
				var img=imgArr[i];
				if(img.classList.contains(g_LOGIN_USER)){
					img.style.backgroundImage='url(' + event.detail.newPath + ')';
				}
			}
		}
	});
}

/**
 * 初始化状态栏背景
 */
function g_statusbarBgInit() {
	var header = document.getElementsByTagName('header');
	if(header.length != 0) {
		var classArr = header[0].className.split(' ');
		if(classArr != 0) {
			for(var i = 0; i < classArr.length; i++) {
				if(classArr[i].indexOf('headerbg') != -1) {
					g_setStatusbarBg(classArr[i]);
					break;
				}
			}
		}
	}
}

/**
 * 修改状态栏的背景图片，以实现沉浸式状态（会调用系统的方法）
 * @param {Object} dom 顶部栏header的dom对象
 * @param {Object} bgFlag 背景图标识，例如：header-bg0
 */
function g_setStatusbarBg(bgName) {
	if(g_config.DEV_PLATFORM == g_config.H5) { //因为要调用系统的方法，在HBuilder上开发时，不执行
		//		console.log('g_setStatusbarBg bgName:'+bgName);
	} else {
		if(plus.os.name == g_config.ANDROID) { //Android平台
			plus.android.runtimeMainActivity().setWindowBackground(bgName);
		}
		if(plus.os.name == g_config.IOS) { //IOS平台
			 var notiClass = plus.ios.importClass("NSNotificationCenter");
            notiClass.defaultCenter().postNotificationNameobject("ChangeStatusBar",bgName);
		}
	}
}

//dom元素初始化
function domInit() {
	//解决maxlength在input的type=number失效的问题
	var inputArr = document.getElementsByTagName('input');
	if(inputArr) {
		for(var i = 0; i < inputArr.length; i++) {
			var inputObj=inputArr[i];
			var maxlength = inputObj.getAttribute('maxlength');
			if(maxlength) {
				inputObj.addEventListener("input",function(e){
					var tempMaxlength=this.getAttribute('maxlength');
					if(this.value.length > tempMaxlength) {
						this.value = this.value.substr(0, tempMaxlength);
					}
				});
			}
		}
	}
}
domInit();

var g_fire={
	'updateAllMission':function(param){  //myMission.js
		mui.fire(plus.webview.getWebviewById(g_module.myCareList.ID + ':myMission.html'), 'updateAllMission', param);
        
        if (!g_utils.isEmpty(plus.webview.getWebviewById(g_module.myCareList.ID +':mission/pm_003/pm_003_card.html'))){
            mui.fire(plus.webview.getWebviewById(g_module.myCareList.ID +':mission/pm_003/pm_003_card.html'), 'reGetData', param);
        }
        
        if (!g_utils.isEmpty(plus.webview.getWebviewById(g_module.myCareList.ID +':mission/pm_011/pm_011_card.html'))){
            mui.fire(plus.webview.getWebviewById(g_module.myCareList.ID +':mission/pm_011/pm_011_card.html'), 'reGetData', param);
        }
		
//        window.plus.bridge.execSync('FRLog', "logString", ['updateAllMission']);
//        //获取积分，调用接口healthPoints/checkPointsBills
//        if (!g_utils.isEmpty(param)){
//            if (!g_utils.isEmpty(param.missionIdArr)){
//                g_tools.postCMD('healthPoints/checkPointsBills', {
//                    missionIdArr: param.missionIdArr,
//                    timeInterval: 10000
//                },function(res) {
//                    if(res.code==0){
//                        var missisonArray = res.data;
//                        var amount = 0;
//                        for (var i=0; i<missisonArray.length; i++){
//                            if (missisonArray[i].outIn == 1){
//                                amount += missisonArray[i].amount;
//                            }
//                        }
//                        if (amount != 0){
//                            //提示获得积分
//                            if  (g_config.DEV_PLATFORM == g_config.IOS)
//                            {
//                                //window.plus.bridge.execSync('FRLog', "logString", ['提示获得积分:'+ amount + '分']);
//                                window.plus.bridge.execSync('FRToast', "showToast", ['获得健康积分+'+ amount + '分']);
//                            }else if(g_config.DEV_PLATFORM == g_config.ANDROID)
//                            {
//
//                            }
//                        }
//                        }else{
//                            g_mui.alert(res.tip);
//                        }
//                });
//            }
//            else if (!g_utils.isEmpty(param.codeArr)){
//                g_tools.postCMD('healthPoints/checkPointsBills', {
//                    codeArr: param.codeArr,
//                    timeInterval: 1000
//                },function(res) {
//                    if(res.code==0){
//                        var missisonArray = res.data;
//                        var amount = 0;
//                        for (var i=0; i<missisonArray.length; i++){
//                            if (missisonArray[i].outIn == 1){
//                                amount += missisonArray[i].amount;
//                            }
//                        }
//                        if (amount != 0){
//                            //提示获得积分
//                            if  (g_config.DEV_PLATFORM == g_config.IOS)
//                            {
//                            //window.plus.bridge.execSync('FRLog', "logString", ['提示获得积分:'+ amount + '分']);
//                                window.plus.bridge.execSync('FRToast', "showToast", ['获得健康积分+'+ amount + '分']);
//                            }else if(g_config.DEV_PLATFORM == g_config.ANDROID)
//                            {
//
//                            }
//                        }
//                    }else{
//                        g_mui.alert(res.tip);
//                    }
//                });
//            }
//        }
		
	},
    'showToast':function(param){
        
        if (!g_utils.isEmpty(param)){
            if (!g_utils.isEmpty(param.missionIdArr)){
                mui.fire(plus.webview.getWebviewById(g_module.index.ID), "showToast", {
                    missionIdArr: param.missionIdArr
                })
            }else if (!g_utils.isEmpty(param.codeArr)){
                mui.fire(plus.webview.getWebviewById(g_module.index.ID), "showToast", {
                    codeArr: param.codeArr
                })
            }
        }
        
        
    }
}
