/**
 * h5调用百度模块定位
 */
var watchId = null;
var g_Location = g_Location || {
	/**
	 * 监听设备位置变化信息(plusready完成后调用)
	 * callBack 回调函数  result.code: 0：成功  -1：失败
	 * result.tip:回调提示
	 * result.time:获取成功毫秒时间
	 * result.longitude:经度
	 * result.latitude:纬度
	 * result.other:json格式的字符串 {"radius":double 定位精度}
	 * result.address:地址
	 */
	watchPositionInfo: function(callBack) {
		var result = {};
		watchId = plus.geolocation.watchPosition(function(res) {
			var accuracy = res.coords.accuracy;
			if(accuracy > 160 || accuracy == 0) {
				result['code'] = -1;
				result['tip'] = "定位精度过大";
			} else {
				result['code'] = 0;
				result['tip'] = "获取成功";
				result['time'] = new Date().getTime();
				result['longitude'] = res.coords.longitude;
				result['latitude'] = res.coords.latitude;
				result['other'] = '{"radius":' + accuracy + '}';
				result['address'] = res.addresses;
				callBack(result);
			}
		}, function(err) {
			result['code'] = -1;
			result['tip'] = 'Gelocation Error: code - ' + err.code + '; message - ' + err.message;
			callBack(result);
		}, {
			enableHighAccuracy: true,
			provider: 'baidu',
			coordsType: 'bd09ll',
			maximumAge: 5000, //5秒
			timeout: 5000 //定位超时时间5秒
		});

	},
	/**
	 * 获取当前的定位信息(plusready完成后调用)
	 * callBack 回调函数  result.code: 0：成功  -1：失败
	 * result.tip:回调提示
	 * result.time:获取成功毫秒时间
	 * result.longitude:经度
	 * result.latitude:纬度
	 * result.other:json格式的字符串 {"radius":double 定位精度}
	 * result.address:地址
	 */
	getCurrLocationInfo: function(callBack) {
		var result = {};
		plus.geolocation.getCurrentPosition(function(res) {
			var accuracy = res.coords.accuracy;
			if(accuracy > 160 || accuracy == 0) {
				result['code'] = -1;
				result['tip'] = "定位精度过大";
			} else {
				result['code'] = 0;
				result['tip'] = "获取成功";
				result['time'] = new Date().getTime();
				result['longitude'] = res.coords.longitude;
				result['latitude'] = res.coords.latitude;
				result['other'] = '{"radius":' + accuracy + '}';
				result['address'] = res.addresses;
				callBack(result);
			}
		}, function(err) {
			result['code'] = -1;
			result['tip'] = 'Gelocation Error: code - ' + err.code + '; message - ' + err.message;
			callBack(result);
		}, {
			enableHighAccuracy: true,
			provider: 'baidu',
			coordsType: 'bd09ll',
			maximumAge: 5000, //5秒
			timeout: 5000 //定位超时时间5秒
		})
	},
	clearWatchPostion: function() {
		if(watchId != null) {
			plus.geolocation.clearWatch(watchId);
			watchId = null;
		}
	}
}