/**
 * 转化模块的path为url
 * @param {Object} path
 */
function g_formatPathToUrl(path){
    if  (g_config.DEV_PLATFORM == g_config.IOS){
        return '_www/'+path;
    }else{
       return plus.io.convertAbsoluteFileSystem(plus.io.convertLocalFileSystemURL('_www')+path);
    }
}

/**
 * 模块集，不能单独使用，需要引用config.js
 */
var g_module = g_module || {
	/**
	 * 获取首页子模块集
	 */
	getIndexSubPages: function(){
		return [g_module.myCareList,g_module.health,g_module.friendCircle,g_module.message,g_module.mine];	
	},
		
	index: {
		TITLE: '首页',
		ID: 'index',
		REFRESH_ID: 'index',
		PATH: 'moduleLocal/index/index.html',
		getUrl:function(){
			 return g_formatPathToUrl(this.PATH);
		}
	},
	forgetPassword: {
		TITLE: '忘记密码',
		ID: 'forgetPassword',
		REFRESH_ID: 'forgetPassword',
		PATH: 'moduleLocal/forgetPassword/forgetPassword1.html',
		getUrl:function(){
			return g_formatPathToUrl(this.PATH);
		}
	},
	login: {
		TITLE: '登录',
		ID: 'login',
		REFRESH_ID: 'login',
		PATH: 'moduleLocal/login/login.html',
		getUrl:function(){
			return g_formatPathToUrl(this.PATH);
		}
	},
	myCareList: {
		TITLE: '我的关爱人列表',
		ID: 'myCareList',
		REFRESH_ID: 'myCareList',
		PATH: 'moduleLocal/myCareList/myCareList.html',
		getUrl:function(){
			return g_formatPathToUrl(this.PATH);
		}
	},
	register: {
		TITLE: '注册',
		ID: 'register',
		REFRESH_ID: 'register',
		PATH: 'moduleLocal/register/register1.html',
		getUrl:function(){
			return g_formatPathToUrl(this.PATH);
		}
	},
	servicesPackageList: {
		TITLE: '服务包列表',
		ID: 'servicesPackageList',
		REFRESH_ID: 'servicesPackageList',
		PATH: 'moduleLocal/servicesPackageList/servicesPackageList.html',
		getUrl:function(){
			return g_formatPathToUrl(this.PATH);
		}
	}, 
	welcome: {
		TITLE: '引导页面',
		ID: 'welcome',
		REFRESH_ID: 'welcome',
		PATH: 'moduleLocal/welcome/welcome.html',
		getUrl:function(){
			return g_formatPathToUrl(this.PATH);
		}
	},
	mine: {
		TITLE: '我',
		ID: 'mine',
		REFRESH_ID: 'mine',
		PATH: 'moduleLocal/mine/mine.html',
		getUrl: function(){
			return g_formatPathToUrl(this.PATH);
		}
	},
	insertMyCare: {
		TITLE: '关爱家人',
		ID: 'insertMyCare',
		REFRESH_ID: 'insertMyCare',
		PATH: 'moduleLocal/insertMyCare/insertMyCare.html',
		getUrl: function(){
			return g_formatPathToUrl(this.PATH);
		}
	},
	insertMyCareGuide: {
		TITLE: '添加关爱',
		ID: 'insertMyCareGuide',
		REFRESH_ID: 'insertMyCareGuide',
		PATH: 'moduleLocal/insertMyCareGuide/insertMyCareGuide.html',
		getUrl: function(){
			return g_formatPathToUrl(this.PATH);
		}
	},
	certification: {
		TITLE: '实名认证',
		ID: 'certification',
		REFRESH_ID: 'certification',
		PATH: 'moduleLocal/certification/inputDevNumber.html',
		getUrl: function(){
			return g_formatPathToUrl(this.PATH);
		}
	},
	improvePersonalData:{
		TITLE: '完善个人资料',
		ID: 'improvePersonalData',
		REFRESH_ID: 'improvePersonalData',
		PATH: 'moduleLocal/improvePersonalData/improveBaseInfo.html',
		getUrl: function(){
			return g_formatPathToUrl(this.PATH);
		}
	},
	helpRegister:{
		TITLE: '帮助他人注册APP账号',
		ID: 'helpRegister',
		REFRESH_ID: 'helpRegister',
		PATH: 'moduleLocal/helpRegister/selectAccount.html',
		getUrl: function(){
			return g_formatPathToUrl(this.PATH);
		}
	},
	message: {
		TITLE: '消息',
		ID: 'message',
		REFRESH_ID: 'message:messageList.html',
		PATH: 'moduleLocal/message/message.html',
		getUrl: function(){
			return g_formatPathToUrl(this.PATH);
		}
	},
	healthRecords: {
		TITLE: '健康档案',
		ID: 'healthRecords',
		REFRESH_ID: 'healthRecords',
		PATH: 'moduleLocal/healthRecords/healthRecords.html',
		getUrl: function(){
			return g_formatPathToUrl(this.PATH);
		}
	},
	healthReport: {
		TITLE: '健康报告',
		ID: 'healthReport',
		REFRESH_ID: 'healthReport',
		PATH: 'moduleLocal/healthReport/healthReport.html',
		getUrl: function(){
			return g_formatPathToUrl(this.PATH);
		}
	},
	implementationRecord: {
		TITLE: '实施记录',
		ID: 'implementationRecord',
		REFRESH_ID: 'implementationRecord',
		PATH: 'moduleLocal/implementationRecord/implementationRecord.html',
		getUrl: function(){
			return g_formatPathToUrl(this.PATH);
		}
	},
	myHuoHuo: {
		TITLE: '我的伙伙',
		ID: 'myHuoHuo',
		REFRESH_ID: 'myHuoHuo',
		PATH: 'moduleLocal/myHuoHuo/myHuoHuo.html',
		getUrl: function(){
			return g_formatPathToUrl(this.PATH);
		}
	},
	careMe: {
		TITLE: '关爱我的人',
		ID: 'careMe',
		REFRESH_ID: 'careMe',
		PATH: 'moduleLocal/careMe/careMe.html',
		getUrl: function(){
			return g_formatPathToUrl(this.PATH);
		}
	},
	setting: {
		TITLE: '设置',
		ID: 'setting',
		REFRESH_ID: 'setting',
		PATH: 'moduleLocal/setting/setting.html',
		getUrl: function(){
			return g_formatPathToUrl(this.PATH);
		}
	},
	myCareState:{
		TITLE:'关爱人状态',
		ID:'myCareState',
		REFRESH_ID: 'myCareState',
		PATH:'moduleLocal/myCareState/myCareState.html',
		getUrl:function(){
			return g_formatPathToUrl(this.PATH);
		}
	},
    friendCircle:{
        TITLE:'圈子',
        ID:'friendCircle',
        REFRESH_ID: 'friendCircle:friendSubList.html',
        PATH:'moduleLocal/friendCircle/friendCircle.html',
        getUrl:function(){
            return g_formatPathToUrl(this.PATH);
        }
    },
    insertMyHealthCard:{
        TITLE:'添加我的健康卡片',
        ID:'insertMyHealthCard',
        REFRESH_ID: 'insertMyHealthCard',
        PATH:'moduleLocal/insertMyHealthCard/insertMyHealthCard.html',
        getUrl:function(){
            return g_formatPathToUrl(this.PATH);
        }
    },
    /*insertMyHealthCard2:{
        TITLE:'添加我的健康卡片2',
        ID:'insertMyHealthCardStep2',
        PATH:'moduleLocal/insertMyHealthCard/inputBaseInfo.html',
        getUrl:function(){
            return g_formatPathToUrl(this.PATH);
        }
    },*/
    healthManage:{
        TITLE:'健康管理',
        ID:'healthManage',
        REFRESH_ID: 'healthManage',
        PATH:'moduleLocal/healthManage/healthManage.html',
        getUrl:function(){
            return g_formatPathToUrl(this.PATH);
        }
    },
    addHealthData:{
    	TITLE:'添加记录',
        ID:'addHealthData',
        REFRESH_ID: 'addHealthData',
        PATH:'moduleLocal/addHealthData/addHealthData.html',
        getUrl:function(){
            return g_formatPathToUrl(this.PATH);
        }
    },
    healthReward:{
    	TITLE:'健康奖励',
        ID:'healthReward',
        REFRESH_ID: 'healthReward',
        PATH:'moduleLocal/healthReward/healthReward.html',
        getUrl:function(){
            return g_formatPathToUrl(this.PATH);
        }
	},
	healthGroup: {
		TITLE: '健康团队',
		ID: 'healthGroup',
		REFRESH_ID: 'healthGroup',
		PATH: 'moduleLocal/healthGroup/healthGroup.html',
		getUrl: function() {
			return g_formatPathToUrl(this.PATH);
		}

	},
	executiveOverview: {
		TITLE: '执行概览',
		ID: 'executiveOverview',
		REFRESH_ID: 'executiveOverview',
		PATH: 'moduleLocal/executiveOverview/executiveOverview.html',
		getUrl: function() {
			return g_formatPathToUrl(this.PATH);
		}
	},
	 health:{
    	TITLE:'健康',
        ID:'health',
        REFRESH_ID: 'health:healthSubList.html',
        PATH:'moduleLocal/health/health.html',
        getUrl:function(){
            return g_formatPathToUrl(this.PATH);
        }

    },
    healthyValuation:{
    	TITLE:'健康评估',
        ID:'healthyValuation',
        REFRESH_ID: 'healthyValuation',
        PATH:'moduleLocal/healthyValuation/healthyValuation.html',
        getUrl:function(){
            return g_formatPathToUrl(this.PATH);
        }
    },
	healthPlan: {
		TITLE: '健康团队',
		ID: 'healthPlan',
		REFRESH_ID: 'healthPlan',
		PATH: 'moduleLocal/healthPlan/healthPlan.html',
		getUrl: function() {
			return g_formatPathToUrl(this.PATH);
		}
	},
	healthPoints:{
    	TITLE:'健康积分',
        ID:'healthPoints',
        REFRESH_ID: 'healthPoints',
        PATH:'moduleLocal/healthPoints/healthGoods.html',
        getUrl:function(){
            return g_formatPathToUrl(this.PATH);
		}
   	},
}
