/**
 * 对mui常用方法进行封装
 */
var g_toast = g_toast || {
	toastObject: null,
	oldMessage: null,
	oldTime: 0,
	toast: function(str) {
		if(str == '' || str == null || str == undefined) {
			return
		}
		if(plus.os.name == g_config.ANDROID) {
			if(g_toast.toastObject == null) {				
				var toastClass = plus.android.importClass("android.widget.Toast");
				g_toast.toastObject = new toastClass.makeText(plus.android.runtimeMainActivity(), null, toastClass.LENGTH_LONG);
				g_toast.oldTime = new Date().getTime();
			}
			if(str == g_toast.oldMessage) {			
				var newTime = new Date().getTime();
				if(newTime - g_toast.oldTime > 3500) {
					g_toast.oldTime = newTime;
					g_toast.toastObject.show();
				}
			} else {
				g_toast.oldMessage = str;
				g_toast.toastObject.setText(str);
				g_toast.toastObject.show();
			}
		} else {
			mui.toast(str, 2000);
		}
	}
}

var g_mui = g_mui || {
	openWindow: function(param){
		var w=mui.openWindow(param);
		//解决rem错误的问题
		w.evalJS('document.documentElement.style.fontSize = ('+g_storage.get(g_storage.DEVICE_CLIENT_WIDTH)+' / 3.75) + "px";');
		return w;
	},
	createWebview: function(url, id, styles, extras){
		var w=plus.webview.create(url, id, styles, extras);
		//解决rem错误的问题
		w.evalJS('document.documentElement.style.fontSize = ('+g_storage.get(g_storage.DEVICE_CLIENT_WIDTH)+' / 3.75) + "px";');
		return w;
	},
	/**
	 * 进入一个模块
	 * @param {Object} module
	 * @param {Object} extras
	 * @param {string} aniShow
	 */
	openModule: function(module, extras, aniShow) {
		if(aniShow == null || aniShow == undefined) aniShow = 'slide-in-right';
		if(extras == null || extras == undefined) extras = {};

		var w=g_mui.openWindow({
			url: module.getUrl(),
			id: module.ID,
			show: {
				autoShow: true, //页面loaded事件发生后自动显示，默认为true
				aniShow: aniShow,
				duration: 300
			},
			extras: extras,
			waiting: {
				autoShow: false, //自动显示等待框，默认为true
			},
			styles: {
				render: 'always',
				scrollIndicator: 'none'
			}
		});
		if(extras.callbackJS!=null&&extras.callbackJS!=''){ //执行回调的js函数
			setTimeout(function(){
				w.evalJS(extras.callbackJS);				
			},300);
		}
		return w;
	},
	/**
	 * 预加载一个模块
	 * @param {Object} arr
	 */
	preloadModule: function(arr) {
		if(arr != null) {
			var preloadPages = new Array();
			for(var i = 0; i < arr.length; i++) {
				var module = arr[i];
				var w=plus.webview.create(module.getUrl(), module.ID);
				w.evalJS('document.documentElement.style.fontSize = ('+g_storage.get(g_storage.DEVICE_CLIENT_WIDTH)+' / 3.75) + "px";');
			}
		}
	},
	/**
	 * 关闭一个模块
	 * @param {Object} module
	 * @param {Object} extras 附加参数
	 */
	closeModule: function(module, extras) {
		//关闭模块相关的所有webview
		var array = plus.webview.all();
		if(array){
			for(var i=0,len=array.length;i<len;i++){
			  	var id=array[i].id;
			  	if(id.indexOf(module.ID)==0){
			  		if(extras&&extras.aniClose){
			  			array[i].close(extras.aniClose);
			  		}else{
						array[i].close('none');
			  		}
			  	}
		    }
		}
	},
	/**
	 * 在模块中打开一个页面
	 * @param {Object} url
	 * @param {Object} extras
	 * @param {Object} aniShow
	 */
	openPage: function(module,url, extras, aniShow) {
		if(aniShow == null || aniShow == undefined) aniShow = 'slide-in-right';
		if(extras == null || extras == undefined) extras = {};
		var w=g_mui.openWindow({
			url: url,
			id: module.ID+':'+url,
			show: {
				autoShow: true, //页面loaded事件发生后自动显示，默认为true
				aniShow: aniShow, //页面显示动画，默认为“pop-in”；
				duration: 300
			},
			extras: extras,
			waiting: {
				autoShow: false, //自动显示等待框，默认为true
			},
			styles: {
				render: 'always',
				scrollIndicator: 'none'
			}
		});
		if(extras.callbackJS!=null&&extras.callbackJS!=''){ //执行回调的js函数
			setTimeout(function(){
				w.evalJS(extras.callbackJS);				
			},300);
		}
		return w;
	},
	/**
	 * 关闭模块内的页面
	 * @param {String} pageId
	 * @param {Object} extras 附加参数
	 */
	closePage: function(pageId,extras){
		var webview=plus.webview.getWebviewById(pageId);
		if(webview){
			if(extras&&extras.aniClose){
	  			webview.close(extras.aniClose);
	  		}else{
				webview.close('none');
	  		}
		}
	},
	/**
	 * 获取模块
	 * @param {Object} module
	 */
	getModule: function(module) {
		return plus.webview.getWebviewById(module.ID);
	},
	/**
	 * 警告框
	 * @param {String} message 提示对话框上显示的内容，例如：'您的登录账号或密码错误！'
	 * @param {String} title 提示对话框上显示的标题，例如：'提示'
	 * @param {String} btnValue 提示对话框上按钮显示的内容，例如：'确定'
	 * @param {Function} callback 提示对话框上关闭后的回调函数，例如：function(){}
	 * @param {String} type 可选，是否使用h5绘制的对话框，例如：'div'，该值为默认值
	 */
	alert: function(message, title, btnValue, callback, type) {
		if(g_utils.isEmpty(message)&&g_utils.isEmpty(title)) return; //若没有任何提示内容，则不提示
		if(g_utils.isEmpty(message)) message=' ';
		if(g_utils.isEmpty(title)) title='温馨提示';
		if(g_utils.isEmpty(btnValue)) btnValue='确定';
		
		if(g_utils.isEmpty(type)){
			mui.alert(message, title, btnValue, callback);			
		}else{
			mui.alert(message, title, btnValue, callback,type);
		}
	},
	/**
	 *确认框
	 * @param {String} message 提示对话框上显示的内容，例如：'确定删除关爱人吗？'
	 * @param {String} title 提示对话框上显示的标题，例如：'确定删除'
	 * @param {Array} btnValue 提示对话框上按钮显示的内容，例如：['否','是']
	 * @param {Function} callback 提示对话框上关闭后的回调函数，例如：function(e){if(e.index == 1){}else{}}
	 * @param {String} type 可选，是否使用h5绘制的对话框，例如：'div'，该值为默认值
	 */
	confirm: function(message, title, btnValue, callback, type) {
		if(g_utils.isEmpty(message)&&g_utils.isEmpty(title)) return; //若没有任何提示内容，则不提示
		if(g_utils.isEmpty(message)) message=' ';
		if(g_utils.isEmpty(title)) title='请选择';
        if(title == 'nil') title='';
		if(g_utils.isEmpty(btnValue)) btnValue=['否','是'];
		
		if(g_utils.isEmpty(type)) {
			mui.confirm(message, title, btnValue, callback);
		}else{
			mui.confirm(message, title, btnValue, callback, type);
		}
	},
	/**
	 * 弹框输入
	 * @param {String} message 提示对话框上显示的内容，例如：'这里是显示的内容'
	 * @param {String} placeholder 编辑框显示的提示文字，例如：'请输入内容'
	 * @param {String} title 提示对话框上显示的标题，例如：'这里是标题'
	 * @param {Array} btnValue 提示对话框上按钮显示的内容，例如：['取消','确定']
	 * @param {Function} callback 提示对话框上关闭后的回调函数，例如：function(e){if(e.index == 1){}else{}}
	 * @param {String} type 可选，是否使用h5绘制的对话框，例如：'div'，该值为默认值
	 */
	prompt: function(message, placeholder, title, btnValue, callback, type) {
		if(g_utils.isEmpty(message)&&g_utils.isEmpty(title)) return; //若没有任何提示内容，则不提示
		if(g_utils.isEmpty(message)) message=' ';
		if(g_utils.isEmpty(placeholder)) placeholder='请输入内容';
		if(g_utils.isEmpty(title)) title=' ';
		if(g_utils.isEmpty(btnValue)) btnValue=['取消','确定'];
		mui.prompt(message, placeholder, title, btnValue, callback, type);
	},
	/**
	 * 显示提示内容
	 * @param {String} message 消息框显示的文字内容
	 * @param {JSON} options 提示消息的参数
	 */
	toast: function(message,options) {

		if(g_utils.isEmpty(message)) return; //若没有任何提示内容，则不提示
		if(g_utils.isEmpty(options)) options={
			duration: 3000,  //持续显示时间 
		};
		mui.toast(message,options);
	},
	/**
	 * 打开图片截取界面
	 * @param {JSON} extras 额外的参数
	 */
	openCropper: function(extras){
		var url=g_formatPathToUrl('/global/plugins/cropper/cropper.html');
		var webview=g_mui.openWindow({
			url: url,
			id: url,
			show: {
				autoShow: true, //页面loaded事件发生后自动显示，默认为true
				aniShow: 'none', //页面显示动画，默认为“pop-in”；
			},
			extras: extras,
			waiting: {
				autoShow: true, //自动显示等待框，默认为true
			},
			styles: {
				scrollIndicator: 'none'
			}
		});
		return webview;
	},
	/**
	 * 打开档案通常选项选择器
	 * @param {JSON} extras 额外的参数 需传入typeName和selectedValue(已选择的值)
	 * type类型字符串：
	 * "minority"代表民族
	 * "degree"代表文化程度
	 * "maritaStatus"代表婚姻状况
	 * "bloodTypeAbo"代表abo血型
	 * "bloodTypeRh"代表rh血型
	 * "payWay"代表医疗支付方式
	 * "career"代表职业
	 */
	openNormalRecordPicker: function(extras) {
		var url = g_formatPathToUrl('/global/plugins/recordPicker/normalRecordPicker.html');
		var webview = g_mui.openWindow({
			url: url,
			id: url,
			show: {
				autoShow: true, //页面loaded事件发生后自动显示，默认为true
				aniShow: 'slide-in-right', //页面显示动画，默认为“pop-in”；
				duration: 300
			},
			extras: extras,
			waiting: {
				autoShow: false, //自动显示等待框，默认为true
			},
			styles: {
				scrollIndicator: 'none'
			}
		});
		return webview;
	},
	/**
	 * 打开档案通常选项选择器
	 * @param {JSON} extras 额外的参数 需传入typeName和selectedValue(已选择的值)
	 * type类型字符串：
	 * "drugAllergy"代表药物过敏史
	 * "anamnesis"代表既往病史
	 * "familyHistory"代表家族病史
	 * "heredopathia"代表遗传病史
	 */
	openMedicalHistoryPicker: function(extras) {
		var url;
		if(extras.typeName == 'familyHistory') {
			var url = g_formatPathToUrl('/global/plugins/recordPicker/inputMedicalHistory1.html');
		} else {
			var url = g_formatPathToUrl('/global/plugins/recordPicker/inputMedicalHistory.html');
		}
		var webview = g_mui.openWindow({
			url: url,
			id: url,
			show: {
				autoShow: true, //页面loaded事件发生后自动显示，默认为true
				aniShow: 'slide-in-right', //页面显示动画，默认为“pop-in”；
				duration: 300
			},
			extras: extras,
			waiting: {
				autoShow: false, //自动显示等待框，默认为true
			},
			styles: {
				scrollIndicator: 'none'
			}
		});
		return webview;

	},
	/**
	 * 打开用户资料显示界面
	 * @param {JSON} extras 额外的参数
	 */
	openUserDataDetail: function(extras) {
		var url = g_formatPathToUrl('/global/plugins/userDataDetail/userDataDetail.html');
		var webview = g_mui.openWindow({
			url: url,
			id: url,
			show: {
				autoShow: true, //页面loaded事件发生后自动显示，默认为true
				aniShow: 'slide-in-right', //页面显示动画，默认为“pop-in”；
				duration: 300
			},
			extras: extras,
			waiting: {
				autoShow: false, //自动显示等待框，默认为true
			},
			styles: {
				scrollIndicator: 'none'
			}
		});
		return webview;
	},
	/**
	 * 初始化图片预览
	 * 注：需在img图片上添加data-preview-src和data-preview-group，例如：<img src="../images/yuantiao.jpg" data-preview-src="" data-preview-group="1" />
	 * @param options 预览插件配置项 如：{delImg:true}可调用预览时删除功能
	 * @param openFun 打开预览回调函数
	 * @param closeFun 关闭预览回调函数
	 */
	previewImageInit: function(options,delFun,openFun,closeFun){
		var previewimageJsCss=document.createElement("link");
		previewimageJsCss.href=g_homePath + '/global/lib/previewImage/previewImage.css';
		previewimageJsCss.rel='stylesheet';
		
		var zoomJs= document.createElement("script");
		zoomJs.src=g_homePath + '/global/lib/previewImage/mui.zoom.js';
		
		var previewimageJs= document.createElement("script");
		previewimageJs.src=g_homePath + '/global/lib/previewImage/mui.previewimage.js';
		
		var oHead = document.getElementsByTagName('HEAD').item(0);
		oHead.appendChild(previewimageJsCss);
		oHead.appendChild(zoomJs);
		oHead.appendChild(previewimageJs);
		
		setTimeout(function(){
			mui.previewImage(options,delFun,openFun,closeFun);
		},1000)
		
	},
	/**
     * 打开r联系人选择
     * @param {JSON} extras 额外的参数
     */
    openSelectContacts: function(extras){
        var url=g_formatPathToUrl('/global/plugins/selectContacts/selectContacts.html');
        var webview=g_mui.openWindow({
            url: url,
            id: url,
            show: {
               autoShow: true, //页面loaded事件发生后自动显示，默认为true
               aniShow: 'slide-in-right', //页面显示动画，默认为“pop-in”；
               duration: 300
            },
           extras: extras,
           waiting: {
               autoShow: true, //自动显示等待框，默认为true
            },
           styles: {
               scrollIndicator: 'none'
           }
        });
        return webview;
    },
    /**
     * 打开图片词条选择
     * @param {JSON} extras 额外的参数
     */
    openAddEntryForPic: function(extras){
        var url=g_formatPathToUrl('/global/plugins/addEntryForPic/addEntryForPic.html');
        var webview=g_mui.openWindow({
            url: url,
            id: url,
            show: {
               autoShow: true, //页面loaded事件发生后自动显示，默认为true
               aniShow: 'slide-in-right', //页面显示动画，默认为“pop-in”；
               duration: 300
            },
           extras: extras,
           waiting: {
               autoShow: true, //自动显示等待框，默认为true
            },
           styles: {
               scrollIndicator: 'none'
           }
        });
        return webview;
    }
}
