(function($, window) {
	var DnePhotoSwiper = function(options, delCallBack) {
		this.option = options;
		this.init();
		this.delCallBack = delCallBack;
	}
	var proto = DnePhotoSwiper.prototype;
	proto.init = function() {
		var self = this;
		window.addEventListener("closePotoSwiper", function(e) {
			var webview = plus.webview.getWebviewById("picturePreview");
			if (webview) {
				webview.close('none');
			}
		});
		if (self.option && self.option.delImg) {
			window.addEventListener("delImage", function(e) {
				var group = e.detail.group;
				var index = e.detail.index;
				var groupList = document.querySelectorAll("[data-preview-group='" + group + "']");
				var delImgDom = groupList[index];
				delImgDom.parentNode.removeChild(delImgDom);
				self.delCallBack && self.delCallBack(delImgDom, group);
			});
		}
		$(document.body).on('tap', 'img[data-preview-src]', function() {
			var imgDataList = [];
			var index = 0;
			var group = this.getAttribute("data-preview-group");
			var src = this.getAttribute("data-preview-src");
			var groupList = document.querySelectorAll("[data-preview-group='" + group + "']");
			for (var j = 0; j < groupList.length; j++) {
				var groupItem = groupList[j];
				var itemSrc = groupItem.getAttribute("data-preview-src");
				var description = groupItem.getAttribute("description");
				if (itemSrc == src) {
					index = j;
				}
				imgDataList.push({
					src: itemSrc,
					description: description
				})
			}
			self.open({
				imgDataList: imgDataList,
				option: self.option,
				index: index,
				group: group
			});
			return false;
		});
	}
	proto.open = function(extra) {
		var url = g_formatPathToUrl('/global/plugins/picturePreview/picturePreview.html');
		var webview = g_mui.openWindow({
			url: url,
			id: "picturePreview",
			show: {
				autoShow: true, //页面loaded事件发生后自动显示，默认为true
				aniShow: 'none', //页面显示动画，默认为“pop-in”；
			},
			extras: extra,
			waiting: {
				autoShow: true, //自动显示等待框，默认为true
			},
			styles: {
				scrollIndicator: 'none',
				background: 'red'
			}
		});
		return webview;
	}
	var photoSwiperApi = null;
	$.initPhotoSwiper = function(options, delCallBack) {
		if (!photoSwiperApi) {
			photoSwiperApi = new DnePhotoSwiper(options, delCallBack);
		}
		return photoSwiperApi;
	}
})(mui, window)
