/**
 * 融云im
 */
var g_RIM = g_RIM || {
	/**
	 * 通过token链接融云IM。
	 */
	linRIM: function() {
		var parameters = {
			"userId": g_tools.getUserId()
		};
		var userInfoList = new Array();
		g_tools.postCMD('getUserInfoByUserId', parameters, function(result) {
			if (result.code == 0) {
				var myProfile = result.data;
				var nameInfo = g_tools.getNickname(myProfile.nickname, g_tools.getUserName());
				var headImg;
				if (!g_utils.isEmpty(myProfile.headImg)) {
					headImg = g_tools.IP_FILE + myProfile.headImg + "&tb=1";				
				} else {
					headImg = g_tools.CHAT_USER_DEFAULT;
				}
				g_storage.set(g_storage.DEVICE_USER_HEAD_URL, headImg);
				var userInfo = {
					'userId': myProfile.userId,
					'userName': nameInfo,
					'headImg': headImg
				}
				userInfoList.push(userInfo);
				g_tools.postCMD('getRongToken', {
					"name": nameInfo
				}, function(data) {
					if (data.code == 0) {
						var token = data.data.token;
						g_RIM.connect(token, function(res) {
							g_RIM.refreshUserInfoCache(JSON.stringify(userInfoList));
							plus.webview.currentWebview().evalJS("linkSuccess()")
						}, function(err) {
							plus.webview.currentWebview().evalJS("linkFail()")
						});
					}
				});
			}
		}, g_tools.MODE_WEB_LOCAL);
	},
	connect: function(token, success, fail) {
		if (g_config.DEV_PLATFORM == g_config.H5) return;

		callbackID = window.plus.bridge.callbackId(success, fail);
		window.plus.bridge.exec('pluginRCloudIM', "connect", [token, callbackID]);
	},
	//设置用户信息，ios不需要
	setUserInfoProvider: function(userId, name, headImg) {
		if (g_config.DEV_PLATFORM == g_config.H5) return;
		if (g_config.DEV_PLATFORM == g_config.ANDROID) {
			window.plus.bridge.execSync('pluginRCloudIM', "setUserInfoProvider", [userId, name, headImg]);
		}
	},
	//打开聊天对话框(逐渐废弃)
	gotoConversationView: function(userName, userId, careName, careId, myHeadImgUrl, careImgUrl, careTel, webId, isDoctor,
		success, fail) {
		if (g_config.DEV_PLATFORM == g_config.H5) return;
		var userInfoList = new Array();
		var userInfo = {
			'userId': careId,
			'userName': careName,
			'headImg': careImgUrl
		}
		userInfoList.push(userInfo);
		g_RIM.refreshUserInfoCache(JSON.stringify(userInfoList));
		if (g_utils.isEmpty(isDoctor)) { //防空值
			isDoctor = '0';
		}
		if (g_config.DEV_PLATFORM == g_config.ANDROID) {
			window.plus.bridge.execSync('pluginRCloudIM', "startPrivateChat", [careId, careName, careTel, webId, isDoctor]);
		} else {
			callbackID = window.plus.bridge.callbackId(success, fail);
			var myId = g_tools.getFoo();
			//注释不要删除，以后可能会用到
			//            var myHeadImg_hb_path = '_downloads/image/' + md5(myHeadImgUrl) + '.jpg'; //HBuilder平台路径
			//            var myHeadImg_sd_path = plus.io.convertLocalFileSystemURL(myHeadImg_hb_path); //SD卡绝对路径
			//
			//            if (careImgUrl == "../../global/img/default_head.png"){
			//                 var careImg_sd_path = plus.io.convertLocalFileSystemURL(careImgUrl); //SD卡绝对路径
			//            }else{
			//                var careImg_hb_path = '_downloads/image/' + md5(careImgUrl) + '.jpg'; //HBuilder平台路径
			//                var careImg_sd_path = plus.io.convertLocalFileSystemURL(careImg_hb_path); //SD卡绝对路径
			//            }
			if (g_utils.isEmpty(myHeadImgUrl)) {
				myHeadImgUrl = "../../global/img/head/default_head.png";
			}
			if (g_utils.isEmpty(careTel)) {
				careTel = "";
			}
			window.plus.bridge.exec('pluginRCloudIM', "gotoConversationView", [callbackID, webId, userId, myHeadImgUrl,
				careName, careId, careImgUrl, g_tools.getFoo(), careTel, isDoctor
			]);
		}
	},
	//打开聊天对话框（新）
	startSingleChatByTargetId: function(targetId, webId, success, fail) {
		if (g_config.DEV_PLATFORM == g_config.H5) return;

		if (targetId == 'admin') {

			var targetName = '系统消息';
			var targetImg = g_tools.IP_ADMIN_PHOTO;

			var myId = g_tools.getUserId();
			var myName = g_tools.getUserName();
			var myImg = g_storage.get(g_storage.DEVICE_USER_HEAD_URL);

			//刷新用户缓存
			var userInfoList = new Array();
			var myInfo = {
				'userId': myId,
				'userName': myName,
				'headImg': myImg
			}
			userInfoList.push(myInfo);
			var targetInfo = {
				'userId': targetId,
				'userName': targetName,
				'headImg': targetImg
			}
			userInfoList.push(targetInfo);
			g_RIM.refreshUserInfoCache(JSON.stringify(userInfoList));

			//打开会话页面
			if (g_config.DEV_PLATFORM == g_config.ANDROID) {
				window.plus.bridge.execSync('pluginRCloudIM', "startPrivateChat", [targetId, targetName, '', webId, '0']);
			} else {
				callbackID = window.plus.bridge.callbackId(success, fail);
				var myId = g_tools.getFoo();

				window.plus.bridge.exec('pluginRCloudIM', "gotoConversationView", [callbackID, webId, myId, myImg, targetName,
					targetId, targetImg, g_tools.getFoo(), '', '0'
				]);
			}
			return;
		}

        var loading;
        var num = 0;
        var time = setInterval(function setcount(){
            if (num == 1){
                loading = plus.nativeUI.showWaiting(g_tools.WAIT_TIP, {
                    loading: {
                        display: 'inline'
                    },
                    modal: false
                });
                clearInterval(time);
            }
            num++;
        }, 1000);
        
		g_tools.postCMD('getPersonInfoByIdForChat', {
			personId: targetId
		}, function(result) {
			// alert(JSON.stringify(result));
            if(!g_utils.isEmpty(loading)) loading.close();
            clearInterval(time);
                        
			if (result.code == 0) {

				var myId = g_tools.getUserId();
				var myName = g_tools.getUserName();
				var myImg = g_storage.get(g_storage.DEVICE_USER_HEAD_URL);

				var targetMonitorPhone = '';
				//  var targetPadPhone = '';
				var targetName = '';
				var targetImg = '';
				var isDoctor = '0';

				if (g_utils.isEmpty(webId)) {
					webId = plus.webview.currentWebview().id;
				}

				if (g_utils.isPoneAvailable(result.data.monitorPhone)) {
					targetMonitorPhone = result.data.monitorPhone;
				}

				//                if(!g_utils.isEmpty(result.data.padPhone)) {
				//                    targetPadPhone = result.data.padPhone;
				//                }

				targetName = result.data.userName;
				if (!g_utils.isEmpty(result.data.name)) {
					targetName = result.data.name;
				}
				if (!g_utils.isEmpty(result.data.nameNote)) {
					targetName = result.data.nameNote;
				}
				if (!g_utils.isEmpty(result.data.doctorNote)) {
					targetName = result.data.doctorNote;
				}

				if (!g_utils.isEmpty(result.data.personType)) {
					isDoctor = '' + result.data.personType;
				}

				if (!g_utils.isEmpty(result.data.headImg)) {
					if (result.data.personType == 1) { //医生
						targetImg = g_tools.IP_FILE + result.data.headImg + "&tb=1&app=2";
					} else {
						targetImg = g_tools.IP_FILE + result.data.headImg + "&tb=1";
					}
				} else {
					if (result.data.personType == 1) {
						targetImg = g_tools.CHAT_DOCTOR_DEFAULT;
					} else {
						targetImg = g_tools.CHAT_USER_DEFAULT;
					}
				}

				//刷新用户缓存
				var userInfoList = new Array();
				var myInfo = {
					'userId': myId,
					'userName': myName,
					'headImg': myImg
				}
				userInfoList.push(myInfo);
				var targetInfo = {
					'userId': targetId,
					'userName': targetName,
					'headImg': targetImg
				}
				userInfoList.push(targetInfo);
				g_RIM.refreshUserInfoCache(JSON.stringify(userInfoList));

				//打开会话页面
				if (g_config.DEV_PLATFORM == g_config.ANDROID) {
					window.plus.bridge.execSync('pluginRCloudIM', "startPrivateChat", [targetId, targetName, targetMonitorPhone,
						webId, isDoctor
					]);
				} else {
					callbackID = window.plus.bridge.callbackId(success, fail);
					var myId = g_tools.getFoo();

					window.plus.bridge.exec('pluginRCloudIM', "gotoConversationView", [callbackID, webId, myId, myImg, targetName,
						targetId, targetImg, g_tools.getFoo(), targetMonitorPhone, isDoctor
					]);
				}

			}
		});
	},
	//获取会话列表
	getConversationList: function(success, fail) {
		if (g_config.DEV_PLATFORM == g_config.H5) return;

		callbackID = window.plus.bridge.callbackId(success, fail);
		window.plus.bridge.exec('pluginRCloudIM', "getConversationList", [callbackID]);
	},
	//开启消息监听
	setOnReceiveMessageListener: function(success, fail) {
		if (g_config.DEV_PLATFORM == g_config.H5) return;
		callbackID = window.plus.bridge.callbackId(success, fail);
		window.plus.bridge.exec('pluginRCloudIM', "setOnReceiveMessageListener", [callbackID]);
	},
	//获取单个对话
	getConversation: function(chatId, type, success, fail) {
		if (g_config.DEV_PLATFORM == g_config.H5) return;
		callbackID = window.plus.bridge.callbackId(success, fail);
		window.plus.bridge.exec('pluginRCloudIM', "getConversation", [callbackID, chatId, type]);
	},
	//退出融云IM
	logout: function() {
		if (g_config.DEV_PLATFORM == g_config.H5) return;

		window.plus.bridge.execSync('pluginRCloudIM', "logout", []);
	},
	//刷新用户信息
	refreshUserInfoCache: function(userInfoList) {
		if (g_config.DEV_PLATFORM == g_config.H5) return;

		window.plus.bridge.execSync('pluginRCloudIM', "refreshUserInfoCache", [userInfoList]);
	},
	//移除会话
	removeConversation: function(id, type, success, fail) {
		if (g_config.DEV_PLATFORM == g_config.H5) return;
		callbackID = window.plus.bridge.callbackId(success, fail);
		window.plus.bridge.execSync('pluginRCloudIM', "removeConversation", [id, type, callbackID]);

	},
	//发送群通知
	sendGroupNotificationMessage: function(operatorUserId, operation, data, message, extra, success, fail) {
		if (g_config.DEV_PLATFORM == g_config.H5) return;
		callbackID = window.plus.bridge.callbackId(success, fail);
		window.plus.bridge.exec('pluginRCloudIM', "sendGroupNotificationMessage", [callbackID, operatorUserId, operation,
			data, message, extra
		]);
	},
	//群会话
	startGroupChat: function(groupId, groupName, isDoctorGroup, webId) {
		if (g_config.DEV_PLATFORM == g_config.H5) {
			return;
		}
		if (g_config.DEV_PLATFORM == g_config.ANDROID) {
			window.plus.bridge.execSync('pluginRCloudIM', "startGroupChat", [groupId, groupName, isDoctorGroup, webId]);
		} else if (g_config.DEV_PLATFORM == g_config.IOS) {
			var userId = g_tools.getUserId();
			var userName = g_tools.getUserName();
			var myHeadImg = g_storage.get(g_storage.DEVICE_USER_HEAD_URL);
			var myId = g_tools.getFoo();

			g_tools.postCMD('getUserInfoByUserId', {
				userId: userId
			}, function(result) {
				if (result.code == 0) {
					var myProfile = result.data;
					if (!g_utils.isEmpty(myProfile.nickname)) {
						userName = myProfile.nickname;
					} else {
						userName = userName.replace(/(\d{3})\d{4}(\d{4})/, '$1****$2');
					}
					if (g_utils.isEmpty(myHeadImg)) {
						myHeadImg = "../../global/img/head/default_head.png";
					}
					window.plus.bridge.execSync('pluginRCloudIM', "startGroupChat", [groupId, groupName, myId, userName, userId,
						myHeadImg, isDoctorGroup, webId
					]);
				}
			});
		}
	},
	createImGroup: function(users, groupName, usersInfo, func) {
		sendData = {
			"users": users,
			"groupName": groupName,
			"usersInfo": usersInfo
		}
		g_tools.postCMD("createImGroup", sendData, function(res) {
			func(res);
		});
	},
	queryImMyGroup: function(func) {
		sendData = {}
		g_tools.postCMD("queryImMyGroup", sendData, function(res) {
			func(res);
		});
	},
	quitImGroup: function(users, groupId, func) {
		sendData = {
			"users": users,
			"groupId": groupId
		}
		g_tools.postCMD("quitImGroup", sendData, function(res) {
			func(res);
		});
	},
	queryImGroup: function(groupId, func) {
		sendData = {
			"groupId": groupId
		}
		g_tools.postCMD("queryImGroup", sendData, function(res) {
			func(res);
		});
	},
	joinImGroup: function(users, groupId, usersInfo, func) {
		sendData = {
			"users": users,
			"groupId": groupId,
			"usersInfo": usersInfo
		}
		g_tools.postCMD("joinImGroup", sendData, function(res) {
			func(res);
		});
	},
	dismissImGroup: function(groupId, func) {
		sendData = {
			"groupId": groupId
		}
		g_tools.postCMD("dismissImGroup", sendData, function(res) {
			func(res);
		});
	}

}
