/**
 * g_tools 工具包不能单独使用，需要mui、storage和md5库
 * 仅能在mui.plusReady中使用
 */
var g_tools = g_tools || {
	/**
	 * ip地址，包含http和端口，//生产地址：web-server.free-star.com.cn，测试ip地址：211.149.172.120
	 */
	/*/
	IP: 'http://192.168.193.234:8888',
	IP_FILE: 'http://192.168.193.234:8888',
	IP_DNE_FILE: 'http://192.168.193.234:11112',
	IP_NO_PORT: 'http://192.168.193.234',
	FEMALE_DEFAULT_IMG: '/getImg?imgId=5e1c2a54cfdc4e21980bd4d7',
	MALE_DEFAULT_IMG: '/getImg?imgId=5e1c2a66cfdc4e21980bd4d9',
	CHAT_USER_DEFAULT:'http://211.149.172.120:9999/static/user_head_img/default_portrait_msg.png',
	CHAT_DOCTOR_DEFAULT:'http://211.149.172.120:9999/static/user_head_img/doctor_default.png',
	/*
	IP: 'http://www.freestarry.cn:8888',
	IP_FILE: 'http://www.freestarry.cn:9999',
	IP_NO_PORT: 'http://www.freestarry.cn',
	FEMALE_DEFAULT_IMG: '/getImg?imgId=5d28290eff7ba23a9621dfdd',
	MALE_DEFAULT_IMG: '/getImg?imgId=5d282911ff7ba23a9621dfdf',
	CHAT_USER_DEFAULT:'http://211.149.172.120:9999/static/user_head_img/default_portrait_msg.png',
	CHAT_DOCTOR_DEFAULT:'http://211.149.172.120:9999/static/user_head_img/doctor_default.png',
	/*/
	IP: 'http://web-server.free-star.com.cn:8888',
	IP_FILE: 'http://web-server.free-star.com.cn:9999',
	IP_NO_PORT: 'http://web-server.free-star.com.cn',
	FEMALE_DEFAULT_IMG: '/getImg?imgId=5e1c26a3cd2e107f37021232',
	MALE_DEFAULT_IMG: '/getImg?imgId=5e1c26becd2e107f37021236',
	CHAT_USER_DEFAULT:'http://web-server.free-star.com.cn:9999/static/user_head_img/default_portrait_msg.png',
	CHAT_DOCTOR_DEFAULT:'http://web-server.free-star.com.cn:9999/static/user_head_img/doctor_default.png',
	//*/
	IP_ADMIN_PHOTO: "http://59.110.104.147:9999/static/user_head_img/admin_head.png",
	MODE_WEB_LOCAL_CACHE: 0, //默认先取网络并存缓存失败再取缓存
	MODE_WEB_LOCAL: 1, //只取网络并存缓存
	MODE_WEB: 2, //只取网络不存缓存
	MODE_CACHE: 3, //只取缓存
	MODE_CACHE_WEB_LOCAL: 4, //先取缓存失败再取网络并存缓存
	MODE_CACHE_WEB: 5, //先取缓存失败再取网络不存缓存
	MODE_CACHE_THEN_WEB_LOCAL: 6,
	TIP_LOCAL_NET_WRONG: '网络错误',
	TIP_CACHE_EMPTY: '访问缓存为空',
	TIP_PICTURE_BEYOND: '图片尺寸太大',
	TIP_MODE_NO: 0, //不提示
	TIP_MODE_TOAST: 1, //TOAST提示
	TIP_MODE_INTERFACE: 2, //界面提示
	TIP_NO_NETWORK_TOAST: '网络连接异常，请检查网络', //断网提示，toast
	OVERTIME_ALERT_SHOW: 'overTimeFlagShow', //超时alert框标识名称
	CALLBACK_TYPE_SUCCESS: 'success', //post执行成功回调的方法种类
	CALLBACK_TYPE_ERROR: 'error', //post执行失败回调的方法种类
	POST_TYPE_URL: 'url', //post访问方式为url
	POST_TYPE_CMD: 'cmd', //post访问方式为cmd
	g_waitIsOpen: true, //自动显示wait框的开关
	WAIT_TIP: '正在加载，请稍候……', //等待框提示文字
	TIMEOUT: 10000, //超时时间
	MAX_REPEAT_POST_COUNT: 2, //最大重新post次数
	/**
	 * 发送第一层url
	 * @param {String} url 不包含ip和端口  例如 'login' 没有斜杠
	 * @param {Object} parameters 
	 * @param {Function} fun(result) 回调函数 result 是json Object code = -2 都是网络错误
	 * @param {int} cache 0:先取网络并存缓存失败再取缓存; 1:只取网络并存缓存; 2:只取网络不存缓存; 3:只取缓存; 4:先取缓存失败再取网络并存缓存; 5:先取缓存失败再取网络不存缓存; 6:先执行【3】再执行【1】;
	 * @param {Object} extra 其他参数 
	 * {
	 * 	timeout 访问网络超时时间 单位毫秒 默认10秒
	 * 	noNetworkMode 0【不提示】、1【Toast提示】、2【界面提示】
	 * 	contentDomId 内容dom的id，仅在noNetworkMode不为0时有效
	 * 	tipDomId 提示dom的id，仅在noNetworkMode不为0时有效
	 * }
	 * 
	 */
	postURL: function(url, parameters, fun, cache, extra) {
		//设置默认值
		if (g_utils.isEmpty(cache)) cache = g_tools.MODE_WEB;
		if (g_utils.isEmpty(extra)) extra = {};
		if (g_utils.isEmpty(extra.timeout)) {
			extra.timeout = g_tools.TIMEOUT;
		}
		if (g_utils.isEmpty(extra.noNetworkMode)) { //设置模式提示方式
			extra.noNetworkMode = g_tools.TIP_MODE_TOAST;
		}

		//提示模式为界面时，显示正在加载界面
		var contentDom, tipDom;
		if (extra.noNetworkMode == g_tools.TIP_MODE_INTERFACE) {
			contentDom = document.getElementById(extra.contentDomId);
			tipDom = document.getElementById(extra.tipDomId);
			g_tools.showInterfaceLoading(tipDom, contentDom);
		}

		//打开wait框
		var param = extra.param;
		if (g_utils.isEmpty(param)) {
			param = {};
			extra.param = param;
		}
		param.disableWait = extra.disableWait; //禁用wait框标识
		if (extra.repeatCount == undefined && extra.noNetworkMode != g_tools.TIP_MODE_INTERFACE) {
			g_tools.openWait(cache, param);
		}

		if (cache == g_tools.MODE_CACHE_THEN_WEB_LOCAL) { //先执行【3】再执行【1】
			g_tools.postURL(url, parameters, function(result) {
				fun(result);

				g_tools.postURL(url, parameters, function(result) {
					if (result['code'] != -2) {
						fun(result);
					}
				}, g_tools.MODE_WEB_LOCAL, extra.timeout);
			}, g_tools.MODE_CACHE, extra.timeout);
		} else if (cache == g_tools.MODE_WEB_LOCAL_CACHE) {
			mui.ajax(this.IP + '/' + url, {
				data: parameters,
				dataType: 'json',
				type: 'post',
				timeout: extra.timeout,
				success: function(result) {
					if (url == 'login' || url == 'unionIdLogin') {
						if (result.key != null) {
							g_storage.set(g_storage.DEVICE_LOGIN_KEY, result.key);
						}
						if (result.userId != null) {
							g_storage.set(g_storage.DEVICE_USER_ID, result.userId);
						}
					}
					userId = g_tools.getUserId();
					if (userId != null && userId != '') {
						str_parameters = JSON.stringify(parameters);
						str_result = JSON.stringify(result);
						g_storage.set(url + '-' + str_parameters + '-' + userId, str_result);
					}

					//post返回值统一处理，包含了断网提示、联网等待toast、超时重新登录等
					if (g_tools.callbackDeal(result, tipDom, contentDom, url, parameters, fun, cache, extra, g_tools.POST_TYPE_URL,
							g_tools.CALLBACK_TYPE_SUCCESS, param)) return;

					fun(result);
				},
				error: function(xhr, type, errorThrown) {
					if (g_tools.postURLRepeat(url, parameters, fun, cache, extra)) return;

					str_parameters = JSON.stringify(parameters);
					userId = g_tools.getUserId();
					str_result = g_storage.get(url + '-' + str_parameters + '-' + userId);
					if (str_result == null) {
						str_result = '{"code":-2,"tip":"' + this.TIP_CACHE_EMPTY + '"}';
					}
					result = JSON.parse(str_result);
					if (result['code'] == -2) {
						result['cache'] = 0;
					} else {
						result['cache'] = 1;
					}

					//post返回值统一处理，包含了断网提示、联网等待toast、超时重新登录等
					if (g_tools.callbackDeal(result, tipDom, contentDom, url, parameters, fun, cache, extra, g_tools.POST_TYPE_URL,
							g_tools.CALLBACK_TYPE_ERROR, param)) return;

					fun(result);
				}
			});
		} else if (cache == g_tools.MODE_WEB_LOCAL) {
			mui.ajax(this.IP + '/' + url, {
				data: parameters,
				dataType: 'json',
				type: 'post',
				timeout: extra.timeout,
				success: function(result) {
					if (url == 'login' || url == 'unionIdLogin') {
						if (result.key != null) {
							g_storage.set(g_storage.DEVICE_LOGIN_KEY, result.key);
						}
						if (result.userId != null) {
							g_storage.set(g_storage.DEVICE_USER_ID, result.userId);
						}
					}
					userId = g_tools.getUserId();
					if (userId != null && userId != '') {
						str_parameters = JSON.stringify(parameters);
						str_result = JSON.stringify(result);
						g_storage.set(url + '-' + str_parameters + '-' + userId, str_result);
					}

					//post返回值统一处理，包含了断网提示、联网等待toast、超时重新登录等
					if (g_tools.callbackDeal(result, tipDom, contentDom, url, parameters, fun, cache, extra, g_tools.POST_TYPE_URL,
							g_tools.CALLBACK_TYPE_SUCCESS, param)) return;

					fun(result);
				},
				error: function(xhr, type, errorThrown) {
					if (g_tools.postURLRepeat(url, parameters, fun, cache, extra)) return;

					result = {};
					result['code'] = -2;
					result['tip'] = this.TIP_LOCAL_NET_WRONG;
					result['type'] = type;

					//post返回值统一处理，包含了断网提示、联网等待toast、超时重新登录等
					if (g_tools.callbackDeal(result, tipDom, contentDom, url, parameters, fun, cache, extra, g_tools.POST_TYPE_URL,
							g_tools.CALLBACK_TYPE_ERROR, param)) return;

					fun(result);
				}
			});
		} else if (cache == g_tools.MODE_WEB) {
			mui.ajax(this.IP + '/' + url, {
				data: parameters,
				dataType: 'json',
				type: 'post',
				timeout: extra.timeout,
				success: function(result) {
					if (url == 'login' || url == 'unionIdLogin') {
						if (result.key != null) {
							g_storage.set(g_storage.DEVICE_LOGIN_KEY, result.key);
						}
						if (result.userId != null) {
							g_storage.set(g_storage.DEVICE_USER_ID, result.userId);
						}
					}

					//post返回值统一处理，包含了断网提示、联网等待toast、超时重新登录等
					if (g_tools.callbackDeal(result, tipDom, contentDom, url, parameters, fun, cache, extra, g_tools.POST_TYPE_URL,
							g_tools.CALLBACK_TYPE_SUCCESS, param)) return;

					fun(result);
				},
				error: function(xhr, type, errorThrown) {
					if (g_tools.postURLRepeat(url, parameters, fun, cache, extra)) return;

					result = {};
					result['code'] = -2;
					result['tip'] = this.TIP_LOCAL_NET_WRONG;
					result['type'] = type;

					//post返回值统一处理，包含了断网提示、联网等待toast、超时重新登录等
					if (g_tools.callbackDeal(result, tipDom, contentDom, url, parameters, fun, cache, extra, g_tools.POST_TYPE_URL,
							g_tools.CALLBACK_TYPE_ERROR, param)) return;

					fun(result);
				}
			});
		} else if (cache == g_tools.MODE_CACHE) {
			str_parameters = JSON.stringify(parameters);
			userId = g_tools.getUserId();
			str_result = g_storage.get(url + '-' + str_parameters + '-' + userId);
			if (str_result == null) {
				str_result = '{"code":-2,"tip":"' + this.TIP_CACHE_EMPTY + '"}';
			}
			result = JSON.parse(str_result);
			if (result['code'] == -2) {
				result['cache'] = 0;
			} else {
				result['cache'] = 1;
			}
			fun(result);
		} else if (cache == g_tools.MODE_CACHE_WEB_LOCAL) {
			str_parameters = JSON.stringify(parameters);
			userId = g_tools.getUserId();
			str_result = g_storage.get(url + '-' + str_parameters + '-' + userId);
			if (str_result == null) {
				str_result = '{"code":-2,"tip":"' + this.TIP_CACHE_EMPTY + '"}';
			}
			result = JSON.parse(str_result);
			if (result['code'] == -2) {
				result['cache'] = 0;
				mui.ajax(this.IP + '/' + url, {
					data: parameters,
					dataType: 'json',
					type: 'post',
					timeout: extra.timeout,
					success: function(result) {
						if (url == 'login' || url == 'unionIdLogin') {
							if (result.key != null) {
								g_storage.set(g_storage.DEVICE_LOGIN_KEY, result.key);
							}
							if (result.userId != null) {
								g_storage.set(g_storage.DEVICE_USER_ID, result.userId);
							}
						}
						userId = g_tools.getUserId();
						if (userId != null && userId != '') {
							str_parameters = JSON.stringify(parameters);
							str_result = JSON.stringify(result);
							g_storage.set(url + '-' + str_parameters + '-' + userId, str_result);
						}

						//post返回值统一处理，包含了断网提示、联网等待toast、超时重新登录等
						if (g_tools.callbackDeal(result, tipDom, contentDom, url, parameters, fun, cache, extra, g_tools.POST_TYPE_URL,
								g_tools.CALLBACK_TYPE_SUCCESS, param)) return;

						fun(result);
					},
					error: function(xhr, type, errorThrown) {
						if (g_tools.postURLRepeat(url, parameters, fun, cache, extra)) return;

						result = {};
						result['code'] = -2;
						result['tip'] = this.TIP_LOCAL_NET_WRONG;
						result['type'] = type;
						//post返回值统一处理，包含了断网提示、联网等待toast、超时重新登录等
						if (g_tools.callbackDeal(result, tipDom, contentDom, url, parameters, fun, cache, extra, g_tools.POST_TYPE_URL,
								g_tools.CALLBACK_TYPE_ERROR, param)) return;

						fun(result);
					}
				});

			} else {
				result['cache'] = 1;

				//post返回值统一处理，包含了断网提示、联网等待toast、超时重新登录等
				if (g_tools.callbackDeal(result, tipDom, contentDom, url, parameters, fun, cache, extra, g_tools.POST_TYPE_URL,
						g_tools.CALLBACK_TYPE_SUCCESS, param)) return;

				fun(result);
			}

		} else if (cache == g_tools.MODE_CACHE_WEB) {
			str_parameters = JSON.stringify(parameters);
			userId = g_tools.getUserId();
			str_result = g_storage.get(url + '-' + str_parameters + '-' + userId);
			if (str_result == null) {
				str_result = '{"code":-2,"tip":"' + this.TIP_CACHE_EMPTY + '"}';
			}
			result = JSON.parse(str_result);
			if (result['code'] == -2) {
				result['cache'] = 0;
				mui.ajax(this.IP + '/' + url, {
					data: parameters,
					dataType: 'json',
					type: 'post',
					timeout: extra.timeout,
					success: function(result) {
						if (url == 'login' || url == 'unionIdLogin') {
							if (result.key != null) {
								g_storage.set(g_storage.DEVICE_LOGIN_KEY, result.key);
							}
							if (result.userId != null) {
								g_storage.set(g_storage.DEVICE_USER_ID, result.userId);
							}
						}

						//post返回值统一处理，包含了断网提示、联网等待toast、超时重新登录等
						if (g_tools.callbackDeal(result, tipDom, contentDom, url, parameters, fun, cache, extra, g_tools.POST_TYPE_URL,
								g_tools.CALLBACK_TYPE_SUCCESS, param)) return;

						fun(result);
					},
					error: function(xhr, type, errorThrown) {
						if (g_tools.postURLRepeat(url, parameters, fun, cache, extra)) return;

						result = {};
						result['code'] = -2;
						result['tip'] = this.TIP_LOCAL_NET_WRONG;
						result['type'] = type;

						//post返回值统一处理，包含了断网提示、联网等待toast、超时重新登录等
						if (g_tools.callbackDeal(result, tipDom, contentDom, url, parameters, fun, cache, extra, g_tools.POST_TYPE_URL,
								g_tools.CALLBACK_TYPE_ERROR, param)) return;

						fun(result);
					}
				});

			} else {
				result['cache'] = 1;

				//post返回值统一处理，包含了断网提示、联网等待toast、超时重新登录等
				if (g_tools.callbackDeal(result, tipDom, contentDom, url, parameters, fun, cache, extra, g_tools.POST_TYPE_URL,
						g_tools.CALLBACK_TYPE_SUCCESS, param)) return;

				fun(result);
			}
		}

	},
	/**
	 * 发送cmd
	 * @param {String} cmd 不包含ip和端口  例如 'getUserInfoByUserName' 没有斜杠
	 * @param {Object} parameters
	 * @param {Function} fun fun(result) 回调函数 result 是json Object code = -2 都是网络错误
	 * @param {int} cache 0: 先取网络并存缓存失败再取缓存; 1:只取网络并存缓存; 2:只取网络不存缓存; 3:只取缓存; 4:先取缓存失败再取网络并存缓存; 5:先取缓存失败再取网络不存缓存; 6:先执行【3】再执行【1】; 
	 * @param {Object} extra 其他参数 
	 * {
	 * 	timeout 访问网络超时时间 单位毫秒 默认10秒
	 * 	noNetworkMode 0【不提示】、1【Toast提示】、2【界面提示】
	 * 	contentDomId 内容dom的id，仅在noNetworkMode不为0时有效
	 * 	tipDomId 提示dom的id，仅在noNetworkMode不为0时有效
	 * }
	 */
	postCMD: function(cmd, parameters, fun, cache, extra) {
		//		console.log('postCMD: '+cmd+' '+cache+' '+JSON.stringify(parameters));
		//设置默认值
		if (g_utils.isEmpty(cache)) cache = g_tools.MODE_WEB;
		if (g_utils.isEmpty(extra)) extra = {};
		if (g_utils.isEmpty(extra.timeout)) {
			extra.timeout = g_tools.TIMEOUT;
		}
		if (g_utils.isEmpty(extra.noNetworkMode)) { //设置模式提示方式
			extra.noNetworkMode = g_tools.TIP_MODE_TOAST;
		}

		//提示模式为界面时，显示正在加载界面
		var contentDom, tipDom;
		if (extra.noNetworkMode == g_tools.TIP_MODE_INTERFACE) {
			contentDom = document.getElementById(extra.contentDomId);
			tipDom = document.getElementById(extra.tipDomId);
			g_tools.showInterfaceLoading(tipDom, contentDom);
		}

		//打开wait框
		var param = extra.param;
		if (g_utils.isEmpty(param)) {
			param = {};
			extra.param = param;
		}
		param.disableWait = extra.disableWait; //禁用wait框标识
		if (extra.repeatCount == undefined && extra.noNetworkMode != g_tools.TIP_MODE_INTERFACE) {
			g_tools.openWait(cache, param);
		}

		if (cache == g_tools.MODE_CACHE_THEN_WEB_LOCAL) { //先执行【3】再执行【1】
			g_tools.postCMD(cmd, parameters, function(result) {
				fun(result);
				g_tools.postCMD(cmd, parameters, function(result) {
					if (result['code'] != -2) {
						fun(result);
					}
				}, g_tools.MODE_WEB_LOCAL, extra.timeout);
			}, g_tools.MODE_CACHE, extra.timeout);
		} else if (cache == g_tools.MODE_WEB_LOCAL_CACHE) {
			ss = JSON.stringify(parameters);
			foo = g_tools.getFoo();
			mui.ajax(this.IP + '/cmd2', {
				data: {
					'method': cmd,
					'parameters': ss,
					'key': foo
				},
				dataType: 'json',
				type: 'post',
				timeout: extra.timeout,
				success: function(result) {
					userId = g_tools.getUserId();
					if (userId != null && userId != '') {
						str_parameters = ss;
						str_result = JSON.stringify(result);
						g_storage.set(cmd + '-' + str_parameters + '-' + userId, str_result);
					}
					//post返回值统一处理，包含了断网提示、联网等待toast、超时重新登录等
					if (g_tools.callbackDeal(result, tipDom, contentDom, cmd, parameters, fun, cache, extra, g_tools.POST_TYPE_CMD,
							g_tools.CALLBACK_TYPE_SUCCESS, param)) return;

					fun(result);
				},
				error: function(xhr, type, errorThrown) {
					if (g_tools.postCMDRepeat(cmd, parameters, fun, cache, extra)) return;

					userId = g_tools.getUserId();
					str_result = g_storage.get(cmd + '-' + ss + '-' + userId);
					if (str_result == null) {
						str_result = '{"code":-2,"tip":"' + this.TIP_CACHE_EMPTY + '"}';
					}
					result = JSON.parse(str_result);
					if (result['code'] == -2) {
						result['cache'] = 0;
					} else {
						result['cache'] = 1;
					}
					//					console.log(tipDom);
					//post返回值统一处理，包含了断网提示、联网等待toast、超时重新登录等
					if (g_tools.callbackDeal(result, tipDom, contentDom, cmd, parameters, fun, cache, extra, g_tools.POST_TYPE_CMD,
							g_tools.CALLBACK_TYPE_ERROR, param)) return;

					fun(result);
				}
			});
		} else if (cache == g_tools.MODE_WEB_LOCAL) {
			ss = JSON.stringify(parameters);
			foo = g_tools.getFoo();
			mui.ajax(this.IP + '/cmd2', {
				data: {
					'method': cmd,
					'parameters': ss,
					'key': foo
				},
				dataType: 'json',
				type: 'post',
				timeout: extra.timeout,
				success: function(result) {
					userId = g_tools.getUserId();
					if (userId != null && userId != '') {
						str_parameters = ss;
						str_result = JSON.stringify(result);
						g_storage.set(cmd + '-' + str_parameters + '-' + userId, str_result);
					}

					//post返回值统一处理，包含了断网提示、联网等待toast、超时重新登录等
					if (g_tools.callbackDeal(result, tipDom, contentDom, cmd, parameters, fun, cache, extra, g_tools.POST_TYPE_CMD,
							g_tools.CALLBACK_TYPE_SUCCESS, param)) return;

					fun(result);
				},
				error: function(xhr, type, errorThrown) {
					if (g_tools.postCMDRepeat(cmd, parameters, fun, cache, extra)) return;

					result = {};
					result['code'] = -2;
					result['tip'] = this.TIP_LOCAL_NET_WRONG;
					result['type'] = type;

					//post返回值统一处理，包含了断网提示、联网等待toast、超时重新登录等
					if (g_tools.callbackDeal(result, tipDom, contentDom, cmd, parameters, fun, cache, extra, g_tools.POST_TYPE_CMD,
							g_tools.CALLBACK_TYPE_ERROR, param)) return;

					fun(result);
				}
			});
		} else if (cache == g_tools.MODE_WEB) {
			ss = JSON.stringify(parameters);
			foo = g_tools.getFoo();
			mui.ajax(this.IP + '/cmd2', {
				data: {
					'method': cmd,
					'parameters': ss,
					'key': foo
				},
				dataType: 'json',
				type: 'post',
				timeout: extra.timeout,
				success: function(result) {
					//post返回值统一处理，包含了断网提示、联网等待toast、超时重新登录等
					if (g_tools.callbackDeal(result, tipDom, contentDom, cmd, parameters, fun, cache, extra, g_tools.POST_TYPE_CMD,
							g_tools.CALLBACK_TYPE_SUCCESS, param)) return;

					fun(result);
				},
				error: function(xhr, type, errorThrown) {
					if (g_tools.postCMDRepeat(cmd, parameters, fun, cache, extra)) return;

					result = {};
					result['code'] = -2;
					result['tip'] = this.TIP_LOCAL_NET_WRONG;
					result['type'] = type;

					//post返回值统一处理，包含了断网提示、联网等待toast、超时重新登录等
					if (g_tools.callbackDeal(result, tipDom, contentDom, cmd, parameters, fun, cache, extra, g_tools.POST_TYPE_CMD,
							g_tools.CALLBACK_TYPE_ERROR, param)) return;

					fun(result);
				}
			});
		} else if (cache == g_tools.MODE_CACHE) {
			ss = JSON.stringify(parameters);
			foo = g_tools.getFoo();
			userId = g_tools.getUserId();
			str_result = g_storage.get(cmd + '-' + ss + '-' + userId);
			if (str_result == null) {
				str_result = '{"code":-2,"tip":"' + this.TIP_CACHE_EMPTY + '"}';
			}
			result = JSON.parse(str_result);
			if (result['code'] == -2) {
				result['cache'] = 0;
			} else {
				result['cache'] = 1;
			}

			fun(result);
		} else if (cache == g_tools.MODE_CACHE_WEB_LOCAL) {
			ss = JSON.stringify(parameters);
			foo = g_tools.getFoo();
			userId = g_tools.getUserId();
			str_result = g_storage.get(cmd + '-' + ss + '-' + userId);
			if (str_result == null) {
				str_result = '{"code":-2,"tip":"' + this.TIP_CACHE_EMPTY + '"}';
			}
			result = JSON.parse(str_result);
			if (result['code'] == -2) {
				result['cache'] = 0;
				mui.ajax(this.IP + '/cmd2', {
					data: {
						'method': cmd,
						'parameters': ss,
						'key': foo
					},
					dataType: 'json',
					type: 'post',
					timeout: extra.timeout,
					success: function(result) {
						userId = g_tools.getUserId();
						if (userId != null && userId != '') {
							str_parameters = ss;
							str_result = JSON.stringify(result);
							g_storage.set(cmd + '-' + str_parameters + '-' + userId, str_result);
						}

						//post返回值统一处理，包含了断网提示、联网等待toast、超时重新登录等
						if (g_tools.callbackDeal(result, tipDom, contentDom, cmd, parameters, fun, cache, extra, g_tools.POST_TYPE_CMD,
								g_tools.CALLBACK_TYPE_SUCCESS, param)) return;

						fun(result);
					},
					error: function(xhr, type, errorThrown) {
						if (g_tools.postCMDRepeat(cmd, parameters, fun, cache, extra)) return;

						result = {};
						result['code'] = -2;
						result['tip'] = this.TIP_LOCAL_NET_WRONG;
						result['type'] = type;

						//post返回值统一处理，包含了断网提示、联网等待toast、超时重新登录等
						if (g_tools.callbackDeal(result, tipDom, contentDom, cmd, parameters, fun, cache, extra, g_tools.POST_TYPE_CMD,
								g_tools.CALLBACK_TYPE_ERROR, param)) return;

						fun(result);
					}
				});

			} else {
				result['cache'] = 1;

				//post返回值统一处理，包含了断网提示、联网等待toast、超时重新登录等
				if (g_tools.callbackDeal(result, tipDom, contentDom, cmd, parameters, fun, cache, extra, g_tools.POST_TYPE_CMD,
						g_tools.CALLBACK_TYPE_SUCCESS, param)) return;

				fun(result);
			}

		} else if (cache == g_tools.MODE_CACHE_WEB) {
			ss = JSON.stringify(parameters);
			foo = g_tools.getFoo();
			userId = g_tools.getUserId();
			str_result = g_storage.get(cmd + '-' + ss + '-' + userId);
			if (str_result == null) {
				str_result = '{"code":-2,"tip":"' + this.TIP_CACHE_EMPTY + '"}';
			}
			result = JSON.parse(str_result);
			if (result['code'] == -2) {
				result['cache'] = 0;
				mui.ajax(this.IP + '/cmd2', {
					data: {
						'method': cmd,
						'parameters': ss,
						'key': foo
					},
					dataType: 'json',
					type: 'post',
					timeout: extra.timeout,
					success: function(result) {
						//post返回值统一处理，包含了断网提示、联网等待toast、超时重新登录等
						if (g_tools.callbackDeal(result, tipDom, contentDom, cmd, parameters, fun, cache, extra, g_tools.POST_TYPE_CMD,
								g_tools.CALLBACK_TYPE_SUCCESS, param)) return;

						fun(result);
					},
					error: function(xhr, type, errorThrown) {
						if (g_tools.postCMDRepeat(cmd, parameters, fun, cache, extra)) return;

						result = {};
						result['code'] = -2;
						result['tip'] = this.TIP_LOCAL_NET_WRONG;
						result['type'] = type;

						//post返回值统一处理，包含了断网提示、联网等待toast、超时重新登录等
						if (g_tools.callbackDeal(result, tipDom, contentDom, cmd, parameters, fun, cache, extra, g_tools.POST_TYPE_CMD,
								g_tools.CALLBACK_TYPE_ERROR, param)) return;

						fun(result);
					}
				});

			} else {
				result['cache'] = 1;

				//post返回值统一处理，包含了断网提示、联网等待toast、超时重新登录等
				if (g_tools.callbackDeal(result, tipDom, contentDom, cmd, parameters, fun, cache, extra, g_tools.POST_TYPE_CMD,
						g_tools.CALLBACK_TYPE_SUCCESS, param)) return;

				fun(result);
			}

		}

	},
	/**
	 * 重新post CMD
	 */
	postCMDRepeat: function(cmd, parameters, fun, cache, extra) {
		if (extra.repeatCount == undefined || extra.repeatCount <= g_tools.MAX_REPEAT_POST_COUNT) {
			if (extra.repeatCount == undefined) {
				extra.repeatCount = 1;
			}
			setTimeout(function() {
				g_tools.postCMD(cmd, parameters, fun, cache, extra);
				extra.repeatCount++;
			}, 100);
			return true;
		} else {
			extra.repeatCount = undefined;
			return false;
		}
	},
	/**
	 * 重新post URL
	 */
	postURLRepeat: function(cmd, parameters, fun, cache, extra) {
		if (extra.repeatCount == undefined || extra.repeatCount <= g_tools.MAX_REPEAT_POST_COUNT) {
			if (extra.repeatCount == undefined) {
				extra.repeatCount = 1;
			}
			setTimeout(function() {
				g_tools.postURL(cmd, parameters, fun, cache, extra);
				extra.repeatCount++;
			}, 100);
			return true;
		} else {
			extra.repeatCount = undefined;
			return false;
		}
	},
	/**
	 * 在界面上显示断网提示内容
	 * @param {Object} contentDom 显示内容的dom
	 * @param {Object} tipDom 显示提示内容的dom
	 * @param {Function} fn 点击刷新后重新提交的post方法
	 */
	showNoNetworkInterface: function(tipDom, contentDom, fn) {
		tipDom.innerHTML = '' +
			'<div class="no-network-tip" >' +
			'	<div><img src="' + g_homePath + '/global/img/icon_no_network.png"</div>' +
			'	<div>网络连接异常，请检查网络</div>' +
			'	<div><button class="mui-btn-warning">点击刷新</button></div>' +
			'</div>';
		var btn = document.getElementsByTagName('button')[0];
		if (btn && !btn.getAttribute('has-listen')) { //防止重复监听
			btn.addEventListener('tap', function(e) {
				this.setAttribute('has-listen', true);
				fn();
			});
		}
	},
	/**
	 * 在界面上显示“正在加载”
	 * @param {Object} contentDom 显示内容的dom
	 * @param {Object} tipDom 显示提示内容的dom
	 */
	showInterfaceLoading: function(tipDom, contentDom) {
		if (!g_utils.isEmpty(contentDom)) {
			contentDom.classList.add('mui-hidden');
		}
		if (!g_utils.isEmpty(tipDom)) {
			tipDom.classList.remove('mui-hidden');
			if (tipDom.innerHTML != '') {
				tipDom.innerHTML = '' +
					'<div class="loading">' +
					'	<img src="' + g_homePath + '/global/img/loading.gif" /> ' + g_tools.WAIT_TIP + '</div>';
			}
		}
	},
	/**
	 * 关于断网的在success或error中的处理
	 * @param {String} result post请求的返回值
	 * @param {Object} tipDom 断网提示dom的id
	 * @param {Object} contentDom 显示内容的dom的id
	 * @param {String} urlOrCmd post请求的url或cmd
	 * @param {Object} parameters post传入参数
	 * @param {Function} fun 回调方法
	 * @param {int} cache 缓存模式
	 * @param {Object} extra 额外参数
	 * @param {String} postType post请求类型
	 * @param {String} callbackType post回调函数的类型
	 */
	noNetworkDeal: function(result, tipDom, contentDom, urlOrCmd, parameters, fun, cache, extra, postType, callbackType) {
		var msg = '';
		if (g_config.DEV_PLATFORM == 'h5') msg = ' ' + urlOrCmd;

		if (callbackType == g_tools.CALLBACK_TYPE_SUCCESS) {
			if (postType == g_tools.POST_TYPE_CMD || postType == g_tools.POST_TYPE_URL) {
				if (extra.noNetworkMode == g_tools.TIP_MODE_INTERFACE) {
					contentDom.classList.remove('mui-hidden');
					tipDom.classList.add('mui-hidden');

					if (result['cache'] == 1) {
						g_toast.toast(g_tools.TIP_NO_NETWORK_TOAST + msg);
					}
				}

				if (extra.noNetworkMode == g_tools.TIP_MODE_TOAST && cache !== g_tools.MODE_CACHE && cache !== g_tools.MODE_CACHE_WEB_LOCAL &&
					cache !== g_tools.MODE_CACHE_WEB) {
					if (result['cache'] == 1) {
						g_toast.toast(g_tools.TIP_NO_NETWORK_TOAST + msg);
					}
				}
			}

			return false;
		} else if (callbackType == g_tools.CALLBACK_TYPE_ERROR) {
			if (extra.noNetworkMode == g_tools.TIP_MODE_INTERFACE) { //界面显示断网提示 
				if (result['cache'] != 1) { //没有缓存时执行
					setTimeout(function() { //设置延迟刷新，主要为了让“正在加载”有个停顿感
						g_tools.showNoNetworkInterface(tipDom, contentDom, function() {
							if (postType == g_tools.POST_TYPE_CMD) {
								g_tools.postCMD(urlOrCmd, parameters, fun, cache, extra);
							} else if (postType == g_tools.POST_TYPE_URL) {
								g_tools.postURL(urlOrCmd, parameters, fun, cache, extra);
							}
						});
					}, 500)
					//界面断网提示不执行回调函数
					return true;
				} else { //有缓存时改为界面显示
					contentDom.classList.remove('mui-hidden');
					tipDom.classList.add('mui-hidden');
					g_toast.toast(g_tools.TIP_NO_NETWORK_TOAST + msg);
				}
			}

			if (extra.noNetworkMode == g_tools.TIP_MODE_TOAST) {
				g_toast.toast(g_tools.TIP_NO_NETWORK_TOAST + msg);
			}
			return false;
		}

		return true;
	},
	/**
	 * 打开等待框
	 */
	openWait: function(cache, param) {
		if (cache == g_tools.MODE_CACHE_THEN_WEB_LOCAL || cache == g_tools.MODE_CACHE || !g_tools.g_waitIsOpen) return;
		setTimeout(function() {
			if (param && g_utils.isEmpty(param.time) && !param.disableWait && !param.noOpen) {
				param.time = new Date().getTime();
				g_tools[param.time + ''] = plus.nativeUI.showWaiting(g_tools.WAIT_TIP, {
					loading: {
						display: 'inline'
					},
					modal: true
				});
				setTimeout(function() {
					g_tools.closeWait(cache, param);
				}, g_tools.TIMEOUT)
			}
		}, 3000);
	},
	/**
	 * 关闭等待框
	 */
	closeWait: function(cache, param) {
		if (cache == g_tools.MODE_CACHE_THEN_WEB_LOCAL || cache == g_tools.MODE_CACHE || !g_tools.g_waitIsOpen) return;
		if (param && !g_utils.isEmpty(param.time) && !param.disableWait) {
			if (g_tools[param.time + ''])
				g_tools[param.time + ''].close();
		} else {
			param.noOpen = true;
		}
		param.time = 0;
	},
	/**
	 * 判断登录是否超时，若超时则自动提示并调整到登录界面
	 */
	checkLoginOvertime: function(result) {
		//TO-DO：下面的判断不能使用result.tip，应该使用result.code，具体值需要跟王舒确认
		if (result && result.tip == '您的账号已在其它地方登录或登录超时,请重新登录' && localStorage.getItem(g_tools.OVERTIME_ALERT_SHOW) ==
			'false') { //localStorage.getItem(g_tools.OVERTIME_ALERT_SHOW)为是否已经执行超时判断的标识，若已执行，则不再重复显示弹出框
			localStorage.setItem(g_tools.OVERTIME_ALERT_SHOW, 'true');
			g_storage.remove(g_storage.DEVICE_LOGIN_KEY);
			g_storage.remove(g_storage.DEVICE_USER_ID);
			g_storage.remove(g_storage.DEVICE_USER_NAME);
			g_storage.remove(g_storage.DEVICE_USER_PW);

			g_mui.alert('您的账号已在其它地方登录或登录超时,请重新登录', '温馨提示', '去登录', function() {
				g_tools.logout();
			});

			return true;
		}

		return false;
	},
	/**
	 * 退出登录，并跳转到登录界面，清除登录相关的缓存，并关闭其他所有的webview
	 */
	logout: function() {
		g_storage.remove(g_storage.DEVICE_LOGIN_KEY);
		g_storage.remove(g_storage.DEVICE_USER_ID);
		g_storage.remove(g_storage.DEVICE_USER_NAME);
		g_storage.remove(g_storage.DEVICE_USER_PW);
		g_storage.remove(g_storage.OVERTIME_ALERT_SHOW);
		//跳转到登录页面
		//定时判断加载情况，一旦加载成功，则自动跳转
		var webview = g_mui.createWebview(g_module.login.getUrl(), g_module.login.ID, {
			render: 'always'
		});
		webview.show('fade-in');

		//修改状态栏背景
		g_setStatusbarBg('headerbg_default');
		//注销融云
		if (g_config.DEV_PLATFORM != g_config.H5) {
			window.plus.bridge.execSync('pluginRCloudIM', "logout", []);
		}
	},

	/**
	 * 登录成功，存入登录相关变量，并进入首界面
	 * @param {String} userId 登录用户的用户id
	 * @param {String} userName 登录用户的用户名
	 * @param {String} password 登录用户的密码
	 * @param {String} callbackJsStr 回调执行字符串
	 */
	login: function(userId, userName, password) {
		//登录成功存储本地
		g_storage.set(g_storage.DEVICE_USER_ID, userId);
		//		g_push.regAndLogin(g_storage.get(g_storage.DEVICE_USER_ID), g_push.defPwd);
		g_storage.set(g_storage.DEVICE_USER_NAME, userName);
		if (!g_utils.isEmpty(password)) {
			g_storage.set(g_storage.DEVICE_USER_PW, g_tools.secondPassword(password)); //只保存二次加密后的值
		}

		g_storage.set(g_storage.DEVICE_HAS_FIRST_LOGIN, 'true'); //设置为已登录过一次

		localStorage.setItem(g_tools.OVERTIME_ALERT_SHOW, 'false'); //初始化alert超时提示框，false时则该框未打开

		g_tools.postCMD('getUserInfoByUserId', {
			userId: userId
		}, function(result) {
			Debugger.log("getUserInfoByUserId->:" + JSON.stringify(result));
			if (result.code == 0) {
				var myProfile = result.data;
				var userInfo = {};
				if (!g_utils.isEmpty(myProfile.headImg)) {
					userInfo.headImg = myProfile.headImg;
				}
				if (!g_utils.isEmpty(myProfile.nickname)) {
					userInfo.nickname = myProfile.nickname;
				}

				if (!g_utils.isEmpty(myProfile.sex)) {
					userInfo.sex = myProfile.sex;
				}
				if (!g_utils.isEmpty(myProfile.birthday)) {
					userInfo.birthday = myProfile.birthday;
				}
				if (!g_utils.isEmpty(myProfile.height)) {
					userInfo.height = myProfile.height;
				}
				if (!g_utils.isEmpty(myProfile.weight)) {
					userInfo.weight = myProfile.weight;
				}
				if (!g_utils.isEmpty(myProfile.isBinded)) {
					userInfo.isBinded = myProfile.isBinded;
				}
				if (!g_utils.isEmpty(myProfile.isAddMyCard)) {
					userInfo.isAddMyCard = myProfile.isAddMyCard;
				}

				/*if(g_utils.isEmpty(myProfile.nickname) || g_utils.isEmpty(myProfile.headImg)) {
					g_mui.openModule(g_module.insertMyHealthCard, {
						'userInfo': JSON.stringify(userInfo)
					});
				} else*/
				if (myProfile.isBinded == 1 || myProfile.isAddMyCard == 1) {

					var webview = g_mui.createWebview(g_module.index.getUrl(), g_module.index.ID, {
						render: 'always'
					});
					plus.nativeUI.showWaiting(g_tools.WAIT_TIP, {
						loading: {
							display: 'inline'
						},
						modal: false
					});
					//定时判断加载情况，一旦首页加载成功，则自动跳转
					setInterval(function() {
						var w = plus.webview.getWebviewById(g_module.myCareList.ID + ':pullrefresh_sub.html');
						if (w != null) {
							plus.nativeUI.closeWaiting();
							webview.show();
							//关闭模块相关的所有webview
							var array = plus.webview.all();
							if (array) {
								var checkModuleArr = g_module.getIndexSubPages();
								checkModuleArr.push(g_module.index);
								//					console.log(JSON.stringify(checkModuleArr));
								for (var i = 0, len = array.length; i < len; i++) {
									var id = array[i].id;
									//					  	console.log('id: '+id);
									var isNeedClose = true; //是否需要关闭 
									for (var j = 0; j < checkModuleArr.length; j++) { //如果在这些模块中，则无需关闭
										var module = checkModuleArr[j];
										//					  		console.log('id: '+id+' module.ID: '+module.ID);
										if (id.indexOf(module.ID) == 0) { //属于该模块
											isNeedClose = false;
											break;
										}
									}
									if (isNeedClose) {
										//					  		console.log('close: '+array[i].id);
										array[i].close('none');
									}
								}
							}
						}
					}, 500);
				} else {
					/*g_mui.openModule(g_module.insertMyHealthCard2, {
						'userInfo': JSON.stringify(userInfo)
					});*/
					g_mui.openModule(g_module.insertMyHealthCard, {
						'userInfo': JSON.stringify(userInfo)
					});
				}
			}
		});

	},
	/*
	 * post返回值统一处理，包含了断网提示、联网等待toast、超时重新登录等
	 */
	callbackDeal: function(result, tipDom, contentDom, urlOrCmd, parameters, fun, cache, extra, postType, callbackType,
		param) {
		var flag = false;
		//关闭wait框
		g_tools.closeWait(cache, param);
		//断网相关处理
		flag = flag || g_tools.noNetworkDeal(result, tipDom, contentDom, urlOrCmd, parameters, fun, cache, extra, postType,
			callbackType);
		flag = flag || g_tools.checkLoginOvertime(result);

		return flag;
	},
	/**
	 * 获取登录用户的userId
	 * return {String} userId
	 */
	getUserId: function() {
		var userId = g_tools['userId'];
		if (g_utils.isEmpty(userId)) { //先找内存，没有再读数据库
			userId = g_storage.get(g_storage.DEVICE_USER_ID);
			g_tools['userId'] = userId;
		}
		return userId;
	},
	/**
	 * 获取登录用户的userName
	 * return {String} userName
	 */
	getUserName: function() {
		var userName = g_tools['userName'];
		if (g_utils.isEmpty(userName)) { //先找内存，没有再读数据库
			userName = g_storage.get(g_storage.DEVICE_USER_NAME);
			g_tools['userName'] = userName;
		}
		return userName;
	},
	getFoo: function() {
		var foo = g_tools['foo'];
		if (g_utils.isEmpty(foo)) { //先找内存，没有再读数据库
			foo = g_storage.get(g_storage.DEVICE_LOGIN_KEY);
			g_tools['foo'] = foo;
		}
		return foo;
	},
	/**
	 * 登录时加salt加密
	 * @param {String} password
	 * @param {String} salt 服务器返回的
	 * @return {String} 加密后的密码
	 */
	encryptionPassword: function(password, salt) {
		the_passowrd = hex_md5(g_tools.secondPassword(password) + salt).toUpperCase();
		return the_passowrd;
	},
	/**
	 * 二次加密
	 * @param {Object} password
	 * @param {Object} salt
	 */
	secondPassword: function(password) {
		passowrd1 = hex_md5(password).toUpperCase();
		passowrd2 = passowrd1.substr((password.length > 12) ? 12 : password.length, 20);
		return passowrd2;
	},
	/**
	 * 清除缓存
	 */
	clearAllCache: function() {
		plus.storage.clear();
	},
	/**
	 * 上传文件 （头像，身份证）
	 * @param {Object} url modifyUserHeadImg,uploadAuthImg0,uploadAuthImg1,uploadAuthImg2,uploadAuthImg3
	 * @param {Object} filePath 图片等文件路径 如'_www/global/css/mui.css'
	 * @param {Object} func(data) 返回函数 参数返回 'code:0,tip:' 和接口文档一样
	 * @param {Object} timeout 超时时间 默认30 s
	 * @param {Object} eventfun function(upload, status)  upload里面有 state: 任务的状态options: 上传任务的参数responseText: 上传任务完成后服务器返回的数据uploadedSize: 已完成上传数据的大小）totalSize: 上传数据的总大小
	 */
	postFile: function(url, filePath, func, eventfun, timeout) {
		if (!arguments[3]) timeout = 30;
		task = plus.uploader.createUpload(g_tools.IP_FILE + '/' + url, {
			method: 'POST',
			timeout: timeout
		}, function(t, status) {
			if (status == 200) {
				func(JSON.parse(t.responseText));
			} else if (status == 413) {
				res = {}
				res["code"] = -3;
				res["tip"] = this.TIP_PICTURE_BEYOND;
				func(res)
			} else {
				res = {}
				res["code"] = -2;
				res["tip"] = this.TIP_LOCAL_NET_WRONG;
				func(res)
			}
		});
		if (!(/file:\/\/\//.test(filePath))) {
			filePath = 'file:///' + filePath;
		}
		var flag = task.addFile(filePath, {
			key: 'file'
		});
		task.addData('file', filePath);
		foo = g_tools.getFoo();
		task.addData('key', foo);
		task.addEventListener('statechanged', function(upload, status) {
			if (!g_utils.isEmpty(eventfun)) eventfun(upload, status);
		}, false);
		task.start();
	},
	postBlobFile: function(url, blobFile, complete,onprogress) {
		var xhr = new XMLHttpRequest();
		var formdata = new FormData();
		var oloaded;
		var ot;
		formdata.append('file', blobFile);
		formdata.append('key', g_tools.getFoo());
		xhr.open('post', g_tools.IP_FILE + '/' + url, true);
		xhr.upload.onprogress = function(event){
			if(onprogress){
				onprogress(100*event.loaded/event.total);
			}
		};
		xhr.upload.onloadstart = function() { //上传开始执行方法
			ot = new Date().getTime(); //设置上传开始时间
			oloaded = 0; //设置上传开始时，以上传的文件大小为0
		};

		xhr.onreadystatechange = function() {
			if (xhr.readyState == 4 && xhr.status == 200) {
				complete(JSON.parse(xhr.responseText));
			}
		};
		xhr.send(formdata);
	},
	/**
	 * 支付相关 参数请参看api文档 func 为返回回调函数
	 * @param {String} orderName
	 * @param {String} orderDescription
	 * @param {String} paymentTypes
	 * @param {String} servicesPackageId
	 * @param {int} count
	 * @param {int} purchaseType
	 * @param {String} jsonDataStr
	 * @param {function} func
	 * 示例
	 * orderName = '测试';
		orderDescription = '测试';
		paymentTypes = 0;
		servicesPackageId = '53c2693becee301f57d621e6';
		count = 1;
		purchaseType = 0;
		jsonDataStr = '{}';
		huohuoPay(orderName, orderDescription, paymentTypes, servicesPackageId, count, purchaseType, jsonDataStr, function(res){
			console.log(res);
		});
	 */
	huohuoPay: function(orderName, orderDescription, paymentTypes, servicesPackageId, count, purchaseType, jsonDataStr,
		func) {
		this.postCMD('addServicesPackageOrder', {
			orderName: orderName,
			orderDescription: orderDescription,
			paymentTypes: paymentTypes,
			servicesPackageId: servicesPackageId,
			count: count,
			purchaseType: purchaseType,
			jsonDataStr: jsonDataStr,
			goodsType: 1
		}, function(res) {
			if (res.code == 0) {
				data = res.data
				orderId = data.orderId;
				totalPrice = data.orderId;

				whatPay = 'alipay';
				if (paymentTypes == 0) {
					whatPay = 'alipay';
				} else {
					whatPay = 'wxpay';
				}
				////http://127.0.0.1/huohuoPHP/alipay/?subject=111&body=124&subject=23423&out_trade_no=32423&total_amount=0.01
				url = g_tools.IP_NO_PORT + ':9527/huohuoPHP/' + whatPay;
				//				console.log(url);
				mui.ajax(url, {
					data: {
						subject: orderName,
						body: orderDescription,
						out_trade_no: orderId,
						total_amount: totalPrice
					},
					dataType: 'text',
					error: function(xhr, type, errorThrown) {
						console.log("error in get");

						func(type);
					},
					success: function(data, textStatus, xhr) {
						var channel = null;
						plus.payment.getChannels(function(s) {
							channel = s;
							console.log(JSON.stringify(channel));
							plus.payment.request(channel[paymentTypes], data, function(result) {
								//'app_id=2016050401361091&biz_content={"body": "body", "total_amount": "0.01", "subject": "subject", "out_trade_no": "out_trade_no", "product_code": "QUICK_MSECURITY_PAY"}&charset=utf-8&method=alipay.trade.app.pay&notify_url=http://211.149.172.120:8888/payBack&sign_type=RSA&timestamp=2017-02-24 14:12:18&version=1.0&sign=XsrmtrGbYd3sQioKsYJzs5u3jecwuYB6Y5buhITBLrOvF4HqD/YwAcYu5jvhXm6dW9FjOyY8IaobQL0V+ZA+DIYST8JoJ0XAHrW3BasqozG/M52Pb49ioDZOee3nf4I53lLUNxY/SpU5JrNRXKUanQLbhcl58tKUWJ+iVYVMqio'
								//plus.payment.request( channel[1], '{"appid":"wxbd4007fa0fe6f7ca","noncestr":"cm5RMDojfiLKYCAU","package":"Sign=WXPay","partnerid":"1351651101","prepayid":"wx201702231750061c60d741b40377708442","timestamp":1487843361,"sign":"8DE7F31E0A418976CBAEA5E304D70C5F"}', function(result ){
								console.log(JSON.stringify(result));
								func(result);
							}, function(error) {
								console.log(JSON.stringify(error));
							});
						}, function(e) {
							console.log("获取支付通道列表失败：" + e.message);
							func(e);
						});
					},
					timeout: 1000 * 60 * 5,
					type: 'get',
				});
			} else {
				func(res);
			}
		});
	},
	/**
	 * 后台悄悄更新差量包
	 * @param {function} func(data) 函数返回 {code,tip} code=0为正常 code=1为 安装失败 code=-1为下载失败
	 */
	updateH5Secretly: function(func) {
		var url = g_tools.IP_FILE + '/static/update/wgtu.wgtu';
		console.log("升级中...");
		var dtask = plus.downloader.createDownload(url, {
			method: "GET"
		}, function(d, status) {
			if (status == 200) {
				console.log("Download wgtu success: " + d.filename);
				plus.runtime.install(d.filename, {}, function() {
					console.log("Update wgtu success, restart now!");
					func({
						code: 0,
						tip: '安装成功'
					});
				}, function(e) {
					func({
						code: 1,
						tip: '安装失败',
						message: e.message,
						error: e
					});
					console.log("Update wgtu failed: " + e.message);
				});
			} else {
				func({
					code: -1,
					tip: '下载失败'
				});
				console.log("Download wgtu failed: " + status);
			}
		});
		dtask.start();
	},
	/**
	 * 获取应用版本号
	 * @param {function} func(data) 函数返回 String 应用版本号 
	 */
	getVersionOfH5: function(func) {
		plus.runtime.getProperty(plus.runtime.appid, function(data) {
			func(data.version)
		});
	},
	/**
	 * 获取用户的显示名
	 * @param {Object} obj
	 */
	getDisplayName: function(obj) {
		if (!g_utils.isEmpty(obj)) {
			if (obj.isCareEachOther == 1 || obj.isCareEachOther == 2 || obj.isCareEachOther == 3) {
				if (!g_utils.isEmpty(obj.note)) {
					return obj.note;
				}
				if (!g_utils.isEmpty(obj.myCareNote)) {
					return obj.myCareNote;
				}
				if (!g_utils.isEmpty(obj.careMeNote)) {
					return obj.careMeNote;
				}
				if (!g_utils.isEmpty(obj.name)) {
					return obj.name;
				}
				if (!g_utils.isEmpty(obj.nickname)) {
					return obj.nickname;
				}
				if (!g_utils.isEmpty(obj.userName)) { //先统一不显示完整的用户名
					return g_printTools.printPwPhone(obj.userName);
				}
			} else {
				if (!g_utils.isEmpty(obj.nickname)) {
					return obj.nickname;
				}
				if (!g_utils.isEmpty(obj.userName)) { //先统一不显示完整的用户名
					return g_printTools.printPwPhone(obj.userName);
				}
			}
		}
		return '';
	},
	getNickname: function(nickname, userName) {
		if (!g_utils.isEmpty(nickname)) {
			return nickname;
		}
		if (!g_utils.isEmpty(userName)) { //先统一不显示完整的用户名
			return g_printTools.printPwPhone(userName);
		}
		return '';
	}
}
