(function($, window) {

	var template = '<div id="{{id}}" class="mui-slider preview_content preview-hidden"><div class="mui-preview-header">{{header}}</div><div class="mui-slider-group box-size"></div><div class="mui-preview-footer mui-hidden">{{footer}}</div></div>';
	var itemTemplate = '<div class="mui-slider-item" ><div class="mui-zoom-scroller"><img src="{{src}}" data-src="{{dataSrc}}" onload="mui.previewload(this)" class="img-filter" style="{{height}}"/></div></div>';
	var defaultGroupName = '__DEFAULT';
	var div = document.createElement('div');
	var imgId = 0;
	var MuiPreview = function(options, delCallBack, openCallBack, closeCallBack) {
		this.options = $.extend(true, {
			id: '__MUI_PREVIEWIMAGE',
			header: '<span class="mui-preview-indicator"></span>',
			footer: '',
			delImg: false,
			delHeader: '<div class="mui-preview-indicator"></div><div class="mui-preview-del"></div>',
		}, options || {});
		this.init();
		this.initEvent();
		this.delCallBack = delCallBack;
		this.openCallBack = openCallBack;
		this.closeCallBack = closeCallBack;
	};
	var proto = MuiPreview.prototype;

	proto.init = function() {
		var options = this.options;
		if(options.delImg) {
			this.dispose();
		}
		var el = document.getElementById(this.options.id);
		if(!el) {
			if(!options.delImg) {
				div.innerHTML = template.replace(/\{\{id\}\}/g, this.options.id).replace('{{header}}', options.header).replace('{{footer}}', options.footer);
			} else {
				div.innerHTML = template.replace(/\{\{id\}\}/g, this.options.id).replace('{{header}}', options.delHeader).replace('{{footer}}', options.footer);
			}

			document.body.appendChild(div.firstElementChild);
			el = document.getElementById(this.options.id);
		}

		this.element = el;
		this.scroller = this.element.querySelector($.classSelector('.slider-group'));
		this.indicator = this.element.querySelector($.classSelector('.preview-indicator'));
		if(options.delImg) {
			this.delImgor = this.element.querySelector($.classSelector('.preview-del'));
		}
		if(options.footer) {
			this.element.querySelector($.classSelector('.preview-footer')).classList.remove($.className('hidden'));
		}
		this.addImages();
	};
	proto.initEvent = function() {
		var self = this;
		var options = this.options;
		if(options.delImg) {
			$(document.body).off('tap', 'img[data-preview-src]');
		}
		$(document.body).on('tap', 'img[data-preview-src]', function() {
			self.open(this);
			return false;
		});
		var laterClose = null;
		var laterCloseEvent = function() {
			!laterClose && (laterClose = $.later(function() {
				//self.scroller.removeEventListener('tap', laterCloseEvent);
				laterClose = null;
				self.close();
			}, 300));
		};
		this.scroller.addEventListener('doubletap', function() {
			if(laterClose) {
				laterClose.cancel();
				laterClose = null;
			}
		});
		self.scroller.addEventListener('tap',laterCloseEvent);
		if(options.delImg) {
			this.delImgor.addEventListener('tap', function() {
				var currentImg = self.currentGroup[self.lastIndex].el;
				var groupNum = self.currentGroup[self.lastIndex].groupNum;
				//删除外层img元素
				currentImg.parentNode.removeChild(currentImg);
				var beforeCurr = self.lastIndex + 1; //删除前在group位置
				var beforeCurrentGroupLength = self.currentGroup.length; //删除前group长度

				if(beforeCurrentGroupLength == 1) { //如果只有一个
					laterCloseEvent();
				} else {
					self.currentGroup.splice(self.lastIndex, 1);
					if(beforeCurr == beforeCurrentGroupLength) { //如果删除的时最后一张,跳到上一张
						var currentIndex = self.lastIndex - 1;
						self.refresh(currentIndex, self.currentGroup);
					} else { //跳到下一张
						var currentIndex = self.lastIndex;
						self.refresh(currentIndex, self.currentGroup);
					}
				}
				self.delCallBack && self.delCallBack(currentImg,groupNum);
			});
		}

		this.element.addEventListener('slide', function(e) {
			if(self.options.zoom && self.lastIndex) {
				var lastZoomerEl = self.element.querySelector('.mui-zoom-wrapper:nth-child(' + (self.lastIndex + 1) + ')');
				if(lastZoomerEl) {
					$(lastZoomerEl).zoom().setZoom(1);
				}
			}
			if(self.currentGroup) {
				var slideNumber = e.detail.slideNumber;
				self.lastIndex = slideNumber;
				self.indicator && (self.indicator.innerText = (slideNumber + 1) + '/' + self.currentGroup.length);
				self._loadItem(slideNumber);
			}
		});
	};
	proto.addImages = function(group, index) {
		this.groups = {};
		var imgs = [];

		if(group) {
			if(group === defaultGroupName) {
				imgs = document.querySelectorAll("img[data-preview-src]:not([data-preview-group])");
			} else {
				imgs = document.querySelectorAll("img[data-preview-src][data-preview-group='" + group + "']");
			}
		} else {
			imgs = document.querySelectorAll("img[data-preview-src]");
		}
		if(imgs.length) {
			for(var i = 0, len = imgs.length; i < len; i++) {
				this.addImage(imgs[i]);
			}
		}
	};
	proto.addImage = function(img) {
		var group = img.getAttribute('data-preview-group');
		group = group || defaultGroupName;
		if(!this.groups[group]) {
			this.groups[group] = [];
		}
		var src = img.getAttribute('src');
		if(img.__mui_img_data && img.__mui_img_data.src === src) { //已缓存且图片未变化
			this.groups[group].push(img.__mui_img_data);
		} else {
			var dataSrc = img.getAttribute('data-preview-src');
			var imgObj = {
				src: src,
				dataSrc: dataSrc,
				el: img,
				groupNum: group
			};
			this.groups[group].push(imgObj);
			img.__mui_img_data = imgObj;
		}
	};

	proto.deteleImg = function() {
		this.currentGroup[this.lastIndex]
	}

	proto.empty = function() {
		this.scroller.innerHTML = '';
	};
	proto._loadItem = function(index, isOpening) { //TODO 暂时仅支持img
		var itemEl = this.scroller.querySelector($.classSelector('.slider-item:nth-child(' + (index + 1) + ')'));
		var itemData = this.currentGroup[index];
		var imgEl = itemEl.querySelector('img');
		this._preloadItem(index + 1);
		this._preloadItem(index - 1);
	};
	proto._preloadItem = function(index) {
		var itemEl = this.scroller.querySelector($.classSelector('.slider-item:nth-child(' + (index + 1) + ')'));
		if(itemEl) {
			var itemData = this.currentGroup[index];
			var imgEl = itemEl.querySelector('img');
		}
	};
	proto.getRangeByIndex = function(index, length) {
		return {
			from: 0,
			to: length - 1
		};
	};

	proto.refresh = function(index, groupArray) {
		this.currentGroup = groupArray;
		//重新生成slider
		var length = groupArray.length;
		var itemHtml = [];
		var currentRange = this.getRangeByIndex(index, length);
		var from = currentRange.from;
		var to = currentRange.to + 1;
		var currentIndex = index;
		var className = '';
		var wHeight =  document.documentElement.clientHeight - 44 + 'px'
		var wWidth = document.documentElement.clientWidth + 'px'
		var wHeightStr = "height:" + wHeight + ";wWidth:" + wWidth + ";" 
		for(var i = 0; from < to; from++, i++) {
			var itemData = groupArray[from];
			itemStr = itemTemplate.replace('{{src}}', itemData.src).replace("{{dataSrc}}", itemData.dataSrc).replace("{{height}}", wHeightStr);
			if(from === index) {
				currentIndex = i;
				className = $.className('active');
			} else {
				className = '';
			}
			itemHtml.push(itemStr.replace('{{className}}', className));
		}
		this.scroller.innerHTML = itemHtml.join('');
		this.lastIndex = currentIndex;
		this.element.offsetHeight;
		$(this.element).slider().gotoItem(currentIndex, 0);
		this.indicator && (this.indicator.innerText = (currentIndex + 1) + '/' + this.currentGroup.length);
		this._loadItem(currentIndex, true);
	};
	proto.openByGroup = function(index, group) {
		index = Math.min(Math.max(0, index), this.groups[group].length - 1);
		this.refresh(index, this.groups[group]);
	};
	proto.open = function(index, group) {
		this.openCallBack && this.openCallBack();
		if(this.isShown()) {
			return;
		}
		this.element.classList.remove("preview-hidden");
		if(typeof index === "number") {
			group = group || defaultGroupName;
			this.addImages(group, index); //刷新当前group
			this.openByGroup(index, group);
		} else {
			group = index.getAttribute('data-preview-group');
			group = group || defaultGroupName;
			this.addImages(group, index); //刷新当前group
			this.openByGroup(this.groups[group].indexOf(index.__mui_img_data), group);
		}	
		
	};
	proto.close = function(index, group) {	
		if(!this.isShown()) {
			return;
		}
		this.element.classList.add("preview-hidden");
		this.closeCallBack && this.closeCallBack();
		$(this.element).slider().destroy();
		//		this.empty();
	};

	//释放当前对象及清除DOM  
	proto.dispose = function() {
		var prevdom = document.getElementById("__MUI_PREVIEWIMAGE");
		prevdom && prevdom.parentNode.removeChild(prevdom);
		previewImageApi = null;
	};
	proto.isShown = function() {
		return !this.element.classList.contains('preview-hidden');
	};

	var previewImageApi = null;
	$.muiPreview = function(options, delCallBack, openCallBack, closeCallBack) {
		if(!previewImageApi) {
			previewImageApi = new MuiPreview(options, delCallBack, openCallBack, closeCallBack);
		}
		return previewImageApi;
	};
	$.getPreviewImage = function() {
		return previewImageApi;
	};
	$.previewload = function(obj) {
		obj.classList.remove("img-filter");
		load(obj);
	};
})(mui, window);