(function($) {
	var defaultElment = '<div class="progress_content"><canvas class="progress_icon" id="progress_canvas" width="100" height="100"></canvas><div class="progress_text"></div></div>'
	var ctx, el;
	var Progress = function() {
		this.init();
	}
	var proto = Progress.prototype;
	proto.init = function() {
		var div = document.createElement('div');
		div.classList.add("progress_bg", "mui-hidden");
		div.innerHTML = defaultElment;
		document.body.appendChild(div);
		el = div;
		var c = document.getElementById("progress_canvas");
		ctx = c.getContext("2d");
		div.addEventListener("tap", function() {}, true);
		this.isShow = false;
	}
	proto.setProgress = function(rate) {
		this.cleanCanvas();
		if (!this.isShow) {
			this.isShow = true;
			el.classList.remove("mui-hidden");
		}
		el.querySelector(".progress_text").innerHTML = "正在上传图片";
		ctx.beginPath();
		ctx.strokeStyle = "#F89D48";
		ctx.lineWidth = 10;
		ctx.arc(50, 50, 45, 0, 2 * Math.PI);
		ctx.stroke();
		ctx.beginPath();
		ctx.strokeStyle = "#F89D48";
		ctx.lineWidth = 40;
		var range = rate * 0.02 - 0.5
		ctx.arc(50, 50, 20, -0.5 * Math.PI, range * Math.PI);
		ctx.stroke();
	}
	proto.finish = function(text) {
		this.setImage("../../global/plugins/progress/progress_finish.png",text);
	}
	proto.unable = function(text) {
		this.setImage("../../global/plugins/progress/progress_unable.png",text);
	}
	proto.fail = function(text) {
		this.setImage("../../global/plugins/progress/progress_unable.png",text);
	}
	proto.cleanCanvas = function() {
		ctx.clearRect(0, 0, 100, 100);
	}
	proto.close = function() {
		this.isShow = false;
		el.classList.add("mui-hidden");
	}
	proto.setImage = function(url,text) {
		var self = this;
		self.cleanCanvas();
		if (!this.isShow) {
			this.isShow = true;
			el.classList.remove("mui-hidden");
		}
		el.querySelector(".progress_text").innerHTML = text;
		var imgIcon = new Image();
		imgIcon.src = url;
		imgIcon.onload = function() {
			ctx.drawImage(imgIcon, 0, 0, 100, 100)
		}
		setTimeout(function() {
			self.close();
		}, 1000)
	}
	var progressApi = null;
	$.initProgress = function() {
		if (!progressApi) {
			progressApi = new Progress();
		}
		return progressApi;
	}
})(window)
