var _selectStr = '无';
var _checkBoxItemList = [];
var _typeName = '';
var _flag = false; //记录有无

mui.init();
mui.plusReady(function() {

	getParam();
	initCheckBoxItemAndTitleWithType(_typeName);

	//将传入参数转化为默认选择的数组
	var defultSelectArray = createDefultSelectArray(_selectStr);

	//根据默认选择的数组初始化顶部‘有无’选择,以及按下的触发事件
	initTopSelectAndEvent(_flag);

	if(_typeName == 'drugAllergy' || _typeName == 'anamnesis') {
		//根据typeName 初始化多选的提示文字
		initGroupTitle(_typeName);
		//根据默认选择的数组添加下方多选区域
		addSelectArea('selectArea', defultSelectArray, _typeName);
	}

	initCommitBtn('commitBtn');
});

function getParam() {
	var self = plus.webview.currentWebview();
	if(!g_utils.isEmpty(self)) {
		if(!g_utils.isEmpty(self.selectedValue)) {
			if (self.selectedValue != '未设置'){
				_selectStr = self.selectedValue;
			}
		}
		if(!g_utils.isEmpty(self.typeName)) {
			_typeName = self.typeName;
		}
	}
}

function initCheckBoxItemAndTitleWithType(typeName) {
	var titleDom = document.getElementById('title');
	if(typeName == 'drugAllergy') { //药物过敏史
		titleDom.innerHTML = drugAllergyData.title;
		for(var i = 0; i < drugAllergyData.data.length; i++) {
			var item = drugAllergyData.data[i];
			_checkBoxItemList.push(drugAllergyData.data[i].name);
		}
		_checkBoxItemList.push('其他');
	} else if(typeName == 'anamnesis') { //既往病史
		titleDom.innerHTML = anamnesisData.title;
		for(var i = 0; i < anamnesisData.data.length; i++) {
			var item = anamnesisData.data[i];
			_checkBoxItemList.push(anamnesisData.data[i].name);
		}
		_checkBoxItemList.push('其他');
	} else {
        titleDom.innerHTML = heredopathiaData.title;
	}
}

function createDefultSelectArray(selectStr) {
	var resultArray = [];
	if(selectStr != '无') {
		_flag = true;
		var tempArray = selectStr.split("、");
		for(var i = 0; i < _checkBoxItemList.length; i++) {
			var tempInt = 0;
			for(var j = 0; j < tempArray.length; j++) {
				if(_checkBoxItemList[i] == tempArray[j]) {
					tempInt = 1;
					selectStr = selectStr.replace(tempArray[j], '')
				}
			}
			if(i < _checkBoxItemList.length - 1) {
				resultArray.push(tempInt);
			}
			selectStr = selectStr.replace('、', '');
		}
		//处理是否有‘其他’信息
		if(!g_utils.isEmpty(selectStr)) {
			resultArray.push(selectStr);
		} else {
			resultArray.push('empty');
		}
	} else {
		for(var i = 0; i < _checkBoxItemList.length - 1; i++) {
			resultArray.push(0);
		}
		resultArray.push('empty');
	}
	return resultArray;
}

function initTopSelectAndEvent(flag) {
	if(flag) {
		var radioDom = document.getElementById('radioSelect1');
		radioDom.checked = true;

		if(_typeName == 'heredopathia') {
			var inputTopDom = document.getElementById('otherInputTop');
			var underLineTopDom = document.getElementById('otherInputUnderlineTop');
			inputTopDom.style.display = 'block';
			inputTopDom.value=_selectStr;
			underLineTopDom.style.display = 'block';
		}
	} else {
		var radioDom = document.getElementById('radioSelect0');
		radioDom.checked = true;
	}

	mui("#topSelect").on("change", "input", function() {
		var groupTitleDom = document.getElementById('groupTitle');
		var rootDom = document.getElementById('selectArea');
		var inputTopDom = document.getElementById('otherInputTop');
		var underLineTopDom = document.getElementById('otherInputUnderlineTop');

		if(this.id == "radioSelect0" && this.checked) { //选择无
			groupTitleDom.style.display = 'none';
			rootDom.style.display = 'none';
			inputTopDom.style.display = 'none';
			underLineTopDom.style.display = 'none';
			_flag = false;
		} else if(this.id == "radioSelect1" && this.checked) { //选择有
			groupTitleDom.style.display = 'block';
			rootDom.style.display = 'block';
			if(_typeName == 'heredopathia') {
				inputTopDom.style.display = 'block';
				underLineTopDom.style.display = 'block';
				groupTitleDom.style.display = 'none';
				rootDom.style.display = 'none';
			}
			_flag = true;
		}
	}, false);

}

function initGroupTitle(typeName) {
	var groupTitleDom = document.getElementById('groupTitle');
	groupTitleDom.innerHTML = findGroupTitleWithTypeName(typeName);
	if(_flag) {
		groupTitleDom.style.display = 'block';
	} else {
		groupTitleDom.style.display = 'none';
	}

}
/*
 *  添加多选模块
 *  param 哪个元素dom下添加分页，则传入此dom.id
 *        记录默认选择项的二维数组
 */
function addSelectArea(domId, defultSelectArray, typeName) {

	var rootDom = document.getElementById(domId);
	if(_flag) {
		rootDom.style.display = 'block';
	} else {
		rootDom.style.display = 'none';
	}

	//添加顶部灰色横线
	var topLineDom = document.createElement('div');
	topLineDom.className = 'top-line';
	rootDom.appendChild(topLineDom);

	//根据全局变量_checkBoxItemList（每个多选项的名字数组），绘制每个多选cell
	for(var i = 0; i < _checkBoxItemList.length; i++) {
		var cellDom = document.createElement('div');
		cellDom.className = 'mui-input-row mui-checkbox mui-left';
		rootDom.appendChild(cellDom);

		var cellTitleDom = document.createElement('label');
		cellTitleDom.innerHTML = _checkBoxItemList[i];
		cellDom.appendChild(cellTitleDom);

		var cellSelectDom = document.createElement('input');
		cellSelectDom.className = 'select-health-item';
		cellSelectDom.setAttribute('name', 'checkbox');
		cellSelectDom.setAttribute('value', i);
		cellSelectDom.setAttribute('type', 'checkbox');
		cellDom.appendChild(cellSelectDom);
		if(defultSelectArray[i] == 1) {
			cellSelectDom.checked = true;
		}

		//如果是绘制最后一个多选项：其他，则添加输入框以及输入框的下划线
		if(i == _checkBoxItemList.length - 1) {
			var inputDom = document.createElement('input');
			inputDom.className = 'other-input';
			inputDom.id = 'otherIput';
			inputDom.setAttribute('type', 'text');
			inputDom.setAttribute('maxlength', '50');
			inputDom.setAttribute('placeholder', findPlaceholderWithTypeName(typeName));
			inputDom.style.display = 'none';
			inputDom.style.zIndex = 999;
			cellDom.appendChild(inputDom);

			var lineDom = document.createElement('div');
			lineDom.id = 'inputLine';
			lineDom.className = 'other-input-underline';
			lineDom.style.display = 'none';
			lineDom.style.zIndex = 1999;
			cellDom.appendChild(lineDom);

			if(defultSelectArray[i] != 'empty') {
				cellSelectDom.checked = true;
				inputDom.value = defultSelectArray[i];
				inputDom.style.display = 'block';
				lineDom.style.display = 'block';
			}

			cellSelectDom.addEventListener('tap', function(e) {
				if(!this.checked) {
					var inputOthersDom = findInputDomWithBrothersDom(this);
					inputOthersDom.style.display = 'block';
					var inputUnderLineDom = findInputUnderLineDomWithBrothersDom(this);
					inputUnderLineDom.style.display = 'block';
				} else {
					var inputOthersDom = findInputDomWithBrothersDom(this);
					inputOthersDom.style.display = 'none';
					var inputUnderLineDom = findInputUnderLineDomWithBrothersDom(this);
					inputUnderLineDom.style.display = 'none';
				}
			});
		}
	}

}

//------------------------点击事件相关构造方法-------------------------
/*
 * 为右上角保存按钮添加点击事件
 * param dom.id
 */
function initCommitBtn(btnDomId) {

	var btnDom = document.getElementById(btnDomId);

	btnDom.addEventListener('tap', function(e) {
		var resultStr = '无';
		if(_flag) {
			resultStr='';
			if(_typeName == 'drugAllergy' || _typeName == 'anamnesis') {
				//遍历checkbox
				var selectDomList = document.querySelectorAll('.select-health-item');
				for(var i = 0; i < selectDomList.length; i++) {

					var index = selectDomList[i].getAttribute('value');

					if(index < _checkBoxItemList.length - 1) { //除开‘其他’选项
						if(selectDomList[i].checked) {
							resultStr += _checkBoxItemList[index] + "、";
						}
					} else if(index == _checkBoxItemList.length - 1) { //判断是否选中‘其他’这个选项
						if(selectDomList[i].checked) {
							var inputDom = findInputDomWithBrothersDom(selectDomList[i]);
							resultStr += inputDom.value;
						}
					}
				}
			} else {
				var selectDom = document.getElementById('radioSelect1');
				var inputDom = findInputDomWithBrothersDom(selectDom);
				resultStr += inputDom.value;
			}
		}

		//如果最后一位是顿号，则去掉
		var reg = /、$/gi;
		resultStr = resultStr.replace(reg, "");

		if(g_utils.isEmpty(resultStr)) {
			g_mui.alert("请选择或填写一个类型，不能为空！");
		} else {
			//获取之前的webview并返回
			var openerView = plus.webview.currentWebview().opener();
			if(_typeName == "drugAllergy") {
				mui.fire(openerView, 'setDrugAllergy', {
					value: resultStr
				});		
			} else if(_typeName == "anamnesis") {
				mui.fire(openerView, 'setAnamnesis', {
					value: resultStr
				});	
			} else if(_typeName == "heredopathia") {
				mui.fire(openerView, 'setHeredopathia', {
					value: resultStr
				});	
			}
			mui.back();
		}

	})
}

//------------------------end 点击事件相关构造方法-------------------------

function findGroupTitleWithTypeName(typeName) {
	if(typeName == 'drugAllergy') { //药物过敏史
		return '请选择用户过敏药物类型：（可多选）';
	} else if(typeName == 'anamnesis') { //既往病史
		return '请选择用户既往疾病类型：（可多选）';
	} else {
		return '';
	}
}

function findPlaceholderWithTypeName(typeName) {
	if(typeName == 'drugAllergy') { //药物过敏史
		return '请输入过敏药物类型';
	} else if(typeName == 'anamnesis') { //既往病史
		return '请输入病史类型';
	} else {
		return '请输入遗传病类型';
	}
}

function findInputDomWithBrothersDom(brothersDom) {
	var brothersDomList = brothersDom.parentNode.childNodes;
	for(var i = 0; i < brothersDomList.length; i++) {
		if(brothersDomList[i].className == 'other-input') {
			return brothersDomList[i]
		}
	}
	return null;
}

function findInputDomWithChildDom(childDom) {
	var childDomList = childDom.parentNode.childNodes;
	for(var i = 0; i < brothersDomList.length; i++) {
		if(childDomList[i].className == 'other-input') {
			return childDomList[i]
		}
	}
	return null;
}

function findInputUnderLineDomWithBrothersDom(brothersDom) {
	var brothersDomList = brothersDom.parentNode.childNodes;
	for(var i = 0; i < brothersDomList.length; i++) {
		if(brothersDomList[i].className == 'other-input-underline') {
			return brothersDomList[i];
		}
	}
	return null;
}
