/*
 * 依赖关系：checkbox 与 input、下划线dom 必须为兄弟级dom，影响function:findInputDomWithBrothersDom 、 findInputUnderLineDomWithBrothersDom
 */
var _checkBoxItemList = ['高血压', '糖尿病', '冠心病', '慢性阻塞性肺疾病', '恶性肿瘤', '脑卒中', '重性精神病', '其他'];
var _tabList = ['父亲', '母亲', '兄弟姐妹', '子女'];
var _medicalHistoryStr = '';
//***
//mui.ready(function() {
//	initTopSelect();
//	initSelectPageShowArea('showArea');
//
//	var defultSelectArray = createDefultSelectArray(_medicalHistoryStr);
//
//	addSelectPage('selectArea', defultSelectArray);
//	initCommitBtn('commitBtn');
//});
//----
mui.init();
mui.plusReady(function() {

	getParam();

	initTopSelect();
	initSelectPageShowArea('showArea');

	var defultSelectArray = createDefultSelectArray(_medicalHistoryStr);
	addSelectPage('selectArea', defultSelectArray);

	initCommitBtn('commitBtn');
});

function getParam() {
	var self = plus.webview.currentWebview();
	if(!g_utils.isEmpty(self)) {
		if(!g_utils.isEmpty(self.selectedValue)) {
			if (self.selectedValue != '未设置'){
                _medicalHistoryStr = self.selectedValue;
            }	
		}
	}
}

function createDefultSelectArray(selectStr) {
	var roleSelectList = selectStr.split("；");
	var defultSelectArray = [];

	for(var i = 0; i < _tabList.length; i++) {
		var containFlag = false; //是否包含关键字符串的标志变量

		for(var j = 0; j < roleSelectList.length; j++) {
			if(roleSelectList[j].indexOf(_tabList[i]) > -1) {
				containFlag = true;
				var tempStr = roleSelectList[j].replace(_tabList[i] + '：', '');
				var tempArray = tempStr.split('、');
				var pushArray = [];

				for(var k = 0; k < _checkBoxItemList.length; k++) {
					var tempInt = 0;
					for(var l = 0; l < tempArray.length; l++) {
						if(_checkBoxItemList[k] == tempArray[l]) {
							tempInt = 1;
							tempStr = tempStr.replace(tempArray[l], '')
						}
					}
					if(k < _checkBoxItemList.length - 1) {
						pushArray.push(tempInt);
					}
					tempStr = tempStr.replace('、', '');
				}
				//处理是否有‘其他’信息
				if(!g_utils.isEmpty(tempStr)) {
					pushArray.push(tempStr);
				} else {
					pushArray.push('empty');
				}

				defultSelectArray.push(pushArray);
			}
		}

		if(!containFlag) {
			defultSelectArray.push('empty');
		}
	}

	return defultSelectArray;
}
//-------------------------界面构造方法---------------------------
/*
 *  初始化分页的显示区域
 *  param 传入显示区域dom.id，显示区域为分页的父元素，用来隐藏多余的滚动区域
 */
function initSelectPageShowArea(domId) {
	var dom = document.getElementById(domId);
	dom.style.width = window.innerWidth + 'px';
	dom.style.height = 0.55 * _checkBoxItemList.length + 'rem';
	//dom.style.height = (window.innerHeight - dom.offsetTop) + 'px';
}

/*
 *  添加分页选择模块
 *  param 哪个元素dom下添加分页，则传入此dom.id
 *        记录默认选择项的二维数组
 */
function addSelectPage(domId, defultSelectArray) {

	var rootDom = document.getElementById(domId);
	rootDom.style.width = window.innerWidth * 4 + 'px';

	for(var i = 0; i < _tabList.length; i++) {

		//添加每个分页里table顶部灰色横线
		var topLineDom = document.createElement('div');
		topLineDom.className = 'top-line';
		topLineDom.style.left = window.innerWidth * i + 'px';
		topLineDom.style.width = window.innerWidth + 'px';
		rootDom.appendChild(topLineDom);

		//添加每个分页
		var pageDom = document.createElement('form');
		pageDom.classList.add('mui-input-group');
		pageDom.style.left = window.innerWidth * i + 'px';
		pageDom.style.top = '2px';
		rootDom.appendChild(pageDom);

		//根据全局变量_checkBoxItemList（每个多选项的名字数组），绘制每个多选cell
		for(var j = 0; j < _checkBoxItemList.length; j++) {
			var cellDom = document.createElement('div');
			cellDom.className = 'mui-input-row mui-checkbox mui-left';
			pageDom.appendChild(cellDom);

			var cellTitleDom = document.createElement('label');
			cellTitleDom.innerHTML = _checkBoxItemList[j];
			cellDom.appendChild(cellTitleDom);

			var cellSelectDom = document.createElement('input');
			cellSelectDom.className = 'select-health-item';
			cellSelectDom.setAttribute('group', i);
			cellSelectDom.setAttribute('name', 'checkbox');
			cellSelectDom.setAttribute('value', j);
			cellSelectDom.setAttribute('type', 'checkbox');
			cellDom.appendChild(cellSelectDom);
			if(defultSelectArray[i] != 'empty') {
				if(defultSelectArray[i][j] == 1) {
					cellSelectDom.checked = true;
				}
			}

			//如果是绘制最后一个多选项：其他，则添加输入框以及输入框的下划线
			if(j == _checkBoxItemList.length - 1) {
				var inputDom = document.createElement('input');
				inputDom.className = 'other-input';
				inputDom.id = 'otherIput' + i;
				inputDom.setAttribute('group', i);
				inputDom.setAttribute('type', 'text');
				inputDom.setAttribute('maxlength', '50');
				inputDom.setAttribute('placeholder', '请输入病史类型');
				inputDom.style.display = 'none';
				inputDom.style.zIndex = 999;
				cellDom.appendChild(inputDom);

				var lineDom = document.createElement('div');
				lineDom.id = 'inputLine' + i;
				lineDom.className = 'other-input-underline';
				lineDom.style.display = 'none';
				lineDom.style.zIndex = 1999;
				cellDom.appendChild(lineDom);

				if(defultSelectArray[i] != 'empty') {
					if(defultSelectArray[i][j] != 'empty') {
						cellSelectDom.checked = true;
						inputDom.value = defultSelectArray[i][j];
						inputDom.style.display = 'block';
						lineDom.style.display = 'block';
					}
				}

				cellSelectDom.addEventListener('tap', function(e) {
					if(!this.checked) {
						var inputOthersDom = findInputDomWithBrothersDom(this);
						inputOthersDom.style.display = 'block';
						var inputUnderLineDom = findInputUnderLineDomWithBrothersDom(this);
						inputUnderLineDom.style.display = 'block';
					} else {
						var inputOthersDom = findInputDomWithBrothersDom(this);
						inputOthersDom.style.display = 'none';
						var inputUnderLineDom = findInputUnderLineDomWithBrothersDom(this);
						inputUnderLineDom.style.display = 'none';
					}
				});
			}
		}

	}
}
//-------------------------end 界面构造方法---------------------------

//------------------------点击事件相关构造方法-------------------------
/*
 * 为右上角保存按钮添加点击事件
 * param dom.id
 */
function initCommitBtn(btnDomId) {

	var btnDom = document.getElementById(btnDomId);

	btnDom.addEventListener('tap', function(e) {
		var fatherStr = '父亲：';
		var matherStr = '母亲：';
		var brothersStr = '兄弟姐妹：';
		var sunStr = '子女：';

		//遍历checkbox
		var selectDomList = document.querySelectorAll('.select-health-item');
		for(var i = 0; i < selectDomList.length; i++) {

			var index = selectDomList[i].getAttribute('value');

			if(index < _checkBoxItemList.length - 1) { //除开‘其他’选项
				if(selectDomList[i].getAttribute('group') == 0 && selectDomList[i].checked) {
					fatherStr += _checkBoxItemList[index] + "、";
				} else if(selectDomList[i].getAttribute('group') == 1 && selectDomList[i].checked) {
					matherStr += _checkBoxItemList[index] + "、";
				} else if(selectDomList[i].getAttribute('group') == 2 && selectDomList[i].checked) {
					brothersStr += _checkBoxItemList[index] + "、";
				} else if(selectDomList[i].getAttribute('group') == 3 && selectDomList[i].checked) {
					sunStr += _checkBoxItemList[index] + "、";
				}
			} 
			else if(index == _checkBoxItemList.length - 1) { //判断是否选中‘其他’这个选项
				if(selectDomList[i].getAttribute('group') == 0 && selectDomList[i].checked) {
					var inputDom = findInputDomWithBrothersDom(selectDomList[i]);
					fatherStr += inputDom.value;
				} else if(selectDomList[i].getAttribute('group') == 1 && selectDomList[i].checked) {
					var inputDom = findInputDomWithBrothersDom(selectDomList[i]);
					matherStr += inputDom.value;
				} else if(selectDomList[i].getAttribute('group') == 2 && selectDomList[i].checked) {
					var inputDom = findInputDomWithBrothersDom(selectDomList[i]);
					brothersStr += inputDom.value;
				} else if(selectDomList[i].getAttribute('group') == 3 && selectDomList[i].checked) {
					var inputDom = findInputDomWithBrothersDom(selectDomList[i]);
					sunStr += inputDom.value;
				}
			}

		}

		//如果最后一位是顿号，则去掉
		var reg = /、$/gi;
		fatherStr = fatherStr.replace(reg, "");
		matherStr = matherStr.replace(reg, "");
		brothersStr = brothersStr.replace(reg, "");
		sunStr = sunStr.replace(reg, "");

		var result = "";
		if(fatherStr != '父亲：') {
			result = result + fatherStr + "；";
		}
		if(matherStr != '母亲：') {
			result = result + matherStr + "；";
		}
		if(brothersStr != '兄弟姐妹：') {
			result = result + brothersStr + "；";
		}
		if(sunStr != '子女：') {
			result = result + sunStr + "；";
		}

		//如果最后一位是分号，则去掉
		var reg = /；$/gi;
		result = result.replace(reg, "");

		if(g_utils.isEmpty(result)) {
			g_mui.alert("请选择或填写一个类型，不能为空！");
		} else {
			//获取之前的webview并返回
			var openerView = plus.webview.currentWebview().opener();
			mui.fire(openerView, 'setFamilyHistory', {
				value: result
			});
            mui.back();
		}
		
	})
}

/*
 * 为右上角保存按钮添加点击事件
 * param 无
 * note  实现方法为查找顶部4个tab的id，并添加tap event
 */
function initTopSelect() {
	for(var i = 0; i < 4; i++) {
		var dom = document.getElementById('select' + i);
		dom.addEventListener('tap', function(e) {
			moveFlag(e.target.getAttribute('value'));
			movePage(e.target.getAttribute('value'));
		});
	}
}

/*
 * 移动顶部tab下方的标志下划线
 * param 选择的第几个tab  int
 */
function moveFlag(select) {
	var flagDom = document.getElementById('selectFlag');
	flagDom.style.left = select * flagDom.offsetWidth + 'px';
}

/*
 * 下方多选部分翻页
 * param 选择的第几个tab  int
 */
function movePage(select) {
	var rootDom = document.getElementById('selectArea');
	rootDom.style.left = -select * window.innerWidth + 'px';
}
//------------------------end 点击事件相关构造方法-------------------------

function findInputDomWithBrothersDom(brothersDom) {
	var brothersDomList = brothersDom.parentNode.childNodes;
	for(var i = 0; i < brothersDomList.length; i++) {
		if(brothersDomList[i].className == 'other-input') {
			return brothersDomList[i]
		}
	}
	return null;
}

function findInputUnderLineDomWithBrothersDom(brothersDom) {
	var brothersDomList = brothersDom.parentNode.childNodes;
	for(var i = 0; i < brothersDomList.length; i++) {
		if(brothersDomList[i].className == 'other-input-underline') {
			return brothersDomList[i];
		}
	}
	return null;
}
