//传入值存储
var selectedContacts = []; //已选择过的联系人列表
var accountContacts = []; //待整合的联系人列表
var preWebViewId = ''; //之前的webViewId,需要返回值则必须传入
var circleMembersPhone = [];

//中间分类存储
var localContacts = []; //存储本机联系人
var emergencyContacts = []; //紧急联系人
var normalContacts = []; //普通联系人

var allPhoneContacts = [];
var hearderTitle=''; //html标题
var isSingleMode=false;  //是否是单选模式
var isContentSelf=true;  //本地通讯录中是否允许包含自己账号的号码

//界面显示相关
var contactListLay = document.getElementById('contactListLay'); //联系人列表（html内容的字符串）
var exportBtn = document.getElementById('export'); //导入按钮
var chooseBtn = document.getElementById('choose'); //全选按钮
var phoneId = 0; //最后显示的通讯录名单编号

//右侧字母导航栏显示内容
var word = ["★", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "#"];

//mui初始化
mui.init();
mui.plusReady(function() {

	var header = document.querySelector('header.mui-bar');
	var list = document.getElementById('list');
	//calc hieght
	list.style.height = (document.body.offsetHeight - header.offsetHeight - exportBtn.offsetHeight) + 'px';

	getParam(); //获得上个页面传入的参数
	
	document.getElementById('title').innerText = hearderTitle; //设置html标题
	getEmergencyNormalContacts(accountContacts); //遍历出紧急联系人与普通联系人
	if(isSingleMode) document.getElementById('fix-bottom-btn').classList.add('single-mode');  //单选模式时，隐藏“全选”按钮
	initCharacterList(); //根据紧急联系人的数量绘制右侧字母导航

	onInitExportBtn();
	onInitChooseBtn();
    if (plus.os.name == g_config.ANDROID){
        initPremission();
        setPermission("0")
    }else{
        getLocalContactsAndShow();
    }
});
function initPremission() {
	var _BARCODE = "permissionUtil",
		B = window.plus.bridge;
	var permissionUtil = {
		setPermission: function(Argus, successCallback, errorCallback) {
			var success = typeof successCallback !== 'function' ? null : function(args) {
					successCallback(args);
				},
				fail = typeof errorCallback !== 'function' ? null : function(code) {
					errorCallback(code);
				};
			callbackID_2 = B.callbackId(success, fail);
			return B.exec(_BARCODE, "setPermission", [callbackID_2, Argus]);
		}
	};
	window.plus.permissionUtil = permissionUtil;
}

function setPermission(type) {
	plus.permissionUtil.setPermission(type, function(result) {
		if(result.ps) {
			getLocalContactsAndShow();
		}
	});
}
/**
 * 获得上个页面传入的参数
 */
function getParam() {
	var self = plus.webview.currentWebview();
	if(!g_utils.isEmpty(self)) {
		if(!g_utils.isEmpty(self.preWebViewId)) {
			preWebViewId = self.preWebViewId;
		}
		if(!g_utils.isEmpty(self.selectedContacts)) {
			selectedContacts = self.selectedContacts;
		}
		if(!g_utils.isEmpty(self.accountContacts)) {
			accountContacts = self.accountContacts;
		}
		if(!g_utils.isEmpty(self.hearderTitle)) {
			hearderTitle = self.hearderTitle;
		}
		if(!g_utils.isEmpty(self.isSingleMode)) {
			isSingleMode = self.isSingleMode;
		}
        if(!g_utils.isEmpty(self.isContentSelf)) {
            isContentSelf = self.isContentSelf;
        }
        if(!g_utils.isEmpty(self.circleMembersPhone_Str)) {
            circleMembersPhone = self.circleMembersPhone_Str.split(",");
        }
	}
}

/**
 * 获取本机通讯录
 */
function getLocalContactsAndShow() {
	plus.contacts.getAddressBook(plus.contacts.ADDRESSBOOK_PHONE, function(addressbook) {
		addressbook.find(["displayName", "phoneNumbers"], function(contacts) {
			if(contacts.length > 0) { //获取当前通讯录里面所有人
				for(var i = 0; i < contacts.length; i++) {
					//这里一定要判断联系人名称不为空 一旦漏判undefined后面所有逻辑都不会执行!!
					if(contacts[i] !== undefined && contacts[i].displayName !== undefined&& contacts[i].displayName !=null) {
						//判断用户的手机号码不为空时 取手机号码
						for(j = 0; j < contacts[i].phoneNumbers.length; j++) {
							if(contacts[i].phoneNumbers[j] !== undefined) {
								var phone = takePhoneNumber(contacts[i].phoneNumbers[j].value);
								if(phone!=null&&phone != '') {
									var displayName=contacts[i].displayName.replace(/\s+/g,'');
									var contact = {
										name: displayName,
										phone: phone,
										priority: 100,
										headImg: "",
										nickname:"",
										userId:""
									};
									localContacts.push(contact);
								}
							}
						}
					}
				}
			}
			mergeAllContacts(); //合并去重复,处理并显示

		}, function(e) {
			g_mui.alert("Find contact error: " + e.message);
		});
	}, function(e) {
		g_mui.alert("Get contact error: " + e.message);
	});
}

/**
 * 遍历出紧急联系人与普通联系人
 */
function getEmergencyNormalContacts(contacts) {

	if(!g_utils.isEmpty(contacts)) {
		emergencyContacts = [];
		normalContacts = [];
		for(phoneId = 0; phoneId < contacts.length; phoneId++) {
			var priority = contacts[phoneId].priority;
			var nickname="";
            if (!g_utils.isEmpty(contacts[phoneId].nickname)){
                nickname=contacts[phoneId].nickname;
            }
			var contact = {
				id: phoneId,
				name: contacts[phoneId].name,
				phone: contacts[phoneId].phone,
				priority: priority,
				headImg: contacts[phoneId].headImg,
				nickname:nickname,
				userId:contacts[phoneId].userId
			};
			//contacts[i].id = phoneId;
			if(priority > 0 && priority <= 10) {
				emergencyContacts.push(contact);
			} else if(priority == 100) {
				normalContacts.push(contact);
			}
		}
	}
}

function mergeAllContacts() {
	for(var i = 0; i < emergencyContacts.length; i++) {
		allPhoneContacts.push(emergencyContacts[i]);
	}
	for(var i = 0; i < localContacts.length; i++) {
		allPhoneContacts.push(localContacts[i]);
	}
	for(var i = 0; i < normalContacts.length; i++) {
		allPhoneContacts.push(normalContacts[i]);
	}

	//去重复
	allPhoneContacts = contatcsUnique(allPhoneContacts);
    allPhoneContacts = spliceContactsWithCircleMembersPhone(allPhoneContacts);
	allPhoneContacts = getShowContacts(allPhoneContacts, selectedContacts);

	//检查所有手机号是否注册过
	var userNameList = [];
	for(var i = 0; i < allPhoneContacts.length; i++) {
		userNameList.push(allPhoneContacts[i].phone);
	}

	var loading = plus.nativeUI.showWaiting('', {
		loading: {
			display: 'inline'
		},
		modal: false
	});
	g_tools.postCMD("getUserNameStatusList", {
		userName: JSON.stringify(userNameList)
	}, function(result) {
		if(!g_utils.isEmpty(loading)) loading.close();
		// alert(JSON.stringify(result));
		if(result.code == 0) {
			var resultList = [];
			var tempList = [];
			resultList = result.data;
			for(var i = 0; i < resultList.length; i++) {
				for(var j = 0; j < allPhoneContacts.length; j++) {
					if(resultList[i].phone == allPhoneContacts[j].phone) {
						var newContact = {
							name: allPhoneContacts[j].name,
							phone: allPhoneContacts[j].phone,
							priority: allPhoneContacts[j].priority,
							isExist: resultList[i].isExist,
							headImg: resultList[i].headImg,
							nickname: resultList[i].nickname,
							userId:resultList[i].userId
						}
						tempList.push(newContact);
					}
				}
			}
			allPhoneContacts = tempList;
			// alert(JSON.stringify(allPhoneContacts));

			getEmergencyNormalContacts(allPhoneContacts); //根据合并后的列表划分出紧急联系人和普通联系人
			refreshContactList(); //绘制列表
		} else {
			g_mui.toast(result.tip);
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE, {
		noNetworkMode: g_tools.TIP_MODE_TOAST
	});
}

//function sortByKey(array, key) {
//    return array.sort(function(a, b) {
//                      var x = a[key]; var y = b[key];
//                      return ((x < y) ? -1 : ((x > y) ? 1 : 0));
//                      });
//}
var inputs;
function refreshContactList() {
	contactListLay.innerHTML = "";
	if(emergencyContacts.length > 0) {
		contactListLay.innerHTML = getEmergencyAllList(emergencyContacts);
	}
	if(normalContacts.length > 0) {
		contactListLay.innerHTML = contactListLay.innerHTML + getNormalAllList(sortPY(normalContacts));
	}
	
	window.indexedList = new mui.IndexedList(list);
}

function radioCheck(obj){  //判断：如果是单选模式，则将复选框改为单选框
	if(!isSingleMode) return;
	
	var choices = document.getElementsByName('choice-item');
	for (var i = 0; i < choices.length; i++) {
		choices[i].checked = false;
	}
 	obj.checked = true;
}

/**
 * 获得紧急联系人的列表的html
 * @param {Object} arr
 */
function getEmergencyAllList(arr) {
	var emergencyInner = "<li data-group='★' class='mui-table-view-divider mui-indexed-list-group'> ★ 紧急联系人 </li>";
	for(var index = 0; index < arr.length; index++) {
		var data = arr[index];
		var imgDataSrc = data.headImg;
		if(!g_utils.isEmpty(imgDataSrc)) {
			imgDataSrc = g_tools.IP_FILE + imgDataSrc+"&tb=1";
		}
		var imgSrc = "../../img/default_portrait_no.png";
		if(data.isExist == 1) {
			imgSrc = "../../img/default_portrait_msg.png";
		}
		emergencyInner += "<li class='mui-table-view-cell mui-indexed-list-item mui-collapse-content mui-checkbox mui-left' data-value=" +
			makePy(data.name) + " data-tags='' id=" + data.id + "><input type='checkbox' name='choice-item' onclick='radioCheck(this)'/><img src='" + imgSrc + "' data-src='" + imgDataSrc + "' onload='load(this)' class='square-head' /><div class='my-value'><div>" +
			data.name + "</div><span>" + data.phone + "</span></div></li>";
	}
	return emergencyInner;
}
/**
 * 获得通讯录的列表html并加上字母导航
 * @param {Object} linkList 排序后的数据链表
 */
function getNormalAllList(linkList) {
	var normalInner = "";
	var tempValue = 1;
	if(emergencyContacts.length > 0) {
		tempValue = 0;
	}
	//为侧栏导航做准备
	for(var index = 0; index < linkList.size(); index++) { //遍历链表
		var data = linkList.getVal(index).data;
		if(data.length != 0) {
			normalInner += "<li data-group=" + word[index + tempValue] + " class='mui-table-view-divider mui-indexed-list-group'>" + word[index + tempValue] + "</li>"
			for(var zindex = 0; zindex < data.length; zindex++) { //遍历数组，把信息放到<li>标签
				var name = data[zindex].name;
				var id = data[zindex].id;
				var dataValue = makePy(name);
				var phone = data[zindex].phone;
				var imgDataSrc = data[zindex].headImg;
				if(!g_utils.isEmpty(imgDataSrc)) {
					imgDataSrc = g_tools.IP_FILE + imgDataSrc+"&tb=1";
				}
				var imgSrc = "../../img/default_portrait_no.png";
				if(data[zindex].isExist == 1) {
					imgSrc = "../../img/default_portrait_msg.png";
				}
				normalInner += "<li class='mui-table-view-cell mui-indexed-list-item mui-collapse-content mui-checkbox mui-left' data-value=" + dataValue + "  data-tags='' id=" + id + "><input type='checkbox' name='choice-item' onclick='radioCheck(this)'/><img src='" + imgSrc + "' data-src='" + imgDataSrc + "' onload='load(this)' class='square-head' /><div class='my-value'><div>" + name + "</div><span>" + phone + "</span></div></li>";
			}
		}
	}
	return normalInner;
}

/**
 * 获得通讯录的列表html并加上字母导航
 */
function initCharacterList() {
	var nav = document.getElementsByClassName('mui-indexed-list-bar')[0];
	var navInner = "";
	if(emergencyContacts.length > 0) { //含有紧急联系人，带★
		for(var index = 0; index < word.length; index++) { //遍历链表
			navInner += "<a>" + word[index] + "</a>"; //侧栏导航代码，哪种字母有名字存在侧栏导航就需要有该字母
		}
	} else { //不含紧急联系人，不带★
		for(var index = 1; index < word.length; index++) { //遍历链表
			navInner += "<a>" + word[index] + "</a>"; //侧栏导航代码，哪种字母有名字存在侧栏导航就需要有该字母
		}
	}

	nav.innerHTML = navInner;
}

/**
 * 去掉特殊符号，及86后符合的11位号码
 * @param {Object} phone
 */
function takePhoneNumber(phone) {
	var reg = /[+-\s]/g,
		tempPhone;
	tempPhone = phone.trim().replace(reg, '').slice(-11);
	if(g_utils.validateMobile(tempPhone)) {
        if (!isContentSelf){
            if (tempPhone!=g_tools.getUserName()){
                return tempPhone;
            }
        }else{
            return tempPhone;
        }
		
	}
	return "";
}
/**
 * 初始化导入按钮
 */
function onInitExportBtn() {
	exportBtn.addEventListener('tap', function() {
		var checkboxArray = [].slice.call(list.querySelectorAll('input[type="checkbox"]'));
		var allSelectContacts=selectedContacts.slice();

		checkboxArray.forEach(function(box) {
			if(box.checked) { //已选择
				var phoneStr = box.parentNode.children[2].children[1].innerText;
				for(var i = 0; i < allPhoneContacts.length; i++) {
					if(allPhoneContacts[i].phone == phoneStr) {
						allSelectContacts.push(allPhoneContacts[i]);
					}
				}
			}
		});

		var nList = plus.webview.currentWebview().opener();
		mui.fire(nList, 'exportContacts', {
            allContacts:allSelectContacts,
			chooseContacts: getShowContacts(allSelectContacts, selectedContacts)
		});
		mui.back(true);
	}, false);
}

/**
 * 初始化全选、取消全选按钮
 */
function onInitChooseBtn() {
	chooseBtn.addEventListener('tap', function() {
		var checkboxArray = [].slice.call(list.querySelectorAll('input[type="checkbox"]'));
		if(this.innerText == "全选") { //全选
			checkboxArray.forEach(function(box) {
				box.checked = true;
			});
			this.innerText = "取消全选";
		} else if(this.innerText == "取消全选") { //取消全选
			checkboxArray.forEach(function(box) {
				box.checked = false;
			});
			this.innerText = "全选";
		}
	}, false);
}

//联系人去重(电话号码相同去重)
function contatcsUnique(allPhoneContacts) {
	var r = [];
	for(var i = 0; i < allPhoneContacts.length; i++) {
		var flag = true;
		var temp = allPhoneContacts[i];
		for(var j = 0; j < r.length; j++) {
			if(temp.phone === r[j].phone) {
				flag = false;
				break;
			}
		}
		if(flag) {
			r.push(temp);
		}
	}
	return r;
}

/**
 * 去除已存在的圈成员
 * @param {Object} contatcs
 */
function spliceContactsWithCircleMembersPhone(allContacts) {
    var tempContacts = allContacts.slice();
    if(!g_utils.isEmpty(circleMembersPhone)) {
        for(var j = 0; j < circleMembersPhone.length; j++) {
            for(var i = tempContacts.length - 1; i >= 0; i--) {
                if(tempContacts[i].phone == circleMembersPhone[j]) {
                    tempContacts.splice(i, 1);
                }
            }
        }
    }
    return tempContacts;
}

/**
 * 去除已选择的联系人
 * @param {Object} contatcs
 */
function getShowContacts(allContacts, selectedContacts) {
   // JSON.stringify(selectedContacts);
	var tempContacts = allContacts.slice();
	if(!g_utils.isEmpty(selectedContacts)) {
		for(var j = 0; j < selectedContacts.length; j++) {
			for(var i = tempContacts.length-1; i >=0; i--) {
				if(tempContacts[i].phone == selectedContacts[j].phone) {
					tempContacts.splice(i, 1);
				}
			}
		}
	}
	return tempContacts;
}

function sortPY(username) {
	var a = new Array();
	var b = new Array();
	var c = new Array();
	var d = new Array();
	var e = new Array();
	var f = new Array();
	var g = new Array();
	var h = new Array();
	var i = new Array();
	var j = new Array();
	var k = new Array();
	var l = new Array();
	var m = new Array();
	var n = new Array();
	var o = new Array();
	var p = new Array();
	var q = new Array();
	var r = new Array();
	var s = new Array();
	var t = new Array();
	var u = new Array();
	var v = new Array();
	var w = new Array();
	var x = new Array();
	var y = new Array();
	var z = new Array();
	var other = new Array();
	for(var index = 0; index < username.length; index++) {
		var str = makePy(username[index].name);

		var result = str[0].charAt(0);

		switch(result) {
			case "a":
			case "A":
				a.push(username[index]);
				break;
			case "b":
			case "B":
				b.push(username[index]);
				break;
			case "c":
			case "C":
				c.push(username[index]);
				break;
			case "d":
			case "D":
				d.push(username[index]);
				break;
			case "e":
			case "E":
				e.push(username[index]);
				break;
			case "f":
			case "F":
				f.push(username[index]);
				break;
			case "g":
			case "G":
				g.push(username[index]);
				break;
			case "h":
			case "H":
				h.push(username[index]);
				break;
			case "i":
			case "I":
				i.push(username[index]);
				break;
			case "j":
			case "J":
				j.push(username[index]);
				break;
			case "k":
			case "K":
				k.push(username[index]);
				break;
			case "l":
			case "L":
				l.push(username[index]);
				break;
			case "m":
			case "M":
				m.push(username[index]);
				break;
			case "n":
			case "N":
				n.push(username[index]);
				break;
			case "o":
			case "O":
				o.push(username[index]);
				break;
			case "p":
			case "P":
				p.push(username[index]);
				break;
			case "q":
			case "Q":
				q.push(username[index]);
				break;
			case "r":
			case "R":
				r.push(username[index]);
				break;
			case "s":
			case "S":
				s.push(username[index]);
				break;
			case "t":
			case "T":
				t.push(username[index]);
				break;
			case "u":
			case "U":
				u.push(username[index]);
				break;
			case "v":
			case "V":
				v.push(username[index]);
				break;
			case "w":
			case "W":
				w.push(username[index]);
				break;
			case "x":
			case "X":
				x.push(username[index]);
				break;
			case "y":
			case "Y":
				y.push(username[index]);
				break;
			case "z":
			case "Z":
				z.push(username[index]);
				break;
			default:
				other.push(username[index]);
				break;
		}
	}
	var linkList = new LinkedList();

	linkList.add(a);
	linkList.add(b);
	linkList.add(c);
	linkList.add(d);
	linkList.add(e);
	linkList.add(f);
	linkList.add(g);
	linkList.add(h);
	linkList.add(i);
	linkList.add(j);
	linkList.add(k);
	linkList.add(l);
	linkList.add(m);
	linkList.add(n);
	linkList.add(o);
	linkList.add(p);
	linkList.add(q);
	linkList.add(r);
	linkList.add(s);
	linkList.add(t);
	linkList.add(u);
	linkList.add(v);
	linkList.add(w);
	linkList.add(x);
	linkList.add(y);
	linkList.add(z);
	linkList.add(other);

	return linkList;

}

//单链表节点
function Entry(next, data) {
	this.next = next;
	this.data = data;
}
//链表
function LinkedList() {
	var length = 0;
	this.head = new Entry(null, null);
	this.end = new Entry(null, null);
	this.add = function(data) {
		var newentry = new Entry(null, data);
		if(this.head.data) {
			this.end.next = newentry;
			this.end = newentry;
		} else {
			this.head = newentry;
			this.end = newentry;
		}
		length += 1;
	};
	this.show = function() {
		var temp = this.head;
		for(; temp != null; temp = temp.next) {
			//            console.log(temp.data);
		}
	};
	this.size = function() {
		return length;
	};
	this.getVal = function(index) {
		var current;
		current = this.head;
		if(index > 0 || index < length) {
			for(var i = 0; i < index; i++) {
				current = current.next;
			}
		} else if(index >= length || index < 0) {
			return;
		}
		return current;
	};
}
