var opener;
var progressView;
var dietArray = [0, 0, 0, 0];
var MAX_NUM = 8;
var _getMissionFlag;
var _entryStr0 = '';
var _entryStr1 = '';
var _entryStr2 = '';
var _entryStr3 = '';
mui.init();
mui.plusReady(function() {
	getCurrentMission(); //获取个人当前任务
	document.addEventListener('saveDietImg', function(event) {
		//alert(JSON.stringify(event.detail.allContacts));
		var macthContent = event.detail.macthContent;
		var path = event.detail.path;
		var dietType = event.detail.dietType;
		uploadImg(path, dietType, macthContent);
	});
	initPremission();
	init();
});



function init() {
	var self = plus.webview.currentWebview();
	opener = self.opener();
	progressView = window.initProgress();
	getDietList();
}

//获取饮食列表
function getDietList() {
	var startTime = new Date();
	startTime.setHours(0);
	startTime.setMinutes(0);
	startTime.setSeconds(0);
	startTime.setMilliseconds(0);
	startTime = startTime.getTime();
	var endTime = startTime + 86400000;
	g_tools.postCMD("getDietListByUserId", {
		userId: g_tools.getUserId,
		startTime: startTime,
		endTime: endTime
	}, function(res) {
		if (res.code == 0) {
			var list = res.data;
			for (var i = 0; i < list.length; i++) {
				var item = list[i];
				var type = parseInt(item.type);
				dietArray[type] = dietArray[type] + 1;
			}
			var dietList = document.querySelectorAll("[diet]");
			for (var i = 0; i < dietList.length; i++) {
				dietList[i].addEventListener("tap", function(e) {
					var diet = parseInt(this.getAttribute("diet"));
					setPermission(3,diet)
					//startCapture(diet)
				})
			}
		}
	})
}

//调用android系统权限
function initPremission() {
	var _BARCODE = "permissionUtil",
		B = window.plus.bridge;
	var permissionUtil = {
		setPermission: function(Argus, successCallback, errorCallback) {
			var success = typeof successCallback !== 'function' ? null : function(args) {
					successCallback(args);
				},
				fail = typeof errorCallback !== 'function' ? null : function(code) {
					errorCallback(code);
				};
			callbackID_2 = B.callbackId(success, fail);
			return B.exec(_BARCODE, "setPermission", [callbackID_2, Argus]);
		}
	};
	window.plus.permissionUtil = permissionUtil;
}

/**
 * 相机权限
 */
function setPermission(type, dietType) {
	if (plus.os.name == g_config.ANDROID) {
		plus.permissionUtil.setPermission(type, function(result) {
				if (result.ps) {
					if (type == "3") {
						startCapture(dietType);
					}
					if (type == "6") {
						startAlbum(dietType);
					}
				}
			},
			function(erro) {
				alert(erro);
			}
		);
	} else {
		if (type == "3") {
			startCapture(dietType);
		}
		if (type == "6") {
			startAlbum(dietType);
		}
	}
}
/**
 * 拍照
 */
function startCapture(dietType) {
	if (progressView.isShow) {
		return
	}
	if (dietArray[parseInt(dietType)] >= MAX_NUM) {
		progressView.unable("每餐最多上传8张照片");
		return
	}
	var cmr = plus.camera.getCamera();
	cmr.captureImage(function(p) {
        setTimeout(function(){  //添加延时处理，否则有概率内存崩溃，初步怀疑是图片保存时间问题
            plus.io.resolveLocalFileSystemURL(p, function(entry) {
	
                if (!g_utils.isEmpty(_getMissionFlag)) {
                    if (_getMissionFlag == 0) {
                        var path = entry.fullPath;
                        uploadImg(path, dietType, '');
                    }
                    if (_getMissionFlag == 1) {
                        var path = entry.fullPath;
                        var str = '';
                        if (dietType == 0) {
                            str = _entryStr0;
                        }
                        if (dietType == 1) {
                            str = _entryStr1;
                        }
                        if (dietType == 2) {
                            str = _entryStr2;
                        }
                        if (dietType == 3) {
                            str = _entryStr3;
                        }
                        if (g_utils.isEmpty(str)) {
                            uploadImg(path, dietType, '');
                        } else {
                            g_mui.openAddEntryForPic({
                                path: path,
                                localUrl: entry.toLocalURL(),
                                dietType: dietType,
                                str: str
                            });
                        
                        }
                    }
                }
                                              
            }, function(e) {});
        },500);
	}, function(e) {}, {
		filename: "_doc/camera/"
	});
}

/**
 * 从相册里选择
 */
function startAlbum(dietType) {
	plus.gallery.pick(function(path) {
		uploadImg(path, dietType);
	}, function(e) {}, {
		filter: "image"
	});
}

// 上传文件
function uploadImg(imgUrl, dietType, macthContent) {
	progressView.setProgress(10);
	lrz(imgUrl)
		.then(function(rst) {
			// 处理成功会执行
			var file = rst.file;
			g_tools.postBlobFile("uploadImg", file, function(result) {
				if (result.code == 0) {
					var _imgUrl = result.url;
					g_tools.postCMD('upDietImg', {
						type: dietType,
						dietImgUrl: _imgUrl,
						time: new Date().getTime(),
						macthContent: macthContent
					}, function(data) {
						if (data.code == 0) {
							progressView.finish("上传完成");
							dietArray[dietType] = dietArray[dietType] + 1;
							//刷新首页积分数据
							var codeArr = ['DM_003', 'PM_008'];
							g_fire.updateAllMission({
								codeArr: JSON.stringify(codeArr)
							});
							g_fire.showToast({
								codeArr: JSON.stringify(codeArr)
							});
							//刷新pm008
							// var webViewPM = plus.webview.getWebviewById(g_module.myCareList.ID + ':mission/pm_008/pm_008_card.html');
							// if (!g_utils.isEmpty(webViewPM)) {
							// 	mui.fire(webViewPM, 'updateDM008Mission', {});
							// }
							mui.fire(opener, "refreshDiet", {});
						} else {
							progressView.fail(data.tip);
						}
					});
				} else {
					progressView.fail(result.tip);
				}
			}, function(progress) {
				progressView.setProgress(progress);
			});
		})
		.catch(function(err) {
			// 处理失败会执行
			progressView.fail("上传失败");
		})
		.always(function(complate) {
			// 不管是成功失败，都会执行
		});
}

function getCurrentMission() {
	// g_tools.postCMD('checkDailyMission', {}, function(res) {
	//获取我的今日所有任务
	g_tools.postCMD('getCurrentMissionByUserId', {},
		function(result) {
			//alert('getCurrentMissionByUserId:'+JSON.stringify(result));
			if (result.code == 0) {
				if (g_utils.isEmpty(result.data.planMissionList)) {
					_getMissionFlag = 0;
				} else {
					_getMissionFlag = 1;
					var tempArray = result.data.planMissionList;
					for (var i = 0; i < tempArray.length; i++) {
						var item = tempArray[i];
						//  alert(JSON.stringify(item));
						if (item.code == 'PM_011') {
							if (!g_utils.isEmpty(item.parametersData.type_0)) {
								var tempStr = '';
								var tempArr = item.parametersData.type_0.menuArr;
								for (j = 0; j < tempArr.length; j++) {
									if (j == tempArr.length - 1) {
										tempStr += tempArr[j].menuName;
									} else {
										tempStr += tempArr[j].menuName + ',';
									}
								}
								_entryStr0 = tempStr;
							}
							if (!g_utils.isEmpty(item.parametersData.type_1)) {
								var tempStr = '';
								var tempArr = item.parametersData.type_1.menuArr;
								for (j = 0; j < tempArr.length; j++) {
									if (j == tempArr.length - 1) {
										tempStr += tempArr[j].menuName;
									} else {
										tempStr += tempArr[j].menuName + ',';
									}
								}
								_entryStr1 = tempStr;
							}
							if (!g_utils.isEmpty(item.parametersData.type_2)) {
								var tempStr = '';
								var tempArr = item.parametersData.type_2.menuArr;
								for (j = 0; j < tempArr.length; j++) {
									if (j == tempArr.length - 1) {
										tempStr += tempArr[j].menuName;
									} else {
										tempStr += tempArr[j].menuName + ',';
									}
								}
								_entryStr2 = tempStr;
							}
							if (!g_utils.isEmpty(item.parametersData.type_3)) {
								var tempStr = '';
								var tempArr = item.parametersData.type_3.menuArr;
								for (j = 0; j < tempArr.length; j++) {
									if (j == tempArr.length - 1) {
										tempStr += tempArr[j].menuName;
									} else {
										tempStr += tempArr[j].menuName + ',';
									}
								}
								_entryStr3 = tempStr;
							}
						}
					}
				}

			}
		}, g_tools.MODE_WEB_LOCAL_CACHE, {
			disableWait: true //禁止显示wait框
		});
	//  });
}
