//图片网络地址url
var SERVER_IMG_ADDRESS = g_tools.IP_FILE;
var DEFAULT_HEAD_IMG = '../../global/img/default_head.png';

//mui初始化
mui.init();
mui.plusReady(function() {

	//model
	mdata = {};
	mdata['careMeList'] = [];

	//methods
	mMethods = {};
	mMethods["isCareMeList"] = isCareMeList;
	mMethods["onTapList"] = onTapList;
	mMethods["getCareMeImgUrl"] = getCareMeImgUrl;
	mMethods["getDisplayName"] = getDisplayName;

	new Vue({
		el: '#main',
		data: mdata,
		methods: mMethods,
		mounted: function(){
			document.getElementById('main').classList.remove('mui-hidden');	
		}
	});

	refresh();

	window.addEventListener('refreshPage', function(e) { //执行刷新
		refresh();
	});
});

//刷新爱我的人列表
function refresh() {
	g_tools.postCMD('getCareMeList2', {}, function(data) {
		if(data.code == 0) {
			mdata['careMeList'] = data.data;
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE, {
		noNetworkMode: g_tools.TIP_MODE_INTERFACE, //界面显示断网提示内容的模式
		contentDomId: 'mainContent', //显示数据内容的dom元素id
		tipDomId: 'noNetworkTip' //显示断网提示的dom元素id
	});
}

/**
 * 是否有人关爱我   true为空 false非空
 * @param {Object} careMeList
 */
function isCareMeList(careMeList) {
	return !g_utils.isEmptyArray(careMeList);
}

function onTapList(careMe) {
	g_mui.openUserDataDetail({
		openerProperty: 4,  //定义参考userDataDetail.js
		userId: careMe.myCareId,
		deletId: careMe.id
	});
//	g_mui.openPage(g_module.careMe, 'careMeSet.html', {
//		careMe: careMe
//	});
}

function getCareMeImgUrl(headImg) {
	var imgUrl = DEFAULT_HEAD_IMG;
	if(!g_utils.isEmpty(headImg)) {
		imgUrl = SERVER_IMG_ADDRESS + headImg+"&tb=1";
	}
	return imgUrl;
}

/**
 * 获取显示的名字
 * @param {Object} careMe
 */
function getDisplayName(careMe) {
	return g_tools.getDisplayName(careMe);
}