var type;
var personInfo = {}; //缓存的人物信息
//进入实名认证时的3种类型
var TYPE_MY = 0; //自己激活伙伙
var TYPE_NEW_OTHER = 1; //帮助他人时未提交实名认证
var TYPE_OTHER = 2; //帮助他人时提交了实名认证
var imgUrls = ["img/custody_icon_weit.png", "img/custody_icon_fail.png", "img/custody_icon_register.png"]; //认证状态图片

//model
mdata = {};
mdata['newActivateInfoList'] = [];
mdata['newActivateInfo'] = {};
mdata['imgUrl'] = "";
mdata['authStatusTip'] = "";
mdata['detailTip'] = "";
mdata['btnTip'] = "";

//mMethods
mMethods = {};
mMethods["goNextTap"] = goNextTap;

//vue加载完加载mui,当用到plus时先加载完plus基座再初始化mui
var vm = new Vue({
	el: '#main',
	data: mdata,
	methods: mMethods,
	mounted: function() {
		//pulsReady
		mui.plusReady(function() {
			//mui初始化
			mui.init();
			//获取传入参数
			var self = plus.webview.currentWebview();
			type = self.type;
            
			mdata.newActivateInfo = self.activateInfo;
			mdata.newActivateInfoList = self.activateInfoList;
			sendChangeEvents(mdata.newActivateInfoList, mdata.newActivateInfo);

			document.addEventListener('resultChange', function(e) {
				mdata.newActivateInfo = e.detail.activateInfo;
				mdata.newActivateInfoList = e.detail.activateInfoList;
				sendChangeEvents(mdata.newActivateInfoList, mdata.newActivateInfo);
			}, false);
			
			//因为首次实名认证时有一定几率无法关闭成功，所以这里再关闭一次
			g_mui.closeModule(g_module.certification);
		});
	}
});

function sendChangeEvents(newActivateInfoList, newActivateInfo) {
	var wObj = plus.webview.getWebviewById(g_module.insertMyCareGuide.ID);

	if(wObj != null) {
		mui.fire(wObj, 'infoChange', {
			activateInfoList: newActivateInfoList
		});
	}

	var otherList = plus.webview.getWebviewById(g_module.insertMyCareGuide.ID+':otherActiveInfoList.html');

	if(otherList != null) {
		mui.fire(otherList, 'otherChange', {
			activateInfoList: newActivateInfoList
		});
	}
	refreshTip(newActivateInfo.name, newActivateInfo.identityCard, newActivateInfo);
}

/**
 * 根据电话获取激活伙伙的信息
 * @param {Object} activateInfoList
 * @param {Object} phone
 */
function getActivateInfoByPhone(activateInfoList, phone) {
	if(activateInfoList.length > 0) {
		for(var i = 0; i < activateInfoList.length; i++) {
			if(activateInfoList[i].phone == phone) {
				return activateInfoList[i];
			}
		}
	}
	return null;
}

function goNextTap(newActivateInfo) {
	var myExtras = {
		activateInfo: newActivateInfo
	};
	if(type == TYPE_OTHER) {
		if(newActivateInfo.realNameAuthStatus == 2) { //未通过的时候
			var info = g_storage.getActivateStorage(TYPE_OTHER, newActivateInfo);
			if(g_utils.isEmpty(info)) {
				reSetNoPassStorage(TYPE_OTHER, newActivateInfo);
			}
			myExtras['type'] = type;
			myExtras['callbackJS'] = "g_mui.closePage('waitingResult.html')";
			g_mui.openModule(g_module.certification, myExtras);
		} else {
			if(newActivateInfo.userId == '') { //则提示还需绑定账号
				myExtras['type'] = type;
				g_mui.openModule(g_module.helpRegister, myExtras);
			} else if(newActivateInfo.userId !== '' && newActivateInfo.isCompleteUserInfo != 1) { //则提示还需完善个人资料
				myExtras['type'] = type;
				g_mui.openModule(g_module.improvePersonalData, myExtras);
			} else if(newActivateInfo.userId !== '' && newActivateInfo.isCompleteUserInfo == 1) { //则点击完成关闭
				g_mui.closePage('waitingResult.html',{
					aniClose:'auto'
				});
			}
		}

	} else if(type == TYPE_MY) {
		if(newActivateInfo.realNameAuthStatus == 2) { //未通过的时候
			//此状态有可能缓存被删掉，这里根据网上信息重置下缓存
			var info = g_storage.getActivateStorage(TYPE_MY, newActivateInfo);
			if(g_utils.isEmpty(info)) {
				var loading = plus.nativeUI.showWaiting("正在加载...", {
					loading: {
						display: 'inline'
					},
					modal: false
				});
				g_tools.postCMD('getActivateInfoList', null, function(result) {
					loading.close();
					if(result.code == 0) {
						mdata.newActivateInfoList = result.data;
						var infoStr = JSON.stringify(getMyActivateInfo(result.data));
						g_storage.setActivateStorage(TYPE_MY, infoStr, newActivateInfo);
						g_mui.openModule(g_module.certification, {
							type: TYPE_MY,
							activateInfo: newActivateInfo,
						});
						setTimeout("plus.webview.close('certificationResult','none')",1000);
					} else {

					}
				}, g_tools.MODE_WEB_LOCAL_CACHE, {
					noNetworkMode: g_tools.TIP_MODE_TOAST
				});
			} else {
				g_mui.openModule(g_module.certification, {
					type: TYPE_MY,
					activateInfo: newActivateInfo,
				});
				setTimeout("plus.webview.close('certificationResult','none')",1000);
			}
		} else {
			if(newActivateInfo.isCompleteUserInfo != 1) { //则提示还需完成个人资料
				myExtras['type'] = type;
				g_mui.openModule(g_module.improvePersonalData, myExtras);
			} else if(newActivateInfo.isCompleteUserInfo == 1) { //点击完成则关闭
				g_mui.openModule(g_module.insertMyCareGuide, {
					callbackJS: 'g_mui.closeModule(g_module.certification);'
				});
			}
		}
	}
}
/**
 * 得到自己的激活伙伙信息
 * @param {Object} activateInfoList
 */
function getMyActivateInfo(activateInfoList) {
	var loginUserId = g_storage.get(g_storage.DEVICE_USER_ID);
	if(!g_utils.isEmpty(activateInfoList)) {
		for(var i = 0; i < activateInfoList.length; i++) {
			if(activateInfoList[i].userId == loginUserId) { //代表自己
				return activateInfoList[i];
			}
		}
	}
	return [];
}
function reSetNoPassStorage(type, activateInfo) {
	var tempInfo = activateInfo;
	var infoStr = JSON.stringify(tempInfo);
	g_storage.setActivateStorage(type, infoStr, activateInfo);
}

function refreshTip(name, identityCard, newActivateInfo) {
	if(type == TYPE_OTHER) {
		if(newActivateInfo.realNameAuthStatus == 1) {
			mdata.authStatusTip = "已提交实名信息，审核中";
			mdata.imgUrl = imgUrls[0];
			if(newActivateInfo.userId == '') { //则提示还需绑定账号
				mdata.btnTip = '注册APP账号';
				mdata.detailTip = '通讯运营商实名信息审核大概需要24小时，请您耐心等待。审核结果将以短信或电话形式通知您，敬请留意！在等待期间您还需帮助' + getHighHonorific(name, identityCard) + '完成APP账号的注册。';
			} else if(newActivateInfo.userId !== '' && newActivateInfo.isCompleteUserInfo != 1) { //则提示还需完善个人资料
				mdata.btnTip = '完善个人资料';
				mdata.detailTip = '通讯运营商实名信息审核大概需要24小时，请您耐心等待。审核结果将以短信或电话形式通知您，敬请留意！在等待期间您还需帮助' + getHighHonorific(name, identityCard) + '完善个人资料。';
			} else if(newActivateInfo.userId !== '' && newActivateInfo.isCompleteUserInfo == 1) { //则点击完成关闭
				mdata.btnTip = '知道了';
				mdata.detailTip = "通讯运营商实名信息审核大概需要24小时，请您耐心等待。审核结果将以短信或电话形式通知您，敬请留意！";
			}

		} else if(newActivateInfo.realNameAuthStatus == 2) { //未通过
			mdata.authStatusTip = "实名信息未通过审核";
			mdata.imgUrl = imgUrls[1];
			mdata.btnTip = '重新提交资料';
			mdata.detailTip = getHighHonorific(name, identityCard) + "的资料不符合运营商审核标准，请重新提交资料。<span class='highlight'>未通过原因：" + newActivateInfo.refuseReason + "。</span>";

		} else if(newActivateInfo.realNameAuthStatus == 3) {
			mdata.authStatusTip = "实名信息已通过审核";
			mdata.imgUrl = imgUrls[2];
			if(newActivateInfo.userId == '') { //则提示还需绑定账号
				mdata.btnTip = '注册APP账号';
				mdata.detailTip = getHighHonorific(name, identityCard) + '的实名认证已通过审核。您还需要帮助' + getPerson(name, identityCard) + '完成APP账号的注册。';
			} else if(newActivateInfo.userId !== '' && newActivateInfo.isCompleteUserInfo != 1) { //则提示还需完善个人资料
				mdata.btnTip = '完善个人资料';
				mdata.detailTip = getHighHonorific(name, identityCard) + '的实名认证已通过审核。为了让' + getPerson(name, identityCard) + '享受到更完整的保障服务，请您再帮助' + getPerson(name, identityCard) + '完善个人资料。';
			}
		}

	} else if(type == TYPE_MY) {
		if(newActivateInfo.realNameAuthStatus == 1) {
			mdata.authStatusTip = "已提交实名信息，审核中";
			mdata.imgUrl = imgUrls[0];
			if(newActivateInfo.isCompleteUserInfo != 1) { //则提示还需完成个人资料
				mdata.btnTip = '完善个人资料';
				mdata.detailTip = '通讯运营商实名信息审核大概需要24小时，请您耐心等待。审核结果将以短信或电话形式通知您，敬请留意！在等待期间您可以完善伙伙使用时所需的资料。';
			} else if(newActivateInfo.isCompleteUserInfo == 1) { //点击完成则关闭
				mdata.btnTip = '知道了';
				mdata.detailTip = '通讯运营商实名信息审核大概需要24小时，请您耐心等待。审核结果将以短信或电话形式通知您，敬请留意！';
			}
		} else if(newActivateInfo.realNameAuthStatus == 2) { //未通过
			mdata.authStatusTip = "实名信息未通过审核";
			mdata.imgUrl = imgUrls[1];
			mdata.btnTip = '重新提交资料';
			mdata.detailTip = "您提交的资料不符合运营商审核标准，请重新提交资料。<span class='highlight'>未通过原因：" + newActivateInfo.refuseReason + "。</span>";
		} else if(newActivateInfo.realNameAuthStatus == 3 && newActivateInfo.isCompleteUserInfo != 1) {
			mdata.authStatusTip = "实名信息已通过审核";
			mdata.imgUrl = imgUrls[2];
			mdata.btnTip = '完善个人资料';
			mdata.detailTip = '您的实名认证已通过审核。为了让您享受到更完整的保障服务，请完善个人资料。';
		}

	}
}

/*function getImgUrlbyStatus(newActivateInfo) {

}*/
/**
 * 人称 (她/他)
 * @param {Object} name
 * @param {Object} identityCard
 */
function getPerson(name, identityCard) {
	return getSexbyIdentityCard(identityCard) == 0 ? "她" : "他";
}
/**
 * 敬语
 * @param {Object} name
 * @param {Object} identityCard
 */
function getHonorific(name, identityCard) {
	return name + (getSexbyIdentityCard(identityCard) == 0 ? "女士" : "先生");
}

/**
 * 高亮敬语HTML
 */
function getHighHonorific(name, identityCard) {
	return "<span class='highlight'>" + getHonorific(name, identityCard) + "</span>";
}
/**
 * 根据身份证号判断性别 0：女，1：男
 * @param {Object} identityCard
 */
function getSexbyIdentityCard(identityCard) {
	return identityCard.substring(16, 17) % 2 == 0 ? "0" : "1";
}
