var clientWidth = document.documentElement.clientWidth;
var REM_UNIT = clientWidth / 3.75;
var _self, _userId, _planId, _startTime, _endTime, thisStart, thisEnd;
var normalValue, _planMissionData;
var parentDom = document.getElementById("parentDom");
var planDataStatistics;
mui.init();
mui.plusReady(function() {
	_self = plus.webview.currentWebview();
	_planMissionData = _self.planMissionData;
	thisStart = parseInt(_planMissionData.chosedStartTime);
	thisEnd = parseInt(_planMissionData.chosedEndTime);
	planDataStatistics = _planMissionData.dataStatistics;
	var stepArr = [];
	var healthArr = [];
	var sportArr = [];
	var sleepArr = [];
	var totalArr;
	for(var j = 0; j < planDataStatistics.length; j++) {
		var item = planDataStatistics[j];
		for(var key in item) {
			if(key == 'step') {
				stepArr.push(item);
			} else if(key.includes("healthData")) {
				healthArr.push(item);
			} else if(key.includes("sportEvent")) {
				sportArr.push(item);
			} else if(key == 'sleep') {
				sleepArr.push(item);
			}
		}
	}
	totalArr = stepArr.concat(healthArr, sleepArr, sportArr);
	for(var i = 0; i < totalArr.length; i++) {
		var item = totalArr[i]
		for(var key in item) {
			if(key == 'step') {
				drawStepData(item[key]);
			} else if(key.includes("healthData") && key != "healthData_7" && key != "healthData_2") {
				drawHealthData(item[key], key);
			} else if(key.includes("healthData") && key == "healthData_7") {
				drawPressureData(item[key]);
			} else if(key.includes("healthData") && key == "healthData_2") {
				drawBloodData(item[key]);
			} else if(key.includes("sportEvent")) {
				continue;
				drawSportEventData(item[key], key);
			} else if(key == 'sleep') {
				continue;
				drawSleepData(item[key]);
			}
		}
	}
	setPlanCycleTime();
	//refreshPage();
});
//刷新页面
function refreshPage() {
	setPlanCycleTime();
	parentDom.innerHTML = "";
	getPlanDataStatistics(thisStart, thisEnd);
}
//设置计划周期
function setPlanCycleTime() {
	var planCycleTimeDom = document.querySelector(".cycle-time");
	planCycleTimeDom.innerHTML = g_utils.dateFormat(thisStart, "yyyy.MM.dd") + "-" +
		g_utils.dateFormat(thisEnd, "yyyy.MM.dd") +
		"（" + getCycle(thisEnd - thisStart) + "天）";
}
//获取周期
function getCycle(ms) {
	return Math.ceil(ms / 86400000);
}

//获取计划数据统计
function getPlanDataStatistics(startTime, endTime) {
	g_tools.postCMD("getPlanDataStatistics", {
		userId: _userId,
		planId: _planId,
		startTime: thisStart,
		endTime: thisEnd
	}, function(result) {
		if(result.code == 0) {
			planDataStatistics = result.data;
			for(var key in planDataStatistics) {
				if(key == 'step') {
					drawStepData(planDataStatistics[key]);
				} else if(key.includes("healthData") && key != "healthData_7" && key != "healthData_2") {
					drawHealthData(planDataStatistics[key], key);
				} else if(key.includes("healthData") && key == "healthData_7") {
					drawPressureData(planDataStatistics[key]);
				} else if(key.includes("healthData") && key == "healthData_2") {
					drawBloodData(planDataStatistics[key]);
				} else if(key.includes("sportEvent")) {
					continue;
					drawSportEventData(planDataStatistics[key], key);
				} else if(key == 'sleep') {
					continue;
					drawSleepData(planDataStatistics[key]);
				}
			}
		}
	});
}
//血糖展示
function drawBloodData(healthData) {
	var title = "血糖";
	var littleTitle = "";
	var healthChartHeight = 1.8 * REM_UNIT + "px";
	var mapBlood = {
		"2": {
			name: "【血糖-餐前】"
		},
		"9": {
			name: "【血糖-餐后】"
		},
		"8": {
			name: "【血糖-空腹】"
		}
	}
	var flag = false;
	var titleLi = document.createElement("li");
	titleLi.classList.add("mui-table-view-cell", "item-icon");
	var analysisLi = document.createElement("li");
	analysisLi.classList.add("mui-table-view-cell", "item-analysis");
	titleLi.innerHTML = title;
	var flag = false;
	var analysisResult = ""
	for(key in healthData) {
		var bloodItem = mapBlood[key];
		var xAxis = new Array();
		var yAxis = new Array();
		var dataList = healthData[key].dataList;
		dataList.reverse();
		if(!g_utils.isEmptyArray(dataList)) {
			var normalValue = healthData[key].normalValue[0];
			var minValue = normalValue.minValue;
			var maxValue = normalValue.maxValue;
			var dataMin = dataList[0].value;
			var dataMax = 0;
			for(var i = 0; i < dataList.length; i++) {
				xAxis.push(i);
				var value = parseFloat(dataList[i].value)
				yAxis.push(value);

				if(dataMin > value) {
					dataMin = value
				}
				if(dataMax < value) {
					dataMax = value
				}
			}
			var chartDiv = document.createElement("div");
			var littleTitle = document.createElement('div');
			littleTitle.className = 'little-title';
			littleTitle.innerHTML = bloodItem.name;
			chartDiv.style.height = healthChartHeight;
			if(!flag) {
				parentDom.appendChild(titleLi);
			}
			parentDom.appendChild(littleTitle);
			parentDom.appendChild(chartDiv);
			drawLineChart(chartDiv, xAxis, yAxis, minValue, maxValue, dataMin, dataMax);
			analysisResult += healthData[key].analysisResult
			flag = true;
		}
	}
	if(flag) {
		analysisLi.innerHTML = analysisResult
		parentDom.appendChild(analysisLi);
	} else {
		var titleLi = document.createElement("li");
		titleLi.classList.add("mui-table-view-cell", "item-icon");
		titleLi.innerHTML = title + "<span>（未上传数据）</span>";
		parentDom.appendChild(titleLi);
		return;
	}
}
//血压展示
function drawPressureData(healthData) {
	var title = "血压";
	var healthChartHeight = 1.8 * REM_UNIT + "px";
	var xAxis = new Array();
	var yAxis_sp = new Array();
	var yAxis_dp = new Array();
	var dataListDp = healthData.dp.dataList;
	dataListDp.reverse();
	var dataListSp = healthData.sp.dataList;
	dataListSp.reverse();
	if(g_utils.isEmptyArray(dataListDp)) {
		var titleLi = document.createElement("li");
		titleLi.classList.add("mui-table-view-cell", "item-icon");
		titleLi.innerHTML = title + "<span>（未上传数据）</span>";
		parentDom.appendChild(titleLi);
		return
	}
	var normalValue = healthData.dp.normalValue[0];
	var minValue = normalValue.minValue;
	var maxValue = normalValue.maxValue;
	for(var i = 0; i < dataListDp.length; i++) {
		var value = dataListDp[i].value;
		xAxis.push(i);
		yAxis_dp.push(value);
	}
	for(var j = 0; j < dataListSp.length; j++) {
		var value = dataListSp[j].value;
		yAxis_sp.push(value);
	}
	//	for(var i = 0; i < dataList.length; i++) {
	//		var valueList = dataList[i].value.split(",");
	//		
	//		yAxis_sp.push(valueList[0]);
	//		yAxis_dp.push(valueList[1]);
	//	}
	var titleLi = document.createElement("li");
	var chartDiv = document.createElement("div");
	var analysisLi = document.createElement("li");
	analysisLi.classList.add("mui-table-view-cell", "item-analysis");
	titleLi.classList.add("mui-table-view-cell", "item-icon");
	titleLi.innerHTML = title;
	chartDiv.style.height = healthChartHeight;
	//	analysisLi.innerHTML = '<bdi>【分析】</bdi>' +
	//		'<p>' + healthData.dp.analysisResult + healthData.sp.analysisResult + '</p>'
	analysisLi.innerHTML = stepData.analysisResult;
	parentDom.appendChild(titleLi);
	parentDom.appendChild(chartDiv);
	parentDom.appendChild(analysisLi);
	drawDoubleLine(chartDiv, xAxis, yAxis_sp, yAxis_dp, minValue, maxValue)
}
//健康数据
function drawHealthData(healthData, type) {
	var title = "";
	var littleTitle = "";
	var dataList = healthData.dataList;
	dataList.reverse();
	switch(type) {
		case "healthData_0":
			title = "脉搏";
			break;
		case "healthData_1":
			title = "血氧";
			break;
		case "healthData_2":
			title = "血糖";
			littleTitle = "餐前";
			break;
		case "healthData_5":
			title = "体重";
			break;
		case "healthData_6":
			title = "体温";
			break;
		default:
			break;
	}
	if(g_utils.isEmptyArray(dataList)) {
		var titleLi = document.createElement("li");
		titleLi.classList.add("mui-table-view-cell", "item-icon");
		titleLi.innerHTML = title + "<span>（未上传数据）</span>";
		parentDom.appendChild(titleLi);
		return;
	}
	var healthChartHeight = 1.8 * REM_UNIT + "px";
	var xAxis = new Array();
	var yAxis = new Array();
	var normalValue = healthData.normalValue[0];
	var minValue = normalValue.minValue;
	var maxValue = normalValue.maxValue;
	var dataMin = dataList[0].value;
	var dataMax = 0;
	for(var i = 0; i < dataList.length; i++) {
		xAxis.push(i);
		var value = parseFloat(dataList[i].value)
		yAxis.push(value);

		if(dataMin > value) {
			dataMin = value
		}
		if(dataMax < value) {
			dataMax = value
		}
	}
	var titleLi = document.createElement("li");
	var chartDiv = document.createElement("div");
	var analysisLi = document.createElement("li");
	analysisLi.classList.add("mui-table-view-cell", "item-analysis");
	titleLi.classList.add("mui-table-view-cell", "item-icon");
	titleLi.innerHTML = title;
	chartDiv.style.height = healthChartHeight;
	//	analysisLi.innerHTML = '<bdi>【分析】</bdi>' +
	//		'<p>' + healthData.analysisResult + '</p>'
	analysisLi.innerHTML = healthData.analysisResult;
	parentDom.appendChild(titleLi);
	parentDom.appendChild(chartDiv);
	parentDom.appendChild(analysisLi);
	drawLineChart(chartDiv, xAxis, yAxis, minValue, maxValue, dataMin, dataMax)
}
//主动运动数据
function drawSportEventData(sportEventData, type) {
	//4【跑步】 、5【骑车】、6【羽毛球】、7【乒乓球】、8【网球】、9【篮球】、10【足球】、11【太极拳】、12【游泳】、21【跳绳】、22【跳舞】
	var chartHeight = 1.8 * REM_UNIT + "px";
	var title = "";
	switch(type) {
		case "sportEvent_3":
			title = "步行";
			break;
		case "sportEvent_4":
			title = "跑步";
			break;
		case "sportEvent_5":
			title = "骑车";
			break;
		case "sportEvent_6":
			title = "羽毛球";
			break;
		case "sportEvent_7":
			title = "乒乓球";
			break;
		case "sportEvent_8":
			title = "网球";
			break;
		case "sportEvent_9":
			title = "篮球";
			break;
		case "sportEvent_10":
			title = "足球";
			break;
		case "sportEvent_11":
			title = "太极拳";
			break;
		case "sportEvent_12":
			title = "游泳";
			break;
		case "sportEvent_21":
			title = "跳绳";
			break;
		case "sportEvent_22":
			title = "跳舞";
			break;
		default:
			break;
	}
	var xAxis = new Array();
	var yAxis = new Array();
	var dataList = sportEventData.dataList;
	if(dataListLength == 0) {
		var titleLi = document.createElement("li");
		titleLi.classList.add("mui-table-view-cell", "item-icon");
		titleLi.innerHTML = title + "<span>（未上传数据）</span>";
		parentDom.appendChild(titleLi);
		return;
	}
	var length = getCycle(thisEnd - thisStart);
	var dataListLength = dataList.length;
	var flag = 0;
	for(var i = 0; i < length; i++) {
		var lineTime = g_utils.dateFormat(thisStart + i * 86400000, "yyyy-MM-dd");
		xAxis.push(getTimeLineNum(lineTime));
		if(dataListLength <= flag) {
			yAxis.push(0);
			continue;
		}
		var dataTime = g_utils.dateFormat(dataList[flag].startTime, "yyyy-MM-dd");
		if(dataTime == lineTime) {
			var itemStart = new Date(dataList[flag].startTime);
			var itemEnd = new Date(dataList[flag].endTime);
			yAxis.push(itemEnd - itemStart / 3600000);
			flag++;
		} else {
			yAxis.push(0);
		}
	}
	var titleLi = document.createElement("li");
	var chartDiv = document.createElement("div");
	var analysisLi = document.createElement("li");
	analysisLi.classList.add("mui-table-view-cell", "item-analysis");
	titleLi.classList.add("mui-table-view-cell", "item-icon");
	titleLi.innerHTML = title;
	chartDiv.style.height = chartHeight;
	//	analysisLi.innerHTML = '<bdi>【分析】</bdi>' +
	//		'<p>' + sportEventData.analysisResult + '</p>'
	analysisLi.innerHTML = stepData.analysisResult;
	parentDom.appendChild(titleLi);
	parentDom.appendChild(chartDiv);
	parentDom.appendChild(analysisLi);
	drawHistogram(chartDiv, xAxis, yAxis)
}
//睡眠数据
function drawSleepData(sleepData) {
	var stepChartHeight = 2 * REM_UNIT + "px";
	var xAxis = new Array();
	var yAxis = new Array();
	var yAxis_other = new Array();
	var dataList = sleepData.dataList;
	if(dataListLength == 0) {
		var titleLi = document.createElement("li");
		titleLi.classList.add("mui-table-view-cell", "item-icon");
		titleLi.innerHTML = "睡眠" + "<span>（未上传数据）</span>";
		parentDom.appendChild(titleLi);
		return;
	}
	var length = getCycle(thisEnd - thisStart);
	var dataListLength = dataList.length;
	var flag = 0;
	for(var i = 0; i < length; i++) {
		var lineTime = g_utils.dateFormat(thisStart + i * 86400000, "yyyy-MM-dd");
		xAxis.push(getTimeLineNum(lineTime));
		if(dataListLength <= flag) {
			yAxis.push(0);
			yAxis_other.push(0);
			continue;
		}
		var dataTime = g_utils.dateFormat(dataList[flag].startTime, "yyyy-MM-dd");
		if(dataTime == lineTime) {
			var itemStart = new Date(dataList[flag].startTime);
			var itemEnd = new Date(dataList[flag].endTime);
			yAxis.push(Math.max(itemStart.getHours() + itemStart.getMinutes() / 60, 20));
			yAxis_other.push(itemStart.getHours() + itemStart.getMinutes() / 60 + (itemEnd - itemStart) / 3600000);
			flag++;
		} else {
			yAxis.push(0);
			yAxis_other.push(0);
		}
	}
	var titleLi = document.createElement("li");
	var chartDiv = document.createElement("div");
	var analysisLi = document.createElement("li");
	analysisLi.classList.add("mui-table-view-cell", "item-analysis");
	titleLi.classList.add("mui-table-view-cell", "item-icon");
	titleLi.innerHTML = "睡眠";
	chartDiv.style.height = stepChartHeight;
	//	analysisLi.innerHTML = '<bdi>【分析】</bdi>' +
	//		'<p>' + sleepData.analysisResult + '</p>'
	analysisLi.innerHTML = stepData.analysisResult;
	parentDom.appendChild(titleLi);
	parentDom.appendChild(chartDiv);
	parentDom.appendChild(analysisLi);
	drawWaterfallMap(chartDiv, xAxis, yAxis, yAxis_other)
}
//绘制步行数据
function drawStepData(stepData) {
	var stepChartHeight = 2 * REM_UNIT + "px";
	var xAxis = new Array();
	var yAxis = new Array();
	var dataList = stepData.daysSportList;
	var planStep = stepData.planStep;
	if(dataListLength == 0) {
		var titleLi = document.createElement("li");
		titleLi.classList.add("mui-table-view-cell", "item-icon");
		titleLi.innerHTML = title + "<span>（未上传数据）</span>";
		parentDom.appendChild(titleLi);
		return;
	}
	if(g_utils.isEmptyArray(dataList)) {
		var titleLi = document.createElement("li");
		titleLi.classList.add("mui-table-view-cell", "item-icon");
		titleLi.innerHTML = "行走步数" + "<span>（未上传数据）</span>";
		parentDom.appendChild(titleLi);
		return
	}
	var length = getCycle(thisEnd - thisStart);
	var flag = 0;
	var dataListLength = dataList.length;
	for(var i = 0; i < length; i++) {
		var lineTime = g_utils.dateFormat(thisStart + i * 86400000, "yyyy-MM-dd");
		var itemStep = 0;
		xAxis.push(getTimeLineNum(lineTime));
		if(dataListLength > flag && lineTime == dataList[flag].date) {
			itemStep = dataList[flag].step
			flag++;
		}
		if(itemStep < planStep) {
			itemStep = {
				value: itemStep,
				itemStyle: {
					normal: {
						color: "#C8EBE6"
					}
				}
			}
		}
		yAxis.push(itemStep);

	}

	var titleLi = document.createElement("li");
	var chartDiv = document.createElement("div");
	var analysisLi = document.createElement("li");
	analysisLi.classList.add("mui-table-view-cell", "item-analysis");
	titleLi.classList.add("mui-table-view-cell", "item-icon");
	titleLi.innerHTML = "行走步数";
	chartDiv.style.height = stepChartHeight;
	//	analysisLi.innerHTML = '<bdi>【分析】</bdi>' +
	//		'<p>' + stepData.analysisResult + '</p>'
	analysisLi.innerHTML = stepData.analysisResult;
	parentDom.appendChild(titleLi);
	parentDom.appendChild(chartDiv);
	parentDom.appendChild(analysisLi);
	drawHistogram(chartDiv, xAxis, yAxis)
}
//获取时间轴显示数据
function getTimeLineNum(stringDate) {
	//	var num = new Date(ms + index * 86400000);
	//	if(num.getDate() == 1) {
	//		return num.getMonth() + 1 + "月"
	//	} else {
	//		return num.getDate()
	//	}
	var dayList = stringDate.split("-");
	if(parseInt(dayList[2]) == 1) {
		return parseInt(dayList[1]) + "月"
	} else {
		return parseInt(dayList[2])
	}
}
//绘制柱状图
function drawHistogram(chartDiv, xAxis, yAxis) {
	var dataAxis = xAxis;
	var data = yAxis;
	var myChart = echarts.init(chartDiv);
	var size = xAxis.length;
	var showSize = Math.min(15 / size, 1) * 100;
	option = {
		backgroundColor: "#FAFAFA",
		grid: {
			x: '0px',
			y: '12px',
			x2: '0px',
			y2: '37px'
		},
		xAxis: {
			data: dataAxis,
			type: "category",
			axisLabel: {
				textStyle: {
					color: '#999999'
				}
			},
			axisTick: {
				show: false
			},
			axisLine: {
				lineStyle: {
					color: '#DADADA'
				}
			}
		},
		yAxis: {
			axisLine: {
				show: false
			},
			axisTick: {
				show: false
			},
			splitLine: {
				show: false
			},
			axisLabel: {
				show: false
			}
		},
		dataZoom: [{
			type: 'inside',
			show: false,
			xAxisIndex: [0],
			start: 0,
			zoomLock: true,
			end: showSize,
			preventDefaultMouseMove: false
		}],
		series: [{
			type: 'bar',
			barWidth: "12px",
			itemStyle: {
				normal: {
					color: "#13C1A1",
				}
			}
		}]
	};
	myChart.setOption(option);
}
//绘制折线图
function drawLineChart(chartDiv, xAxis, yAxis, minValue, maxValue, dataMin, dataMax) {
	var myChart = echarts.init(chartDiv);
	var size = xAxis.length;
	var showSize = Math.min(15 / size, 1) * 100;
	var max = 15;
	if(size > 15) {
		max = size
	}
	if(dataMin > minValue) {
		dataMin = minValue
	}
	if(dataMax < maxValue) {
		dataMax = maxValue
	}
	var diff = dataMax - dataMin;
	option = {
		backgroundColor: "#FAFAFA",
		grid: {
			x: '0px',
			y: '12px',
			x2: '0px',
			y2: '20px',
		},
		xAxis: {
			data: xAxis,
			max: max,
			type: "category",
			boundaryGap: true,
			axisLabel: {
				show: false
			},
			axisTick: {
				show: false
			},
			axisLine: {
				lineStyle: {
					color: '#DADADA'
				}
			}
		},
		yAxis: {
			min: Math.max(dataMin - 0.5 * diff, 0),
			max: dataMax + 0.5 * diff,
			scale: true,
			axisLine: {
				show: false
			},
			axisTick: {
				show: false
			},
			splitLine: {
				show: false
			},
			axisLabel: {
				show: false
			}
		},
		dataZoom: [{
			type: 'inside',
			show: false,
			xAxisIndex: [0],
			zoomLock: true,
			start: 0,
			end: showSize,
			preventDefaultMouseMove: false
		}],
		series: [{
			type: 'line',
			symbol: 'circle',
			symbolSize: 8,
			showAllSymbol: true,
			itemStyle: {
				normal: {
					color: "#13C1A1"
				}
			},
			areaStyle: {
				normal: {
					color: "#E1F5F2"
				}
			},
			label: {
				normal: {
					textStyle: {
						fontSize: 10
					},
					show: true,
				}
			},
			markLine: {
				silent: true,
				symbol: [
					"none", "none"
				],
				data: [
					[{
							value: minValue,
							x: 0,
							yAxis: minValue
						}, // 当xAxis为类目轴时，数值1会被理解为类目轴的index，通过xAxis:-1|MAXNUMBER可以让线到达grid边缘
						{
							x: "100%",
							yAxis: minValue
						},
					],
					[{
							value: maxValue,
							x: 0,
							yAxis: maxValue
						}, // 当xAxis为类目轴时，数值1会被理解为类目轴的index，通过xAxis:-1|MAXNUMBER可以让线到达grid边缘
						{
							x: "100%",
							yAxis: maxValue
						},
					]
				]
			},
			data: yAxis
		}]
	};
	myChart.setOption(option);
}
//绘制双线图
function drawDoubleLine(chartDiv, xAxis, yAxis_sp, yAxis_dp, minValue, maxValue) {
	var myChart = echarts.init(chartDiv);
	var size = xAxis.length;
	var showSize = Math.min(15 / size, 1) * 100;
	var diff = maxValue - minValue;
	var max = 15;
	if(size > 15) {
		max = size
	}
	option = {
		backgroundColor: "#FAFAFA",
		grid: {
			x: '0px',
			y: '12px',
			x2: '0px',
			y2: '20px',
		},
		xAxis: {
			data: xAxis,
			max: max,
			type: "category",
			boundaryGap: true,
			axisLabel: {
				show: false
			},
			axisTick: {
				show: false
			},
			axisLine: {
				lineStyle: {
					color: '#DADADA'
				}
			}
		},
		yAxis: {
			//			max: maxValue + 2 * diff,
			//			min: minValue - 2 * diff,
			boundaryGap: ['10%', '10%'],
			scale: true,
			axisLine: {
				show: false
			},
			axisTick: {
				show: false
			},
			splitLine: {
				show: false
			},
			axisLabel: {
				show: false
			}
		},
		dataZoom: [{
			type: 'inside',
			show: false,
			xAxisIndex: [0],
			start: 0,
			zoomLock: true,
			end: showSize,
			preventDefaultMouseMove: false
		}],
		series: [{
			type: 'line',
			symbol: 'circle',
			symbolSize: 8,
			showAllSymbol: true,
			itemStyle: {
				normal: {
					color: "#13C1A1"

				}
			},
			label: {
				normal: {
					textStyle: {
						fontSize: 10
					},
					show: true,
				}
			},
			areaStyle: {
				normal: {
					color: "#E1F5F2"
				}
			},
			markLine: {
				silent: true,
				symbol: [
					"none", "none"
				],
				data: [

					[{
							value: maxValue,
							x: 0,
							yAxis: maxValue
						},
						{
							x: "100%",
							yAxis: maxValue
						},
					]
				]
			},
			data: yAxis_sp
		}, {
			type: 'line',
			symbol: 'circle',
			symbolSize: 8,
			showAllSymbol: true,
			itemStyle: {
				normal: {
					color: "#ECA15C"
				}
			},
			label: {
				normal: {
					textStyle: {
						fontSize: 10
					},
					show: true,
				}
			},
			areaStyle: {
				normal: {
					color: "#FBF1E8"
				}
			},
			markLine: {
				silent: true,
				symbol: [
					"none", "none"
				],
				data: [
					[{
							value: minValue,
							x: 0,
							yAxis: minValue
						},
						{
							x: "100%",
							yAxis: minValue
						},
					]
				]
			},
			data: yAxis_dp
		}]
	};
	myChart.setOption(option);
}
//绘制瀑布图
function drawWaterfallMap(chartDiv, xAxis, yAxis, yAxis_other) {
	var dataAxis = xAxis;
	var data = yAxis_other;
	var dataOther = yAxis;
	var size = xAxis.length;
	var showSize = Math.min(5 / size, 1) * 100;
	var myChart = echarts.init(chartDiv);
	option = {
		backgroundColor: "#FAFAFA",
		grid: {
			x: '0px',
			y: '12px',
			x2: '0px',
			y2: '37px'
		},
		xAxis: {
			data: dataAxis,
			boundaryGap: false,
			axisLabel: {
				textStyle: {
					color: '#999999'
				}
			},
			axisTick: {
				show: false
			},
			axisLine: {
				lineStyle: {
					color: '#DADADA'
				}
			}
		},
		yAxis: {
			min: 20,
			axisLine: {
				show: false
			},
			axisTick: {
				show: false
			},
			splitLine: {
				show: false
			},
			axisLabel: {
				show: false
			}
		},
		dataZoom: [{
			type: 'inside',
			show: false,
			xAxisIndex: [0],
			start: 0,
			zoomLock: true,
			end: showSize,
			preventDefaultMouseMove: false
		}],
		series: [{
			type: 'bar',
			stack: '睡眠',
			barWidth: "12px",
			itemStyle: {
				normal: {
					barBorderColor: 'rgba(0,0,0,0)',
					color: 'rgba(0,0,0,0)'
				},
				emphasis: {
					barBorderColor: 'rgba(0,0,0,0)',
					color: 'rgba(0,0,0,0)'
				}
			},
			data: dataOther
		}, {
			type: 'bar',
			stack: '睡眠',
			barWidth: "12px",
			itemStyle: {
				normal: {
					color: "#6097D8"
				}
			},
			data: data
		}]
	};
	myChart.setOption(option);
}
