var _self, _userId, _planId, _startTime, _endTime, thisStart, thisEnd;
var _opener;
var typeList = ["早餐","午餐","晚餐"]
var planTemplate = {
	"PM_001": {
		icon: "icon-buxing",
		title: "步行计划",
		description: function(item) {
			return "每日步行达到：" + item.limit + "步";
		}
	},
	"PM_002": {
		icon: "icon-fuyao",
		title: "服药计划",
		description: function(item) {
			return item.drug + "</br>" + "每次剂量" + item.amount + item.unit + "，" + item.day + "天" + item.count + "次";
		}
	},
	"PM_003": {
		icon: "icon-celiang",
		title: "测量计划",
		description: function(item) {
			return item.typeName + "：" + item.day + "天" + item.count + "次";
		}
	},
	"PM_004": {
		icon: "icon-jiankangxiguan",
		title: "健康习惯计划",
		description: function(item) {
			return item.titles;
		}
	},
	"PM_005": {
		icon: "icon-zhudongyundong",
		title: "运动健身计划",
		description: function(item) {
			return item.typeName + "：" + item.min + "分钟"
		}
	},
	"PM_006": {
		icon: "icon-shuimian",
		title: "睡眠计划",
		description: function(item) {
			return "最晚入睡时间：" + item.timeStr + "</br>" + "睡眠持续时长：" + item.hour + "小时"
		}
	},
	"PM_007": {
		icon: "icon-fuzhu",
		title: "辅助训练计划",
		description: function(item) {
			return item.type + "</br>" + "运动时长" + item.min + "分钟： " + item.day + "天" + item.count + "次"
		}
	},
	"PM_008": {
		icon: "icon-yingshi",
		title: "健康饮食计划",
		description: function(item) {
			var str = "";
			for(var i = 0; i < 3; i++) {
				var key = "type_" + i
				if(!g_utils.isEmpty(item[key])) {
					str += '【' + typeList[i] + '】' + item[key].content + "</br>"
				}
			}
			return str + "【上传饮食照片】"
		}
	},
	"PM_009": {
		icon: "icon-yingshi",
		title: "健康饮食计划",
		description: function(item) {
			var str = "";
			for(var i = 0; i < 3; i++) {
				var key = "content" + i
				if(!g_utils.isEmpty(item[key])) {
					str += '【' + typeList[i] + '】' + item[key] + "</br>"
				}
			}
			str = str.substr(0, str.length - 5);
			return str
		}
	}
}
var parentDom = document.getElementById("parent");
var _opener;
var planData;
mui.init();
mui.plusReady(function() {
	_self = plus.webview.currentWebview();
	_planMissionData = _self.planMissionData;
	thisStart = parseInt(_planMissionData.chosedStartTime);
	thisEnd = parseInt(_planMissionData.chosedEndTime);
	planData = _planMissionData.chosedPlanMissionAbstract;
	var finishNum = 0;
	var totalTask = 0;
	for(var i = 0; i < planData.length; i++) {
		var itemTaskNum = planData[i].totalMissionCount;
		var itemFinishNum = planData[i].completedMissionCount;
		finishNum += itemFinishNum;
		totalTask += itemTaskNum;
		setPlanItem(planData[i]);
	}
	setTitle(totalTask, finishNum);
	setPlanCycleTime();
});
//刷新页面
function refreshPage() {
	//parentDom.innerHTML = "";
	setTitle(0, 0);
	setPlanCycleTime();
	var hiddenList = document.querySelectorAll("li");
	for(var i = 0; i < hiddenList.length; i++) {
		hiddenList[i].classList.add("mui-hidden");
		if(hiddenList[i].classList.contains("process-content")) {
			hiddenList[i].innerHTML = ""
		}
	}
	getPlanMissionAbstract(thisStart, thisEnd);
}

function getPlanMissionAbstract(startTime, endTime) {
	g_tools.postCMD("getPlanMissionAbstract", {
		userId: _userId,
		planId: _planId,
		startTime: startTime,
		endTime: endTime
	}, function(result) {
		if(result.code == 0) {
			planData = result.data.planMissionAbstract;
			//setTitle(planData.totalMissionCount,planData.completedMissionCount);
			var finishNum = 0;
			var totalTask = 0;
			for(var i = 0; i < planData.length; i++) {
				var itemTaskNum = planData[i].totalMissionCount;
				var itemFinishNum = planData[i].completedMissionCount;
				finishNum += itemFinishNum;
				totalTask += itemTaskNum;
				setPlanItem(planData[i]);
			}
			setTitle(totalTask, finishNum);
		}
	});
}
//获取周期
function getCycle(ms) {
	return Math.ceil(ms / 86400000);
}
//设置计划周期
function setPlanCycleTime() {
	var planCycleTimeDom = document.querySelector(".cycle-time");
	planCycleTimeDom.innerHTML = g_utils.dateFormat(thisStart, "yyyy.MM.dd") + "-" +
		g_utils.dateFormat(thisEnd, "yyyy.MM.dd") +
		"（" + getCycle(thisEnd - thisStart) + "天）";
}

function setTitle(totalMissionCount, completedMissionCount) {
	var degree;
	if(totalMissionCount == 0) {
		degree = "0%";
	} else {
		degree = parseInt(completedMissionCount / totalMissionCount * 100) + "%";
	}
	document.getElementById("totalTask").innerHTML = '总任务</br><bdi>' + totalMissionCount + '<bdi>';
	document.getElementById("finishTask").innerHTML = '已完成</br><bdi>' + completedMissionCount + '<bdi>';
	document.getElementById("degreeTask").innerHTML = '完成度</br><bdi>' + degree + '<bdi>';
}

function setPlanItem(itemData) {
	var totalMissionCount = itemData.totalMissionCount;
	var completedMissionCount = itemData.completedMissionCount;
	var code = itemData.code;
	var template = planTemplate[code];
	var taskDom = document.getElementById(code);
	var titleDom = document.getElementsByName(code);
	var processItem = document.createElement("div");
	processItem.className = "process-item";
	processItem.innerHTML = '<div>' + template.description(itemData.parametersData) + '</div>' +
		'<div class="schedule-box">' +
		completedMissionCount + '/' + totalMissionCount + '</br>' +
		'<div class="progress-content">' +
		'<progress value="' + completedMissionCount + '" max="' + totalMissionCount + '">' +
		'</progress>' +
		'</div>'
	taskDom.classList.remove("mui-hidden");
	titleDom[0].classList.remove("mui-hidden");
	taskDom.appendChild(processItem);
}
