var CHAMPION_NO = 1;
//图片网络地址url
var SERVER_IMG_ADDRESS = g_tools.IP_FILE;
var DEFAULT_HEAD_IMG = 'img/default_portrait_msg.png';
var sexUrls = ["img/friend_icon_weman.png", "img/friend_icon_man.png"];
var _circleId = null;
var myIndex;
var isReady = false;
var outChampionMembers;
var DEFAULT_SHOW_COUNT = 10; //默认显示数量
var REFRESH_STEP_COUNT = 10; //每次刷新时的步长
var rankListLay = document.getElementById('rankListLay');

mui.init({
	pullRefresh: {
		container: '#refreshContainer',
		down: {
			//下拉成功回调函数
			callback: pullfreshDown
		},
		up: {
			//上拉成功回调函数
			contentrefresh: '正在加载...',
			callback: pullfreshUp
		}
	}
});

mui.ready(function() {
	mui.plusReady(function() {
		var self = plus.webview.currentWebview();
		_circleId = self.circleId;
		//隐藏掉滚动条
		plus.webview.currentWebview().setStyle({
			scrollIndicator: 'none'
		});

		//用于刷新排行榜，后面功能调用触发
		document.addEventListener('rankInfoRefresh', function(e) {
			getCircleRankInfo();
		}, false);
		initCircleRankInfo();
	});
});

function pullfreshDown() {
	if(isReady) {
		setTimeout(function() {
			getCircleRankInfo();
		}, 100);
	}
}

function pullfreshUp() {
	if(isReady) {
		setTimeout(function() {
			var cells = document.body.querySelectorAll('.mui-table-view-cell');
			//获取当前卡片数量
			count = cells.length - 1;
			for(var i = count, len = i + REFRESH_STEP_COUNT; i < len && i < outChampionMembers.length; i++) {
				var otherMember = outChampionMembers[i];
				rereshOneOtherRank(otherMember, i);
			}
			mui('#refreshContainer').pullRefresh().endPullupToRefresh(count >= outChampionMembers.length); //参数为true代表没有更多数据了。
		}, 100);
	}
}

function intoProfileByCareId(careId) {
	g_mui.openUserDataDetail({
		openerProperty: 1,
		userId: careId,
	});
}

function initCircleRankInfo() {
	g_tools.postCMD('getCircleRankInfo', {
		circleId:_circleId
	}, function(data) {
		if(data.code == 0) {
			var members = data.data.members;
			if(members) {
				isReady = true;
				var sortMembers = sortRankInfoByNo(members);
				var championInfo = sortMembers[0];
				var myRankInfo = getMyRankInfo(sortMembers);
				outChampionMembers = deleteFristJsonObj(sortMembers);
				refreshMyRank(myRankInfo, sortMembers);
				refreshChampionRank(championInfo);
				//默认显示4条
				rankListLay.innerHTML = "";
				if(outChampionMembers != null && outChampionMembers.length != 0 && outChampionMembers != '') {
					for(var i = 0; i < Math.min(DEFAULT_SHOW_COUNT, outChampionMembers.length); i++) {
						var otherMember = outChampionMembers[i];
						rereshOneOtherRank(otherMember, i);
					}
				}
			}
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE, {
		noNetworkMode: g_tools.TIP_MODE_TOAST //！！！！！！！！！重点代码！！！！！！！！！
	});
}

function getCircleRankInfo() {
	g_tools.postCMD('getCircleRankInfo', {
		circleId:_circleId
	}, function(data) {
		if(data.code == 0) {
			var members = data.data.members;
			if(members) {
				isReady = true;
				var sortMembers = sortRankInfoByNo(members);
				var championInfo = sortMembers[0];
				var myRankInfo = getMyRankInfo(sortMembers);
				outChampionMembers = deleteFristJsonObj(sortMembers);
				refreshMyRank(myRankInfo, sortMembers);
				refreshChampionRank(championInfo);
				//默认显示3条
				rankListLay.innerHTML = ""
				if(outChampionMembers != null && outChampionMembers.length != 0 && outChampionMembers != '') {
					for(var i = 0; i < Math.min(DEFAULT_SHOW_COUNT, outChampionMembers.length); i++) {
						var otherMember = outChampionMembers[i];
						rereshOneOtherRank(otherMember, i);
					}
				}
				//结束下拉刷新
				mui('#refreshContainer').pullRefresh().endPulldownToRefresh();
				//重置上拉加载
				mui('#refreshContainer').pullRefresh().refresh(true);
			}
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE, {
		disableWait: true, //禁止显示wait框
		noNetworkMode: g_tools.TIP_MODE_TOAST //！！！！！！！！！重点代码！！！！！！！！！
	});
}

function refreshMyRank(myRankInfo, sortMembers) {
	var myCircleImg = document.getElementById('myCircleImg');
	var myRankNo = document.getElementById('myRankNo');
	var myBestNo = document.getElementById('myBestNo');
	var myBestCount = document.getElementById('myBestCount');
	var myBestNoRate = document.getElementById('myBestNoRate');
	var myChampionRate = document.getElementById('myChampionRate');
	var mySportScore = document.getElementById('mySportScore');
	var myCareScore = document.getElementById('myCareScore');
	var myHealthScore = document.getElementById('myHealthScore');
	var myLastTip = document.getElementById('myLastTip');
	var items = document.getElementsByClassName('times-radio-item');

	if(myRankInfo != null && myRankInfo != undefined) {
		if(!g_utils.isEmpty(myRankInfo.headImg)) {
			var imgUrl = SERVER_IMG_ADDRESS + myRankInfo.headImg + "&tb=1";
			myCircleImg.setAttribute('data-src', imgUrl);
			myCircleImg.onload();
			myCircleImg.addEventListener('tap',function(){
				intoProfileByCareId(myRankInfo.userId);
			});
		}
		if(!g_utils.isEmpty(myRankInfo.no)) {
			myRankNo.innerHTML = myRankInfo.no;
		}
		if(!g_utils.isEmpty(myRankInfo.bestNo)) {
			myBestNo.innerHTML = myRankInfo.bestNo;
		}
		if(!g_utils.isEmpty(myRankInfo.bestNoCount)) {
			myBestCount.innerHTML = myRankInfo.bestNoCount;
		}
		if(!g_utils.isEmpty(myRankInfo.bestNoRate)) {
			if(myRankInfo.bestNo == CHAMPION_NO) {
				myChampionRate.classList.remove('mui-hidden');
				for(var i = 0; i < items.length; i++) {
					items[i].classList.add('height2');
				}
				myBestNoRate.innerHTML = getPercent(myRankInfo.bestNoRate);
			} else {
				myChampionRate.classList.add('mui-hidden');
				for(var i = 0; i < items.length; i++) {
					items[i].classList.remove('height2');
				}
				myBestNoRate.innerHTML = getPercent(myRankInfo.bestNoRate);
			}
		}
		if(!g_utils.isEmpty(myRankInfo.sportScore)) {
			mySportScore.innerHTML = myRankInfo.sportScore;
		}

		if(!g_utils.isEmpty(myRankInfo.careScore)) {
			myCareScore.innerHTML = myRankInfo.careScore;
		}

		if(!g_utils.isEmpty(myRankInfo.healthScore)) {
			myHealthScore.innerHTML = myRankInfo.healthScore;
		}

		if(myIndex > 0) {
			myLastTip.classList.remove('mui-hidden');
			myLastTip.innerHTML = getLastTip(myRankInfo, sortMembers);
		} else {
			myLastTip.classList.add('mui-hidden');
		}
	}
}

function refreshChampionRank(championInfo) {
	var championImg = document.getElementById('championImg');
	var championName = document.getElementById('championName');
	var championDescription = document.getElementById('championDescription');
	var championSportScore = document.getElementById('championSportScore');
	var championCareScore = document.getElementById('championCareScore');
	var championHealthScore = document.getElementById('championHealthScore');

	if(!g_utils.isEmpty(championInfo)) {
		if(!g_utils.isEmpty(championInfo.headImg)) {
			var imgUrl = SERVER_IMG_ADDRESS + championInfo.headImg + "&tb=1";
			championImg.setAttribute('data-src', imgUrl);
			championImg.onload();
			championImg.addEventListener('tap',function(){
				intoProfileByCareId(championInfo.userId);
			});
		}
		championName.innerHTML = "";
		if(!g_utils.isEmpty(championInfo.nickname) || !g_utils.isEmpty(championInfo.userName)) {
			championName.innerHTML = getDisplayName(championInfo);
		}

		if(!g_utils.isEmpty(championInfo.sex)) {
			var img = document.createElement("img");
			img.className = "sex-img";
			img.src = getSexIconUrl(championInfo.sex);
			championName.appendChild(img);
		}

		championDescription.innerHTML = getChampionDescription(championInfo);

		if(!g_utils.isEmpty(championInfo.sportScore)) {
			championSportScore.innerHTML = championInfo.sportScore;
		}

		if(!g_utils.isEmpty(championInfo.careScore)) {
			championCareScore.innerHTML = championInfo.careScore;
		}

		if(!g_utils.isEmpty(championInfo.healthScore)) {
			championHealthScore.innerHTML = championInfo.healthScore;
		}
	}
}

/**
 * 刷新一条其它排行信息
 * @param {Object} otherMember
 */
function rereshOneOtherRank(otherMember, index) {
	var li = getOutChampionLi(otherMember, index);
	rankListLay.appendChild(li);

	//添加头像点击事件
    var liDom = document.getElementById(otherMember.userId);
    if(!g_utils.isEmpty(liDom)) {
        liDom.addEventListener('tap',function(){
            intoProfileByCareId(otherMember.userId);
        });
    }
}

function getOutChampionLi(member, index) {
	var div = document.createElement('div');
	div.className = 'mui-table-view-cell mui-media mui-collapse-content';
	var orderHeadHtml = "";
	if(index == 0) {
		orderHeadHtml = '<div class="rankList"><img src="img/friend_icon_no2.png" class="rank-order-img"/>';
	} else if(index == 1) {
		orderHeadHtml = '<div class="rankList"><img src="img/friend_icon_no3.png" class="rank-order-img"/>';
	} else {
		var order = index + 2;
		orderHeadHtml = '<div class="rankList"><div class="rank-order-txt">' + order + '</div>';
	}

	div.innerHTML = orderHeadHtml + '<img class="rank-head-img head-img" src="img/default_portrait_min.png"' +
		' data-src=' + getImgUrl(member.headImg) + ' onload="load(this)"'+
		//'onclick=intoProfileByCareId("' + member.userId +'") />' +
		'id="' + member.userId +'" />' +
		'<div class="rank-info-content"><div class="rank-name">' + getDisplayName(member) +
		'<img class="small-sex-icon" src="' + getSexIconUrl(member.sex) + '"/></div><div class="rank-info">' +
		'<div class="rank-info-item sport-color"><div class="sport-title rank-value">' + member.sportScore +
		'</div></div><div class="rank-info-item care-color"><div class="care-title rank-value ">' + member.careScore +
		'</div></div><div class="rank-info-item health-color"><div class="health-title rank-value">' + member.healthScore +
		'</div></div></div></div>';

	return div;
}
/**
 * 得到我与上一名比较的差距提示
 * @param {Object} 
 */
function getLastTip(myRankInfo, sortMembers) {
	var lastTip = "";
	var myAllScore = myRankInfo.healthScore + myRankInfo.sportScore + myRankInfo.careScore;
	if(myIndex > 0) {
		var lastRankInfo = sortMembers[myIndex - 1];
		var lastAllScore = lastRankInfo.healthScore + lastRankInfo.sportScore + lastRankInfo.careScore;
		var disScore = Math.max(1, lastAllScore - myAllScore);
		lastTip = "再增加" + disScore + "分就可以赶上前一名了！"
	}
	return lastTip;
}

function getSexIconUrl(sex) {
	var imgUrl = sexUrls[1];
	if(sex >= 0) {
		imgUrl = sexUrls[sex];
	}
	return imgUrl;
}
/**
 * 得到我的圈子排行信息
 */
function getMyRankInfo(members) {
	var myRankInfo = {};
	var myUserId = g_tools.getUserId(); //获得登录用户userId
	if(members != null || members != undefined) {
		for(var i = 0; i < members.length; i++) {
			if(myUserId == members[i].userId) {
				myIndex = i;
				myRankInfo = members[i];
			}
		}
	}
	return myRankInfo;
}

/**
 * 根据名次排序排行榜列表
 */
function sortRankInfoByNo(members) {
	return JsonSort(members, 'no');
}

/*
@function JsonSort 对json排序
@param    json     用来排序的json
@param    key      排序的键值
*/
function JsonSort(json, key) {
	for(var j = 1, jl = json.length; j < jl; j++) {
		var temp = json[j],
			val = temp[key],
			i = j - 1;
		while(i >= 0 && json[i][key] > val) {
			json[i + 1] = json[i];
			i = i - 1;
		}
		json[i + 1] = temp;
	}
	return json;
}

function getImgUrl(headImg) {
	var imgUrl = DEFAULT_HEAD_IMG;
	if(headImg != null && headImg != undefined) {
		imgUrl = SERVER_IMG_ADDRESS + headImg + "&tb=1";
	}
	return imgUrl;
}

/**
 * 获取显示的名字
 * @param {Object} obj
 */
function getDisplayName(obj) {
	return g_tools.getNickname(obj.nickname,obj.userName);
}

/**
 * 计算出百分比
 * @param {Object} noRate
 */
function getPercent(noRate) {
	var rate = noRate * 100;
	if(rate == 0) {
		return 0;
	} else if(rate < 1) {
		return "小于1";
	}
	return Math.floor(rate);
}

/**
 * 得到冠军的描述文字
 */
function getChampionDescription(championInfo) {
	var descrpt = "";
	var precentRate = Math.floor(championInfo.bestNoRate * 100);
	var bestNoCount = championInfo.bestNoCount;
	if(precentRate > 10) { //百分率大于10%
		descrpt = "我已经获得过" + bestNoCount + "次第一名，夺冠率高达" + precentRate + "%哟，想来挑战一下？"
	} else {
		if(bestNoCount == 0) {
			descrpt = "我是今天第一名了哟，想来挑战一下？"
		} else {
			descrpt = "我已经获得过" + bestNoCount + "次第一名哟，想来挑战一下？"
		}
	}
	return descrpt;
}

function deleteFristJsonObj(JsonArray) {
	var outFristJsonArray = [];
	for(var i = 0; i < JsonArray.length; i++) {
		if(i > 0) {
			outFristJsonArray.push(JsonArray[i]);
		}
	}
	return outFristJsonArray;
}