var INVITATION_PASS_STATUS = 1; //通过邀请状态
var INVITATION_IGNORE_STATUS = 2; //忽略邀请状态
//图片网络地址url
var SERVER_IMG_ADDRESS = g_tools.IP_FILE;
var DEFAULT_HEAD_IMG = '../../global/img/default_head.png';
var nullPage = document.getElementById("nullPage"); //空值页面
var invatitionLay = document.getElementById("invatition-lay"); //邀请列表容器
var blank15 = document.getElementById("blank15");
var circleLay = document.getElementById("circle-lay"); //圈子列表容器
var isHaveShowDatas = false; //有要显示的数据
var isNotDoneInvation = false; //有未处理的邀请
var isNotHaveCircle = false; //有无圈子
var showInvationCount = 0;
var isReady = true;
var invitationList, circleList;

var DEFAULT_SHOW_COUNT = 10; //默认显示圈子的数量
var REFRESH_STEP_COUNT = 10; //每次刷新时圈子的步长
mui.init({
	pullRefresh: {
		container: '#refreshContainer',
		down: {
			//下拉成功回调函数
			callback: pullfreshDown
		},
		up: {
			//上拉成功回调函数
			contentrefresh: '正在加载...',
			callback: pullfreshUp
		}
	}
});
mui.ready(function() {
	mui.plusReady(function() {
		//隐藏掉滚动条
		plus.webview.currentWebview().setStyle({
			scrollIndicator: 'none'
		});

		//用于刷新圈子列表，后面功能调用触发
		document.addEventListener('refreshPage', function(e) {
			initCircleInvitationList();
		}, false);
		mui.fire(plus.webview.getWebviewById('index'),"subPageReady",{});
	});
});

/**
 * 跳转到圈子详情页面
 * @param {Object} circleInfo 圈子
 */
function onTapCircleList(circleInfo) {
	g_mui.openPage(g_module.friendCircle, 'circleDetail.html', {
		circleInfo: circleInfo,
	});
}

function pullfreshDown() {
	if(isReady) {
		setTimeout(function() {
			getCircleInvitationList();
		}, 100);
	}
}

function pullfreshUp() {
	if(isReady) {
		setTimeout(function() {
			var cells = document.body.querySelectorAll('.mui-table-view-cell');
			//获取当前卡片数量
			count = cells.length - showInvationCount;
			for(var i = cells.length, len = i + REFRESH_STEP_COUNT; i < len && i < circleList.length; i++) {
				var circle = circleList[i];
				refreshOneCircleList(circle);
			}
			mui('#refreshContainer').pullRefresh().endPullupToRefresh(count >= circleList.length); //参数为true代表没有更多数据了。
		}, 100);
	}
}

function initTableItem() {
	//清空圈子列表的子项
	invatitionLay.innerHTML = "";
	circleLay.innerHTML = "";
	//取消蒙板
	if(isHaveShowDatas) { //如果有数据
		plus.webview.currentWebview().setStyle({
			mask: 'none'
		});
		nullPage.classList.add("mui-hidden");
		if(isNotDoneInvation) { //有要显示的邀请
			refreshInvationList(invitationList);
			if(isNotHaveCircle) {
				blank15.classList.remove("mui-hidden");
				circleLay.classList.remove("mui-hidden");
			} else {
				blank15.classList.add("mui-hidden");
				circleLay.classList.add("mui-hidden");
			}

		} else {
			circleLay.classList.remove("mui-hidden");
			blank15.classList.add("mui-hidden");
		}

		//默认显示
		for(var i = 0; i < Math.min(DEFAULT_SHOW_COUNT, circleList.length); i++) {
			refreshOneCircleList(circleList[i]);
		}
	} else {
		//防止空值页面可以下拉刷新,先加一个蒙版,有数据时再取消蒙版
		nullPage.classList.remove('mui-hidden');
		plus.webview.currentWebview().setStyle({
			mask: 'rgba(0,0,0,0)'
		});
	}

}

function initCircleInvitationList() {
	showInvationCount = 0;
	//获取对于某个用户的圈子邀请列表
	g_tools.postCMD('getCircleInvitationWithUser', {}, function(data) {
		if(data.code == 0) {
			invitationList = data.data.reverse();
			if(invitationList != null && invitationList.length != 0 && invitationList != '') {
				for(var i = 0; i < invitationList.length; i++) {
					if(invitationList[i].status == 0) { //是未处理过的邀请
						isReady = true;
						isHaveShowDatas = true;
						isNotDoneInvation = true;
						showInvationCount++;
					}
				}
				if(isNotDoneInvation) {
					mui.fire(plus.webview.getWebviewById(g_module.index.ID), "setInviteIcon", {
						isNotDoneInvation: isNotDoneInvation
					});
				}
			}
			//得到我的圈子列表
			g_tools.postCMD('getMyJoinCircle', {}, function(data) {
				if(data.code == 0) {
					circleList = data.data.reverse();
					if(circleList && circleList.length != 0) {
						isHaveShowDatas = true;
						isNotHaveCircle = true;
						isReady = true;
					}
					initTableItem();
				}
			}, g_tools.MODE_WEB_LOCAL_CACHE);
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE, { //！！！！！！！！！重点代码！！！！！！！！！
		noNetworkMode: g_tools.TIP_MODE_INTERFACE, //界面显示断网提示内容的模式
		contentDomId: 'mainContent', //显示数据内容的dom元素id
		tipDomId: 'noNetworkTip' //显示断网提示的dom元素id
	});
}

function getCircleInvitationList() {
	showInvationCount = 0;
	isReady = false;
	isHaveShowDatas = false;
	isNotDoneInvation = false;
	g_tools.postCMD('getCircleInvitationWithUser', {}, function(data) {
		if(data.code == 0) {
			invitationList = data.data.reverse();
			if(invitationList != null && invitationList.length != 0 && invitationList != '') {
				for(var i = 0; i < invitationList.length; i++) {
					if(invitationList[i].status == 0) { //是未处理过的邀请
						isReady = true;
						isHaveShowDatas = true;
						isNotDoneInvation = true;
						showInvationCount++;
					}
				}
				if(!isNotDoneInvation) {
					mui.fire(plus.webview.getWebviewById(g_module.index.ID), "setInviteIcon", {
						isNotDoneInvation: isNotDoneInvation
					});
				}
			}
			//得到我的圈子列表
			g_tools.postCMD('getMyJoinCircle', {}, function(data) {
				if(data.code == 0) {
					circleList = data.data.reverse();
					if(circleList && circleList.length != 0) {
						isHaveShowDatas = true;
						isNotHaveCircle = true;
						isReady = true;
					}
					initTableItem();
					//结束下拉刷新
					mui('#refreshContainer').pullRefresh().endPulldownToRefresh();
					//重置上拉加载
					mui('#refreshContainer').pullRefresh().refresh(true);
				}
			}, g_tools.MODE_WEB_LOCAL_CACHE, {
				disableWait: true, //禁止显示wait框
			});
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE, {
		disableWait: true, //禁止显示wait框
		noNetworkMode: g_tools.TIP_MODE_TOAST //！！！！！！！！！重点代码！！！！！！！！！
	});
}

function refreshInvationList(invitationList) {
	if(invitationList.length > 0) {
		for(var i = 0; i < invitationList.length; i++) {
			if(invitationList[i].status == 0) { //是未处理过的邀请
				var li = getInvatitionLi(invitationList[i]);
				invatitionLay.appendChild(li);
			}
		}
	}
}

function getInvatitionLi(invitation) {
	var li = document.createElement('li');
	li.className = 'mui-table-view-cell mui-media mui-collapse-content';
	li.innerHTML = '<div class="invitation-head">' +
		'<span class="invitation-tip">' + invitation.inviterName + '邀请您加入圈子</span>' +
		'<span class="invitation-time">' + fomatDate(invitation.invitationTime) + '</span></div>' +
		'<img class="mui-media-icon circle-img" src="../../global/img/circlePhoto.png"' +
		'data-src=' + getCircleImgUrl(invitation.circleImg) + ' onload="load(this)"/>' +
		'<div class="invitation-content"><div class="circle-name">' + invitation.name +
		'<span class="circleNum">' + invitation.memberNum + '人</span></div>' +
		'<p class="circle-desicription mui-ellipsis-2">' + invitation.declaration + '</p></div>' +
		'<div class="invitation-button"><button type="button" class="mui-btn" onclick=acceptInvitation("' + invitation.invitationId + '")>加入</button>' +
		'<button type="button" class="mui-btn top20" onclick=ignoreInvitation("' + invitation.invitationId + '")>忽略</button></div>';
	return li;
}

function refreshOneCircleList(circle) {
	var li = getCircleLi(circle);
	circleLay.appendChild(li);
}

function getCircleLi(circle) {
	var li = document.createElement('li');
	li.className = 'mui-table-view-cell mui-media mui-collapse-content';
	li.innerHTML = '<img class="mui-media-icon circle-img" src="../../global/img/circlePhoto.png"' +
		'data-src=' + getCircleImgUrl(circle.circleImg) + ' onload="load(this)"/>' +
		'<div class="circle-content"><div class="circle-name">' + circle.name +
		'<span class="circleNum">' + circle.members.length + '人</span></div>' +
		'<p class="circle-desicription mui-ellipsis-2">' + circle.declaration + '</p></div>';
	li.addEventListener('tap', function(event) {
		onTapCircleList(circle);
	});
	return li;
}

/**
 * 格式化日期格式 如2017-11-20
 * @param {String} invitationTime 时间毫秒
 */
function fomatDate(invitationTime) {
	return g_printTools.printDateStrByTimeMillis(invitationTime);
}

/**
 * 接受邀请加入圈子
 * @param {Object} invitationId
 * @param {Object} status
 */
function acceptInvitation(invitationId) {
	g_tools.postCMD('setCircleInvitationStatus', {
		invitationId: invitationId,
		status: INVITATION_PASS_STATUS
	}, function(data) {
		if(data.code == 0) {
			pullfreshDown();
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE);
}

/**
 * 忽略邀请
 * @param {Object} invitationId
 * @param {Object} status
 */
function ignoreInvitation(invitationId) {
	g_tools.postCMD('setCircleInvitationStatus', {
		invitationId: invitationId,
		status: INVITATION_IGNORE_STATUS
	}, function(data) {
		if(data.code == 0) {
			pullfreshDown();
		}
	});
}

function getCircleImgUrl(circleImg) {
	var imgUrl = DEFAULT_HEAD_IMG;
	if(!g_utils.isEmpty(circleImg)) {
		imgUrl = SERVER_IMG_ADDRESS + circleImg + "&tb=1";
	}
	return imgUrl;
}

//用于ios接收跳转事件
//document.addEventListener("gotoCircleDetail", function(event) {
//    if(plus.os.name == g_config.IOS) {
//        var UserDefaultsClass = plus.ios.importClass("NSUserDefaults");
//        var standardUserDefaults = UserDefaultsClass.standardUserDefaults();
//        var circleInfo = plus.ios.invoke(standardUserDefaults, "objectForKey:", "currentCircleInfo");
//        //alert(circleInfo);
//        g_mui.openPage(g_module.friendCircle, 'circleDetail.html', {
//            circleInfo: JSON.parse(circleInfo),
//        });
//    }
//});
