var selectedContacts = []; //已选择过的联系人列表
var allCare = [];
var circleMembersPhone = [];

//界面显示相关
var contactListLay = document.getElementById('contactListLay'); //联系人列表（html内容的字符串）
var exportBtn = document.getElementById('export'); //导入按钮
var chooseBtn = document.getElementById('choose'); //全选按钮

//右侧字母导航栏显示内容
var word = ["A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "#"];

//mui初始化
mui.init();
mui.plusReady(function() {

	var header = document.querySelector('header.mui-bar');
	var list = document.getElementById('list');
	//calc hieght
	list.style.height = (document.body.offsetHeight - header.offsetHeight - exportBtn.offsetHeight) + 'px';

	getParam();

	//生成右侧字母导航
	var nav = document.getElementsByClassName('mui-indexed-list-bar')[0];
	var navInner = "";
	for(var index = 0; index < word.length; index++) { //遍历链表
		navInner += "<a>" + word[index] + "</a>"; //侧栏导航代码，哪种字母有名字存在侧栏导航就需要有该字母
	}
	nav.innerHTML = navInner;

	onInitExportBtn();
	onInitChooseBtn();

	getAllCare();
});

/**
 * 获得上个页面传入的参数
 */
function getParam() {
	var self = plus.webview.currentWebview();
	if(!g_utils.isEmpty(self)) {
		if(!g_utils.isEmpty(self.selectedContacts)) {
			selectedContacts = self.selectedContacts;
		}
        if(!g_utils.isEmpty(self.circleMembersPhone_Str)) {
            circleMembersPhone = self.circleMembersPhone_Str.split(",");
        }
	}  
}

function getAllCare() {
	var loading = plus.nativeUI.showWaiting('', {
		loading: {
			display: 'inline'
		},
		modal: false
	});

	g_tools.postCMD('getCareMeList2', {}, function(data) {
		if(data.code == 0) {
			var resultList = data.data;

			for(var i = 0; i < resultList.length; i++) {
				var nickname = "";
				if(!g_utils.isEmpty(resultList[i].nickname)) {
					nickname = resultList[i].nickname;
				}
				var newCare = {
					name: g_tools.getDisplayName(resultList[i]),
					phone: resultList[i].userName,
					headImg: resultList[i].headImg,
					isExist: 1,
					nickname: nickname,
					userId: resultList[i].myCareId
				}
                if (g_tools.getUserName()!=newCare.phone){
                    allCare.push(newCare);
                }
			}

			//获取关爱人
			g_tools.postCMD('getMyCareList3', {}, function(data) {
				if(!g_utils.isEmpty(loading)) loading.close(); //关闭等待框

				if(data.code == 0) {
					var resultList1 = data.data;
					for(var i = 0; i < resultList1.length; i++) {
						var nickname1 = "";
						if(!g_utils.isEmpty(resultList1[i].nickname)) {
							nickname1 = resultList1[i].nickname;
						}
						var newCare = {
							name: g_tools.getDisplayName(resultList1[i]),
							phone: resultList1[i].userName,
							headImg: resultList1[i].headImg,
							isExist: 1,
							nickname: nickname1,
							userId: resultList1[i].careId
						}
                        if (g_tools.getUserName()!=newCare.phone){
                            allCare.push(newCare);
                        }
					}
					//去重复
					allCare = contatcsUnique(allCare);
                    allCare = spliceContactsWithCircleMembersPhone(allCare);
					allCare = getShowContacts(allCare, selectedContacts);

					//添加id
					tempList = [];
					for(var i = 0; i < allCare.length; i++) {
						var newCare = {
							name: allCare[i].name,
							phone: allCare[i].phone,
							headImg: allCare[i].headImg,
							isExist: 1,
							id: i,
							nickname: allCare[i].nickname,
							userId: allCare[i].userId
						}
						tempList.push(newCare);
					}
					allCare = tempList;
					//绘制列表
					refreshContactList();
					window.indexedList = new mui.IndexedList(list);
				}
			}, g_tools.MODE_WEB_LOCAL_CACHE);
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE);
}

function refreshContactList() {
	contactListLay.innerHTML = "";
	contactListLay.innerHTML = getAllList(sortPY(allCare));
}

/**
 * 获得关爱列表html并加上字母导航
 * @param {Object} linkList 排序后的数据链表
 */
function getAllList(linkList) {
	var normalInner = "";

	//为侧栏导航做准备
	for(var index = 0; index < linkList.size(); index++) { //遍历链表
		var data = linkList.getVal(index).data;
		if(data.length != 0) {
			normalInner += "<li data-group=" + word[index] + " class='mui-table-view-divider mui-indexed-list-group'>" + word[index] + "</li>"
			for(var zindex = 0; zindex < data.length; zindex++) { //遍历数组，把信息放到<li>标签
				var name = data[zindex].name;
				var id = data[zindex].id;
				var dataValue = makePy(name);
				var phone = data[zindex].phone;
				var imgDataSrc = data[zindex].headImg;
				if(!g_utils.isEmpty(imgDataSrc)) {
					imgDataSrc = g_tools.IP_FILE + imgDataSrc+"&tb=1";
				}
				var imgSrc = "../../global/img/default_portrait_msg.png";
				normalInner += "<li class='mui-table-view-cell mui-indexed-list-item mui-collapse-content mui-checkbox mui-left' data-value=" + dataValue + "  data-tags='' id=" + id + "><input type='checkbox'/><img src='" + imgSrc + "' data-src='" + imgDataSrc + "' onload='load(this)' class='square-head' /><div class='my-value'><div>" + name + "</div><span>" + phone + "</span></div></li>";
			}
		}
	}
	return normalInner;
}

/**
 * 初始化导入按钮
 */
function onInitExportBtn() {
	exportBtn.addEventListener('tap', function() {
		var checkboxArray = [].slice.call(list.querySelectorAll('input[type="checkbox"]'));
		var allSelectContacts = selectedContacts.slice();

		checkboxArray.forEach(function(box) {
			if(box.checked) { //已选择
				var phoneStr = box.parentNode.children[2].children[1].innerText;
				for(var i = 0; i < allCare.length; i++) {
					if(allCare[i].phone == phoneStr) {
						allSelectContacts.push(allCare[i]);
					}
				}
			}
		});

		var nList = plus.webview.currentWebview().opener();
		mui.fire(nList, 'exportContacts', {
			allContacts: allSelectContacts,
			chooseContacts: getShowContacts(allSelectContacts, selectedContacts)
		});
		mui.back(true);
	}, false);
}

/**
 * 初始化全选、取消全选按钮
 */
function onInitChooseBtn() {
	chooseBtn.addEventListener('tap', function() {
		var checkboxArray = [].slice.call(list.querySelectorAll('input[type="checkbox"]'));
		if(this.innerText == "全选") { //全选
			checkboxArray.forEach(function(box) {
				box.checked = true;
			});
			this.innerText = "取消全选";
		} else if(this.innerText == "取消全选") { //取消全选
			checkboxArray.forEach(function(box) {
				box.checked = false;
			});
			this.innerText = "全选";
		}
	}, false);
}

//联系人去重(电话号码相同去重)
function contatcsUnique(allPhoneContacts) {
	var r = [];
	for(var i = 0; i < allPhoneContacts.length; i++) {
		var flag = true;
		var temp = allPhoneContacts[i];
		for(var j = 0; j < r.length; j++) {
			if(temp.phone === r[j].phone) {
				flag = false;
				break;
			}
		}
		if(flag) {
			r.push(temp);
		}
	}
	return r;
}

/**
 * 去除已存在的圈成员
 * @param {Object} contatcs
 */
function spliceContactsWithCircleMembersPhone(allContacts) {
    var tempContacts = allContacts.slice();
    if(!g_utils.isEmpty(circleMembersPhone)) {
        for(var j = 0; j < circleMembersPhone.length; j++) {
            for(var i = tempContacts.length - 1; i >= 0; i--) {
                if(tempContacts[i].phone == circleMembersPhone[j]) {
                    tempContacts.splice(i, 1);
                }
            }
        }
    }
    return tempContacts;
}

/**
 * 去除已选择的联系人
 * @param {Object} contatcs
 */
function getShowContacts(allContacts, selectedContacts) {
	var tempContacts = allContacts.slice();
	if(!g_utils.isEmpty(selectedContacts)) {
		for(var j = 0; j < selectedContacts.length; j++) {
			for(var i = tempContacts.length - 1; i >= 0; i--) {
				if(tempContacts[i].phone == selectedContacts[j].phone) {
					tempContacts.splice(i, 1);
				}
			}
		}
	}
	return tempContacts;
}

function sortPY(username) {
	var a = new Array();
	var b = new Array();
	var c = new Array();
	var d = new Array();
	var e = new Array();
	var f = new Array();
	var g = new Array();
	var h = new Array();
	var i = new Array();
	var j = new Array();
	var k = new Array();
	var l = new Array();
	var m = new Array();
	var n = new Array();
	var o = new Array();
	var p = new Array();
	var q = new Array();
	var r = new Array();
	var s = new Array();
	var t = new Array();
	var u = new Array();
	var v = new Array();
	var w = new Array();
	var x = new Array();
	var y = new Array();
	var z = new Array();
	var other = new Array();
	for(var index = 0; index < username.length; index++) {
		var str = makePy(username[index].name);

		var result = str[0].charAt(0);

		switch(result) {
			case "a":
			case "A":
				a.push(username[index]);
				break;
			case "b":
			case "B":
				b.push(username[index]);
				break;
			case "c":
			case "C":
				c.push(username[index]);
				break;
			case "d":
			case "D":
				d.push(username[index]);
				break;
			case "e":
			case "E":
				e.push(username[index]);
				break;
			case "f":
			case "F":
				f.push(username[index]);
				break;
			case "g":
			case "G":
				g.push(username[index]);
				break;
			case "h":
			case "H":
				h.push(username[index]);
				break;
			case "i":
			case "I":
				i.push(username[index]);
				break;
			case "j":
			case "J":
				j.push(username[index]);
				break;
			case "k":
			case "K":
				k.push(username[index]);
				break;
			case "l":
			case "L":
				l.push(username[index]);
				break;
			case "m":
			case "M":
				m.push(username[index]);
				break;
			case "n":
			case "N":
				n.push(username[index]);
				break;
			case "o":
			case "O":
				o.push(username[index]);
				break;
			case "p":
			case "P":
				p.push(username[index]);
				break;
			case "q":
			case "Q":
				q.push(username[index]);
				break;
			case "r":
			case "R":
				r.push(username[index]);
				break;
			case "s":
			case "S":
				s.push(username[index]);
				break;
			case "t":
			case "T":
				t.push(username[index]);
				break;
			case "u":
			case "U":
				u.push(username[index]);
				break;
			case "v":
			case "V":
				v.push(username[index]);
				break;
			case "w":
			case "W":
				w.push(username[index]);
				break;
			case "x":
			case "X":
				x.push(username[index]);
				break;
			case "y":
			case "Y":
				y.push(username[index]);
				break;
			case "z":
			case "Z":
				z.push(username[index]);
				break;
			default:
				other.push(username[index]);
				break;
		}
	}
	var linkList = new LinkedList();

	linkList.add(a);
	linkList.add(b);
	linkList.add(c);
	linkList.add(d);
	linkList.add(e);
	linkList.add(f);
	linkList.add(g);
	linkList.add(h);
	linkList.add(i);
	linkList.add(j);
	linkList.add(k);
	linkList.add(l);
	linkList.add(m);
	linkList.add(n);
	linkList.add(o);
	linkList.add(p);
	linkList.add(q);
	linkList.add(r);
	linkList.add(s);
	linkList.add(t);
	linkList.add(u);
	linkList.add(v);
	linkList.add(w);
	linkList.add(x);
	linkList.add(y);
	linkList.add(z);
	linkList.add(other);

	return linkList;

}

//单链表节点
function Entry(next, data) {
	this.next = next;
	this.data = data;
}
//链表
function LinkedList() {
	var length = 0;
	this.head = new Entry(null, null);
	this.end = new Entry(null, null);
	this.add = function(data) {
		var newentry = new Entry(null, data);
		if(this.head.data) {
			this.end.next = newentry;
			this.end = newentry;
		} else {
			this.head = newentry;
			this.end = newentry;
		}
		length += 1;
	};
	this.show = function() {
		var temp = this.head;
		for(; temp != null; temp = temp.next) {
			//            console.log(temp.data);
		}
	};
	this.size = function() {
		return length;
	};
	this.getVal = function(index) {
		var current;
		current = this.head;
		if(index > 0 || index < length) {
			for(var i = 0; i < index; i++) {
				current = current.next;
			}
		} else if(index >= length || index < 0) {
			return;
		}
		return current;
	};
}
