var listDom = document.getElementById("scroll-list");
var noNetWorkDom = document.querySelector(".no_netWork");
var reconnectDom = document.getElementById("no_netWork_button");
var emptyDom = document.querySelector(".message-mask");
//mui初始化
mui.init({});
mui.plusReady(function() {
	getMedicalTeamMemberList();
	mui('.mui-scroll-wrapper').scroll({
		deceleration: 0.0005 //flick 减速系数，系数越大，滚动速度越慢，滚动距离越小，默认值0.0006
	});
	//隐藏掉滚动条
	plus.webview.currentWebview().setStyle({
		scrollIndicator: 'none'
	});
	document.addEventListener('refreshPage', function(e) {
		current_page = 0;
		cleanList();
		getMedicalTeamMemberList();
	});
	reconnectDom.addEventListener("tap", function() {
		if(this.getAttribute("isClick") == "1") {
			return
		} else {
			this.setAttribute("isClick", "1");
			getMedicalTeamMemberList();
		}
	});

	//接收ios原生会话框返回的刷新事件
	document.addEventListener('refreshTeamForIos', function(e) {
		current_page = 0;
		cleanList();
		getMedicalTeamMemberList();
	});
});

//原生调用，关闭聊天页面
function chatClose() {
	current_page = 0;
	cleanList();
	getMedicalTeamMemberList();
}

//医生团队成员信息列表
function getMedicalTeamMemberList() {
	g_tools.postCMD('getMedicalTeamMemberListByUserId', {}, function(result) {
		if(result.code == 0) {
			reconnectDom.setAttribute("isClick", "0");
			noNetWorkDom.classList.add("hide");
			if(result.data.length == 0) {
				emptyDom.classList.remove("mask-close");
				noNetWorkDom.classList.add("hide");
			} else {
				emptyDom.classList.add("mask-close");
				showMember(result.data);
			}
		} else {
			//显示断网页面
			noNetWorkDom.classList.remove("hide");
		}
	})
}

function cleanList() {
	while(listDom.hasChildNodes()) {
		listDom.removeChild(listDom.firstChild);
	}
}

function showMember(data) {
	if(data.length == 0) {
		return;
	}
	for(var i = 0; i < data.length; i++) {
		var item = data[i];
		var memberDiv = document.createElement("div");
		var memberId = item.memberId;
		var memberImg = item.headImg;
		var memberName = item.memberName;
		var memberLevel = item.titleLevel;
        var memberIsOnline = 0;
		memberDiv.classList.add("member-content", "li-style");
		memberDiv.setAttribute("memberId", memberId);
		memberDiv.setAttribute("memberName", memberName);
		memberDiv.setAttribute("headImg", memberImg); //这里需要保存原始的headImg值
		if(g_utils.isEmpty(memberImg)) {
			memberImg = "../../global/img/doctor_default.png";
		} else {
			memberImg = g_tools.IP + memberImg + "&tb=1" + "&app=2";
		}
		var flagClass = 'flag-online';
		var flagContent = '在线';
		if(!g_utils.isEmpty(item.isOnline)) {
            memberIsOnline = item.isOnline;
			if(item.isOnline == 0) {
				flagClass = 'flag-offline';
				flagContent = '离线';
			}
		}
        memberDiv.setAttribute("memberIsOnline", memberIsOnline);
        
		memberDiv.innerHTML = '<img src="' + memberImg + '" class="mui-media-object member-photo" />' +
			'<div class="member-detail">' +
			'<div class="doctor-line">' +
			'<div class="doctor-name">' + memberName + '</div>' +
			(memberLevel ? ('<div class="doctor-level">' + memberLevel + '</div>' + '</div>') : '') +
			'<div class="doctor-flag ' + flagClass + '">' + flagContent + '</div>' +
			'</div>' +
			'<div class="member-chat mui-icon-message-active"></div>'
		memberDiv.addEventListener('tap', function() {
			var memberId = this.getAttribute("memberId");
			var memberName = this.getAttribute("memberName");
            var memberIsOnline = this.getAttribute("memberIsOnline");
			g_mui.openPage(g_module.healthGroup, "memberDetail.html", {
				memberId: memberId,
				memberName: memberName,
                memberIsOnline: memberIsOnline,
				page: "USER_DOCTOR"
			});
		});
		var dom = memberDiv.querySelector('.member-chat');
		if(dom != null) {
			memberDiv.querySelector('.member-chat').addEventListener('tap', function(e) {
				e.stopPropagation(); //阻止事件继续传递
				var parentNode = this.parentNode;
				var doctorName = g_tools.getUserName();
				var doctorId = g_tools.getUserId();
				var name = parentNode.getAttribute('memberName');
				var chatId = parentNode.getAttribute('memberId');
				var doctorImg = g_storage.get(g_storage.DEVICE_USER_HEAD_URL);
				var headImg = parentNode.getAttribute('headImg');
				var imgDataSrc = "../../global/img/doctor_default_rec.png";
				if(!g_utils.isEmpty(headImg)) {
					imgDataSrc = g_tools.IP_FILE + headImg + "&tb=1&app=2";
				}
//				g_RIM.gotoConversationView(doctorName, doctorId, name, chatId, doctorImg, imgDataSrc, '', plus.webview.currentWebview().id, '1', function(data) {}, function(err) {});
                g_RIM.startSingleChatByTargetId(chatId,'',function(data) {}, function(err) {});
			});
		}
		listDom.appendChild(memberDiv);
	}
}
