var _self, _memberId, _memberName, _page, _isMyslef, _headImg, _loading, _toDoId, _toDoDoctorId, _memberIsOnline;
var _isCareDoctor;
//mui初始化
mui.init();
mui.plusReady(function() {
	_self = plus.webview.currentWebview();
	_memberId = _self.memberId;
	_memberName = _self.memberName;
	_page = _self.page;
	_isCareDoctor = _self.isCareDoctor;
	_isMyslef = _self.isMyslef;
	_memberIsOnline = _self.memberIsOnline;

	getMedicalTeamMemberInfo();

	//视频申请
	getToDoList();

});
//获取团队医生信息
function getMedicalTeamMemberInfo() {
	g_tools.postCMD("getDoctorMemberInfoById", {
		memberId: _memberId
	}, function(result) {
		if (result.code == 0) {
			showMemberDetail(result.data);
		}
	});
}

function getToDoList() {
	var nowDate = new Date();
	g_tools.postCMD("getDoctorToDoListForUser", {
		//    'doctorId': _memberId,
		'userId': g_tools.getUserId(),
		'toDoType': 3,
		'currentPage': 0,
		'pageSize': 100,
		'startTime': 0
	}, function(result) {
		//  alert(JSON.stringify(result));
		if (result.code == 0) {
			for (var i = 0; i < result.data.length; i++) {
				if (result.data[i].isHaveDone == 0) {
					_toDoId = result.data[i].id;
					_toDoDoctorId = result.data[i].toDoMemberIdList[0];
					//alert(_toDoDoctorId);
				}
			}
			initBtn();
		}
	});
}

function initBtnDom() {
	var btn = document.getElementById("bottomBtn");
	if (_isCareDoctor) {
		btn.classList.add("mui-hidden");
	}
	if (g_utils.isEmpty(_toDoId)) { //没有在问诊中或者历史请求非对当前医生
		btn.innerHTML = '申请视频咨询';
		btn.classList.remove('button-style2');
		btn.classList.add('button-style1');
	} else {
		if (_memberId != _toDoDoctorId) {
			btn.innerHTML = '申请视频咨询';
			btn.classList.remove('button-style2');
			btn.classList.add('button-style1');
		} else {
			btn.innerHTML = '撤销申请';
			btn.classList.remove('button-style1');
			btn.classList.add('button-style2');
		}

	}
}

function initBtn() {

	initBtnDom();

	var btn = document.getElementById("bottomBtn");
	btn.addEventListener('tap', function() {
		if (g_utils.isEmpty(_toDoId)) { //没有在问诊中历史请求非对当前医生
			if (_memberIsOnline == 1) { //医生在线
				questToDo();
			} else {
				var btnArray = ['取消', '确定'];
				g_mui.confirm('医生暂时不在线，申请将在医生上线后被接收，等待时间较长，您确定要提交此申请吗？', '提示', btnArray, function(e) {
					if (e.index == 1) { //点击确定
						questToDo();
					}
				});
			}

		} else {
			// 先判断待办是否已完成
			_toDoId = '';
			g_tools.postCMD("getDoctorToDoListForUser", {
				//  'doctorId': _memberId,
				'userId': g_tools.getUserId(),
				'toDoType': 3,
				'currentPage': 0,
				'pageSize': 10,
				'startTime': 0
			}, function(result) {
				//alert(JSON.stringify(result));
				if (result.code == 0) {

					for (var i = 0; i < result.data.length; i++) {
						if (result.data[i].isHaveDone == 0) {
							_toDoId = result.data[i].id;
							_toDoDoctorId = result.data[i].toDoMemberIdList[0];
						}
					}

					if (g_utils.isEmpty(_toDoId)) { //当前视频请求已完成

						//给出提示
						g_mui.alert('本次视频咨询申请医生已处理，根据需要您可再次发起咨询申请');
						//重置按钮样式状态
						initBtnDom();

					} else { //存在视频请求 ，先判断是否为当前医生的待办
						if (_memberId != _toDoDoctorId) {
							g_mui.alert('您已有一个待回复的申请');
						} else {
							var btnArray = ['取消', '确定'];
							g_mui.confirm('是否撤销申请', '提示', btnArray, function(e) {
								if (e.index == 1) { //点击确定
									g_tools.postCMD("deleteDoctorToDoForUser", {
										'toDoId': _toDoId
									}, function(result) {
										if (result.code == 0) {
											_toDoId = '';
											_toDoDoctorId = '';

											var btn = document.getElementById("bottomBtn");
											btn.innerHTML = '申请视频咨询';
											btn.classList.remove('button-style2');
											btn.classList.add('button-style1');

											g_mui.toast("申请已撤销");
											sendNoticeMsg(1); //send msg
										}
									});
								}
							});
						}

					}

				}
			});


		}
	});

}

function questToDo() {
	var toDoMemberIdList = new Array();
	toDoMemberIdList.push(_memberId);
	var nowDate = new Date();

	_loading = plus.nativeUI.showWaiting('请求中……', {
		loading: {
			display: 'inline'
		},
		modal: false
	});
	g_tools.postCMD("createDoctorToDoForUser", {
		'createMemberId': g_tools.getUserId(),
		'toDoUserId': g_tools.getUserId(),
		'toDoType': 3,
		'toDoTime': nowDate.getTime(),
		'toDoContent': '健康APP通话回复咨询',
		'toDoMemberIdList': JSON.stringify(toDoMemberIdList)
	}, function(result) {
		if (!g_utils.isEmpty(_loading)) _loading.close();
		if (result.code == 0) {
			_toDoId = result.data.toDoId;
			_toDoDoctorId = _memberId;

			initBtnDom();

			g_mui.toast("申请已提交");
			sendNoticeMsg(0); //send msg
		}
	});
}

function showMemberDetail(data) {
	_headImg = g_utils.isEmpty(data.headImg) ? "../../global/img/doctor_default.png" : g_tools.IP + data.headImg +
		"&tb=1&app=2";
	_memberName = data.name;

	document.getElementById("photo").setAttribute("src", _headImg);
	document.getElementById("name").innerHTML = data.name + (data.titleLevel ? ('<span class="member-level">' + data.titleLevel +
		'</span>') : "");
	document.getElementById("company").innerHTML = "所属单位：" + (g_utils.isEmpty(data.unit) ? "无" : data.unit);
	document.getElementById("department").innerHTML = "所属科室：" + (g_utils.isEmpty(data.departMent) ? "无" : data.departMent);
	document.getElementById("skill").innerHTML = (g_utils.isEmpty(data.skills) ? "资料暂未设置" : data.skills);
	if (g_utils.isEmpty(data.skills)) {
		document.getElementById("skill").classList.add('color-gray');
	}
	document.getElementById("introduce").innerHTML = (g_utils.isEmpty(data.introduce) ? "资料暂未设置" : data.introduce);
	if (g_utils.isEmpty(data.introduce)) {
		document.getElementById("introduce").classList.add('color-gray');
	}
	document.getElementById("serviceTime").innerHTML = (g_utils.isEmpty(data.serviceTime) ? "资料暂未设置" : data.serviceTime);
	if (g_utils.isEmpty(data.serviceTime)) {
		document.getElementById("serviceTime").classList.add('color-gray');
	}
}


function sendNoticeMsg(msgType) {
	var nowDate = new Date();
	g_tools.postCMD("getUserInfoByUserId", {
		'userId': g_tools.getUserId()
	}, function(result) {
		// alert(JSON.stringify(result));
		if (result.code == 0) {

			var name = result.data.nickname;
			if (!g_utils.isEmpty(result.data.name)) {
				name = result.data.name;
			}
			if (!g_utils.isEmpty(result.data.doctorNote)) {
				name = result.data.doctorNote;
			}

			//send msg
			var targetIds = new Array();
			targetIds.push(_memberId);
			var msgContent = '';
			if (msgType == 0) {
				msgContent = name + '向您发起了视频咨询申请，已为您创建待办提醒，请及时处理';
			} else {
				msgContent = name + '撤销了对您的视频咨询申请，已为您删除待办提醒';
			}
			g_tools.postCMD("sendNoticeMsg", {
				'targetIds': JSON.stringify(targetIds),
				'msgContent': msgContent
			}, function(result) {
				if (result.code == 0) {

				}
			});

		}
	});
}
