mui.init();
var planStart = null;
var planEnd = null;
var clientWidth = document.documentElement.clientWidth;
mui.plusReady(function() {
	var reportId, _self;
	_self = plus.webview.currentWebview();
	//隐藏滚动条
	_self.setStyle({
		scrollIndicator: "none"
	});
	reportId = _self.reportId;
	initScroll();
	refreshPlanPage(reportId);
	//	document.getElementById('show-button').addEventListener('tap', function() {
	//		var doctorSuggest = document.getElementById('doctor-suggest');
	//		if(this.getAttribute("isAll") == '1') {
	//			this.innerHTML = "展开内容";
	//			this.setAttribute('isAll', '0');
	//			doctorSuggest.classList.add("show-some");
	//		} else {
	//			this.innerHTML = "收起";
	//			this.setAttribute('isAll', '1');
	//			doctorSuggest.classList.remove("show-some");
	//			if(doctorSuggest.offsetHeight < 0.64 * clientWidth / 3.75) {
	//				doctorSuggest.classList.add("show-some");
	//			}
	//		}
	//	});
});
//初始化滚动模块
function initScroll() {
	mui('#diet-breakfast').scroll({
		scrollY: false, //是否竖向滚动
		scrollX: true, //是否横向滚动
		indicators: true, //是否显示滚动条
		deceleration: 0.0006, //阻尼系数,系数越小滑动越灵敏
		bounce: true //是否启用回弹
	});
	mui('#diet-lunch').scroll({
		scrollY: false, //是否竖向滚动
		scrollX: true, //是否横向滚动
		indicators: true, //是否显示滚动条
		deceleration: 0.0006, //阻尼系数,系数越小滑动越灵敏
		bounce: true //是否启用回弹
	});
	mui('#diet-dinner').scroll({
		scrollY: false, //是否竖向滚动
		scrollX: true, //是否横向滚动
		indicators: true, //是否显示滚动条
		deceleration: 0.0006, //阻尼系数,系数越小滑动越灵敏
		bounce: true //是否启用回弹
	});
	mui('#diet-night').scroll({
		scrollY: false, //是否竖向滚动
		scrollX: true, //是否横向滚动
		indicators: true, //是否显示滚动条
		deceleration: 0.0006, //阻尼系数,系数越小滑动越灵敏
		bounce: true //是否启用回弹
	});
}

function refreshPlanPage(reportId) {
	getReport(reportId);
}
//获取健康报告
function getReport(reportId) {
	var parameters = {
		reportId: reportId
	}
	g_tools.postCMD('getReportInfoById', parameters, function(res) {
		if(res.code == 0) {
			if(!g_utils.isEmptyObject(res.data)) {
				//显示健康计划和评语
				var dataInfo = res.data;
				var startTime = dataInfo.startTime;
				var endTime = dataInfo.endTime;
				var doctorId = dataInfo.doctorId;
				var reportMsg = dataInfo.assessResult;
				showReportInfo(startTime, endTime, reportMsg, doctorId);
				showAbnormal(res.data.healthExceptionList);
				showHealth(res.data.healthDataList, startTime, endTime);
				showSport(res.data.sportDataList, startTime, endTime);
				showSleep(res.data.sleepDataList, startTime, endTime);
				showDiet(res.data.dietList);
			} else {

			}
		}
	}, g_tools.MODE_WEB);
}

function showReportInfo(startTime, endTime, reportMsg, doctorId) {
	var reportCircleDom = document.getElementById('report-circle');
	var reportTimeDom = document.getElementById('report-time');
	var reportSugestDom = document.getElementById('doctor-suggest');
	var doctorPhotoDom = document.querySelector('.doctor-img');
	var doctorNameDom = document.querySelector('.doctor-name');
	var doctorMarkDom = document.querySelector('.doctor-mark');
	var reportStartStr = g_utils.dateFormat(startTime, 'yyyy.MM.dd');
	var reportEndStr = g_utils.dateFormat(endTime, 'yyyy.MM.dd');
	var expandDom = document.getElementById('show-expand');
	if(!g_utils.isEmpty(reportMsg)) {
		reportSugestDom.innerHTML = reportMsg;
	} else {
		reportSugestDom.innerHTML = "没有医生评语";
	}
	if(reportSugestDom.offsetHeight > 0.64 * clientWidth / 3.75) {
		reportSugestDom.classList.remove("show-some");
		reportSugestDom.classList.add("show-all-some");
		expandDom.classList.remove('hide');
		expandDom.addEventListener('tap', function() {
			if(this.getAttribute("isAll") == '1') {
				this.innerHTML = '<font class="show-button" >展开内容</font>';
				this.setAttribute('isAll', '0');
				reportSugestDom.classList.remove("show-all");
				reportSugestDom.classList.add("show-all-some");
			} else {
				this.innerHTML = '<font class="show-button" >收起</font>';
				this.setAttribute('isAll', '1');
				reportSugestDom.classList.remove("show-all-some");
				reportSugestDom.classList.add("show-all");
			}
		});
	}
	reportCircleDom.innerHTML = '报告周期：' + reportStartStr + '-' + reportEndStr;
	reportTimeDom.innerHTML = "报告时间：" + reportEndStr;
	g_tools.postCMD("getInvitedDoctorInfo", {}, function(res) {
		if(res.code == 0) {
			var doctorInfo = res.data;
			var doctorPhoto = doctorInfo.headImg;
			var doctorName = doctorInfo.name;
			var departMent = doctorInfo.departMent;
			var titleLevel = doctorInfo.titleLevel;
			var unit = res.data.unit;
			if(!g_utils.isEmpty(doctorPhoto)) {
				doctorPhoto = g_tools.IP_FILE + doctorPhoto + '&tb=1&app=2';
			} else {
				doctorPhoto = "../../global/img/default_portrait_msg.png";
			}
			doctorPhotoDom.setAttribute("src", doctorPhoto);
			doctorNameDom.innerHTML = doctorName;
			doctorMarkDom.innerHTML = departMent + '&emsp;' + titleLevel + '</br>' + unit;
		}
	}, g_tools.MODE_WEB);
}
//显示异常数据
function showAbnormal(dataList) {
	var parentDom = document.getElementById('abnoemal-item');
	if(g_utils.isEmptyArray(dataList)) {
		parentDom.querySelector('[name="show"]').classList.add('hide');
		parentDom.querySelector('.item-empty').classList.remove('hide');
		return;
	} else {
		parentDom.querySelector('[name="show"]').classList.remove('hide');
		parentDom.querySelector('.item-empty').classList.add('hide');
		var alarmNum = 0;
		var warningNum = 0;
		var normalNum = 0;
		var alarmRatioDom = parentDom.getElementById('alarm-ratio');
		var alarmTimeDom = parentDom.getElementById('alarm-time');
		var warningRatioDom = parentDom.getElementById('warning-ratio');
		var warningTimeDom = parentDom.getElementById('warning-time');
		var normalRatioDom = parentDom.getElementById('normal-ratio');
		var normalTimeDom = parentDom.getElementById('normal-time');
		var chart = parentDom.getElementById('abnormal-chart');
		for(i in dataList) {
			var status = dataList[i].status;
			var statusList = status.split(',');
			for(j in statusList) {
				switch(statusList[j]) {
					case '0':
						normalNum++;
						break;
					case '1':
						warningNum++;
						break;
					case '2':
						alarmNum++;
						break;
					default:
						break;
				}
			}
		}
		var sum = alarmNum + warningNum + normalNum;
		alarmRatioDom.innerHTML = Math.round(alarmNum * 1000 / sum) / 10 + '%';
		warningRatioDom.innerHTML = Math.round(warningNum * 1000 / sum) / 10 + '%';
		normalRatioDom.innerHTML = Math.round(normalNum * 1000 / sum) / 10 + '%';
		alarmTimeDom.innerHTML = alarmNum + "次";
		warningTimeDom.innerHTML = warningNum + "次";
		normalTimeDom.innerHTML = normalNum + "次";
		drawPieChart(echarts.init(chart), [{
			value: alarmNum,
			name: "报警",
			itemStyle: {
				normal: {
					color: '#F47C0F'
				}
			}
		}, {
			value: warningNum,
			name: "预警",
			itemStyle: {
				normal: {
					color: '#FFCE1A'
				}
			}
		}, {
			value: normalNum,
			name: "正常",
			itemStyle: {
				normal: {
					color: '#13C1A1'
				}
			}
		}])
	}

}
//清除异常列表
function cleanAbnormal() {}
//显示健康数据
function showHealth(dataList, startTime, endTime) {
	if(g_utils.isEmptyArray(dataList)) {
		document.getElementById("health-sign").classList.add("hide");
		return
	} else {
		document.getElementById("health-sign").classList.remove("hide");
	}
	var book = [{
		chartList: [],
	}, {
		chartList: [],
	}, {
		chartList: [],
	}, {
		chartList: [],
	}, {
		chartList: [],
	}, {
		chartList: [],
	}, {
		chartList: [],
	}, {
		chartList: [],
		doubleChartList: []
	}];
	var parentDom = document.getElementById('health-sign');
	for(i in dataList) {
		var itemType = dataList[i].type;
		var itemTime = dataList[i].time;
		var itemValue = dataList[i].value;
		var itemStatus = dataList[i].status;
		if(itemType != 5 && itemType != 7) {
			var chartPoint = null;
			var color = getStausColor(itemStatus);
			if(itemStatus == '0') {
				chartPoint = setPointColor([itemTime, parseFloat(itemValue)], color);
			} else {
				chartPoint = setPointColor([itemTime, parseFloat(itemValue)], color, color);
			}
			book[itemType].chartList.push(chartPoint);
		} else if(itemType == 5) {
			var valueList = itemValue.split(",");
			var statusList = itemStatus.split(',');
			var chartPoint = null;
			var color = getStausColor(statusList[0]);
			if(statusList[0] == '0') {
				chartPoint = setPointColor([itemTime, parseFloat(valueList[0])], color);
			} else {
				chartPoint = setPointColor([itemTime, parseFloat(valueList[0])], color, color);
			}
			book[itemType].chartList.push(chartPoint);
		} else {
			var valueList = itemValue.split(",");
			var statusList = itemStatus.split(',');
			var chartPoint = null;
			var chartPoint2 = null;
			var color = getStausColor(statusList[0]);
			var color2 = getStausColor(statusList[1]);
			if(statusList[0] == '0') {
				chartPoint = setPointColor([itemTime, parseFloat(valueList[0])], color);
			} else {
				chartPoint = setPointColor([itemTime, parseFloat(valueList[0])], color, color);
			}
			if(statusList[1] == '0') {
				chartPoint2 = setPointColor([itemTime, parseFloat(valueList[1])], color2);
			} else {
				chartPoint2 = setPointColor([itemTime, parseFloat(valueList[1])], color2, color2);
			}
			book[itemType].chartList.push(chartPoint);
			book[itemType].doubleChartList.push(chartPoint2);
		}
	}
	for(j in book) {
		var dataLength = book[j].chartList.length;
		if(dataLength != 0) {
			var parentDom = document.querySelector('[health="' + j + '"]');
			parentDom.classList.remove('hide');
			var maxDom = parentDom.querySelector('[name="max"]');
			var minDom = parentDom.querySelector('[name="min"]');
			var averageDom = parentDom.querySelector('[name="average"]');
			var drawChartDom = parentDom.querySelector('[name="chart"]');
			var showItem = healthChartListGetAverage(book[j].chartList);
			maxDom.innerHTML = showItem.max;
			minDom.innerHTML = showItem.min;
			averageDom.innerHTML = showItem.average;
			if(j == 7) {
				var maxOtherDom = parentDom.querySelector('[name="max-one"]');
				var minOtherDom = parentDom.querySelector('[name="min-one"]');
				var averageOtherDom = parentDom.querySelector('[name="average-one"]');
				var showOtherItem = healthChartListGetAverage(book[j].doubleChartList);
				maxOtherDom.innerHTML = showOtherItem.max;
				minOtherDom.innerHTML = showOtherItem.min;
				averageOtherDom.innerHTML = showOtherItem.average;
				drawDoubleLineChart(echarts.init(drawChartDom), startTime, endTime, showItem.max, book[j].chartList, book[j].doubleChartList);
			} else {
				drawLineChart(echarts.init(drawChartDom), startTime, endTime, showItem.max, book[j].chartList);
			}
		}
	}
}
//清除健康数据
function cleanHealth() {
	var parentDom = document.getElementById('health-trend');
	var childList = parentDom.querySelectorAll('li');
	for(var i = 0; i < childList.length; i++) {
		if(!childList[i].classList.contains('list-title')) {
			parentDom.removeChild(childList[i]);
		}
	}
}
//显示运动数据
function showSport(dataList, startTime, endTime) {
	var daysSportList = dataList.daysSportList;
	var eventTimePercentList = dataList.eventTimePercentList;
	var parentDom = document.getElementById("sport-box");
	if(g_utils.isEmptyArray(daysSportList) || daysSportList == '[]') {
		parentDom.querySelector('[name="show"]').classList.add('hide');
		parentDom.querySelector('.item-empty').classList.remove('hide');
		return;
	} else {
		parentDom.querySelector('[name="show"]').classList.remove('hide');
		parentDom.querySelector('.item-empty').classList.add('hide');
	}
	var timeDiff = (endTime - startTime) / 1000;
	var stepDom = parentDom.querySelector('#sport-step');
	var distanceDom = parentDom.querySelector('#sport-distance');
	var calDom = parentDom.querySelector('#sport-cal');
	var stepChart = parentDom.querySelector('#step-chart');
	var calChart = parentDom.querySelector('#cal-chart');
	var eventNumChart = parentDom.querySelector('#sport-chart-one');
	var eventTimeChart = parentDom.querySelector('#sport-chart-two');
	stepDom.innerHTML = dataList.totalStep;
	distanceDom.innerHTML = Math.floor(dataList.totalDistance / 10) / 100;
	calDom.innerHTML = Math.floor(dataList.totalEnergy);

	var stepChartList = new Array();
	var energyChartList = new Array();
	var maxStep = 0;
	var maxCal = 0
	for(i in daysSportList) {
		var process = daysSportList[i].process;
		if(daysSportList[i].step > maxStep) {
			maxStep = daysSportList[i].step;
		}
		if(daysSportList[i].energy > maxCal) {
			maxCal = daysSportList[i].energy;
		}
		var color;
		if(process < 1) {
			color = '#AEF225';
		} else {
			color = '#9BDB7A';
		}
		var stepPoint = [i, daysSportList[i].step];
		var energyPoint = setPointColor(Math.floor(daysSportList[i].energy), color);
		stepChartList.push(stepPoint);
		energyChartList.push(energyPoint);
	}
	var eventNumChartList = new Array();
	var eventTimeChartList = new Array();
	var count = 0;
	var g_eventTimePercentList = new Array();
	for(g in eventTimePercentList) {
		if(count > 5) break;
		var type = eventTimePercentList[g].type;
		if(type != 23 && type != 13) {
			count++;
			g_eventTimePercentList.push(eventTimePercentList[g]);
		}
	}
	for(j in g_eventTimePercentList) {
		var itemType = g_eventTimePercentList[j].type;
		var eventParentDom = document.getElementById('event-content');
		var itemColor = getSportMarkColor(j);
		var itemSport = sportProperty.getSportName(itemType);
		var itemTimes = eventTimePercentList[j].times;
		var itemLong = g_printTools.printTimeBySec(eventTimePercentList[j].TimePercent * timeDiff);
		var divDom = document.createElement('div');
		if(j != g_eventTimePercentList.length - 1 && j != 4) {
			divDom.classList.add('color-col-content', 'bottom-line');
		} else {
			divDom.className = 'color-col-content';
		}
		var str = '<div class="color-mark" style="background:' + itemColor + '"></div>' +
			'<font class="font-style-two sport-one">' + itemSport + '</font>' +
			'<font class="font-style-two cell-two">一共' + itemTimes + '次</font>' +
			'<font class="font-style-two cell-three">' + itemLong + '</font>'
		divDom.innerHTML = str;
		eventParentDom.appendChild(divDom);
		eventNumChartList.push({
			value: itemTimes,
			name: itemSport,
			itemStyle: {
				normal: {
					color: itemColor
				}
			}
		});
		eventTimeChartList.push({
			value: eventTimePercentList[j].TimePercent * timeDiff,
			name: itemSport,
			itemStyle: {
				normal: {
					color: itemColor
				}
			}
		});
	}
	drawPieChart(echarts.init(eventNumChart), eventNumChartList);
	drawPieChart(echarts.init(eventTimeChart), eventTimeChartList);
	drawBarChart(echarts.init(calChart), maxCal, energyChartList);
	drawLineChart(echarts.init(stepChart), 0, daysSportList.length, maxStep, stepChartList);
}
//清除运动数据
function cleanSport() {

}
//显示睡眠数据
function showSleep(dataList, startTime, endTime) {
	var startDay = timeToZero(startTime);
	var endDay = timeToEnd(endTime);
	var DAYS = msToDay(endDay - startDay);
	var DAY_TIMEMILLIS = 24 * 60 * 60 * 1000;
	var daysSleepList = dataList.daysSleepList;
	var parentDom = document.getElementById('sleep-item');
	if(g_utils.isEmptyArray(daysSleepList) || daysSleepList == '[]') {
		parentDom.querySelector('[name="show"]').classList.add('hide');
		parentDom.querySelector('.item-empty').classList.remove('hide');
		return;
	} else {
		parentDom.querySelector('[name="show"]').classList.remove('hide');
		parentDom.querySelector('.item-empty').classList.add('hide');
	}
	var goSleepTimeDom = parentDom.getElementById('go-sleep-time');
	var getUpTimeDom = parentDom.getElementById('get-up-time');
	var averageSleepTimeDom = parentDom.getElementById('average-sleep-time');
	var sleepChart = echarts.init(parentDom.getElementById('draw-sleep'));
	var averageInSleepTime = g_utils.dateFormat(dataList.averageInSleepTime,"HH:mm");
	var averageWakeTime = g_utils.dateFormat(dataList.averageWakeTime,"HH:mm");
	var averageSleepTime = msToHour(dataList.averageSleepTime);
	var startList = new Array();
	var endList = new Array();
	goSleepTimeDom.innerHTML = averageInSleepTime;
	getUpTimeDom.innerHTML = averageWakeTime;
	averageSleepTimeDom.innerHTML = averageSleepTime.hour+Math.floor(averageSleepTime.min/6)/10+"小时";
	for(var i = 0; i < DAYS; i++) {
		var tempDate = g_utils.dateFormat(tempStartTime, 'yyyy-MM-dd');
		tempStartTime += DAY_TIMEMILLIS;
		var sleepData = getSleepByDate(tempDate, daysSleepList);
		if(sleepData) {
			var itemStartTime = sleepData.startTime;
			var itemEndTime = sleepData.endTime;
			var date = sleepData.date;
			var inSleepTime = msToHour(itemEndTime - itemStartTime);
			var thisDay = g_utils.stringToDate(date).getTime();
			var sleepTime = msToHour(itemStartTime - thisDay);
			if(sleepTime.hour < 10) sleepTime.hour = sleepTime.hour + 24; //若开始睡眠时间距离当天0点小于10，则按照头一天0点计算
			startList.push(sleepTime.hour + Math.floor(sleepTime.min / 6) / 10);
			endList.push(inSleepTime.hour + Math.floor(inSleepTime.min / 6) / 10);
		} else {
			startList.push(0);
			endList.push(0);
		}
	}
	var clientWidth = document.documentElement.clientWidth;
	var barNum = DAYS;
	var barWidth = clientWidth * 0.67 / barNum
	drawStairsBarChart(sleepChart, startList, endList, barNum, barWidth);
}
//清除睡眠数据
function cleanSleep() {

}
//显示膳食数据
function showDiet(dataList) {
	var parentDom = document.getElementById('diet-item');
	if(g_utils.isEmptyArray(dataList)) {
		parentDom.querySelector('[name="show"]').classList.add('hide');
		parentDom.querySelector('.item-empty').classList.remove('hide');
		return;
	} else {
		parentDom.querySelector('[name="show"]').classList.remove('hide');
		parentDom.querySelector('.item-empty').classList.add('hide');
	}
	var breakfastDom = document.getElementById('breakfast-img');
	var lunchDom = document.getElementById('lunch-img');
	var dinnerDom = document.getElementById('dinner-img');
	var nightDom = document.getElementById('night-img');
	var domList = new Array();
	domList.push(breakfastDom, lunchDom, dinnerDom, nightDom);
	for(i in dataList) {
		//		reduceImg.className = 'dite-img';
		//		reduceImg.src = "image/icon_reduce.png";
		//		<img src="' + srcUrl + '" class="dite-img"' +
		//				'data-preview-src="' + previesSrcUrl + '"' +
		//				'data-preview-group="1" />
		var type = dataList[i].type;
		var img = "";
		if(!g_utils.isEmpty(dataList[i].dietImgUrl)) {
			img = g_tools.IP_FILE + dataList[i].dietImgUrl + '&tb=1';
		}
		var imgDom = document.createElement('img');
		imgDom.className = 'diet-icon';
		imgDom.setAttribute('src', img);
		var parentDom = domList[type];
		parentDom.appendChild(imgDom);
	}
}
//清除膳食数据
function cleanDiet() {
	var breakfastDom = document.getElementById('breakfast-img');
	var lunchDom = document.getElementById('lunch-img');
	var dinnerDom = document.getElementById('dinner-img');
	var nightDom = document.getElementById('night-img');
	while(breakfastDom.hasChildNodes()) {
		breakfastDom.removeChild(breakfastDom.firstChild);
	}
	while(lunchDom.hasChildNodes()) {
		lunchDom.removeChild(lunchDom.firstChild);
	}
	while(dinnerDom.hasChildNodes()) {
		dinnerDom.removeChild(dinnerDom.firstChild);
	}
	while(nightDom.hasChildNodes()) {
		nightDom.removeChild(nightDom.firstChild);
	}
}
//毫秒转换为小时
function msToHour(ms) {
	var hour = Math.floor(ms / 3600000);
	var min = Math.floor(ms % 3600000 / 60000);
	return {
		hour: hour,
		min: min
	};
}

function getStausColor(staus) {
	var color;
	switch(staus) {
		case "0":
			color = "#A1DA7A";
			break;
		case "1":
			color = "#FFDA54";
			break;
		case "2":
			color = "#F47C0F";
			break;
		default:
			break;
	}
	return color;
}

function getSportMarkColor(index) {
	var color;
	switch(index) {
		case '0':
			color = "#9BDB7A";
			break;
		case '1':
			color = "#F9FF51";
			break;
		case '2':
			color = "#FFD042";
			break;
		case '3':
			color = "#FF983B";
			break;
		case '4':
			color = "#F47C0F";
			break;
	}
	return color;
}

function setPointColor(point, itemStyleColor, labelColor) {
	var stylePoint = {
		value: point
	};
	if(labelColor != undefined) {
		stylePoint.label = {
			normal: {
				textStyle: {
					color: labelColor
				}
			}
		}
	}
	if(itemStyleColor != undefined) {
		stylePoint.itemStyle = {
			normal: {
				color: itemStyleColor,
			}
		}
	}
	return stylePoint;
}

function healthChartListGetAverage(list) {
	var max = 0;
	var min = 999;
	var sum = 0;
	for(i in list) {
		var itemValue = list[i].value[1];
		if(itemValue > max) {
			max = itemValue;
		}
		if(itemValue < min) {
			min = itemValue
		}
		sum = sum + itemValue;
	}
	var average = Math.floor(sum * 10 / (list.length)) / 10;
	return {
		max: max,
		min: min,
		average: average
	}
}

function timeToZero(ms) {
	var time
	if(ms != undefined) {
		time = new Date(ms);
	} else {
		time = new Date();
	}
	time.setHours(0);
	time.setMinutes(0);
	time.setSeconds(0);
	time.setMilliseconds(0);
	return time.getTime();
}

function timeToEnd(ms) {
	var time = new Date(ms);
	time.setHours(23);
	time.setMinutes(59);
	time.setSeconds(59);
	time.setMilliseconds(999);
	return time.getTime();
}

function msToDay(ms) {
	return Math.ceil(ms / 86400000);
}

function getSleepByDate(date, arr) {
	if(!g_utils.isEmptyArray(arr)) {
		for(var i = 0; i < arr.length; i++) {
			if(date == arr[i].date) {
				return arr[i];
			}
		}
	}
	return null;
}