var currentPage = 0;
var PAGE_SIZE = 4;
var NO_SHOW = 0; //不显示
var nullPage = document.getElementById("nullPage");
var refreshContainer = document.getElementById("refreshContainer");
var scrollContent = document.getElementById('scroll-content');


var statusImgPath = ['img/plan_no_start.png', 'img/plan_going.png', 'img/plan_finshed.png', 'img/plan_finshed.png'];

//mui初始化
mui.init({
	pullRefresh: {
		container: '#refreshContainer',
		down: {
			//下拉成功回调函数
			callback: pullfreshDown
		},
		up: {
			//上拉成功回调函数
			contentrefresh: '正在加载...',
			callback: pullfreshUp
		}
	}
});
mui.plusReady(function() {
	//隐藏掉滚动条
	plus.webview.currentWebview().setStyle({
		scrollIndicator: 'none'
	});
	
	initPlanList();
});

function initPlanList() {
	g_tools.postCMD('getHistoryPlanList', {
		currentPage: currentPage,
		pageSize: PAGE_SIZE
	}, function(data) {
		if(data.code == 0) {
			var planList = data.data;
//			console.log(JSON.stringify(planList));
			initRefreshPlanList(planList);
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE, { //！！！！！！！！！重点代码！！！！！！！！！
		noNetworkMode: g_tools.TIP_MODE_INTERFACE, //界面显示断网提示内容的模式
		contentDomId: 'mainContent', //显示数据内容的dom元素id
		tipDomId: 'noNetworkTip' //显示断网提示的dom元素id
	});
}

function pullfreshDown() {
	setTimeout(function() {
		getDownRefreshPlanList();
	}, 500);
}

function pullfreshUp() {
	setTimeout(function() {
		getUpRefreshPlanList();
	}, 500);
}

function initRefreshPlanList(planList) {
	if(planList && planList.length != 0) {
		plus.webview.currentWebview().setStyle({ //取消蒙板
			mask: 'none'
		});
		nullPage.classList.add('mui-hidden');
		scrollContent.classList.remove('mui-hidden');
		downRefresh(planList);
	} else {
		nullPage.classList.remove('mui-hidden');
		scrollContent.classList.add('mui-hidden');
		plus.webview.currentWebview().setStyle({ //添加蒙板
			mask: 'rgba(0,0,0,0)'
		});
	}
}

function getDownRefreshPlanList() {
	currentPage = 0;
	g_tools.postCMD('getHistoryPlanList', {
		currentPage: currentPage,
		pageSize: PAGE_SIZE
	}, function(data) {
		if(data.code == 0) {
			var planList = data.data;
			if(planList && planList.length != 0) { //不为空
				initRefreshPlanList(planList);
			}
			var list = plus.webview.getWebviewById(g_module.interventionPlan.ID);
			mui.fire(list, 'refreshAddPlan');

			//结束下拉刷新
			mui('#refreshContainer').pullRefresh().endPulldownToRefresh();
			//重置上拉加载
			mui('#refreshContainer').pullRefresh().refresh(true);
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE, {
		disableWait: true, //禁止显示wait框
		noNetworkMode: g_tools.TIP_MODE_TOAST //！！！！！！！！！重点代码！！！！！！！！！
	});
}

function getUpRefreshPlanList() {
	currentPage++; //页面增1
	g_tools.postCMD('getHistoryPlanList', {
		currentPage: currentPage,
		pageSize: PAGE_SIZE
	}, function(data) {
		if(data.code == 0) {
			var planList = data.data;
			if(planList && planList.length != 0) { //不为空
				upRefresh(planList);
				mui('#refreshContainer').pullRefresh().endPullupToRefresh(false);
			} else {
				mui('#refreshContainer').pullRefresh().endPullupToRefresh(true); //参数为true代表没有更多数据了。
			}
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE, {
		disableWait: true, //禁止显示wait框
		noNetworkMode: g_tools.TIP_MODE_TOAST //！！！！！！！！！重点代码！！！！！！！！！
	});
}

function downRefresh(planList) {
	scrollContent.innerHTML = "";
	for(var i = 0, len = planList.length; i < len; i++) {
		var plan = planList[i];
		refreshOnePlan(plan);
	}
}

function upRefresh(planList) {
	for(var i = 0, len = planList.length; i < len; i++) {
		var plan = planList[i];
		refreshOnePlan(plan);
	}
}

function refreshOnePlan(plan) {
	if(!g_utils.isEmpty(plan.isShowWithDoctor) && plan.isShowWithDoctor != 0) {
		var li = getPlanLi(plan);
		scrollContent.appendChild(li);
	}
}

function getPlanLi(plan) {
	var reportNum = 0;
	if(!g_utils.isEmptyArray(plan.linkReportsId)) {
		reportNum = plan.linkReportsId.length;
	}
	var li = document.createElement('li');
	li.className = 'mui-table-view-cell';
	var div1 = document.createElement('div');
	div1.className = 'mui-slider-right mui-disabled';
	var a = document.createElement('a');
	a.className = 'mui-btn mui-btn-red';
	a.innerText = '删除';
	div1.addEventListener('tap', function(event) {
		onTapDelPlan(plan.id, plan.status, li);
	});
	div1.appendChild(a);

	var div2 = document.createElement('div');
	div2.className = 'mui-slider-handle mui-media';
	div2.innerHTML = '<img class="mui-media-object mui-pull-right img_right" src="' + statusImgPath[plan.status] + '">' +
		'<div>计划周期：<span>' + getPlanCircle(plan.startTime, plan.endTime) + '</span></div>' +
		'<div>健康报告数：<span>' + reportNum + '份</span></div>' +
		'<div>私人医生：<span>' + plan.doctorName + '</span></div>';

	div2.addEventListener('tap', function(event) {
		onTapPlanDetailList(plan.id);
	});
	li.appendChild(div1);
	li.appendChild(div2);
	return li;
}

function getPlanCircle(startTime, endTime) {
	return g_utils.dateFormat(startTime, "yyyy.MM.dd") + "-" + g_utils.dateFormat(endTime, "yyyy.MM.dd");
}

/**
 * 跳转到干预计划详情页面
 * @param {Object} planId 干预计划Id
 */
function onTapPlanDetailList(planId) {
	g_mui.openPage(g_module.healthManage, 'planDetails.html', {
		planId: planId
	});
}

function onTapDelPlan(planId, status, li) {
	var btnArray = ['确认', '取消'];
	if(status == 2) { //已结束可删除
		g_mui.confirm('确定删除这条干预计划吗？', '删除干预计划', btnArray, function(e) {
			if(e.index == 0) { //点击确定
				modifyPlanNoShow(planId);
				setTimeout(function() {
					mui.swipeoutClose(li);
				}, 0);

			} else {
				setTimeout(function() {
					mui.swipeoutClose(li);
				}, 0);
			}
		});
	} else { //进行中和未开始不能删除
		g_mui.alert('请结束该项干预计划后再进行删除', '无法删除该计划', function() {
			setTimeout(function() {
				mui.swipeoutClose(li);
			}, 0);
		});
	}
}

function modifyPlanNoShow(_planId) { //删除计划后该计划不在显示
	g_tools.postCMD('modifyPlanInfo', {
		planId: _planId,
		isShowWithDoctor: NO_SHOW
	}, function(data) {
		if(data.code == 0) {
			g_mui.toast("删除成功！");
			initPlanList();
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE, {
		noNetworkMode: g_tools.TIP_MODE_TOAST //！！！！！！！！！重点代码！！！！！！！！！
	});
}
