//图片网络地址url
var SERVER_IMG_ADDRESS = g_tools.IP_FILE;
var DEFAULT_HEAD_IMG = 'img/default_portrait_msg.png';

var planTitleArr = ['膳食计划', '运动计划', '健康测量计划', '睡眠计划', '服药计划', '其它计划'];
var DIET_TYPE = 0;
var SPORT_TYPE = 1;
var MESSURE_TYPE = 2;
var SLEEP_TYPE = 3;
var MEDICATION_TYPE = 4;
var OTHER_TYPE = 5;

var CONTENT_SHOW_MAX_LINES = 3; //内容最多显示3行

var NO_START_STATUS = 0; //未开始
var GOING_STATUS = 1; //进行中
var FINISHED_STATUS = 2; //已结束
var CLOSED_STATUS = 3;
statusImgPath = ['img/plan_no_start.png', 'img/plan_going.png', 'img/plan_finshed.png', 'img/plan_finshed.png']

var note_appendImg_flag = false; //备注及附件是否有内容
//dom
var cycleTxt = document.getElementById('cycleTxt');
var doctorName = document.getElementById('doctorName');
var reportNum = document.getElementById('reportNum');
var statusImg = document.getElementById('statusImg');

var assessResultLi = document.getElementById('assessResultLi');
var planContentLay = document.getElementById('planContentLay');
var noteLi = document.getElementById('noteLi');

var imgLay = document.getElementById('imgLay');
var healthReportLay = document.getElementById('healthReportLay');
var reportListLay = document.getElementById('reportListLay');

var _planId;
var planInfo = {};
//mui初始化
mui.init();
mui.plusReady(function() {
	var self = plus.webview.currentWebview();
	_planId = self.planId;
	//隐藏掉滚动条
	plus.webview.currentWebview().setStyle({
		scrollIndicator: 'none'
	});
	//刷新数据
	getPlanInfoByPlanId();

});

/*
 * yyyy年MM月dd日转yyyy-MM-dd
 */
function turnDateFormat(dateStr) {
	var year = dateStr.split('')[0] + dateStr.split('')[1] + dateStr.split('')[2] + dateStr.split('')[3];
	var month = dateStr.split('')[5] + dateStr.split('')[6];
	var day = dateStr.split('')[08] + dateStr.split('')[9];
	return year + "-" + month + "-" + day;
}

function refreshPlanInfo() {
	var startTime, endTime;
	if(!g_utils.isEmpty(planInfo.startTime)) {
		startTime = g_utils.dateFormat(planInfo.startTime, "yyyy.MM.dd");
	}
	if(!g_utils.isEmpty(planInfo.endTime)) {
		endTime = "-" + g_utils.dateFormat(planInfo.endTime, "yyyy.MM.dd");

	}
	cycleTxt.innerHTML = startTime + endTime;

	if(!g_utils.isEmpty(planInfo.doctorName)) {
		doctorName.innerHTML = planInfo.doctorName;
		doctorName.classList.remove('unget');
	}

	if(planInfo.linkReportsId && planInfo.linkReportsId.length != 0) {
		reportNum.innerHTML = planInfo.linkReportsId.length + "份";
	}

	if(!g_utils.isEmpty(planInfo.status)) {
		statusImg.src = statusImgPath[planInfo.status];
	}

	assessResultLi.innerHTML = "";
	if(!g_utils.isEmpty(planInfo.assessResult)) {
		var li = getAssessResultLi(planInfo.assessResult);
		assessResultLi.appendChild(li);
	}
	planContentLay.innerHTML = "";
	if(planInfo.planContentList && planInfo.planContentList.length != 0) {
		planContentLay.innerHTML = getPlanContentListHtml(planInfo.planContentList);
	}

	noteLi.innerHTML = "";
	if(!g_utils.isEmpty(planInfo.note)) {
		note_appendImg_flag = true;
		var li = getNoteLi(planInfo.note);
		noteLi.appendChild(li);
	}

	imgLay.innerHTML = "";
	if(planInfo.appendImgs && planInfo.appendImgs.length != 0) {
		note_appendImg_flag = true;
		imgLay.classList.remove('mui-hidden');
		var images = planInfo.appendImgs;
		for(var i = 0, len = images.length; i < len; i++) {
			var imageUrl = images[i];
			var div = document.createElement('div');
			div.className = 'imgcontain';
			var srcUrl = getImgUrl(imageUrl) + "&tb=1";
			var previesSrcUrl = getImgUrl(imageUrl);
			div.innerHTML = '<img src="' + srcUrl + '" class="appendImg"' +
				'data-preview-src="' + previesSrcUrl + '"' +
				'data-preview-group="1" />';
			imgLay.appendChild(div);
		}
	} else {
		imgLay.classList.add('mui-hidden');
	}

	if(!note_appendImg_flag) { //结束关闭状态备注计附件都没有内容，则隐藏整块
		noteLay.classList.add('mui-hidden');
	}

	g_mui.previewImageInit();
	initCollapsePlanTxt();
}

function getPlanContentListHtml(planContentList) {
	var planContentListHtml = "";
	for(var i = 0, len = planContentList.length; i < len; i++) {
		var planContent = planContentList[i];
		var planTitle = planTitleArr[planContent.planType];

		planContentListHtml += '<div class="mui-table-view-cell mui-collapse-content plan-item">' +
			'<div class="plan-title">' + planTitle + '</div>' +
			'<div class="content-container">' +
			'<div class="plan-text">' + planContent.planContent + '</div>' +
			'<div class="expand-collapse"></div>' +
			'</div>' +
			'</div>';

	}
	return planContentListHtml;
}

function getAssessResultLi(assessResult) {
	var li = document.createElement('li');
	li.className = 'mui-table-view-cell mui-collapse-content plan-item';
	li.innerHTML = '<div class="content-container">' +
		'<div class="plan-text">' + assessResult + '</div>' +
		'<div class="expand-collapse"></div>' +
		'</div>';

	return li;
}

function getNoteLi(note) {
	var li = document.createElement('li');
	li.className = 'mui-table-view-cell mui-collapse-content plan-item divider';
	li.innerHTML = '<div class="content-container">' +
		'<div class="plan-text">' + note + '</div>' +
		'<div class="expand-collapse"></div>' +
		'</div>';

	return li;
}


//初始化展开收缩内容（大于三行时）
function initCollapsePlanTxt() {
	mui('.plan-text').each(function() {
		var planContentTxt = this;
		var planContentContainer = planContentTxt.parentNode;
		var planContentExpandCollapse = planContentTxt.nextSibling;
		var txtLines = countLines(planContentTxt);

		if(txtLines > CONTENT_SHOW_MAX_LINES) { //大于3行
			planContentContainer.setAttribute("class", "content-container collapse");
			planContentExpandCollapse.addEventListener('tap', function(event) {
				var planContentContainer = this.parentNode;
				var planContentTxt = this.previousSibling;
				if(planContentContainer.getAttribute("class").split(" ").indexOf("collapse") !== -1) {
					planContentContainer.setAttribute("class", "content-container expand");
				} else {
					planContentContainer.setAttribute("class", "content-container collapse");
				}
			}, false);
		} else {
			planContentContainer.setAttribute("class", "content-container");
		}

	});
}

//计算行数
function countLines(ele) {
	var styles = window.getComputedStyle(ele, null);
	var lh = parseInt(styles.lineHeight);
	var h = parseInt(styles.height);
	var lc = Math.round(h / lh);
	/*console.log('line count:' + lc + ',line-height:' + lh + ',height:' + h);*/
	return lc;
}

/*
 * 获取计划信息
 */
function getPlanInfoByPlanId() {
	var parameters = {};
	addParameter('planId', _planId, parameters);
	g_tools.postCMD("getPlanInfoByPlanId", parameters, function(result) {
		if(result.code == 0) {
			planInfo = result.data;
			refreshPlanInfo();
			getReportListByPlanId();
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE, {
		disableWait: true, //禁止显示wait框
		noNetworkMode: g_tools.TIP_MODE_TOAST //！！！！！！！！！重点代码！！！！！！！！！
	});
}

function getReportListByPlanId() {
	var parameters = {};
	addParameter('planId', _planId, parameters);
	g_tools.postCMD("getReportListByPlanId", parameters, function(result) {
		if(result.code == 0) {
			var reportList = result.data;
			refreshReportList(reportList);
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE);
}

function refreshReportList(reportList) {
	reportListLay.innerHTML = ""; //清空
	if(reportList && reportList.length != 0) {
		healthReportLay.classList.remove('mui-hidden');
		for(var i = 0, len = reportList.length; i < len; i++) {
			var reportItem = reportList[i];
			var reportLi = getReportLi(reportItem);
			reportListLay.appendChild(reportLi);
		}
	} else {
		healthReportLay.classList.add('mui-hidden');
	}
}

function getReportLi(reportItem) {
	var startTime = reportItem.startTime;
	var endTime = reportItem.endTime;
	var _reportId = reportItem.reportId;
	var timeTitle = g_printTools.printDateStrByTimeMillis(startTime) + " 至 " + g_printTools.printDateStrByTimeMillis(endTime);
	var reportLi = document.createElement('li');
	reportLi.className = 'mui-table-view-cell mui-collapse-content';
	reportLi.innerHTML = '<a class="mui-navigate-right">' + timeTitle + '</a>';
	reportLi.addEventListener('tap', function() {
		g_mui.openPage(g_module.healthManage, 'healthDetail.html', {
			reportId: _reportId
		});
	});
	return reportLi;
}


/*
 * 插入请求参数
 */
function addParameter(key, value, parameters) {
	parameters[key] = value;
}


function getImgUrl(img) {
	var imgUrl = DEFAULT_HEAD_IMG;
	if(!g_utils.isEmpty(img)) {
		imgUrl = SERVER_IMG_ADDRESS + img+"&app=2";
	}
	return imgUrl;
}