var _self;
var current_page = 0;
var PAGE_STEP = 10;
var listDom = document.getElementById("scroll-list");
var noNetWorkDom = document.querySelector(".no_netWork");
var reconnectDom = document.getElementById("no_netWork_button");
var emptyDom = document.querySelector(".message-mask");
mui.init({
	pullRefresh: {
		container: '#refreshContainer',
		down: {
			//下拉成功回调函数
			callback: pullfreshDown
		},
		up: {
			//上拉成功回调函数
			contentrefresh: '正在加载...',
			callback: pullfreshUp
		}
	}
});
mui.plusReady(function() {
	_self = plus.webview.currentWebview();
	getPlanListByUserId();
	document.addEventListener('refreshPage', function(e) {
		pullfreshDown();
	});
	reconnectDom.addEventListener("tap", function() {
		if(this.getAttribute("isClick") == "1") {
			return
		} else {
			this.setAttribute("isClick", "1");
			pullfreshDown();
		}
	});
});
//获取健康计划列表
function getPlanListByUserId() {
	g_tools.postCMD('getPlanListByUserId', {
		currentPage: current_page,
		pageSize: PAGE_STEP
	}, function(result) {
		if(result.code == 0) {
			if(current_page == 0) {
				cleanList();
				if(result.data.length == 0) {
					emptyDom.classList.add("mask-show");
					emptyDom.classList.remove("mask-close");
					noNetWorkDom.classList.add("hide");
					mui('#refreshContainer').pullRefresh().endPulldownToRefresh();
					return
				} else {
					emptyDom.classList.remove("mask-show");
					emptyDom.classList.add("mask-close");
					showHealthPlan(result.data);
				}
				//重置上拉加载
				mui('#refreshContainer').pullRefresh().refresh(true);
				//mui('#refreshContainer').pullRefresh().enablePullupToRefresh();
				mui('#refreshContainer').pullRefresh().endPulldownToRefresh();
			} else {
				if(result.data.length < PAGE_STEP) {
					mui('#refreshContainer').pullRefresh().endPullupToRefresh(true);
					setTimeout(function() {
						mui('#refreshContainer').pullRefresh().disablePullupToRefresh();
					}, 1000)
				}else{
					mui('#refreshContainer').pullRefresh().endPullupToRefresh(false);
				}
				showHealthPlan(result.data);
			}
			current_page++;
		} else {
			//显示断网页面
			noNetWorkDom.classList.remove("hide");
		}
	})
}
//下拉刷新
function pullfreshDown() {
	setTimeout(function() {
		current_page = 0;
		getPlanListByUserId();
	}, 100);
}
//上拉加载
function pullfreshUp() {
	setTimeout(function() {
		getPlanListByUserId();
	}, 100);
}

function showHealthPlan(data) {
	for(var i = 0; i < data.length; i++) {
		var item = data[i];
		var li = document.createElement("li");

		var contentDom = document.createElement("div");
		contentDom.setAttribute("planId", item.id);
		contentDom.setAttribute("startTime", item.startTime);
		contentDom.setAttribute("endTime", item.endTime);

		contentDom.classList.add("mui-slider-handle", getStatusClass(item.status));
		li.className = "mui-table-view-cell"

		contentDom.innerHTML = '<img src="img/cycle.png" class="item-icon"/ >' + g_utils.dateFormat(item.startTime, "yyyy.MM.dd") + '-' +
			g_utils.dateFormat(item.endTime, "yyyy.MM.dd") + '（' + msGetDay(item.endTime - item.startTime) + '天）' + '</br>' +
			'<img src="img/doctor.png" class="item-icon"/ >' + '医师：' + item.doctorName

		li.appendChild(contentDom);
		listDom.appendChild(li);
		contentDom.addEventListener("tap", function() {
			var startTime = this.getAttribute("startTime");
			var endTime = this.getAttribute("endTime");
			var planId = this.getAttribute("planId");
			g_mui.openPage(g_module.healthPlan,"planDetail.html", {
				planId: planId,
				startTime: startTime,
				endTime: endTime
			});
		});
	}
}
//获取状态类名
function getStatusClass(status) {
	var className;
	switch(status) {
		case 0:
			className = "plan-not-start"
			break;
		case 1:
			className = "plan-processing"
			break;
		case 2:
			className = "plan-over"
			break;
		case 3:
			className = "plan-over"
			break;
		case 4:
			className = "plan-over"
			break;
		default:
			break;
	}
	return className;
}

function cleanList() {
	while(listDom.hasChildNodes()) {
		listDom.removeChild(listDom.firstChild);
	}
}

function msGetDay(ms) {
	return Math.ceil(ms / 86400000);
}