var _self, _planId, _planInfo;

var planTimeDom = document.getElementById("plan-time");
mui.init();
mui.plusReady(function() {
	_self = plus.webview.currentWebview();
	_planId = _self.planId;
	getPlanInfo();
});
//获取计划信息
function getPlanInfo() {
	g_tools.postCMD("getPlanInfoByPlanId2", {
		planId: _planId
	}, function(res) {
		if(res.code == 0) {
               //     alert(JSON.stringify(res.data));
			_planInfo = res.data;
			var totalTask = 0;
			var finishTask = 0;
			var planMissionAbstract = _planInfo.planMissionAbstract;
			mui.each(planMissionAbstract, function(index, item) {
				var itemCode = item.code;
				var itemTask = item.totalMissionCount;
				var itemFinish = item.completedMissionCount;
				totalTask += itemTask;
				finishTask += itemFinish;
			//	planTemplate[itemCode].dataList.push(item);
			});
//			for(key in planTemplate) {
//				refreshPlan({
//					code: key,
//					dataList: planTemplate[key].dataList
//				});
//			}
			setTitle(totalTask, finishTask);

            refreshPlan();
		}
	})
}
//设置顶部
function setTitle(totalTask, finishTask) {
	g_tools.postCMD("getDoctorMemberInfoById", {
		memberId: _planInfo.doctorId
	}, function(res) {
		if(res.code == 0) {
			var doctorName = res.data.name;
			var titleDom = document.getElementById("plantitle");
			titleDom.innerHTML = 
//			'<div class="box-two">执行时间：' + g_utils.dateFormat(_planInfo.startTime, "yyyy.MM.dd") + "-" +
//				g_utils.dateFormat(_planInfo.endTime, "yyyy.MM.dd") + "（" + getDay(_planInfo.endTime - _planInfo.startTime) + "天）" + '</div>' +
				'<div class="box-one">执行医师：' + doctorName + '</div>' +
				'<div class="box-one">执行状态：' + getStatus(_planInfo.status) + '</div>' +
				'<div class="box-two">完成进度：<progress value="' + finishTask + '" max="' + totalTask + '">' +
				'</progress> ' + finishTask + '/' + totalTask + '</div>'
		}
	});
}
//获取天数
function getDay(ms) {
	return Math.ceil(ms / 86400000);
}
//获取状态值
function getStatus(status) {
	var statusName = ""
	switch(status) {
		case 0:
			statusName = "未开始";
			break;
		case 1:
			statusName = "执行中";
			break;
		case 2:
			statusName = "已结束";
			break;
        case 3:
            statusName = "提前结束";
            break;
		default:
			statusName = "已结束";
	}
	return statusName
}
//刷新计划
function refreshPlan() {
        
    //评估要点
    if (!g_utils.isEmpty(_planInfo.assessResult)){
        var evaluationPointDom = document.getElementById('evaluationPoint');
        evaluationPointDom.innerHTML = _planInfo.assessResult.replace(/\n/g,'<br>');
        evaluationPointDom.parentNode.classList.remove("mui-hidden");
    }
    
    //管理目标
    if (!g_utils.isEmpty(_planInfo.targetContent)){
        var startTime = _planInfo.startTime;
        var endTime = _planInfo.endTime;
        var cycleDate = "";
        if(!g_utils.isEmpty(startTime) && !g_utils.isEmpty(endTime)) {
            cycleDate = g_utils.dateFormat(startTime, "yyyy.MM.dd") + "-" + g_utils.dateFormat(endTime, "yyyy.MM.dd");
        }
        var managePointDom = document.getElementById('managePoint');
        managePointDom.innerHTML = '现阶段主要针对' + _planInfo.targetContent.replace(/\n/g,'<br>') + '进行干预管理，管理时间周期为' + cycleDate + '。';
        managePointDom.parentNode.classList.remove("mui-hidden");
    }
    
    var planMissionAbstract = _planInfo.planMissionAbstract
                    // alert(JSON.stringify(planMissionAbstract));
    for (var i=0 ;i < planMissionAbstract.length;i++){
        var code = planMissionAbstract[i].code;
        if (code != 'PM_011'){
             document.getElementById(code).classList.remove("mui-hidden");
        }
       
        if (code == 'PM_001'){  //计步任务
            var listDom = document.getElementById('sportContentList');
            var contentList = planMissionAbstract[i].parametersData.mission;
            
            var domHtmlCode = '';
            for (var j=0;j< contentList.length;j++){
                domHtmlCode += '<div class="content-text border-bottom flex-between">' +
                    '<div>' + contentList[j].time + '</div>' +
                    '<div class="step-content">' + contentList[j].step +'步</div>'+
                '</div>';
            }
                     
            listDom.innerHTML = domHtmlCode;
                     
        }else if (code == 'PM_002'){ //服药计划
            var listDom = document.getElementById('medicine');
            var contentList = planMissionAbstract[i].parametersData.mission;
                     
            var domHtmlCode = '';
            for (var j=0;j< contentList.length;j++){
                domHtmlCode += '<div>' + contentList[j].drug + '：' + '每次剂量' + contentList[j].amount + contentList[j].unit + '；' + contentList[j].day + '日' +  contentList[j].count + '次' + '</div>';
            }
                     
            listDom.innerHTML = domHtmlCode;
                     
        }else if (code == 'PM_003'){ //测量任务
            var listDom = document.getElementById('healthMeasure');
            var contentList = planMissionAbstract[i].parametersData.mission;
                     
            var domHtmlCode = '';
            for (var j=0;j< contentList.length;j++){
                domHtmlCode += '<div>' + '记录' + contentList[j].typeName + '数据：' + contentList[j].day + '日' +  contentList[j].count + '次' + '</div>';
            }
                     
            listDom.innerHTML = domHtmlCode;
                     
        }else if (code == 'PM_005'){ //主动运动
            var listDom = document.getElementById('sportPlan');
            var contentList = planMissionAbstract[i].parametersData.mission;
                     
            var domHtmlCode = '';
            for (var j=0;j< contentList.length;j++){
                domHtmlCode += '<div>' + '完成' + contentList[j].typeName + '运动：' + contentList[j].day + '日' +  contentList[j].count + '次，每次' + contentList[j].amount + contentList[j].unit + '</div>';
            }
                     
            listDom.innerHTML = domHtmlCode;
                     
        }else if (code == 'PM_006'){ //睡眠
            var listDom = document.getElementById('sleep');
                     
            var domHtmlCode = '';
            domHtmlCode += '<div>' + '最晚入睡时间：' + planMissionAbstract[i].parametersData.timeStr + '；睡眠时长：' + planMissionAbstract[i].parametersData.hour + '小时</div>';
                     
            listDom.innerHTML = domHtmlCode;
                     
        }else if (code == 'PM_007'){ //辅助
            var listDom = document.getElementById('trainingAids');
            var contentList = planMissionAbstract[i].parametersData.mission;
                     
            var domHtmlCode = '';
            for (var j=0;j< contentList.length;j++){
                domHtmlCode += '<div>' + '完成' + contentList[j].typeName + '：' + contentList[j].day + '日' +  contentList[j].count + '次，每次' + contentList[j].min + '分钟</div>';
            }
                     
            listDom.innerHTML = domHtmlCode;
                     
        }else if (code == 'PM_010'){ //营养素
            var listDom = document.getElementById('nutrient');
            var contentList = planMissionAbstract[i].parametersData.mission;
                     
            var domHtmlCode = '';
            for (var j=0;j< contentList.length;j++){
                domHtmlCode += '<div>' + contentList[j].drug + '：' + '每次剂量' + contentList[j].amount + contentList[j].unit + '；' + contentList[j].day + '日' +  contentList[j].count + '次' + '</div>';
            }
                     
            listDom.innerHTML = domHtmlCode;
                     
        }else if (code == 'PM_011'){ //饮食
            var contentJson = planMissionAbstract[i].parametersData;
                     
            if (!g_utils.isEmpty(contentJson.type_0)){ //早餐
                document.getElementById('PM_011_0').classList.remove("mui-hidden");
                
                var titleListDom = document.getElementById('breakfastContentList');
                var list = contentJson.type_0.menuArr;
                var domHtmlCode = '';
                for (var j=0;j< list.length;j++){
                    domHtmlCode += '<div class="content-text border-bottom">' + list[j].menuName + '：' + list[j].menuIntro + '</div>';
                }
                titleListDom.innerHTML = domHtmlCode;
                     
                var tipDom = document.getElementById('breakfastTipContent');
                var tipsStr = contentJson.type_0.tips;
                tipDom.innerHTML = tipsStr.replace(/\n/g,'<br>');
            }
            if (!g_utils.isEmpty(contentJson.type_1)){ //午餐
                document.getElementById('PM_011_1').classList.remove("mui-hidden");
                     
                var titleListDom = document.getElementById('lunchContentList');
                var list = contentJson.type_1.menuArr;
                var domHtmlCode = '';
                for (var j=0;j< list.length;j++){
                    domHtmlCode += '<div class="content-text border-bottom">' + list[j].menuName + '：' + list[j].menuIntro + '</div>';
                }
                titleListDom.innerHTML = domHtmlCode;
                     
                var tipDom = document.getElementById('lunchTipContent');
                var tipsStr = contentJson.type_1.tips;
                tipDom.innerHTML = tipsStr.replace(/\n/g,'<br>');
            }
            if (!g_utils.isEmpty(contentJson.type_2)){ //晚餐
                document.getElementById('PM_011_2').classList.remove("mui-hidden");
                     
                var titleListDom = document.getElementById('supperContentList');
                var list = contentJson.type_2.menuArr;
                var domHtmlCode = '';
                for (var j=0;j< list.length;j++){
                    domHtmlCode += '<div class="content-text border-bottom">' + list[j].menuName + '：' + list[j].menuIntro + '</div>';
                }
                titleListDom.innerHTML = domHtmlCode;
                     
                var tipDom = document.getElementById('supperTipContent');
                tipDom.innerHTML = contentJson.type_2.tips.replace(/\n/g,'<br>');
            }
            if (!g_utils.isEmpty(contentJson.type_3)){ //加餐
                document.getElementById('PM_011_3').classList.remove("mui-hidden");
                     
                var titleListDom = document.getElementById('snackContentList');
                var list = contentJson.type_3.menuArr;
                var domHtmlCode = '';
                for (var j=0;j< list.length;j++){
                    domHtmlCode += '<div class="content-text border-bottom">' + list[j].menuName + '：' + list[j].menuIntro + '</div>';
                }
                titleListDom.innerHTML = domHtmlCode;
                     
                var tipDom = document.getElementById('snackTipContent');
                tipDom.innerHTML = contentJson.type_3.tips.replace(/\n/g,'<br>');
            }
        }
    }

}
