var PAGE_STEP = 20; //刷新步长

var tabelList = document.querySelector(".mui-table-view");
var currentPoints=document.getElementById('currentPoints');
var healthGoodsList = new Array(), nowPage = 0;
var siteTag = '';
var site_items = ['苏马荡', '武汉'];
var site_tag = ['S_0718_01','S_027_01']
var site_point = ['108.702023,30.460922;100000','114.309913,30.608692;200000'];  //中心点;服务半径

mui.plusReady(function() {
	
	init();
	
	getHealthPointsBills(g_tools.MODE_WEB_LOCAL_CACHE, {
		disableWait: true
	});
              
    var helpIconDom = document.getElementById('helpIcon');
    helpIconDom.addEventListener('tap', function(e) {
        g_mui.openPage(g_module.healthPoints, 'healthPointsRule.html');
    });
	
	var qrCodeDom = document.getElementById('qrCode');
	qrCodeDom.addEventListener('tap', function(e) {
		g_mui.openPage(g_module.healthPoints, 'QRCode.html');
	});
              
    var healthPointsDom = document.getElementById('healthPoints');
    healthPointsDom.addEventListener('tap', function(e) {
        g_mui.openPage(g_module.healthPoints, 'healthPoints.html');
    });
              
    var areaChooseDom = document.getElementById('areaChoose');
    areaChooseDom.addEventListener('tap', function(e) {
        if(mui.os.plus) {
            var buttons = [{
                title: "苏马荡"
            }, {
                title: "武汉"
            }];
            plus.nativeUI.actionSheet({
                cancel: "取消",
                buttons: buttons
            }, function(b) { /*actionSheet 按钮点击事件*/
                switch(b.index) {
                    case 1:
                        selectArea('S_0718_01');
                        break;
                    case 2:
                        selectArea('S_027_01');
                        break;
                    default:
                        break;
                }
            })
        }
    });
              
    document.addEventListener('refreshHealthPoints', function(e) {
        getHealthPointsBills(g_tools.MODE_WEB_LOCAL_CACHE, {
             disableWait: true
        });
    });
	
});
//获取健康币明细
function getHealthPointsBills(mode, timeOutHanding) {
	g_tools.postCMD('healthPoints/getHealthPointsBills', {
		currentPage: nowPage,
		pageSize: PAGE_STEP
	}, function(res) {
		if(res.code == 0) {
			//积分总计
			currentPoints.innerHTML=res.data.currentPoints;
                    //TODO
//            getPointsGoodsListBySiteTag(g_tools.MODE_WEB_LOCAL_CACHE, {
//                disableWait: true
//            });
                    
            //获取最近位置并刷新商品列表
            getRecentLocation();
                    
		}
	}, mode, timeOutHanding);
}

function getPointsGoodsListBySiteTag(mode,timeOutHanding){
    g_tools.postCMD('getPointsGoodsListBySiteTag', {
        siteTag:siteTag,
        currentPage: nowPage,
        pageSize: PAGE_STEP
    }, function(res) {
        if(res.code == 0) {
            
            var data = res.data;
           
                setTimeout(function() {
                    if(nowPage == 0) {
                        healthGoodsList = data;
                        resetList();
                        //结束下拉刷新
                        mui('#pullrefresh').pullRefresh().endPulldownToRefresh();
                        //重置上拉加载
                        mui('#pullrefresh').pullRefresh().refresh(true);
                    } else {
                               
                        //上拉加载
                        addList(data);
                    }
                }, 100);
            
            
        }
    }, mode, timeOutHanding);
}

//初始化下拉刷新
function init() {
	mui.init({
		pullRefresh: {
			container: '#pullrefresh',
			down: {
				//下拉成功回调函数
				callback: pullDownRefresh
			},
			up: {
				//上拉成功回调函数
				contentrefresh: '正在加载...',
				contentnomore: '没有更多数据了',
				callback: pullUpRefresh
			}
		}
	});
}
//重置表单
function resetList() {
	for(var i=tabelList.children.length-1;i>=0;i--){
		if(i>=2) tabelList.removeChild(tabelList.children[i]);
	}
	//检查是否没有记录
	if(!g_utils.isEmptyArray(healthGoodsList)) {
		document.getElementById('noBillsItemTip').classList.add('mui-hidden');
		mui.each(healthGoodsList, function(index, item) {
			appendListItem(index, item);
		});
	} else {
		document.getElementById('noBillsItemTip').classList.remove('mui-hidden');
		//显示空值界面
	}
}
//添加表单
function addList(data) {
	//没有更多数据
	if(!g_utils.isEmptyArray(data)) {
		var start = healthGoodsList.length;
		var dataLength = data.length;
		for(var i = 0; i < dataLength; i++) {
			healthGoodsList.push(data[i]);
			appendListItem(start + i, data[i]);
		}
	}
	mui('#pullrefresh').pullRefresh().endPullupToRefresh(data.length != PAGE_STEP);
}
//下拉刷新
function pullDownRefresh() {
	nowPage = 0;
	setTimeout(function(){
		getHealthPointsBills(g_tools.MODE_WEB_LOCAL_CACHE, {
			disableWait: true
		});
	}, 500);
}
//上拉加载
function pullUpRefresh() {
	nowPage++;
    getPointsGoodsListBySiteTag(g_tools.MODE_WEB_LOCAL_CACHE, {
        disableWait: true
    });
}
//添加列表子项
function appendListItem(index, item) {
	var li = document.createElement("li");
	var itemPreviewImage = item.previewImageArr[0];
	var itemName = item.name;
	var itemPrice = '';
    if (!g_utils.isEmpty(item.pointsUse) && item.pointsUse != 0){
        if (!g_utils.isEmpty(item.pointsPrice) && item.pointsPrice != 0){
            itemPrice = item.pointsUse + '积分 + ' + item.pointsPrice + '元';
        }else{
            itemPrice = item.pointsUse + '积分';
        }
    }else{
        itemPrice = item.price + '元';
    }
	li.className = "goods-cell";
	li.setAttribute("index", index);
	str = '<img class="goods-image" src="' + g_tools.IP_FILE + itemPreviewImage + '&tb=1" data-src="' + g_tools.IP_FILE + itemPreviewImage + '&tb=1" onload="load(this)" />' +
        '<div class="goods-info">' +
            '<div class="goods-info-name">' + itemName + '</div>' +
            '<div class="goods-info-price">' + itemPrice + '</div>' +
		'</div>'
	li.innerHTML = str;
	tabelList.appendChild(li);
	addTapEvent(li);  
}
//添加点击事件
function addTapEvent(dom) {
	dom.addEventListener('tap', function() {
		var index = this.getAttribute("index");
        g_mui.openPage(g_module.healthPoints, 'healthGoodsDetail.html', {
            data: healthGoodsList[index]
        });
	});
}

function selectArea(areaId){
    nowPage = 0;
    
    var areaChooseDom = document.getElementById('areaChoose');
    if (areaId == 'S_0718_01'){
        areaChooseDom.innerHTML = '苏马荡';
        siteTag = areaId;
        
        getPointsGoodsListBySiteTag(g_tools.MODE_WEB_LOCAL_CACHE, {
            disableWait: true
        });
    }else if (areaId == 'S_027_01'){
        areaChooseDom.innerHTML = '武汉';
        siteTag = areaId;
        
        getPointsGoodsListBySiteTag(g_tools.MODE_WEB_LOCAL_CACHE, {
            disableWait: true
        });
    }
}

function getRecentLocation(){
    g_tools.postCMD('getRecentLocation', {
    }, function(res) {
        if(res.code == 0) {
            if (!g_utils.isEmpty(res.data.longitude) && !g_utils.isEmpty(res.data.latitude)){
                getSiteByLocation(res.data.longitude,res.data.latitude);
            }else{
            	setTimeout(function(){
		            //结束下拉刷新
		            mui('#pullrefresh').pullRefresh().endPulldownToRefresh();
		            //重置上拉加载
		            mui('#pullrefresh').pullRefresh().refresh(true);
		        }, 500);
            }
        }
    }, g_tools.MODE_WEB_LOCAL_CACHE);
}

function getSiteByLocation(longitude,latitude){
    var minDistance = Number.MAX_VALUE;
    var minIndex = -1;
    for (var i = 0; i < site_point.length;i++){  //找出最近的服务点
        var arr = site_point[i].split(';');
        var lngLat = arr[0].split(',');
        var raduis = parseInt(arr[1]);
        var distance = g_utils.getFlatternDistance(lngLat[0], lngLat[1], longitude, latitude);
        if (distance < raduis && distance<minDistance){  //在服务半径内且比最小的还小
            minIndex = i;
            minDistance = distance;
        }
    }
    if (minIndex>=0){
        //找到了最近的点
        siteTag = site_tag[minIndex];
        //刷新商品列表
        getPointsGoodsListBySiteTag(g_tools.MODE_WEB_LOCAL_CACHE, {
            disableWait: true
        });
    }else{
        setTimeout(function(){
            //结束下拉刷新
            mui('#pullrefresh').pullRefresh().endPulldownToRefresh();
            //重置上拉加载
            mui('#pullrefresh').pullRefresh().refresh(true);
        }, 500);
    }
}

function addTestData(){
    var data = [{
                 "id": "asdh121h1k23h1231",
                 "previewImageArr": ["/getImg?imgId=57ecc7be695fa84a53ded010", ""],
                 "name": "神仙丹",
                 "price": "16.6",
                 "pointsUse": 300,
                 "pointsPrice": "15"
                 }, {
                 "id": "ger23243243242342",
                 "previewImageArr": ["../../global/img/healthPoints/blank_img.png", ""],
                 "name": "大补丸",
                 "price": "10.6",
                 "pointsUse": 200,
                 "pointsPrice": "8"
                 }, {
                 "id": "asdh121h1k23h1231",
                 "previewImageArr": ["../../global/img/healthPoints/blank_img.png", ""],
                 "name": "神仙丹2",
                 "price": "16.6",
                 "pointsUse": 0,
                 "pointsPrice": "15"
                 }, {
                 "id": "ger23243243242342",
                 "previewImageArr": ["../../global/img/healthPoints/blank_img.png", ""],
                 "name": "大补丸",
                 "price": "10.6",
                 "pointsUse": 200,
                 "pointsPrice": "8"
                 }, {
                 "id": "asdh121h1k23h1231",
                 "previewImageArr": ["../../global/img/healthPoints/blank_img.png", ""],
                 "name": "神仙丹",
                 "price": "16.6",
                 "pointsUse": 300,
                 "pointsPrice": "15"
                 }, {
                 "id": "ger23243243242342",
                 "previewImageArr": ["../../global/img/healthPoints/blank_img.png", ""],
                 "name": "大补丸",
                 "price": "10.6",
                 "pointsUse": 200,
                 "pointsPrice": "8"
                 }];
    
    healthGoodsList = data;
}
