var MIN_HEIGHT = 90;
var MAX_HEIGHT = 250;
var MIN_WEIGHT_INTEGER = 25; //体重整数部分
var MAX_WEIGHT_INTEGER = 150;
var MIN_WEIGHT_DECIMAL = 0; //体重小数部分
var MAX_WEIGHT_DECIMAL = 9;
//平台
var os = null;
//用户类
var myProfile;
//picker
var sexPicker, heightPicker, weightPicker, birthPicker;
//dom
//group 1
var showSexPicker = document.getElementById('showSexPicker'); //性别
var sexResult = document.getElementById('sexResult');

var showHeightPicker = document.getElementById('showHeightPicker'); //身高
var heightResult = document.getElementById('heightResult');

var showWeightPicker = document.getElementById('showWeightPicker'); //体重
var weightResult = document.getElementById('weightResult');

var showBirthPicker = document.getElementById('showBirthPicker'); //生日
var birthResult = document.getElementById('birthResult');
//-------------

//group2
var showUserMinor = document.getElementById('userMinority'); //民族
var userMinorResult = document.getElementById('userMinorityResult');

var showUserDegreex = document.getElementById('userDegreex'); //文化程度
var userDegreexResult = document.getElementById('userDegreexResult');

var showUserCareer = document.getElementById('userCareer'); //职业
var userCareerResult = document.getElementById('userCareerResult');

var showUserMaritaStatus = document.getElementById('userMaritaStatus'); //婚姻状况
var userMaritaStatusResult = document.getElementById('userMaritaStatusResult');

var showUserPayWay = document.getElementById('userPayWay'); //支付方式
var userPayWayResult = document.getElementById('userPayWayResult');

var showUserBloodTypeAbo = document.getElementById('userBloodTypeAbo'); //ABO血型
var userBloodTypeAboResult = document.getElementById('userBloodTypeAboResult');

var showUserBloodTypeRh = document.getElementById('userBloodTypeRh'); //RH血型
var userBloodTypeRhResult = document.getElementById('userBloodTypeRhResult');

var showUserDrugAllergy = document.getElementById('userDrugAllergy'); //药物过敏史
var userDrugAllergyResult = document.getElementById('userDrugAllergyResult');

var showUserAnamnesis = document.getElementById('userAnamnesis'); //既往病史
var userAnamnesisResult = document.getElementById('userAnamnesisResult');

var showUserFamilyHistory = document.getElementById('userFamilyHistory'); //家族病史
var userFamilyHistoryResult = document.getElementById('userFamilyHistoryResult');

var showUserHeredopathia = document.getElementById('userHeredopathia'); //遗传病史
var userHeredopathiaResult = document.getElementById('userHeredopathiaResult');
//-------------

//group3
var showHomePhone = document.getElementById('showHomePhone'); //家庭电话
var homePhoneResult = document.getElementById('homePhoneResult');

var showSetAdd = document.getElementById('showSetAdd'); //家庭地址
var addResult = document.getElementById('addResult');
//-------------

//group4
var normal = document.getElementById('normal'); //健康值范围
//-------------
var weightRangeFrom;
//mui初始化
mui.init();
mui.plusReady(function() {
	//刷新数据
	getUserInfoByUserId();
	getSettings();

});

//获取用户设置
function getSettings() {
	g_tools.postCMD("getSettings", {}, function(res) {
		if(res.code == 0) {
			weightRangeFrom = res.data.weightRangeFrom
			initDomTap();
		}
	})
}

//改变体重默认范围
function changeWeightNormalValue(height) {
	var obj = [{
		type: 5,
		minValue: (18.5 * Math.pow(parseFloat(height) / 100, 2)).toFixed(1),
		maxValue: (25 * Math.pow(parseFloat(height) / 100, 2)).toFixed(1)
	}]
	g_tools.postCMD("modifyNormalValue", {
		normalValue: JSON.stringify(obj)
	}, function(res) {
		if(res.code == 0) {
			modifyUserInfo('height', height);
		}
	})
}

function initDomTap() {

	//性别
	sexPicker = new mui.PopPicker();
	sexPicker.setData([{
		value: "1",
		text: '男'
	}, {
		value: "0",
		text: '女'
	}]);

	showSexPicker.addEventListener('tap', function(event) {
		var sexValue = sexResult.innerHTML;
		if(sexValue !== "未设置") {
			sexPicker.pickers[0].setSelectedValue(sexValue == "男" ? "1" : "0");
		}
		sexPicker.show(function(items) {
			sexResult.className = 'selected';
			var selectSexValue = parseInt(items[0].value);
			modifyUserInfo('sex', selectSexValue);
		});
	}, false);
	//-----------------------------------------
	//身高
	showHeightPicker.addEventListener('tap', function(event) {
		new KeyBoard(heightResult, 0, {
			title: "身高",
			unit: "厘米",
			isInput: false,
			okCallback: function(backValue) {
				g_tools.postCMD("getSettings", {}, function(res) {
					if(res.code == 0) {
						weightRangeFrom = res.data.weightRangeFrom
						if(weightRangeFrom == 1) {
							modifyUserInfo('height', backValue);
						} else {
							changeWeightNormalValue(backValue);
						}
					}
				})
			},
			range: "90-250"
		});
	}, false);
	//-----------------------------------------
	//体重
	showWeightPicker.addEventListener('tap', function(event) {
		new KeyBoard(weightResult, 1, {
			title: "体重",
			unit: "kg",
			isInput: false,
			okCallback: function(backValue) {
				modifyUserInfo('weight', backValue);
			},
			range: "25.0-150.9"
		});
	}, false);
	//-----------------------------------------
	//生日
	var nowDate = new Date();
	var nowYear = nowDate.getFullYear() - 1;
	var beginYear = nowYear - 100;
	var optionsJson = '{"type":"date","beginYear":' + beginYear + ',"endYear":' + nowYear + ',"value":"1990-10-10"}';
	var options = JSON.parse(optionsJson);
	birthPicker = new mui.DtPicker(options);

	showBirthPicker.addEventListener('tap', function(event) {
		var birthValue = birthResult.innerHTML;
		if(birthValue !== "未设置") {
			birValue = birthValue.replace(/(\d{4}).(\d{1,2}).(\d{1,2}).+/mg, '$1-$2-$3');
			birthPicker.setSelectedValue(birValue);
		}
		birthPicker.show(function(selectItems) {
			var year = selectItems.y.text;
			var month = selectItems.m.text;
			var day = selectItems.d.text;
			birthResult.className = 'selected';
			var birthMills = Date.parse(month + "/" + day + "/" + year);
			modifyUserInfo('birthday', birthMills);
		})
	}, false);
	//-----------------------------------------

	//民族
	showUserMinor.addEventListener('tap', function(e) {
		g_mui.openNormalRecordPicker({
			typeName: "minority",
			selectedValue: userMinorResult.innerText
		});
	});
	document.addEventListener('setMinority', function(ee) {
		userMinorResult.className = 'selected';
		userMinorResult.innerText = ee.detail.value;
		modifyUserInfo('minority', ee.detail.value);
	}, false);
	//-----------------------------------------
	//文化程度
	showUserDegreex.addEventListener('tap', function(e) {
		g_mui.openNormalRecordPicker({
			typeName: "degree",
			selectedValue: userDegreexResult.innerText
		});
	});
	document.addEventListener('setDegree', function(ee) {
		userDegreexResult.className = 'selected';
		userDegreexResult.innerText = ee.detail.value;
		modifyUserInfo('degree', ee.detail.value);
	}, false);
	//-----------------------------------------
	//职业
	showUserCareer.addEventListener('tap', function(e) {
		var selectedValue = userCareerResult.innerText;
		if(userCareerResult.classList.contains('un_selected')) {
			selectedValue = "";
		}
		g_mui.openNormalRecordPicker({
			typeName: "career",
			selectedValue: selectedValue
		});
	});
	document.addEventListener('setCareer', function(ee) {
		userCareerResult.className = 'selected';
		userCareerResult.innerText = ee.detail.value;
		modifyUserInfo('career', ee.detail.value);
	}, false);
	//-----------------------------------------
	//婚姻状况
	showUserMaritaStatus.addEventListener('tap', function(e) {
		g_mui.openNormalRecordPicker({
			typeName: "maritaStatus",
			selectedValue: userMaritaStatusResult.innerText
		});
	});
	document.addEventListener('setMaritaStatus', function(ee) {
		userMaritaStatusResult.className = 'selected';
		userMaritaStatusResult.innerText = ee.detail.value;
		modifyUserInfo('maritaStatus', ee.detail.value);
	}, false);
	//-----------------------------------------
	//医疗支付方式
	showUserPayWay.addEventListener('tap', function(e) {
		var selectedValue = userPayWayResult.innerText;
		if(userPayWayResult.classList.contains('un_selected')) {
			selectedValue = "";
		}
		g_mui.openNormalRecordPicker({
			typeName: "payWay",
			selectedValue: selectedValue
		});
	});
	document.addEventListener('setPayWay', function(ee) {
		userPayWayResult.className = 'selected';
		userPayWayResult.innerText = ee.detail.value;
		modifyUserInfo('payWay', ee.detail.value);
	}, false);
	//-----------------------------------------
	//abo血型
	showUserBloodTypeAbo.addEventListener('tap', function(e) {
		g_mui.openNormalRecordPicker({
			typeName: "bloodTypeAbo",
			selectedValue: userBloodTypeAboResult.innerText
		});
		document.addEventListener('setAbo', function(ee) {
			userBloodTypeAboResult.className = 'selected';
			userBloodTypeAboResult.innerText = ee.detail.value;
			modifyUserInfo('bloodTypeAbo', ee.detail.value);
		}, false);
	});
	//-----------------------------------------
	//rh血型
	showUserBloodTypeRh.addEventListener('tap', function(e) {
		g_mui.openNormalRecordPicker({
			typeName: "bloodTypeRh",
			selectedValue: userBloodTypeRhResult.innerText
		});
		document.addEventListener('setRh', function(ee) {
			userBloodTypeRhResult.className = 'selected';
			userBloodTypeRhResult.innerText = ee.detail.value;
			modifyUserInfo('bloodTypeRh', ee.detail.value);
		}, false);
	});
	//-----------------------------------------
	//药物过敏史
	showUserDrugAllergy.addEventListener('tap', function(e) {
		g_mui.openMedicalHistoryPicker({
			typeName: "drugAllergy",
			selectedValue: userDrugAllergyResult.innerText
		});
	});
	document.addEventListener('setDrugAllergy', function(ee) {
		userDrugAllergyResult.className = 'selected';
		userDrugAllergyResult.innerText = ee.detail.value;
		modifyUserInfo('drugAllergyHistory', ee.detail.value);
	}, false);
	//-----------------------------------------
	//既往病史
	showUserAnamnesis.addEventListener('tap', function(e) {
		g_mui.openMedicalHistoryPicker({
			typeName: "anamnesis",
			selectedValue: userAnamnesisResult.innerText
		});
	});
	document.addEventListener('setAnamnesis', function(ee) {
		userAnamnesisResult.className = 'selected';
		userAnamnesisResult.innerText = ee.detail.value;
		modifyUserInfo('pastHistory', ee.detail.value);
	}, false);
	//-----------------------------------------
	//家族病史
	showUserFamilyHistory.addEventListener('tap', function(e) {
		g_mui.openMedicalHistoryPicker({
			typeName: "familyHistory",
			selectedValue: userFamilyHistoryResult.innerText
		});
	});
	document.addEventListener('setFamilyHistory', function(ee) {
		userFamilyHistoryResult.className = 'selected';
		userFamilyHistoryResult.innerText = ee.detail.value;
		modifyUserInfo('familyHistory', ee.detail.value);
	}, false);
	//-----------------------------------------
	//遗传病史
	showUserHeredopathia.addEventListener('tap', function(e) {
		g_mui.openMedicalHistoryPicker({
			typeName: "heredopathia",
			selectedValue: userHeredopathiaResult.innerText
		});
	});
	document.addEventListener('setHeredopathia', function(ee) {
		userHeredopathiaResult.className = 'selected';
		userHeredopathiaResult.innerText = ee.detail.value;
		modifyUserInfo('heredityHistory', ee.detail.value);
	}, false);
	//-----------------------------------------

	//家庭电话
	showHomePhone.addEventListener("tap", function() {
		//        var eHomePhonePage = plus.webview.getWebviewById("eHomePhone.html");
		//        var homePhone = myProfile.homePhone;
		//        if(!g_utils.isEmpty(homePhone)) {
		//            mui.fire(eHomePhonePage, 'sendHomePhone', {
		//                homePhone: homePhone
		//            });
		//        }
		//
		//        eHomePhonePage.show('slide-in-right');
		var homePhone = myProfile.homePhone;
		var param = {
			homePhone: homePhone
		};
		g_mui.openPage(g_module.healthRecords, 'eHomePhone.html', param, "slide-in-right");
	}, false);
	document.addEventListener('setHomePhoneValue', function(ee) {
		homePhoneResult.className = 'selected';
		modifyUserInfo('homePhone', ee.detail.homePhone)
	}, false);

	//-----------------------------------------
	//家庭地址
	showSetAdd.addEventListener("tap", function() {
		var add = myProfile.address;
		var param = {
			address: add
		};
		g_mui.openPage(g_module.healthRecords, "eAddress.html", param, "slide-in-right");
	}, false);
	document.addEventListener('setAddValue', function(ee) {
		addResult.className = 'selected';
		modifyUserInfo('address', ee.detail.address);
	}, false);

	//-----------------------------------------

	//-----------------------------------------
	//正常值设定
	normal.addEventListener("tap", function(event) {
		g_mui.openPage(g_module.healthRecords, 'normalSet.html');
	});

}

/*
 * 根据最大值和最小值生成picker用身高Datas数组
 */
function creatHeightDatas(min, max) {
	var datas = [];
	for(var i = 0; i < max - min + 1; i++) {
		var data = {};
		data.value = min + i;
		data.text = min + i + "厘米";
		datas.push(data);
	}

	return datas;
}
/*
 * 根据最大值和最小值生成picker用体重Datas数组
 */
function creatWeightDatas(minInteger, maxInteger, minDecimal, maxDecimal) {
	var datas = [];
	var children = [];
	var secondchildren = [{
		value: 0,
		text: "kg"
	}]
	for(var i = 0; i < maxDecimal - minDecimal + 1; i++) {
		var childrenData = {};
		childrenData.value = (minDecimal + i);
		childrenData.text = "." + (minDecimal + i);
		childrenData.children = secondchildren;
		children.push(childrenData);
	}

	for(var j = 0; j < maxInteger - minInteger + 1; j++) {
		var data = {};
		data.value = minInteger + j;
		data.text = minInteger + j;
		data.children = children;
		datas.push(data);
	}

	return datas;
}

/*
 * 刷新信息
 */
function refreshRecordData() {
	if(!g_utils.isEmpty(myProfile)) {
		//基本资料 group1
		if(myProfile.sex >= 0) {
			sexResult.innerHTML = myProfile.sex === 1 ? "男" : "女";
			sexResult.className = 'selected';
		}
		if(myProfile.height > 0) {
			heightResult.innerHTML = myProfile.height + "厘米";
			heightResult.className = 'selected';
		}
		if(myProfile.weight > 0) {
			weightResult.innerHTML = myProfile.weight.toFixed(1) + "kg";
			weightResult.className = 'selected';
		}
		if(!g_utils.isEmpty(myProfile.birthday)) {
			birthResult.innerHTML = g_utils.dateFormat(myProfile.birthday, "yyyy年MM月dd日");
			birthResult.className = 'selected';
		}

		//健康资料 group2
		if(!g_utils.isEmpty(myProfile.minority)) {
			userMinorResult.innerText = myProfile.minority;
			userMinorResult.className = 'selected';
		}
		if(!g_utils.isEmpty(myProfile.degree)) {
			userDegreexResult.innerText = myProfile.degree;
			userDegreexResult.className = 'selected';
		}
		if(!g_utils.isEmpty(myProfile.career)) {
			userCareerResult.innerText = myProfile.career;
			userCareerResult.className = 'selected';
		}
		if(!g_utils.isEmpty(myProfile.maritaStatus)) {
			userMaritaStatusResult.innerText = myProfile.maritaStatus;
			userMaritaStatusResult.className = 'selected';
		}
		if(!g_utils.isEmpty(myProfile.payWay)) {
			userPayWayResult.innerText = myProfile.payWay;
			userPayWayResult.className = 'selected';
		}
		if(!g_utils.isEmpty(myProfile.bloodTypeAbo)) {
			userBloodTypeAboResult.innerHTML = myProfile.bloodTypeAbo;
			userBloodTypeAboResult.className = 'selected';
		}
		if(!g_utils.isEmpty(myProfile.bloodTypeRh)) {
			userBloodTypeRhResult.innerHTML = myProfile.bloodTypeRh;
			userBloodTypeRhResult.className = 'selected';
		}
		if(!g_utils.isEmpty(myProfile.drugAllergyHistory)) {
			userDrugAllergyResult.innerHTML = myProfile.drugAllergyHistory;
			userDrugAllergyResult.className = 'selected';
		}
		if(!g_utils.isEmpty(myProfile.pastHistory)) {
			userAnamnesisResult.innerHTML = myProfile.pastHistory;
			userAnamnesisResult.className = 'selected';
		}
		if(!g_utils.isEmpty(myProfile.familyHistory)) {
			userFamilyHistoryResult.innerHTML = myProfile.familyHistory;
			userFamilyHistoryResult.className = 'selected';
		}
		if(!g_utils.isEmpty(myProfile.heredityHistory)) {
			userHeredopathiaResult.innerHTML = myProfile.heredityHistory;
			userHeredopathiaResult.className = 'selected';
		}

		//家庭资料 group3
		if(!g_utils.isEmpty(myProfile.homePhone)) {
			homePhoneResult.innerText = myProfile.homePhone;
			homePhoneResult.className = 'selected';
		}
		if(!g_utils.isEmpty(myProfile.address)) {
			addResult.innerText = myProfile.address.replace("-", "");
			addResult.className = 'selected';
		}

	}
}

/*
 * 获取用户信息
 */
function getUserInfoByUserId() {
	var parameters = {};
	var userId = g_tools.getUserId();
	addParameter('userId', userId, parameters);
	g_tools.postCMD("getUserInfoByUserId", parameters, function(result) {
		if(result.code == 0) {
			myProfile = result.data;
			refreshRecordData();
		}
	}, g_tools.MODE_CACHE_THEN_WEB_LOCAL);
}

/*
 * 更改用户信息
 * @param ｛String｝属性名
 * @param ｛｝属性值
 */
function modifyUserInfo(key, value) {
	var parameters = {};
	addParameter(key, value, parameters);
	g_tools.postCMD("modifyUserInfo", parameters, function(result) {
		if(result.code == 0) {
			getUserInfoByUserId();
		}
	}, g_tools.MODE_WEB);
}

/*
 * 插入请求参数
 */
function addParameter(key, value, parameters) {
	parameters[key] = value;
}