var mDecPicker, mIntPicker; //两种值选择框
var normalSettings;
var weightPicker, hPressurePicker, lPressurePicker, pulsePicker, sugarPicker, temperaturePicker, oxygenPicker;
var PICKER_ROLL_TIME = 500; //选择器自动滚动时间（及动画显示的时间）

var showWeightPicker = document.getElementById('showWeightPicker');
var weightResult = document.getElementById('weightResult');

var showHPressurePicker = document.getElementById('showHPressurePicker');
var hPressureResult = document.getElementById('hPressureResult');

var showLPressurePicker = document.getElementById('showLPressurePicker');
var lPressureResult = document.getElementById('lPressureResult');

var showPulsePicker = document.getElementById('showPulsePicker');
var pulseResult = document.getElementById('pulseResult');

var limosisSugarPicker = document.getElementById('limosisSugarPicker');
var limosisSugarResult = document.getElementById('limosisSugarResult');

var beaforeMealSugarPicker = document.getElementById('beaforeMealSugarPicker');
var beaforeMealSugarResult = document.getElementById('beaforeMealSugarResult');

var afterMealSugarPicker = document.getElementById('afterMealSugarPicker');
var afterMealSugarResult = document.getElementById('afterMealSugarResult');

var showTemperaturePicker = document.getElementById('showTemperaturePicker');
var temperatureResult = document.getElementById('temperatureResult');

var showOxygenPicker = document.getElementById('showOxygenPicker');
var oxygenResult = document.getElementById('oxygenResult');

var reSetBtn = document.getElementById('reSetBtn');

var PULSE_TYPE = 0; //脉搏
var OXYGEN_TYPE = 1; //血氧
var LIMOSIS_SUGAR_TYPE = 8; //空腹血糖
var BEGORRE_SUGAR_TYPE = 2; //餐前血糖
var AFTER_SUGAR_TYPE = 9; //餐后血糖
var HIGH_PRESSURE_TYPE = 3; //血压高压
var LOW_PRESSURE_TYPE = 4; //血压低压
var WEIGHT_TYPE = 5; //体重
var TEMPERATURE_TYPE = 6; //体温

var pulseSet, oxygenSet, limosisSugarSet, beaforeMealSugarSet, afterMealSugarSet, highPressureSet, lowPressureSet, weightSet, temperatureSet;

var resetParameters = {
	"normalValue": []
}
var weightRangeFrom = 0;
var weightDefaultRange;
var userHeight;
//mui初始化
mui.init();
mui.plusReady(function() {
	getUserInfo();
	initPickers();
});

function getUserInfo() {
	g_tools.postCMD("getUserInfoByUserId", {
		userId: g_tools.getUserId()
	}, function(res) {
		if(res.code == 0) {
			userHeight = res.data.height;
			getDefaultNormalValue();
		}
	})
}

function getDefaultNormalValue() {
	g_tools.postCMD("getDefaultNormalValue", {}, function(res) {
		if(res.code == 0) {
			var normalDataList = res.data;
			for(var key in normalDataList) {
				var itemNormal = normalDataList[key];
				itemNormal.type = parseInt(key);
				if(key == '5') {
					weightDefaultRange = itemNormal;
					continue;
				}
				resetParameters.normalValue.push(itemNormal);				
			}
			getNormalSetting();
			reSetBtn.addEventListener('tap', function(event) {
				g_mui.confirm('重置后，您之前设置的正常值将全部恢复到默认值。确定要重置吗？', '重置正常值', ['取消', '确定'], function(e) {
					if(e.index == 1) {
						//modifySettings
						weightRangeFrom = 0;
						g_tools.postCMD("modifySettings", {
							weightRangeFrom: 0
						}, function(res) {
							if(res.code == 0) {								
								modifyNormalValue(resetParameters);
							}
						})
					}
				});
			});
		}
	});

}

function getWeightRange() {
	var minValue = parseFloat(18.5 * Math.pow(userHeight / 100, 2)).toFixed(1);
	var maxValue = parseFloat(25 * Math.pow(userHeight / 100, 2)).toFixed(1);
	var obj = {};
	obj['type'] = WEIGHT_TYPE;
	obj['minValue'] = minValue;
	obj['maxValue'] = maxValue;
	return obj
}

function initPickers() {
	mDecPicker = new mui.PopPicker({
		layer: 5
	});
	mIntPicker = new mui.PopPicker({
		layer: 3
	});

	//-----------------------------------------
	//体重
	showWeightPicker.addEventListener('tap', function(event) {
		mDecPicker.setData(CreatDecData(25, 200, 0, 9));
		var weightValue = weightResult.innerHTML;
		if(weightValue != "未设置") {
			setDecPickersbyRange(weightValue, mDecPicker);
		}
		mDecPicker.show(function(items) {
			weightResult.className = 'selected';
			if(validateModifyParamters(getDecRange(items))) {
				var modifyParameters = creatModifyParameters(WEIGHT_TYPE, getDecRange(items));
			}
			weightRangeFrom = 1;
			g_tools.postCMD("modifySettings", {
				weightRangeFrom: 1
			}, function(res) {
				if(res.code == 0) {
					modifyNormalValue(modifyParameters);
				}
			})
		});
	}, false);
	//-----------------------------------------

	//高压
	showHPressurePicker.addEventListener('tap', function(event) {
		mIntPicker.setData(CreatIntegerData(40, 200));
		var hPressureValue = hPressureResult.innerHTML;
		if(hPressureValue != "未设置") {
			setIntPickersbyRange(hPressureValue, mIntPicker);
		}
		mIntPicker.show(function(items) {
			//			hPressureResult.innerHTML = getIntRange(items);
			hPressureResult.className = 'selected';
			if(validateModifyParamters(getIntRange(items))) {
				var modifyParameters = creatModifyParameters(HIGH_PRESSURE_TYPE, getIntRange(items));
			}
			modifyNormalValue(modifyParameters);
		});
	}, false);
	//-----------------------------------------

	//低压
	showLPressurePicker.addEventListener('tap', function(event) {
		mIntPicker.setData(CreatIntegerData(40, 200));
		var lPressureValue = lPressureResult.innerHTML;
		if(lPressureValue != "未设置") {
			setIntPickersbyRange(lPressureValue, mIntPicker);
		}
		mIntPicker.show(function(items) {
			//			lPressureResult.innerHTML = getIntRange(items);
			lPressureResult.className = 'selected';
			if(validateModifyParamters(getIntRange(items))) {
				var modifyParameters = creatModifyParameters(LOW_PRESSURE_TYPE, getIntRange(items));
			}
			modifyNormalValue(modifyParameters);
		});
	}, false);
	//-----------------------------------------

	//脉搏
	showPulsePicker.addEventListener('tap', function(event) {
		mIntPicker.setData(CreatIntegerData(40, 200));
		var pulseValue = pulseResult.innerHTML;
		if(pulseValue != "未设置") {
			setIntPickersbyRange(pulseValue, mIntPicker);
		}
		mIntPicker.show(function(items) {
			//			pulseResult.innerHTML = getIntRange(items);
			pulseResult.className = 'selected';
			if(validateModifyParamters(getIntRange(items))) {
				var modifyParameters = creatModifyParameters(PULSE_TYPE, getIntRange(items));
			}
			modifyNormalValue(modifyParameters);
		});
	}, false);
	//-----------------------------------------

	//空腹血糖
	limosisSugarPicker.addEventListener('tap', function(event) {
		mDecPicker.setData(CreatDecData(1, 12, 0, 9));
		var sugarValue = limosisSugarResult.innerHTML;
		if(sugarValue != "未设置") {
			setDecPickersbyRange(sugarValue, mDecPicker);
		}
		mDecPicker.show(function(items) {
			//			sugarResult.innerHTML = getDecRange(items);
			limosisSugarResult.className = 'selected';
			if(validateModifyParamters(getDecRange(items))) {
				var modifyParameters = creatModifyParameters(LIMOSIS_SUGAR_TYPE, getDecRange(items));
			}
			modifyNormalValue(modifyParameters);
		});
	}, false);
	//-----------------------------------------

	//餐前血糖
	beaforeMealSugarPicker.addEventListener('tap', function(event) {
		mDecPicker.setData(CreatDecData(1, 12, 0, 9));
		var sugarValue = beaforeMealSugarResult.innerHTML;
		if(sugarValue != "未设置") {
			setDecPickersbyRange(sugarValue, mDecPicker);
		}
		mDecPicker.show(function(items) {
			//			sugarResult.innerHTML = getDecRange(items);
			beaforeMealSugarResult.className = 'selected';
			if(validateModifyParamters(getDecRange(items))) {
				var modifyParameters = creatModifyParameters(BEGORRE_SUGAR_TYPE, getDecRange(items));
			}
			modifyNormalValue(modifyParameters);
		});
	}, false);
	//-----------------------------------------

	//餐后血糖
	afterMealSugarPicker.addEventListener('tap', function(event) {
		mDecPicker.setData(CreatDecData(1, 12, 0, 9));
		var sugarValue = afterMealSugarResult.innerHTML;
		if(sugarValue != "未设置") {
			setDecPickersbyRange(sugarValue, mDecPicker);
		}
		mDecPicker.show(function(items) {
			//			sugarResult.innerHTML = getDecRange(items);
			afterMealSugarResult.className = 'selected';
			if(validateModifyParamters(getDecRange(items))) {
				var modifyParameters = creatModifyParameters(AFTER_SUGAR_TYPE, getDecRange(items));
			}
			modifyNormalValue(modifyParameters);
		});
	}, false);
	//-----------------------------------------

	//体温
	showTemperaturePicker.addEventListener('tap', function(event) {
		mDecPicker.setData(CreatDecData(30, 44, 0, 9));
		var temperatureValue = temperatureResult.innerHTML;
		if(temperatureValue != "未设置") {
			setDecPickersbyRange(temperatureValue, mDecPicker);
		}
		mDecPicker.show(function(items) {
			//			temperatureResult.innerHTML = getDecRange(items);
			temperatureResult.className = 'selected';
			if(validateModifyParamters(getDecRange(items))) {
				var modifyParameters = creatModifyParameters(TEMPERATURE_TYPE, getDecRange(items));
			}
			modifyNormalValue(modifyParameters);
		});
	}, false);
	//-----------------------------------------

	//血氧
	showOxygenPicker.addEventListener('tap', function(event) {
		var oxygenValue = oxygenResult.innerHTML;
		if(oxygenValue != "未设置") {
			mIntPicker.setData(CreatIntegerData(80, 100));
			setIntPickersbyRange(oxygenValue, mIntPicker);
		}
		mIntPicker.show(function(items) {
			//			oxygenResult.innerHTML = getIntRange(items);
			oxygenResult.className = 'selected';
			if(validateModifyParamters(getIntRange(items))) {
				var modifyParameters = creatModifyParameters(OXYGEN_TYPE, getIntRange(items));
			}
			modifyNormalValue(modifyParameters);
		});
	}, false);
	//-----------------------------------------
}

/**
 * 获取小数设置的范围值
 * @param {Object} items pick的item
 */
function getDecRange(items) {
	return items[0].text + items[1].text + items[2].text + items[3].text + items[4].text;
}
/**
 * 获取整数设置的范围值
 * @param {Object} items
 */
function getIntRange(items) {
	return items[0].text + items[1].text + items[2].text;
}

/**
 * 根据浮点型范围设置picker
 * @param {Object} range
 * @param {Object} picker
 */
function setDecPickersbyRange(range, picker) {
	var floats = range.split("-");
	var lowFloat = floats[0];
	var highFloat = floats[1];
	var lows = lowFloat.split(".");
	var lowInt = lows[0];
	var lowDec = lows[1];
	var highs = highFloat.split(".");
	var highInt = highs[0];
	var highDec = highs[1];

	setTimeout(function() { //做一些延时调用，以便于所有的pickers项都能正常加载
		picker.pickers[0].setSelectedValue(lowInt, PICKER_ROLL_TIME, function() {});
		picker.pickers[1].setSelectedValue(lowDec, PICKER_ROLL_TIME, function() {});
		picker.pickers[3].setSelectedValue(highInt, PICKER_ROLL_TIME, function() {});
		picker.pickers[4].setSelectedValue(highDec, PICKER_ROLL_TIME, function() {});
	}, 200);
}
/**
 * 根据整型范围设置picker
 * @param {Object} range
 * @param {Object} picker
 */
function setIntPickersbyRange(range, picker) {
	var intValue = range.split("-");
	var lowInt = intValue[0];
	var highInt = intValue[1];

	setTimeout(function() { //做一些延时调用，以便于所有的pickers项都能正常加载
		picker.pickers[0].setSelectedValue(lowInt, PICKER_ROLL_TIME, function() {});
		picker.pickers[2].setSelectedValue(highInt, PICKER_ROLL_TIME, function() {});
	}, 200);
}

/**
 * 根据类型获得对应设置数据
 */
function getSettingByType() {

	for(var i = 0; i < normalSettings.length; i++) {
		var type = normalSettings[i].type;
		switch(type) {
			case PULSE_TYPE:
				pulseSet = normalSettings[i];
				break;
			case OXYGEN_TYPE:
				oxygenSet = normalSettings[i];
				break;
			case LIMOSIS_SUGAR_TYPE:
				limosisSugarSet = normalSettings[i];
				break;
			case BEGORRE_SUGAR_TYPE:
				beaforeMealSugarSet = normalSettings[i];
				break;
			case AFTER_SUGAR_TYPE:
				afterMealSugarSet = normalSettings[i];
				break;
			case HIGH_PRESSURE_TYPE:
				highPressureSet = normalSettings[i];
				break;
			case LOW_PRESSURE_TYPE:
				lowPressureSet = normalSettings[i];
				break;
			case WEIGHT_TYPE:
				if(weightRangeFrom == 1) {
					weightSet = normalSettings[i];
				} else {
					if(userHeight) {
						weightSet = getWeightRange();
					} else {
						weightSet = weightDefaultRange;
					}
					if(resetParameters.normalValue.length == 8){
						resetParameters.normalValue.push(weightSet)
					}
				}
				break;
			case TEMPERATURE_TYPE:
				temperatureSet = normalSettings[i];
				break;
			default:
				break;
		}
	}
}

function setWeightReset(weightSet){
	var length = resetParameters.normalValue.length;
	var flag = 0
	for(var i = 0;i<length;i++){
		if(resetParameters.normalValue[i].type == 5){
			flag = 1;
			resetParameters.normalValue[i] = weightSet;
			break;
		}
	}
	if(flag == 0){
		resetParameters.normalValue.push(weightSet)
	}
}

/**
 * 生成整数的picker数据
 * @param {Object} maxInt
 * @param {Object} minInt
 */
function CreatIntegerData(minInt, maxInt) {
	var datas = [];
	var firstChildren = [{
		value: "0",
		text: "-"
	}];
	var secondchildren = []
	for(var i = 0; i < maxInt - minInt + 1; i++) {
		var data = {};
		data.value = (minInt + i);
		data.text = (minInt + i);
		secondchildren.push(data);
	}
	firstChildren[0]["children"] = secondchildren;

	for(var j = 0; j < maxInt - minInt + 1; j++) {
		var data = {};
		data.value = minInt + j;
		data.text = minInt + j;
		data.children = firstChildren;
		datas.push(data);
	}

	return datas;
}
/**
 * 生成有小数的picker数据
 * @param {Object} minInt
 * @param {Object} maxInt
 * @param {Object} minDec
 * @param {Object} maxDec
 */
function CreatDecData(minInt, maxInt, minDec, maxDec) {
	var datas = [];
	var firstChlidren = [];
	var secondChlidren = [{
		value: "0",
		text: "-"
	}];
	var thirdChlidren = [];
	var fourChlidren = [];

	for(var i = 0; i < maxDec - minDec + 1; i++) {
		var data = {};
		data.value = (minDec + i);
		data.text = "." + (minDec + i);
		fourChlidren.push(data);
	}

	for(var i = 0; i < maxInt - minInt + 1; i++) {
		var data = {};
		data.value = (minInt + i);
		data.text = (minInt + i);
		data.children = fourChlidren;
		thirdChlidren.push(data);
	}
	secondChlidren[0]["children"] = thirdChlidren;

	for(var i = 0; i < maxDec - minDec + 1; i++) {
		var data = {};
		data.value = (minDec + i);
		data.text = "." + (minDec + i);
		data.children = secondChlidren;
		firstChlidren.push(data);
	}

	for(var i = 0; i < maxInt - minInt + 1; i++) {
		var data = {};
		data.value = (minInt + i);
		data.text = (minInt + i);
		data.children = firstChlidren;
		datas.push(data);
	}

	return datas;
}

function getNormalSetting() {
	g_tools.postCMD("getSettings", {}, function(result) {
		if(result.code == 0) {
			normalSettings = result.data.normalValue;
			if(!g_utils.isEmpty(result.data.weightRangeFrom)){
				weightRangeFrom = result.data.weightRangeFrom;
			}		
			refreshNormalSetData();
		}
	});
}

function refreshNormalSetData() {
	getSettingByType();
	if(!g_utils.isEmpty(weightSet)) {
		weightResult.innerHTML = weightSet.minValue + "-" + weightSet.maxValue;
		weightResult.className = 'selected';
	}
	if(!g_utils.isEmpty(highPressureSet)) {
		hPressureResult.innerHTML = highPressureSet.minValue + "-" + highPressureSet.maxValue;
		hPressureResult.className = 'selected';
	}
	if(!g_utils.isEmpty(lowPressureSet)) {
		lPressureResult.innerHTML = lowPressureSet.minValue + "-" + lowPressureSet.maxValue;
		lPressureResult.className = 'selected';
	}
	if(!g_utils.isEmpty(pulseSet)) {
		pulseResult.innerHTML = pulseSet.minValue + "-" + pulseSet.maxValue;
		pulseResult.className = 'selected';
	}
	if(!g_utils.isEmpty(limosisSugarSet)) {
		limosisSugarResult.innerHTML = limosisSugarSet.minValue.toFixed(1) + "-" + limosisSugarSet.maxValue.toFixed(1);
		limosisSugarResult.className = 'selected';
	}
	if(!g_utils.isEmpty(beaforeMealSugarSet)) {
		beaforeMealSugarResult.innerHTML = beaforeMealSugarSet.minValue.toFixed(1) + "-" + beaforeMealSugarSet.maxValue.toFixed(1);
		beaforeMealSugarResult.className = 'selected';
	}
	if(!g_utils.isEmpty(afterMealSugarSet)) {
		afterMealSugarResult.innerHTML = afterMealSugarSet.minValue.toFixed(1) + "-" + afterMealSugarSet.maxValue.toFixed(1);
		afterMealSugarResult.className = 'selected';
	}
	if(!g_utils.isEmpty(temperatureSet)) {
		temperatureResult.innerHTML = temperatureSet.minValue.toFixed(1) + "-" + temperatureSet.maxValue.toFixed(1);
		temperatureResult.className = 'selected';
	}

	if(!g_utils.isEmpty(oxygenSet)) {
		oxygenResult.innerHTML = oxygenSet.minValue + "-" + oxygenSet.maxValue;
		oxygenResult.className = 'selected';
	}
}
/**
 * 修改正常值范围
 * @param {Object} Json数组 parameters
 */
function modifyNormalValue(parameters) {
	g_tools.postCMD("modifyNormalValue", parameters, function(result) {
		if(result.code == 0) {
			getNormalSetting();
		}
	});
}
/**
 * 修改正常值范围参数
 * @param {Object} type
 * @param {Object} rangeValue
 */
function creatModifyParameters(type, rangeValue) {
	var arr = [],
		obj = {},
		parameters = {},
		ranges;
	ranges = rangeValue.split("-");
	obj["type"] = type;
	obj["minValue"] = ranges[0];
	obj["maxValue"] = ranges[1];
	arr.push(obj);
	addParameter("normalValue", arr, parameters);
	return parameters;
}

/**
 * 验证正常值范围参数
 * @param {Object} type
 * @param {Object} rangeValue
 */
function validateModifyParamters(rangeValue) {
	var ranges;
	ranges = rangeValue.split("-");
	var min = parseFloat(ranges[0]);
	var max = parseFloat(ranges[1]);
	if(max <= min) {
		g_mui.alert('设置的最小值不能超过最大值');
		return false;
	} else {
		return true;
	}
	return true;
}
/*
 * 插入请求参数
 */
function addParameter(key, value, parameters) {
	parameters[key] = value;
}