var currentPage = 0;
var PAGE_SIZE = 5;

//图片网络地址url
var SERVER_IMG_ADDRESS = g_tools.IP_FILE;
var DEFAULT_HEAD_IMG = '../../global/img/default_head.png';

var reportLay = document.getElementById('reportLay');
var nullPage = document.getElementById("nullPage");
var refreshContainer = document.getElementById("refreshContainer");

//mui初始化
mui.init({
	pullRefresh: {
		container: '#refreshContainer',
		down: {
			//下拉成功回调函数
			callback: pullfreshDown
		},
		up: {
			//上拉成功回调函数
			contentrefresh: '正在加载...',
			callback: pullfreshUp
		}
	}
});

mui.plusReady(function() {
	//隐藏掉滚动条
	plus.webview.currentWebview().setStyle({
		scrollIndicator: 'none'
	});

	//用于刷新健康报告列表，后面功能调用触发
	document.addEventListener('reportListRefresh', function(e) {
		getDownRefreshReportList();
	}, false);

	initReportList();
	initPreview();
});

function initPreview() {
	mui.initPhotoSwiper({},function(e){
		
	});
}

function initReportList() {
	g_tools.postCMD('getInspectionReportListByUserId', {
		currentPage: currentPage,
		pageSize: PAGE_SIZE
	}, function(data) {
		if(data.code == 0) {
			var reportList = data.data;
			initRefreshReportList(reportList);
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE, { //！！！！！！！！！重点代码！！！！！！！！！
		disableWait: true, //禁止显示wait框
		noNetworkMode: g_tools.TIP_MODE_TOAST //！！！！！！！！！重点代码！！！！！！！！！
	});
}

function initRefreshReportList(reportList) {
	if(reportList && reportList.length != 0) {
		plus.webview.currentWebview().setStyle({ //取消蒙板
			mask: 'none'
		});
		nullPage.classList.add('mui-hidden');
		reportLay.classList.remove('mui-hidden');
		downRefresh(reportList);
	} else {
		nullPage.classList.remove('mui-hidden');
		reportLay.classList.add('mui-hidden');
		plus.webview.currentWebview().setStyle({ //添加蒙板
			mask: 'rgba(0,0,0,0)'
		});
	}
}

function pullfreshDown() {
	setTimeout(function() {
		getDownRefreshReportList();
	}, 500);
}

function pullfreshUp() {
	setTimeout(function() {
		getUpRefreshReportList();
	}, 500);
}

function getDownRefreshReportList() {
	currentPage = 0;
	g_tools.postCMD('getInspectionReportListByUserId', {
		currentPage: currentPage,
		pageSize: PAGE_SIZE
	}, function(data) {
		if(data.code == 0) {
			var reportList = data.data;
			if(reportList && reportList.length != 0) { //不为空
				initRefreshReportList(reportList);
			} else {
				nullPage.classList.remove('mui-hidden');
				reportLay.classList.add('mui-hidden');
				plus.webview.currentWebview().setStyle({ //添加蒙板
					mask: 'rgba(0,0,0,0)'
				});
			}
			//结束下拉刷新
			mui('#refreshContainer').pullRefresh().endPulldownToRefresh();
			//重置上拉加载
			mui('#refreshContainer').pullRefresh().refresh(true);
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE, {
		disableWait: true, //禁止显示wait框
		noNetworkMode: g_tools.TIP_MODE_TOAST //！！！！！！！！！重点代码！！！！！！！！！
	});
}

function getUpRefreshReportList() {
	currentPage++; //页面增1
	g_tools.postCMD('getInspectionReportListByUserId', {
		currentPage: currentPage,
		pageSize: PAGE_SIZE
	}, function(data) {
		if(data.code == 0) {
			var reportList = data.data;
			if(reportList && reportList.length != 0) { //不为空
				upRefresh(reportList);
				mui('#refreshContainer').pullRefresh().endPullupToRefresh(false);
			} else {
				mui('#refreshContainer').pullRefresh().endPullupToRefresh(true); //参数为true代表没有更多数据了。
			}
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE, {
		disableWait: true, //禁止显示wait框
		noNetworkMode: g_tools.TIP_MODE_TOAST //！！！！！！！！！重点代码！！！！！！！！！
	});
}

function downRefresh(reportList) {
	reportLay.innerHTML = "";
	for(var i = 0, len = reportList.length; i < len; i++) {
		var report = reportList[i];
		refreshOneReport(report, i + 1);
	}
}

function upRefresh(reportList) {
	for(var i = 0, len = reportList.length; i < len; i++) {
		var report = reportList[i];
		refreshOneReport(report, i + 1 + currentPage * 3);
	}
}

function refreshOneReport(report, imgsGroupNum) {
	var reportDiv = getReportDiv(report, imgsGroupNum);

	reportLay.appendChild(reportDiv);
}

function getReportDiv(report, imgsGroupNum) {
	var reportTitle = "";
	var reportContent = "";
	var reportImgsHtml = "";
	var reportCreatDate = "";
	if(!g_utils.isEmpty(report.title)) {
		var reportTitle = report.title;;
	}
	if(!g_utils.isEmpty(report.content)) {
		reportContent = report.content;;
	}
	if(!g_utils.isEmptyArray(report.reportImgs)) {
		var _reportImgs = report.reportImgs;
		reportImgsHtml = getReportImgsHtml(_reportImgs, imgsGroupNum);
	}
	if(!g_utils.isEmpty(report.createTime)) {
		reportCreatDate = g_printTools.printDateAndTimeStrByTimeMillis(report.createTime);
	}

	var reportDiv = document.createElement('div');
	reportDiv.className = "report-item";

	var reportTitleDiv = document.createElement('div');
	reportTitleDiv.className = "report-title";
	reportTitleDiv.innerText = reportTitle;

	var reportContentDiv = document.createElement('div');
	reportContentDiv.className = "report-content";
	reportContentDiv.innerText = reportContent;

	var reportImgsDiv = document.createElement('div');
	reportImgsDiv.className = "report-imgs";
	reportImgsDiv.innerHTML = reportImgsHtml;

	var reportTimeDiv = document.createElement('div');
	reportTimeDiv.className = "report-time";

	var reportTimeSpan = document.createElement('span');
	reportTimeSpan.className = "report-date";
	reportTimeSpan.innerText = reportCreatDate;

	var deleteImg = document.createElement('img');
	deleteImg.className = "delete-Report-icon";
	deleteImg.id = report.id;
	deleteImg.src = "img/del_icon.png";

	deleteImg.addEventListener('tap', function() {
		var reportId = this.id;
		//删除操作
		g_mui.confirm('要删除这条报告吗？', '温馨提示', ['取消', '确定'], function(e) {
			if(e.index == 1) {
				//删除一条报告
				g_tools.postCMD("delInspectionReport", {
					reportId: reportId,
				}, function(result) {
					if(result.code == 0) {
						getDownRefreshReportList();
					}
				})
				//删除报告时，刷新健康信息流
				mui.fire(plus.webview.getWebviewById(g_module.health.ID + ':healthSubList.html'), 'healthSubListRefresh');
			}
		});
	}, false)

	reportDiv.appendChild(reportTitleDiv);
	reportDiv.appendChild(reportContentDiv);
	reportDiv.appendChild(reportImgsDiv);
	reportDiv.appendChild(reportTimeDiv);
	reportDiv.appendChild(reportTimeSpan);
	reportDiv.appendChild(deleteImg);
	//	console.log(reportDiv.innerHTML);

	return reportDiv;
}

function getReportImgsHtml(reportImgs, imgsGroupNum) {
	var reportImgsHtml = "";
	for(var i = 0, len = reportImgs.length; i < len; i++) {
		var reportImg = reportImgs[i];
		var reportImgUrl = getImgUrl(reportImg) + "&tb=1" + "&app=1";
		var previesSrcUrl = getImgUrl(reportImg) + "&app=1";
		reportImgsHtml += '<img class="reportImg" src="../../global/img/loading.svg"' +
			' data-src="' + reportImgUrl + '"' +
			' onload="load(this)"' +
			' data-preview-src="' + previesSrcUrl + '"' +
			' data-preview-group="' + imgsGroupNum + '"' + '/>';
	}
	return reportImgsHtml;
}

function getImgUrl(img) {
	var imgUrl = DEFAULT_HEAD_IMG;
	if(!g_utils.isEmpty(img)) {
		imgUrl = SERVER_IMG_ADDRESS + img;
	}
	return imgUrl;
}