var PAGE_STEP = 20; //刷新步长
var PAGE_READY = false;
var tabelList = document.querySelector(".mui-table-view");
var moneyCheckList, nowPage = 0;
mui.plusReady(function() {
	getMoneyCheckList(0, g_tools.MODE_WEB_LOCAL_CACHE, {
		noNetworkMode: g_tools.TIP_MODE_INTERFACE,
		contentDomId: 'mainContent',
		tipDomId: 'noNetworkTip'
	});
});
//获取健康币明细
function getMoneyCheckList(currentPage, mode, timeOutHanding) {
	g_tools.postCMD('reward/getMoneyCheckList', {
		currentPage: currentPage,
		pageSize: PAGE_STEP
	}, function(res) {
		if(res.code == 0) {
			var data = res.data;
			if(!PAGE_READY) {
				moneyCheckList = data;
				init();
				PAGE_READY = true;
			} else {
				setTimeout(function() {
					if(currentPage == 0) {
						moneyCheckList = data;
						resetList();
						//结束下拉刷新
						mui('#pullrefresh').pullRefresh().endPulldownToRefresh();
						//重置上拉加载
						mui('#pullrefresh').pullRefresh().refresh(true);
					} else {
						//上拉加载
						addList(data);
					}
				}, 100);
			}
		}
	}, mode, timeOutHanding);
}
//初始化下拉刷新
function init(data) {
	mui.init({
		pullRefresh: {
			container: '#pullrefresh',
			down: {
				//下拉成功回调函数
				callback: pullDownRefresh
			},
			up: {
				//上拉成功回调函数
				contentrefresh: '正在加载...',
				contentnomore: '没有更多数据了',
				callback: pullUpRefresh
			}
		}
	});
	resetList();
}
//重置表单
function resetList() {
	while(tabelList.hasChildNodes()) {
		tabelList.removeChild(tabelList.firstChild);
	}
	//检查是否没有记录
	if(!g_utils.isEmptyArray(moneyCheckList)) {
		mui.each(moneyCheckList, function(index, item) {
			appendListItem(index, item);
		});
	} else {
		//显示空值界面
	}
}
//添加表单
function addList(data) {
	//没有更多数据
	if(!g_utils.isEmptyArray(data)) {
		var start = moneyCheckList.length;
		var dataLength = data.length;
		for(var i = 0; i < dataLength; i++) {
			moneyCheckList.push(data[i]);
			appendListItem(start + i, data[i]);
		}
	}
	mui('#pullrefresh').pullRefresh().endPullupToRefresh(data.length != PAGE_STEP);
}
//下拉刷新
function pullDownRefresh() {
	nowPage = 0;
	getMoneyCheckList(0, g_tools.MODE_WEB_LOCAL_CACHE, {
		disableWait: true
	});
}
//上拉加载
function pullUpRefresh() {
	nowPage++;
	getMoneyCheckList(nowPage, g_tools.MODE_WEB_LOCAL_CACHE, {
		disableWait: true
	});
}
//添加列表子项
function appendListItem(index, item) {
	var li = document.createElement("li");
	var itemRemark = item.remark;
	var itemTitle = item.title;
	var itemCreateTime = item.createTime;
	var itemMoney = item.money;
	var itemType = item.type;
	var itemNumber = item.number;
	var color, str;
	li.className = "mui-table-view-cell";
	li.setAttribute("index", index);
	itemTitle = "【" + itemTitle + "】";
	itemCreateTime = g_utils.dateFormat(itemCreateTime, "yyyy-MM-dd HH:mm");
	if(itemType == 0) {
		itemMoney = "+" + itemMoney;
		color = "money-earning";
	} else if(itemType == 1) {
		itemMoney = "-" + itemMoney;
		color = "money-expense";
	}
	str = '<div class="box">' +
		'<div class="font-style-one">' + itemRemark + '</div>' +
		'<div class="font-style-two style-one">' + itemTitle + '</div>' +
		'<div class="font-style-two">' + itemCreateTime + '</div>' +
		'</div><div class="num ' + color + '">' + itemMoney + '</div>'
	li.innerHTML = str;
	tabelList.appendChild(li);
	addTapEvent(li);
}
//添加点击事件
function addTapEvent(dom) {
	dom.addEventListener('tap', function() {
		var index = this.getAttribute("index");
		g_mui.openPage(g_module.healthReward, 'billDetail.html', {
			data: moneyCheckList[index]
		});
	});
}