var _showAreaDom = document.getElementById('showArea');
var _showAreaSecDom = document.getElementById('showAreaSec');
var _rankingListDom = document.getElementById('rankingList');
var _healthListDom = document.getElementById('healthList');
var _fashionListDom = document.getElementById('fashionList');
var _dayGetListDom = document.getElementById('dayGetList');
var _dayUseListDom = document.getElementById('dayUseList');

var _countDownHourDom = document.getElementById('countDownHour');
var _countDownMinDom = document.getElementById('countDownMin');
var _countDownSecDom = document.getElementById('countDownSec');
var _countDownTitleDom = document.getElementById('countDownTitle');

var _selectFlagOffsetLeft = 0.23; //单位rem

var _isNo1 = false;

var _calendar, _self;

var _nickname = '';
var _headImg = '';
var _todayDate = '';
var _scoreRankDate = '';

var _secondTableSelect = 0;

//图片网络地址url
var SERVER_IMG_ADDRESS = g_tools.IP_FILE;

//mui初始化
mui.init();
mui.plusReady(function() {

	var nowDate = new Date();
	_todayDate = g_utils.dateFormat(nowDate, 'yyyy-MM-dd');
	_scoreRankDate = g_utils.dateFormat(nowDate, 'yyyy-MM-dd');

	//隐藏下面的榜单
	_showAreaDom.style.display = 'none';
	_showAreaSecDom.style.display = 'none';
	var topSelectDom = document.getElementById('selectTop');
	topSelectDom.style.display = 'none';
				
	//获取传入参数
	getParam();

	//初始化动画效果
	initAnimation();

	//初始化时间选择插件
	initCalendar();

	//tab页点击初始化
	initAllTap();

	//获取数据
	getData();

});

/**
 * 获得上个页面传入的参数
 */
function getParam() {
	_self = plus.webview.currentWebview();
	if(!g_utils.isEmpty(_self)) {
		if(!g_utils.isEmpty(_self.nickname)) {
			_nickname = _self.nickname;
		}
		if(!g_utils.isEmpty(_self.headImg)) {
			_headImg = _self.headImg;
			updateMyHeadImg(SERVER_IMG_ADDRESS + _headImg + "&tb=1");
		}
	}
}

function updateMyHeadImg(imgUrl) {
	var domList = document.querySelectorAll('.my-head-img');
	for(var i = 0; i < domList.length; i++) {
		domList[i].setAttribute('data-src', imgUrl);
		domList[i].onload();
	}
}

function initDomWithAndHeight() {
	//初始化积分列表显示区域高度
	setShowAreaHeight();

	//初始化第二块列表显示区域高度
	setShowAreaSecHeight(_secondTableSelect);
	initSelectTabviewSecWith();
	initSelectTabviewSecOffset();
}

function initAllTap() {
	initPageTransitionTap(); //页面跳转
	initSelectTabviewSecTap(); //tab的点击事件
	initScoreRankDateSelect();
}

function initAnimation() {
	var selectFlagSecDom = document.getElementById('selectFlagSec');
	selectFlagSecDom.classList.add('move-animation');
	var selectAreaSecDom = document.getElementById('selectAreaSec');
	selectAreaSecDom.classList.add('move-animation');
}
//-------------------------获取数据相关方法-------------------------
function getData() {
	getMyMoney();
	getDailyLuckyStarDrawTime();
	checkRuleAviable();
}

function getMyMoney() {
	g_tools.postCMD('reward/getMyMoney', {}, function(data) {
		if(data.code == 0) {
			if(g_utils.isEmpty(data.data.currentMoney)) {
				setMycurrentMoney(0);
			} else {
				setMycurrentMoney(data.data.currentMoney);
			}
		}
	});
}

/*
 * 获取每日伙伙幸运之星揭晓时间
 */
function getDailyLuckyStarDrawTime() {
	g_tools.postCMD('reward/getDailyLuckyStarDrawTime', {},
		function(data) {
			if(data.code == 0) {
				if(!g_utils.isEmpty(data.data.drawTimeStr)) {
					var nowDate = new Date();
					var timeStr = g_utils.dateFormat(nowDate, 'yyyy-MM-dd');
					var intervalTime = g_utils.stringToDate(timeStr + ' ' + data.data.drawTimeStr + ':00') - nowDate.getTime();
					if(intervalTime > 0) { //未到开奖时间
						startCountDown(intervalTime / 1000);
					} else { //已到开奖时间，请求开奖结果
						getDailyLuckyStar();
					}
				}
			}
		});
}

/*
 * 获取每日伙伙幸运之星
 */
function getDailyLuckyStar() {
	g_tools.postCMD('reward/getDailyLuckyStar', {
		'date': _todayDate
	}, function(data) {
		if(data.code == 0 && !g_utils.isEmpty(data.data.createTime) && data.data.createTime != 0) {
			var nickname = data.data.nickname;
			var headImg = data.data.headImg;

			var money = 0;
			if(!g_utils.isEmpty(data.data.money)) {
				money = data.data.money;
			}
			showLuckyStar(nickname, headImg, money);
			return;
		} else { //未获取到开奖结果
			var nowDate = new Date();
			var timeStr = g_utils.dateFormat(nowDate, 'yyyy-MM-dd');
			var intervalTime = nowDate.getTime() - g_utils.stringToDate(timeStr + ' ' + data.data.drawTimeStr + ':00');
			if(intervalTime >= 60 * 60 * 1000) { //间隔已大于1小时则判断当天没有幸运星
				setLuckyStarNobodyStatus();
				return;
			} else {
				setLuckyStarWaitingStatus();
			}
		}
	});

	var staTimer = setInterval(function() {
		g_tools.postCMD('reward/getDailyLuckyStar', {
				'date': _todayDate
			},
			function(data) {
				//                alert(JSON.stringify(data));
				if(data.code == 0) {
					if(!g_utils.isEmpty(data.data.createTime) && data.data.createTime != 0) {
						var nickname = data.data.nickname;
						var headImg = data.data.headImg;
						var money = 0;
						if(!g_utils.isEmpty(data.data.money)) {
							money = data.data.money;
						}
						showLuckyStar(nickname, headImg, money);
						clearInterval(staTimer);
					} else { //未获取到开奖结果
						var nowDate = new Date();
						var timeStr = g_utils.dateFormat(nowDate, 'yyyy-MM-dd');
						var intervalTime = nowDate.getTime() - g_utils.stringToDate(timeStr + ' ' + data.data.drawTimeStr + ':00');
						if(intervalTime >= 60 * 60 * 1000) { //间隔已大于1小时则判断当天没有幸运星
							setLuckyStarNobodyStatus();
						} else {
							setLuckyStarWaitingStatus();
						}
					}
				}
			});
	}, 10000);
}

/*
 * 判断登录用户所属机构是否已启用某规则
 */
function checkRuleAviable() {
	g_tools.postCMD('reward/checkRuleAvailable', {
		'code': 'I002'
	}, function(data) {
		if(data.code == 0) {
			if(data.data.isAvailable == 1) {
				refreshScoreRank();
				
				_showAreaDom.style.display = '';
                _showAreaSecDom.style.display = '';
                var topSelectDom = document.getElementById('selectTop');
                topSelectDom.style.display = '';
                    
                    //初始化一些布局的宽高度
                    initDomWithAndHeight();
                    //tab栏默认选中第一栏
                    moveFlagSec(0);
                
				//刷新4个榜单
				getStarRankList(0);
				getStarRankList(1);
				getStarRankList(2);
				getStarRankList(3);

			} else {
				refreshScoreRank();

				//隐藏下面的榜单
				_showAreaDom.style.display = 'none';
				_showAreaSecDom.style.display = 'none';
				var topSelectDom = document.getElementById('selectTop');
				topSelectDom.style.display = 'none';
				
//				getStarRankList(0);
//				getStarRankList(1);
//				getStarRankList(2);
//				getStarRankList(3);
			}
		}
	});
}

function refreshScoreRank() {
	var scoreRankDateDom = document.getElementById('scoreRankDate');
	scoreRankDateDom.innerHTML = '&nbsp;' + _scoreRankDate;

	getMyScoreRank();
	getScoreRankList();

}
/*
 * 获取登录用户当日的积分榜数据并刷新页面对应部分
 */
function getMyScoreRank() {
	g_tools.postCMD('reward/getMyScoreRank', {
		'date': _scoreRankDate
	}, function(data) {
		if(data.code == 0) {
			setMyInfoInRankingList(data.data.no, data.data.upScore, data.data.healthScore, data.data.sportScore, data.data.careScore);
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE);
}
///*
// * 获取获取我的其他榜数据
// * type = 0 健康达人榜
// *      = 1 时尚达人榜
// *      = 2 单日最多获得榜
// *      = 3 单日最多使用榜
// */
//function getMyStarRank(type) {
//    g_tools.postCMD('reward/getMyStarRank', {
//        'type': type
//    }, function(data) {
////        alert(JSON.stringify(data));
//        if(data.code == 0) {
//            var money = 0;
//            if(!g_utils.isEmpty(data.data.money)) {
//                money = data.data.money;
//            }
//            var no = 0;
//            if(!g_utils.isEmpty(data.data.no)) {
//                money = data.data.no;
//            }
//            setMyInfoInOtherListForType(type, money, no);
//        }
//    }, g_tools.MODE_WEB_LOCAL_CACHE);
//}

/*
 * 获取积分榜数据并刷新页面对应部分
 */
function getScoreRankList() {
	g_tools.postCMD('reward/getScoreRankList', {
		'date': _scoreRankDate,
		'currentPage': 0,
		'pageSize': 5
	}, function(data) {
		if(data.code == 0) {
			//去掉原有的cell
			var rankingListOtherDom = document.getElementById('rankingListOther');

			while(rankingListOther.hasChildNodes()) //当rankingListDom只剩下显示本人的cell，则跳出循环
			{
				rankingListOther.removeChild(rankingListOther.firstChild);
			}

			//添加新的cell
			if(!g_utils.isEmpty(data.data)) {
				for(var i = 0; i < data.data.length; i++) {
					var item = data.data[i];
					var isLastCell = false;
					if(i == data.data.length - 1) {
						isLastCell = true;
					}
					var cellDom = createRankingListCell(item.headImg, item.nickname, item.sportScore, item.careScore, item.healthScore, isLastCell, i);
					rankingListOther.appendChild(cellDom);

					setShowAreaHeight();
				}
			}

		}
	}, g_tools.MODE_WEB_LOCAL_CACHE);
}

/*
 * 获取其他榜数据并刷新页面对应部分
 * type = 0 健康达人榜
 *      = 1 时尚达人榜
 *      = 2 单日最多获得榜
 *      = 3 单日最多使用榜
 */
function getStarRankList(type) {
	g_tools.postCMD('reward/getStarRankList', {
		'type': type,
		'currentPage': 0,
		'pageSize': 5
	}, function(data) {
		//alert(JSON.stringify(data));
		if(data.code == 0) {

			var otherListDom;

			if(type == 0) {
				otherListDom = _healthListDom;
			} else if(type == 1) {
				otherListDom = _fashionListDom;
			} else if(type == 2) {
				otherListDom = _dayGetListDom;
			} else if(type == 3) {
				otherListDom = _dayUseListDom;
			}

			//去掉原有的cell
			if(!g_utils.isEmpty(otherListDom)) {
				while(otherListDom.hasChildNodes()) //当rankingListDom只剩下显示本人的cell，则跳出循环
				{
					otherListDom.removeChild(otherListDom.firstChild);
				}
			}

			//添加新的cell
			if(!g_utils.isEmpty(data.data)) {
				for(var i = 0; i < data.data.length; i++) {
					var item = data.data[i];
					var isLastCell = false;
					if(i == data.data.length - 1) {
						isLastCell = true;
					}
					var cellDom;
					cellDom = createOtherListCell(type, item.headImg, item.nickname, item.money, isLastCell, i);
					otherListDom.appendChild(cellDom);

					if(_secondTableSelect == type) { //如果当前选择的对应榜单，则重新设置显示区域高度
						setShowAreaSecHeight(_secondTableSelect);
					}
				}
			}

		}
	}, g_tools.MODE_WEB_LOCAL_CACHE);
}

//-------------------------初始化界面元素大小相关方法---------------------------
/*
 * 初始化列表的宽度
 */
function initSelectTabviewSecWith() {
	var domList = document.querySelectorAll('.fr-tabview-sec');
	for(var i = 0; i < domList.length; i++) {
		domList[i].style.width = domList[i].parentNode.offsetWidth / 4 + 'px';
	}
}

/*
 * 初始化列表的位置
 */
function initSelectTabviewSecOffset() {
	_healthListDom.style.left = 0;
	_fashionListDom.style.left = (_fashionListDom.parentNode.offsetWidth / 4) * 1 + 'px';
	_dayGetListDom.style.left = (_dayGetListDom.parentNode.offsetWidth / 4) * 2 + 'px';
	_dayUseListDom.style.left = (_dayUseListDom.parentNode.offsetWidth / 4) * 3 + 'px';
}

/*
 * 根据积分列表高度
 */
function setShowAreaHeight() {
	var num = 0;
	var domList = document.getElementById('rankingListOther').childNodes;
	for(var i = 0; i < domList.length; i++) {
		if(domList[i].classList && domList[i].classList.contains('fr-tabview-cell')) {
			num++;
		}
	}
	_showAreaDom.style.height = num * 0.84 + 2.81 + 0.1 + 'rem';
}

function setShowAreaSecHeight(select) {

	var num = 0;

	var domList;
	if(select == 0) {
		var domList = _healthListDom.childNodes;
	} else if(select == 1) {
		var domList = _fashionListDom.childNodes;
	} else if(select == 2) {
		var domList = _dayGetListDom.childNodes;
	} else if(select == 3) {
		var domList = _dayUseListDom.childNodes;
	}

	for(var i = 0; i < domList.length; i++) {
		if(domList[i].classList && domList[i].classList.contains('fr-tabview-cell')) {
			num++;
		}
	}
	_showAreaSecDom.style.height = num * 0.84 + 0.1 + 'rem';
}

//-------------------------构造界面相关方法---------------------------
function createRankingListCell(headImg, name, sportNum, careNum, healthNum, isLastCell, index) {
	if(!g_utils.isEmpty(headImg)) {
		headImg = g_tools.IP_FILE + headImg + "&tb=1";
	}

	var cellDom = document.createElement('div');
	cellDom.className = 'fr-tabview-cell other-line';

	var cellInfoDom = document.createElement('div');

	if(isLastCell) {
		cellInfoDom.className = 'other-info';
	} else {
		cellInfoDom.className = 'bottom-line other-info';
	}

	var classStr = '';
	if(index == 0) {
		classStr = 'reward-no1';
		cellInfoDom.classList.add('top-line');
	} else if(index == 1) {
		classStr = 'reward-no2';
	} else if(index == 2) {
		classStr = 'reward-no3';
	}
    
    if (index >= 3){
        cellInfoDom.innerHTML += '<div class="reward-no-icon reward-non">'+(index+1)+'</div>';
    }else{
        cellInfoDom.innerHTML += '<div class="' + classStr + ' reward-no-icon"></div>';
    }
    
//    cellInfoDom.innerHTML += '<div class="' + classStr + ' reward-no-icon"></div>';
	cellInfoDom.innerHTML += '<img src="../../global/img/default_portrait_msg.png" data-src="' + headImg + '" class="other-head-img head-img" onload="load(this)"/>';
	cellInfoDom.innerHTML += '<div class="champion-name-other twoline-top">' + name + '</div>';
	cellInfoDom.innerHTML += '<div class="sport-title other-sport-icon"></div>';
	cellInfoDom.innerHTML += '<div class="care-title other-care-icon"></div>';
	cellInfoDom.innerHTML += '<div class="health-title other-health-icon"></div>';
	cellInfoDom.innerHTML += '<div class="other-num-text other-sport-text">' + sportNum + '</div>';
	cellInfoDom.innerHTML += '<div class="other-num-text other-care-text">' + careNum + '</div>';
	cellInfoDom.innerHTML += '<div class="other-num-text other-health-text">' + healthNum + '</div>';

	cellDom.appendChild(cellInfoDom);

	return cellDom;
}

function createOtherListCell(type, headImg, name, currencyNum, isLastCell, index) {

	if(!g_utils.isEmpty(headImg)) {
		headImg = g_tools.IP_FILE + headImg + "&tb=1";
	}

	var curencyText = '';
	if(type == 0 || type == 1) {
		curencyText = '累计获得健康币';
	} else if(type == 2) {
		curencyText = '单日最多获得';
	} else if(type == 3) {
		curencyText = '单日最多使用';
	}

	var cellDom = document.createElement('div');
	cellDom.className = 'fr-tabview-cell other-line';

	var cellInfoDom = document.createElement('div');
	if(isLastCell) {
		cellInfoDom.className = 'other-info';
	} else {
		cellInfoDom.className = 'bottom-line other-info';
	}
	var classStr = '';
	if(index == 0) {
		classStr = 'reward-no1';
	} else if(index == 1) {
		classStr = 'reward-no2';
	} else if(index == 2) {
		classStr = 'reward-no3';
	}
    
    if (index >= 3){
        cellInfoDom.innerHTML += '<div class="reward-no-icon reward-non">'+(index+1)+'</div>';
    }else{
       cellInfoDom.innerHTML += '<div class="' + classStr + ' reward-no-icon"></div>';
    }
	
	cellInfoDom.innerHTML += '<img src="../../global/img/default_portrait_msg.png" data-src="' + headImg + '" class="other-head-img head-img" onload="load(this)"/>';
	cellInfoDom.innerHTML += '<div class="champion-name-other online-top">' + name + '</div>';
	cellInfoDom.innerHTML += '<div class="health-currency-icon other-health-curency-top">' + currencyNum + '</div>';
	cellInfoDom.innerHTML += '<div class="health-currency-text other-health-curency-text-top">' + curencyText + '</div>';

	cellDom.appendChild(cellInfoDom);

	return cellDom;
}
//-------------------------更新界面数据方法---------------------------
function setMycurrentMoney(currentMoney) {
	var currentMoneyDom = document.getElementById('currentMoney');
	currentMoneyDom.innerHTML = currentMoney;
}

function setMyInfoInRankingList(rankingNum, upScore, healthScore, sportScore, careScore) {
	if(!g_utils.isEmpty(rankingNum)) {

		var rankingListAdviseDom = document.getElementById('rankingListAdvise');
		var rankingListMyDescriptionDom = document.getElementById('rankingListMyDescription');

		rankingListMyDescriptionDom.innerHTML = '当日排行' + rankingNum + '名';
		if(rankingNum == 0) { //未参与排名
			rankingListMyDescriptionDom.innerHTML = '当日未参与排名';
			rankingListAdviseDom.style.display = 'none';
			return;
		}

		if(rankingNum == 1) { //第一名
			rankingListAdviseDom.style.display = 'none';
		} else { //非第一名
			if(!g_utils.isEmpty(upScore)) {
				rankingListAdviseDom.innerHTML = '再增加' + upScore + '分就可以赶上前一名了！';
			}
		}

		setShowAreaHeight();
	}

	//更新三个值
	if(!g_utils.isEmpty(sportScore)) {
		var championSportScoreDom = document.getElementById('championSportScore');
		championSportScoreDom.innerHTML = sportScore;
	}
	if(!g_utils.isEmpty(careScore)) {
		var championCareScoreDom = document.getElementById('championCareScore');
		championCareScoreDom.innerHTML = careScore;
	}
	if(!g_utils.isEmpty(healthScore)) {
		var championHealthScoreDom = document.getElementById('championHealthScore');
		championHealthScoreDom.innerHTML = healthScore;
	}
}

/*
 * 带天数的倒计时
 * param  times  传入倒计时时间，单位 秒
 */
function startCountDown(times) {
	var timer = null;
	timer = setInterval(function() {
		var day = 0,
			hour = 0,
			minute = 0,
			second = 0; //时间默认值
		if(times > 0) {
			day = Math.floor(times / (60 * 60 * 24));
			hour = Math.floor(times / (60 * 60)) - (day * 24);
			minute = Math.floor(times / 60) - (day * 24 * 60) - (hour * 60);
			second = Math.floor(times) - (day * 24 * 60 * 60) - (hour * 60 * 60) - (minute * 60);
		}
		//	if(day <= 9) day = '0' + day;
		hour = hour + 24 * day; //不显示天，用
		if(hour <= 9) hour = '0' + hour;
		if(minute <= 9) minute = '0' + minute;
		if(second <= 9) second = '0' + second;

		//找到小时、分钟、秒的显示dom
		_countDownHourDom.innerHTML = hour;
		_countDownMinDom.innerHTML = minute;
		_countDownSecDom.innerHTML = second;
		times--;
                        
        if(times <= 0) {
            clearInterval(timer);
            getDailyLuckyStar();
        }
	}, 1000);
	
}

function setLuckyStarWaitingStatus() {
	_countDownTitleDom.innerHTML = '正在揭晓中，请稍等……';
	_countDownHourDom.style.display = 'none';
	_countDownMinDom.style.display = 'none';
	_countDownSecDom.style.display = 'none';
	//隐藏冒号
	var domList = document.querySelectorAll('.luck-star-time-break');
	for(var i = 0; i < domList.length; i++) {
		domList[i].style.display = 'none';
	}
}

function setLuckyStarNobodyStatus() {
	_countDownTitleDom.innerHTML = '咦？今天没人参加？';
	_countDownHourDom.style.display = 'none';
	_countDownMinDom.style.display = 'none';
	_countDownSecDom.style.display = 'none';
	//隐藏冒号
	var domList = document.querySelectorAll('.luck-star-time-break');
	for(var i = 0; i < domList.length; i++) {
		domList[i].style.display = 'none';
	}
}

function showLuckyStar(name, headImg, num) {
	if(!g_utils.isEmpty(headImg)) {
		headImg = g_tools.IP_FILE + headImg + "&tb=1";
	}
	_countDownTitleDom.style.display = 'none';
	_countDownHourDom.style.display = 'none';
	_countDownMinDom.style.display = 'none';
	_countDownSecDom.style.display = 'none';

	//隐藏冒号
	var domList = document.querySelectorAll('.luck-star-time-break');
	for(var i = 0; i < domList.length; i++) {
		domList[i].style.display = 'none';
	}

	var luckyStarCardDom = document.getElementById('luckyStarCard');

	//如果luckyStarCardDom子元素含有lucky-star-info，则删除
	var childList = luckyStarCardDom.childNodes;
	for(var i = 0; i < childList.length; i++) {
		if(childList[i].className == 'lucky-star-info') {
			luckyStarCardDom.removeChild(childList[i]);
		}
	}

	//创建新的lucky-star-info
	var luckyStarInfoDom = document.createElement('div');
	luckyStarInfoDom.className = 'lucky-star-info';
	luckyStarCardDom.appendChild(luckyStarInfoDom);
	luckyStarInfoDom.innerHTML = '<img src="../../global/img/default_portrait_msg.png" data-src="' + headImg + '" class="lucky-star-info-img head-img" onload="load(this)"/>';
	luckyStarInfoDom.innerHTML += '<div class="lucky-star-info-name">' + name + '</div>';
	luckyStarInfoDom.innerHTML += '<div class="lucky-star-info-other">+' + num + '</div>';
}
//------------------------点击事件相关方法-------------------------
function initPageTransitionTap() {
	//明细
	var currencyDetailDom = document.getElementById('currencyDetail');
	currencyDetailDom.addEventListener('tap', function(e) {
		g_mui.openPage(g_module.healthReward, 'healthCoin.html', {});
	});

	//二维码
	var qrCodeDom = document.getElementById('qrCode');
	qrCodeDom.addEventListener('tap', function(e) {
		g_mui.openPage(g_module.healthReward, 'QRCode.html', {
			'nickname': _nickname,
			'headImg': _headImg
		});
	});

	//历史幸运星
	var luckyStarHistoryDom = document.getElementById('luckyStarHistory');
	luckyStarHistoryDom.addEventListener('tap', function(e) {
		g_mui.openPage(g_module.healthReward, 'historyLuckyStar.html', {});
	});
}

function initSelectTabviewSecTap() {
	for(var i = 0; i < 4; i++) {
		var dom = document.getElementById('selectSec' + i);
		dom.addEventListener('tap', function(e) {
			moveFlagSec(e.target.getAttribute('value'));
			movePageSec(e.target.getAttribute('value'));

			for(var i = 0; i < 4; i++) {
				var dom = document.getElementById('selectSec' + i);
				if(e.target.getAttribute('value') == i) {
					dom.classList.add('item-selected');
				} else {
					dom.classList.remove('item-selected');
				}
			}
			setShowAreaSecHeight(e.target.getAttribute('value'));
		});
	}
}

function initScoreRankDateSelect() {
	var scoreRankDateDom = document.getElementById('scoreRankDate');
	scoreRankDateDom.addEventListener('tap', function(e) {
		openCalendar();
	});
}
/*
 * 第二组group移动顶部tab下方的标志下划线
 * param 选择的第几个tab  int
 */
function moveFlagSec(select) {
	var selectCardDom = document.getElementById('selectCardSec');
	var flagDom = document.getElementById('selectFlagSec');
	flagDom.style.left = select * selectCardDom.offsetWidth / 4 + (selectCardDom.offsetWidth / 4 - flagDom.offsetWidth) / 2 + 'px';
	_secondTableSelect = select;

}

/*
 * 第二组group下方多选部分翻页
 * param 选择的第几个tab  int
 */
function movePageSec(select) {
	var rootDom = document.getElementById('selectAreaSec');
	var selectCardSecDom = document.getElementById('selectCardSec');
	rootDom.style.left = -select * selectCardSecDom.offsetWidth + 'px';

	setTimeout(function() {
		getStarRankList(select);
	}, 500);

}

//初始化时间选择控件
function initCalendar() {
	//日历页面
	_calendar = g_mui.createWebview('../myCareState/calendar.html', 'calendar', {
		background: "transparent",
		popGesture: 'none',
	}, {
		pageType: 1
	});

	//按时间刷新页面
	window.addEventListener('changeday', function(event) {
		//关闭日历
		plus.webview.hide(_calendar, 'auto', 300);
		_self.setStyle({
			mask: 'none'
		});
		//chooseDay = {"year":2018,"month":7,"day":3}
		var chooseDay = event.detail.view;
		var year = chooseDay.year;
		var month = chooseDay.month + 1;
		var day = chooseDay.day;

		if(month <= 9) month = '0' + month;
		if(day <= 9) day = '0' + day;
		//alert(year+'-'+month+'-'+day);
		_scoreRankDate = year + '-' + month + '-' + day;
		refreshScoreRank();

	});
}

//显示日历页
function openCalendar() {
	plus.webview.show(_calendar, 'slide-in-bottom', 300, function(e) {});
	_self.setStyle({
		mask: 'rgba(0,0,0,0.5)'
	});
}
