var PAGE_STEP = 10 //刷新步长
var PAGE_READY = false;
var tabelList = document.querySelector(".mui-table-view");
var historyLuckyStarList, nowPage = 0;
init();
mui.plusReady(function() {
	getHistoryLuckyStarList(0, g_tools.MODE_WEB_LOCAL_CACHE, {
		noNetworkMode: g_tools.TIP_MODE_INTERFACE,
		contentDomId: 'mainContent',
		tipDomId: 'noNetworkTip'
	});
});

function getHistoryLuckyStarList(currentPage, mode, timeOutHanding) {
	g_tools.postCMD('reward/getHistoryLuckyStarList', {
		currentPage: currentPage,
		pageSize: PAGE_STEP
	}, function(res) {
		if(res.code == 0) {
			var data = res.data;
			if(!PAGE_READY) {
				historyLuckyStarList = data;
				init();
				PAGE_READY = true;
			} else {
				setTimeout(function() {
					//下拉刷新
					if(currentPage == 0) {
						historyLuckyStarList = data;
						resetList();
						//结束下拉刷新
						mui('#pullrefresh').pullRefresh().endPulldownToRefresh();
						//重置上拉加载
						mui('#pullrefresh').pullRefresh().refresh(true);
					} else {
						//上拉加载
						addList(data);
					}
				}, 100)
			}
		}
	}, mode, timeOutHanding);
}
//初始化下拉刷新
function init() {
	mui.init({
		pullRefresh: {
			container: '#pullrefresh',
			down: {
				//下拉成功回调函数
				callback: pullDownRefresh
			},
			up: {
				//上拉成功回调函数
				contentrefresh: '正在加载...',
				callback: pullUpRefresh
			}
		}
	});
	resetList();
}

//重置表单
function resetList() {
	while(tabelList.hasChildNodes()) {
		tabelList.removeChild(tabelList.firstChild);
	}
	//检查是否没有记录
	if(!g_utils.isEmptyArray(historyLuckyStarList)) {
		mui.each(historyLuckyStarList, function(index, item) {
			appendListItem(index, item);
		});
	} else {
		//显示空值界面

	}
}
//添加表单
function addList(data) {
	//没有更多数据
	if(!g_utils.isEmptyArray(data)) {
		var start = historyLuckyStarList.length;
		var dataLength = data.length;
		for(var i = 0; i < dataLength; i++) {
			historyLuckyStarList.push(data[i]);
			appendListItem(start + i, data[i]);
		}

	}
	mui('#pullrefresh').pullRefresh().endPullupToRefresh(dataLength != PAGE_STEP);
}
//下拉刷新
function pullDownRefresh() {
	nowPage = 0;
	getHistoryLuckyStarList(0, g_tools.MODE_WEB_LOCAL_CACHE, {
		disableWait: true
	});
}
//上拉加载
function pullUpRefresh() {
	nowPage++;
	getHistoryLuckyStarList(nowPage, g_tools.MODE_WEB_LOCAL_CACHE, {
		disableWait: true
	});
}
//添加列表子项
function appendListItem(index, item) {
	var div = document.createElement("div");
	div.classList.add("box", "box-two");
	div.setAttribute("index", index);
	var itemHeadImg = item.headImg;
	var itemCreateTime = item.createTime;
	var itemMoney = item.money;
	var itemNickname = item.nickname;
	if(!g_utils.isEmpty(itemHeadImg)) {
		itemHeadImg = g_tools.IP_FILE + itemHeadImg + "&tb=1";
	} else {
		itemHeadImg = '../../global/img/default_portrait_msg.png';
	}
	itemCreateTime = g_utils.dateFormat(itemCreateTime, "yyyy-MM-dd");
	itemMoney = "+" + itemMoney;
	var str;
	str = '<div class="location location-one font-style-one">' + itemCreateTime + '</div>' +
		'<img class="location location-four photo" src="' + itemHeadImg + '">' +
		'<div class="location location-five font-style-one name-content">' + itemNickname + '</div>' +
		'<div class="location location-six font-style-one coin-num">' + itemMoney + '</div>'
	div.innerHTML = str;
	tabelList.appendChild(div);
}