var currentPage = 0;
var PAGE_SIZE = 10;
var NO_SHOW = 0; //不显示
var nullPage = document.getElementById("nullPage");
var refreshContainer = document.getElementById("refreshContainer");
var scrollContent = document.getElementById('scroll-content');

//mui初始化
mui.init({
	pullRefresh: {
		container: '#refreshContainer',
		down: {
			//下拉成功回调函数
			callback: pullfreshDown
		},
		up: {
			//上拉成功回调函数
			contentrefresh: '正在加载...',
			callback: pullfreshUp
		}
	}
});
mui.plusReady(function() {
	//隐藏掉滚动条
	plus.webview.currentWebview().setStyle({
		scrollIndicator: 'none'
	});
	//用于刷新计划列表，后面功能调用触发
	window.addEventListener('valuationListRefresh', function(e) {
		pullfreshDown();
	}, false);
	initValuationList();
});

function initValuationList() {
	g_tools.postCMD('getHealthyValuationList', {
		currentPage: currentPage,
		pageSize: PAGE_SIZE
	}, function(data) {
		if(data.code == 0) {
			var valuationList = data.data;
			initRefreshValuationList(valuationList);
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE, { //！！！！！！！！！重点代码！！！！！！！！！
		disableWait: true, //禁止显示wait框
        noNetworkMode: g_tools.TIP_MODE_TOAST //！！！！！！！！！重点代码！！！！！！！！！
	});
}

function pullfreshDown() {
	setTimeout(function() {
		getDownRefreshValuationList();
	}, 500);
}

function pullfreshUp() {
	setTimeout(function() {
		getUpRefreshValuationList();
	}, 500);
}

function initRefreshValuationList(valuationList) {
	if(valuationList && valuationList.length != 0) {
		plus.webview.currentWebview().setStyle({ //取消蒙板
			mask: 'none'
		});
		nullPage.classList.add('mui-hidden');
		scrollContent.classList.remove('mui-hidden');
		downRefresh(valuationList);
	} else {
		nullPage.classList.remove('mui-hidden');
		scrollContent.classList.add('mui-hidden');
		plus.webview.currentWebview().setStyle({ //添加蒙板
			mask: 'rgba(0,0,0,0)'
		});
	}
}

function getDownRefreshValuationList() {
	currentPage = 0;
	g_tools.postCMD('getHealthyValuationList', {
		currentPage: currentPage,
		pageSize: PAGE_SIZE
	}, function(data) {
		if(data.code == 0) {
			var valuationList = data.data;
			if(valuationList && valuationList.length != 0) { //不为空
				initRefreshValuationList(valuationList);
			}

			//结束下拉刷新
			mui('#refreshContainer').pullRefresh().endPulldownToRefresh();
			//重置上拉加载
			mui('#refreshContainer').pullRefresh().refresh(true);
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE, {
		disableWait: true, //禁止显示wait框
		noNetworkMode: g_tools.TIP_MODE_TOAST //！！！！！！！！！重点代码！！！！！！！！！
	});
}

function getUpRefreshValuationList() {
	currentPage++; //页面增1
	g_tools.postCMD('getHealthyValuationList', {
		currentPage: currentPage,
		pageSize: PAGE_SIZE
	}, function(data) {
		if(data.code == 0) {
			var valuationList = data.data;
			if(valuationList && valuationList.length != 0) { //不为空
				upRefresh(valuationList);
				mui('#refreshContainer').pullRefresh().endPullupToRefresh(false);
			} else {
				mui('#refreshContainer').pullRefresh().endPullupToRefresh(true); //参数为true代表没有更多数据了。
			}
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE, {
		disableWait: true, //禁止显示wait框
		noNetworkMode: g_tools.TIP_MODE_TOAST //！！！！！！！！！重点代码！！！！！！！！！
	});
}

function downRefresh(valuationList) {
	scrollContent.innerHTML = "";
	for(var i = 0, len = valuationList.length; i < len; i++) {
		var valuation = valuationList[i];
		refreshOneValuation(valuation);
	}
}

function upRefresh(valuationList) {
	for(var i = 0, len = valuationList.length; i < len; i++) {
		var valuation = valuationList[i];
		refreshOneValuation(valuation);
	}
}

function refreshOneValuation(valuation) {
		var li = getValuationLi(valuation);
		scrollContent.appendChild(li);
}

function getValuationLi(valuation) {
	var li = document.createElement('li');
	li.className = 'mui-table-view-cell mui-collapse-content valuation-item';
	var aDom=document.createElement('a');
	aDom.className="mui-navigate-right";
	var div1 = document.createElement('div');
	div1.className = 'valuation-time';
	div1.innerHTML ='评估日期：<span>'+g_utils.dateFormat(valuation.createTime,"yyyy.MM.dd")+'</span>';


	var div2 = document.createElement('div');
	div2.className = 'valuation-doctor';
	div2.innerHTML = '评估医生：<span>'+valuation.doctorName+'</span>';
	
	aDom.appendChild(div1);
	aDom.appendChild(div2);
	
	aDom.addEventListener('tap', function(event) {
		onTapValuationDetailList(valuation.id);
	});
	li.appendChild(aDom);
	
	return li;
}


/**
 * 跳转到评估详情页面
 * @param {Object} valuationId 评估Id
 */
function onTapValuationDetailList(valuationId) {
	g_mui.openPage(g_module.healthyValuation, 'valuationDetails.html', {
		valuationId: valuationId
	});
}