var type;
var activateInfo = "";
var personInfo = {}; //缓存的人物信息
//进入实名认证时的3种类型
var TYPE_MY = 0; //自己激活伙伙
var TYPE_NEW_OTHER = 1; //帮助他人时未提交实名认证
var TYPE_OTHER = 2; //帮助他人时提交了实名认证
var g_MIN_PASSWORD_LENGTH = 6;
var g_MAX_PASSWORD_LENGTH = 12;

//model
mdata = {};
mdata['password'] = "";

//mMethods
mMethods = {};
mMethods["onNextStep"] = onNextStep;

//vue加载完加载mui,当用到plus时先加载完plus基座再初始化mui
var vm = new Vue({
	el: '#main',
	data: mdata,
	methods: mMethods,
	mounted:function() {
		//pulsReady
		mui.plusReady(function() {
			//mui初始化
			mui.init();
			var self = plus.webview.currentWebview();
			type = self.type;
			activateInfo = self.activateInfo;
			var info = g_storage.getActivateStorage(type, activateInfo);

			if(!g_utils.isEmpty(info)) {
				personInfo = JSON.parse(info);
			}
		});
	}
});

function onNextStep() {
	var pwd = mdata.password;

	if(g_utils.isEmpty(pwd)) {
		g_mui.alert("密码不能为空");
		return;
	}
	if(pwd.length < g_MIN_PASSWORD_LENGTH) {
		g_mui.alert("密码不能小于" + g_MIN_PASSWORD_LENGTH + "位");
		return;
	}
	if(pwd.length > g_MAX_PASSWORD_LENGTH) {
		g_mui.alert("密码不能大于" + g_MAX_PASSWORD_LENGTH + "位");
		return;
	}
	g_tools.postCMD('checkLoginPassword', {
		userName: personInfo.userName,
		password: g_tools.secondPassword(mdata.password),
		targetMonitorPhone: activateInfo.phone
	}, function(reslut) {
		if(reslut.code == 0) {
			//提交后状态发生改变，需重新拉取信息
			g_tools.postCMD('getActivateInfoList', null, function(result) {
				if(result.code == 0) {
					var activateInfoList = result.data;
					activateInfo = getActivateInfoByPhone(activateInfoList, activateInfo.phone);
					
					var resultList = plus.webview.getWebviewById('waitingResult.html');
					if(resultList != null) {
						mui.fire(resultList, 'resultChange', {
							activateInfo: activateInfo,
							activateInfoList: activateInfoList
						});
					}
					
					var w=openModuleByUrl('moduleLocal/helpRegister/registerSuccess.html', 'registerSuccess.html', {
						type: type,
						activateInfo: activateInfo,
						userName: personInfo.userName,
						password: mdata.password
					});
					setTimeout(function(){
						w.evalJS('g_mui.closeModule(g_module.helpRegister);');
					},300);
				} else {
					g_mui.toast(result.tip);
				}
			});
		} else {
			g_mui.alert(reslut.tip);
			/*g_mui.alert("登录密码验证错误，请输入正确的登录密码！");*/
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE, {
		noNetworkMode: g_tools.TIP_MODE_TOAST
	});
}

/**
 * 根据电话获取激活伙伙的信息
 * @param {Object} activateInfoList
 * @param {Object} phone
 */
function getActivateInfoByPhone(activateInfoList, phone) {
	if(activateInfoList.length > 0) {
		for(var i = 0; i < activateInfoList.length; i++) {
			if(activateInfoList[i].phone == phone) {
				return activateInfoList[i];
			}
		}
	}
	return null;
}

/**
 * 进入模块的指定页
 * @param {Object} url
 * @param {Object} id
 * @param {Object} extras
 * @param {Object} aniShow
 */
function openModuleByUrl(path, id, extras, aniShow) {
	if(aniShow == null || aniShow == undefined) aniShow = 'slide-in-right';
	if(extras == null || extras == undefined) extras = {};
	var url = g_formatPathToUrl(path);
	return g_mui.openWindow({
		url: url,
		id: id,
		show: {
			autoShow: true, //页面loaded事件发生后自动显示，默认为true
			aniShow: aniShow,
			duration: 300
		},
		extras: extras,
		waiting: {
			autoShow: false, //自动显示等待框，默认为true
		},
		styles: {
			render: 'always',
			scrollIndicator: 'none'
		}
	})
}
