var type;
var activateInfo = "";
var personInfo = {}; //缓存的人物信息

//进入实名认证时的3种类型
var TYPE_MY = 0; //自己激活伙伙
var TYPE_NEW_OTHER = 1; //帮助他人时未提交实名认证
var TYPE_OTHER = 2; //帮助他人时提交了实名认证

//model
mdata = {};
mdata['honorific'] = "";
mdata['simPhone'] = "";
mdata['userName'] = "";

//mMethods
mMethods = {};
mMethods["useSimPhoneRegister"] =useSimPhoneRegister ;
mMethods["onNextStep"] = onNextStep;

//vue加载完加载mui,当用到plus时先加载完plus基座再初始化mui
var vm = new Vue({
	el: '#main',
	data: mdata,
	methods: mMethods,
	mounted: function() {
		//pulsReady
		mui.plusReady(function() {
			//mui初始化
			mui.init();
			var self = plus.webview.currentWebview();
			type = self.type;
			activateInfo = self.activateInfo;
			var info = g_storage.getActivateStorage(type, activateInfo);

			if(!g_utils.isEmpty(info)) { //先读取缓存如果没有缓存用网上数据更新
				personInfo = JSON.parse(info);
			}
			refresh(activateInfo.name, activateInfo.identityCard, activateInfo.phone);
		});
	}
});

function refresh(name, identityCard, phone) {
	mdata.honorific = getHonorific(name, identityCard);
	mdata.simPhone = phone;

	if(!g_utils.isEmpty(personInfo.userName)) {
		if(phone != personInfo.userName) {
			mdata.userName = personInfo.userName;
		}
	}
}

/**
 * 使用伙伙sim卡号注册
 */
function useSimPhoneRegister() {
	personInfo['userName'] = mdata.simPhone;
	var infoStr = JSON.stringify(personInfo);
	g_storage.setActivateStorage(type, infoStr, activateInfo);
	g_mui.openPage(g_module.helpRegister, 'setPassword.html', {
		type: type,
		activateInfo: activateInfo,
		isMonitorPhone: true
	});
}

function onNextStep() { //以手机号注册
	if(g_utils.isEmpty(mdata.userName)) {
		g_mui.alert("请输入注册手机号");
	} else if(!g_utils.validateMobile(mdata.userName)) {
		g_mui.alert("请输入正确的手机号");
	} else {
		g_tools.postCMD("getUserNameStatus", {
			userName: mdata.userName
		}, function(result) {
			if(result.code == 0) {
				var isExist = result.data.isExist; //该账号是否已经存在
				var isBinded = result.data.isBinded; //该账号是否已经完成首次绑定

				if(isExist == 0) { //不存在
					//先拉取缓存在存入
					var info = g_storage.getActivateStorage(type, activateInfo);
					if(!g_utils.isEmpty(info)) {
						personInfo = JSON.parse(info);
					}
					personInfo['userName'] = mdata.userName;
					var infoStr = JSON.stringify(personInfo);
					g_storage.setActivateStorage(type, infoStr, activateInfo);
					getIdentifyCode(mdata.userName);

					/*if(isSimPhone) { //是sim卡号
						g_mui.openPage(g_module.helpRegister, 'sendVerification.html', {
							type: type,
							activateInfo: activateInfo
						});
					} else {
						getIdentifyCode(mdata.picked);
					}*/

				} else if(isExist == 1) { //已存在
					if(isBinded == 0) { //未绑定
						//先拉取缓存在存入
						var info = g_storage.getActivateStorage(type, activateInfo);
						if(!g_utils.isEmpty(info)) {
							personInfo = JSON.parse(info);
						}

						personInfo['userName'] = mdata.userName;
						var infoStr = JSON.stringify(personInfo);
						g_storage.setActivateStorage(type, infoStr, activateInfo);
						g_mui.openPage(g_module.helpRegister, "loginPassword.html", {
							type: type,
							activateInfo: activateInfo
						});
					} else if(isBinded == 1) { //已完成首次绑定
						g_mui.alert("该账号已注册并且已绑定了伙伙，请选择其它账号注册！");
					}
				}

			} else {
				g_mui.toast(result.tip);
			}
		}, g_tools.MODE_WEB_LOCAL_CACHE, {
			noNetworkMode: g_tools.TIP_MODE_TOAST
		});
	}
}

function getIdentifyCode(pickedPhone) {
	g_tools.postURL('getPhoneCode', {
		mode: 0,
		phone: pickedPhone
	}, function(result) {
		if(result.code == 0) {
			g_mui.openPage(g_module.helpRegister, 'sendVerification.html', {
				type: type,
				activateInfo: activateInfo
			});
		} else {
			g_mui.alert(result.tip);
		}
	});
}

/**
 * 敬语
 * @param {Object} name
 * @param {Object} identityCard
 */
function getHonorific(name, identityCard) {
	return name + (getSexbyIdentityCard(identityCard) == 0 ? "女士" : "先生");
}

/**
 * 根据身份证号判断性别 0：女，1：男
 * @param {Object} identityCard
 */
function getSexbyIdentityCard(identityCard) {
	return identityCard.substring(16, 17) % 2 == 0 ? "0" : "1";
}