var currentPage = 0;
var PAGE_SIZE = 5;

//图片网络地址url
var SERVER_IMG_ADDRESS = g_tools.IP_FILE;
var DEFAULT_HEAD_IMG = '../../global/img/default_head.png';

var recordLay = document.getElementById('recordLay');
var nullPage = document.getElementById("nullPage");
var refreshContainer = document.getElementById("refreshContainer");

//mui初始化
mui.init({
	pullRefresh: {
		container: '#refreshContainer',
		down: {
			//下拉成功回调函数
			callback: pullfreshDown
		},
		up: {
			//上拉成功回调函数
			contentrefresh: '正在加载...',
			callback: pullfreshUp
		}
	}
});

mui.plusReady(function() {
	//隐藏掉滚动条
	plus.webview.currentWebview().setStyle({
		scrollIndicator: 'none'
	});

	//用于刷新实施记录列表，后面功能调用触发
	document.addEventListener('recordListRefresh', function(e) {
		getDownRefreshrecordList();
	}, false);

	initrecordList();
	initPreview();
});

function initPreview() {
	mui.initPhotoSwiper({},function(){});
}

function initrecordList() {
	g_tools.postCMD('getImplementationRecordListByUserId', {
		currentPage: currentPage,
		pageSize: PAGE_SIZE
	}, function(data) {
//		console.log(JSON.stringify(data));
		if(data.code == 0) {
			var recordList = data.data;
			initRefreshrecordList(recordList);
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE, { //！！！！！！！！！重点代码！！！！！！！！！
		disableWait: true, //禁止显示wait框
		noNetworkMode: g_tools.TIP_MODE_TOAST //！！！！！！！！！重点代码！！！！！！！！！
	});
}

function initRefreshrecordList(recordList) {
	if(recordList && recordList.length != 0) {
		plus.webview.currentWebview().setStyle({ //取消蒙板
			mask: 'none'
		});
		nullPage.classList.add('mui-hidden');
		recordLay.classList.remove('mui-hidden');
		downRefresh(recordList);
	} else {
		nullPage.classList.remove('mui-hidden');
		recordLay.classList.add('mui-hidden');
		plus.webview.currentWebview().setStyle({ //添加蒙板
			mask: 'rgba(0,0,0,0)'
		});
	}
}

function pullfreshDown() {
	setTimeout(function() {
		getDownRefreshrecordList();
	}, 500);
}

function pullfreshUp() {
	setTimeout(function() {
		getUpRefreshrecordList();
	}, 500);
}

function getDownRefreshrecordList() {
	currentPage = 0;
	g_tools.postCMD('getImplementationRecordListByUserId', {
		currentPage: currentPage,
		pageSize: PAGE_SIZE
	}, function(data) {
		if(data.code == 0) {
			var recordList = data.data;
			if(recordList && recordList.length != 0) { //不为空
				initRefreshrecordList(recordList);
			}
			//结束下拉刷新
			mui('#refreshContainer').pullRefresh().endPulldownToRefresh();
			//重置上拉加载
			mui('#refreshContainer').pullRefresh().refresh(true);
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE, {
		disableWait: true, //禁止显示wait框
		noNetworkMode: g_tools.TIP_MODE_TOAST //！！！！！！！！！重点代码！！！！！！！！！
	});
}

function getUpRefreshrecordList() {
	currentPage++; //页面增1
	g_tools.postCMD('getImplementationRecordListByUserId', {
		currentPage: currentPage,
		pageSize: PAGE_SIZE
	}, function(data) {
		if(data.code == 0) {
			var recordList = data.data;
			if(recordList && recordList.length != 0) { //不为空
				upRefresh(recordList);
				mui('#refreshContainer').pullRefresh().endPullupToRefresh(false);
			} else {
				mui('#refreshContainer').pullRefresh().endPullupToRefresh(true); //参数为true代表没有更多数据了。
			}
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE, {
		disableWait: true, //禁止显示wait框
		noNetworkMode: g_tools.TIP_MODE_TOAST //！！！！！！！！！重点代码！！！！！！！！！
	});
}

function downRefresh(recordList) {
	recordLay.innerHTML = "";
	for(var i = 0, len = recordList.length; i < len; i++) {
		var record = recordList[i];
		refreshOnerecord(record,i+1);
	}
}

function upRefresh(recordList) {
	for(var i = 0, len = recordList.length; i < len; i++) {
		var record = recordList[i];
		refreshOnerecord(record,i+1+currentPage*3);
	}
}

function refreshOnerecord(record,imgsGroupNum) {
	var recordDiv = getrecordDiv(record,imgsGroupNum);
	recordLay.appendChild(recordDiv);
}

function getrecordDiv(record,imgsGroupNum) {
	var recordContent = "";
	var recordImgsHtml = "";
	var recordCreatDate = "";

	if(!g_utils.isEmpty(record.content)) {
		recordContent = record.content;;
	}
	if(!g_utils.isEmptyArray(record.recordImgs)) {
		var _recordImgs = record.recordImgs;
		recordImgsHtml = getRecordImgsHtml(_recordImgs,imgsGroupNum);
	}
	if(!g_utils.isEmpty(record.doctorName)&&!g_utils.isEmpty(record.createTime)) {
		recordCreatDate = record.doctorName + ' ' +  g_printTools.printDateAndTimeStrByTimeMillis(record.createTime);
	}

	var recordDiv = document.createElement('div');
	recordDiv.className = "record-item";
	
	var recordContentDiv=document.createElement('div');
	recordContentDiv.className = "record-content";
	recordContentDiv.innerText=recordContent;
	
	var recordImgsDiv=document.createElement('div');
	recordImgsDiv.className = "record-imgs";
	recordImgsDiv.innerHTML=recordImgsHtml;
	
	var recordTimeDiv=document.createElement('div');
	recordTimeDiv.className = "record-time";
	 
	var recordTimeSpan=document.createElement('span');
	recordTimeSpan.className = "record-date";
	recordTimeSpan.innerText=recordCreatDate;
	
	recordDiv.appendChild(recordContentDiv);
	recordDiv.appendChild(recordImgsDiv);
	recordDiv.appendChild(recordTimeDiv);
	recordDiv.appendChild(recordTimeSpan);
//	console.log(recordDiv.innerHTML);
	
	return recordDiv;
}

function getRecordImgsHtml(recordImgs,imgsGroupNum) {
	var recordImgsHtml = "";
	for(var i = 0, len = recordImgs.length; i < len; i++) {
		var recordImg = recordImgs[i];
		var recordImgUrl = getImgUrl(recordImg) + "&tb=1"+ "&app=2";
		var previesSrcUrl = getImgUrl(recordImg)+ "&app=2";
		recordImgsHtml += '<img class="recordImg" src="../../global/img/loading.svg"' +
			' data-src="' + recordImgUrl + '"' +
			' onload="load(this)"' +
			' data-preview-src="' + previesSrcUrl + '"' +
			' data-preview-group="' + imgsGroupNum + '"' + '/>';
	}
	return recordImgsHtml;
}

function getImgUrl(img) {
	var imgUrl = DEFAULT_HEAD_IMG;
	if(!g_utils.isEmpty(img)) {
		imgUrl = SERVER_IMG_ADDRESS + img;
	}
	return imgUrl;
}