var priorityPicker;
var titleDom = document.getElementById("title");
var emergencyContacts = [];
var selectedContacts = [];  //所有选中的联系人（含紧急联系人）
//所有的紧急联系人优先级
var allPriority = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10];

//model
mdata = {};
mdata["emergencyContacts"] = [];
mdata["name"] = "";
mdata["phone"] = "";
mdata["showPriority"] = "";
mdata["priority"] = "";
mdata["relation"] = "";

//methods
mMethods = {};
mMethods["addContactByMail"] = addContactByMail;
mMethods["onTapPriorityPicker"] = onTapPriorityPicker;
mMethods["onSave"] = onSave;

//vue加载完加载mui,当用到plus时先加载完plus基座再初始化mui
var vm = new Vue({
	el: '#main',
	data: mdata,
	methods: mMethods,
	mounted:function() {
		//pulsReady
		mui.plusReady(function() {
			//mui初始化
			mui.init();
			var self = plus.webview.currentWebview();
            titleDom.innerHTML = self.titleStr;
			emergencyContacts=self.emergencyContacts;
			mdata.emergencyContacts =emergencyContacts ;
			selectedContacts=self.selectedContacts
			initPriorityPicker();
			
			//定义通讯录查找监听事件
			document.addEventListener('exportContacts', function(event) {
				//返回的是一个json数组
				var contacts = event.detail.chooseContacts;
				if(contacts!=null&&contacts.length>0){
					mdata.name = contacts[0].name;
					mdata.phone = contacts[0].phone;
				}
			});
		});
	}
});

function initPriorityPicker() {
	priorityPicker = new mui.PopPicker();
	priorityPicker.setData(creatPickerData());
	//默认第一个未使用优先级
	var firstUnUsePriority = getUnUsePriority()[0];
	mdata.showPriority = "紧急联系人" + firstUnUsePriority;
	mdata.priority = firstUnUsePriority;
}

function onTapPriorityPicker() {
	priorityPicker.pickers[0].setSelectedValue(mdata.showPriority.substring(5));
	priorityPicker.show(function(items) {
		mdata.showPriority = items[0].text;
		mdata.priority = parseInt(items[0].value);
	});
}

function addContactByMail() {
	g_mui.openSelectContacts({
    	selectedContacts: selectedContacts,
    	hearderTitle: '请从通讯录中选择（单选）',
    	isSingleMode: true
    });
}

function validateInfo(name, phone, priority) {
	if(g_utils.isEmpty(name)) {
		g_mui.alert("姓名不能为空！");
		return false;
	} else if(g_utils.isEmpty(phone)) {
		g_mui.alert("电话号码不能为空！");
		return false;
	} else if(g_utils.isEmpty(priority)) {
		g_mui.alert("紧急联系人优先级不能为空，请选择！");
		return false;
	} else if(!g_utils.validateTel(phone)) {
		g_mui.alert("电话号码格式错误，请输入正确的电话号码！");
		return false;
	}
	return true;
}

function onSave(name, phone, priority, relation) {
	if(validateInfo(name, phone, priority)) {
		var contact = {};
		contact['name'] = name;
		contact['phone'] = phone;
		contact['priority'] = priority;
		contact['relation'] = relation;
		var list = plus.webview.currentWebview().opener();
		emergencyContacts.push(contact);
		mui.fire(list, 'saveContact', {
			emergencyContacts: emergencyContacts
		});
		mui.back(true);
	}
}

function creatPickerData() {
	var unusePriority = getUnUsePriority();
	var datas = [];

	for(var i = 0; i < unusePriority.length; i++) {
		var data = {};
		data.value = unusePriority[i];
		data.text = "紧急联系人" + unusePriority[i];
		datas.push(data);
	}
	return datas;
}

function getUsePriority() {
	var priority = [];
	if(!g_utils.isEmpty(emergencyContacts)) {
		for(var i = 0; i < emergencyContacts.length; i++) {
			priority.push(emergencyContacts[i].priority);
		}
	}
	return priority;
}

function getUnUsePriority() {
	var usePriority = getUsePriority();
	var priority = [];
	for(var i = 0; i < allPriority.length; i++) {
		var isHave = false;
		if(!g_utils.isEmpty(usePriority)) {
			for(var j = 0; j < usePriority.length; j++) {
				if(allPriority[i] == usePriority[j]) {
					isHave = true;
				}
			}
		}
		if(!isHave) {
			priority.push(allPriority[i]);
		}
	}
	return priority;
}
