var type;
var titleDom = document.getElementById("title");
var activateInfo = "";
var personInfo = {}; //缓存的人物信息
//进入实名认证时的3种类型
var TYPE_MY = 0; //自己激活伙伙
var TYPE_NEW_OTHER = 1; //帮助他人时未提交实名认证
var TYPE_OTHER = 2; //帮助他人时提交了实名认证

//model
mdata = {};
mdata['honorific'] = "";
mdata["emergencyContacts"] = [];

//methods
mMethods = {};
mMethods["goAddEmergencyContact"] = goAddEmergencyContact;
mMethods["onNextStep"] = onNextStep;

//vue加载完加载mui,当用到plus时先加载完plus基座再初始化mui
var vm = new Vue({
	el: '#main',
	data: mdata,
	methods: mMethods,
	mounted:function() {
		//pulsReady
		mui.plusReady(function() {
			mui.init();
			//隐藏掉滚动条
			mui('.mui-scroll-wrapper').scroll({
				indicators: false
			});

			var self = plus.webview.currentWebview();
			type = self.type;
			activateInfo = self.activateInfo;
            titleDom.innerHTML = self.titleStr;
			var info = g_storage.getActivateStorage(type, activateInfo);
			if(!g_utils.isEmpty(info)) {
				personInfo = JSON.parse(info);
				if(!g_utils.isEmpty(personInfo.emergencyContacts)) {
					mdata.emergencyContacts = personInfo.emergencyContacts;
				}
			}
			refreshTip();
			window.addEventListener('saveContact', function(event) {
				//通过event.detail可获得传递过来的参数内容
				var contacts = event.detail.emergencyContacts;
				mdata.emergencyContacts = contacts;
                saveChange(contacts);
			});
			scrollTopFixed('addTap', 'topAdd');
			swipeDeleteContact();
		});
	}
});
function refreshTip() {
	if(type == TYPE_OTHER) {
		mdata.honorific = getHonorific(activateInfo.name, activateInfo.identityCard);
		document.getElementById("call").classList.add("highlight");
	} else if(type == TYPE_MY) {
		mdata.honorific = '您';
	}
}

function swipeDeleteContact() {
	//左右滑出现删除按钮
	var btnArray = ['确认', '取消'];
	mui('#eList').on('tap', '.mui-btn', function(event) {
		var elem = this;
		var li = elem.parentNode.parentNode;
		g_mui.confirm('确认删除该紧急联系人？', '确定删除', btnArray, function(e) {
			if(e.index == 0) {
				var index = li.firstChild.innerText;
				mdata.emergencyContacts.splice(index, 1);
                  saveChange(mdata.emergencyContacts);
				setTimeout(function() {
					mui.swipeoutClose(li);
				}, 0);
				/*li.parentNode.removeChild(li);*/
			} else {
				setTimeout(function() {
					mui.swipeoutClose(li);
				}, 0);
			}
		});
	});
}

function goAddEmergencyContact(emergencyContacts) {
	if(!g_utils.isEmpty(emergencyContacts) && emergencyContacts.length < 10) {
		var selectedContacts=emergencyContacts.slice();
		//选中号码中同时加入普通联系人的号码
		var info = g_storage.getActivateStorage(type, activateInfo);
		var normalContacts=new Array();
		if(!g_utils.isEmpty(info)) {
			var personInfo = JSON.parse(info);
			normalContacts = personInfo.normalContacts;
		}
		if(normalContacts!=null){
			for(var i=0;i<normalContacts.length;i++){
				selectedContacts.push(normalContacts[i]);
			}			
		}
		
		g_mui.openPage(g_module.improvePersonalData, 'addEmergencyContact.html', {
			'emergencyContacts': emergencyContacts,
			'selectedContacts': selectedContacts,  //所有选中的联系人（含紧急联系人）
            titleStr:titleDom.innerHTML
		});
	} else {
		g_mui.alert("最多添加10名紧急联系人！")
	}
}

function onNextStep(emergencyContacts) {
	if(g_utils.isEmpty(emergencyContacts) || emergencyContacts.length < 2) {
		g_mui.alert("至少输入2个紧急联系人！")
	} else {
		//先拉取缓存在存入
		var info = g_storage.getActivateStorage(type, activateInfo);
		if(!g_utils.isEmpty(info)) {
			personInfo = JSON.parse(info);
		}
		personInfo['emergencyContacts'] = emergencyContacts;
		var infoStr = JSON.stringify(personInfo);
		g_storage.setActivateStorage(type, infoStr, activateInfo);
		
		g_mui.openPage(g_module.improvePersonalData, 'normalContactList.html', {
			type: type,
			activateInfo: activateInfo,
            titleStr:titleDom.innerHTML
		});
	}
}

function saveChange(emergencyContacts)
{
    //先拉取缓存在存入
    var info = g_storage.getActivateStorage(type, activateInfo);
    if(!g_utils.isEmpty(info)) {
        personInfo = JSON.parse(info);
    }
    personInfo['emergencyContacts'] = emergencyContacts;
    var infoStr = JSON.stringify(personInfo);
    g_storage.setActivateStorage(type, infoStr, activateInfo);
}

function scrollTopFixed(id1, id2) {
	var obj1 = document.getElementById(id1);
	var height = obj1.offsetTop;

	var obj2 = document.getElementById(id2);
	var scroll = mui('.mui-scroll-wrapper').scroll();
	document.querySelector('.mui-scroll-wrapper').addEventListener('scroll', function(e) {
		var scrollTop = -scroll.y;
		if(scrollTop < height) {
			obj2.classList.add('mui-hidden');
		} else {
			obj2.classList.remove('mui-hidden');
		}
	});
}
/**
 * 敬语
 * @param {Object} name
 * @param {Object} identityCard
 */
function getHonorific(name, identityCard) {
	return name + (getSexbyIdentityCard(identityCard) == 0 ? "女士" : "先生");
}
/**
 * 根据身份证号判断性别 0：女，1：男
 * @param {Object} identityCard
 */
function getSexbyIdentityCard(identityCard) {
	return identityCard.substring(16, 17) % 2 == 0 ? "0" : "1";
}
