var heightPicker, weightPicker;
var MIN_HEIGHT = 90;
var MAX_HEIGHT = 250;
var MIN_WEIGHT_INTEGER = 25; //体重整数部分
var MAX_WEIGHT_INTEGER = 150;
var MIN_WEIGHT_DECIMAL = 0; //体重小数部分
var MAX_WEIGHT_DECIMAL = 9;

var type;
var activateInfo = "";
var personInfo = {}; //缓存的人物信息
//进入实名认证时的3种类型
var TYPE_MY = 0; //自己激活伙伙
var TYPE_NEW_OTHER = 1; //帮助他人时未提交实名认证
var TYPE_OTHER = 2; //帮助他人时提交了实名认证

//model
mdata = {};
mdata['honorific'] = "";
mdata["height"] = "";
mdata["weight"] = "";
mdata["title"] = "";

//methods
mMethods = {};
mMethods["onHeightPicker"] = onHeightPicker;
mMethods["onWeightPicker"] = onWeightPicker;
mMethods["onNextStep"] = onNextStep;

//vue加载完加载mui,当用到plus时先加载完plus基座再初始化mui
var vm = new Vue({
	el: '#main',
	data: mdata,
	methods: mMethods,
	mounted: function() {
		//pulsReady
		mui.plusReady(function() {
			mui.init();
			//			initPicker();
			var self = plus.webview.currentWebview();
			type = self.type;

			var titleDom = document.getElementById("title");
			if(self.opener().id == "waitingResult.html" && type == 2) {
				titleDom.innerHTML = "步骤三：完善个人资料";
				mdata["title"] = "步骤三：完善个人资料";
			} else {
				titleDom.innerHTML = "步骤二：完善个人资料";
				mdata["title"] = "步骤二：完善个人资料";
			}
			activateInfo = self.activateInfo;
			//			console.log(JSON.stringify(activateInfo));
			var info = g_storage.getActivateStorage(type, activateInfo);
			//                      alert(type);
			//                      alert(JSON.stringify(info));         
			if(!g_utils.isEmpty(info)) {
				personInfo = JSON.parse(info);
				if(!g_utils.isEmpty(personInfo.height)) {
					mdata.height = personInfo.height;
				}
				if(!g_utils.isEmpty(personInfo.weight)) {
					mdata.weight = personInfo.weight;
				}
			}

			refreshTip();
		});
	}
});

function refreshTip() {
	if(type == TYPE_OTHER) {
		mdata.honorific = getHonorific(activateInfo.name, activateInfo.identityCard);
		document.getElementById("call").classList.add("highlight");
	} else if(type == TYPE_MY) {
		mdata.honorific = "您";
	}
}

/*function initPicker() {
	heightPicker = new mui.PopPicker();
	heightPicker.setData(creatHeightDatas(MIN_HEIGHT, MAX_HEIGHT));

	weightPicker = new mui.PopPicker({
		layer: 3
	});
	weightPicker.setData(creatWeightDatas(MIN_WEIGHT_INTEGER, MAX_WEIGHT_INTEGER, MIN_WEIGHT_DECIMAL, MAX_WEIGHT_DECIMAL));
}*/

function onHeightPicker(height) {
	new KeyBoard(null, 0, {
		title: "身高",
		unit: "厘米",
		isInput: true,
		okCallback: function(backValue) {
			mdata.height = backValue+"厘米";
			saveChange(mdata.height, mdata.weight);
		},
		range:"90-250"
	});
	/*if(height != "") {
		heightPicker.pickers[0].setSelectedValue(height.replace("厘米", ""));
	}
	heightPicker.show(function(items) {
		mdata.height = items[0].text;
        saveChange(mdata.height,mdata.weight);
	});*/
}

function onWeightPicker(weight) {
	new KeyBoard(null, 1, {
		title: "体重",
		unit: "kg",
		isInput: true,
		okCallback: function(backValue) {
			mdata.weight =backValue+"kg";
			saveChange(mdata.height,mdata.weight);
		},
		range:"25.0-150.9"
	});
	/*if(weight != "") {
		wValue = weight.replace("kg", "").split(".");
		weightPicker.pickers[0].setSelectedValue(wValue[0]);
		weightPicker.pickers[1].setSelectedValue(wValue[1]);
	}
	weightPicker.show(function(items) {
		mdata.weight = items[0].text + "" + items[1].text + "kg";
        saveChange(mdata.height,mdata.weight);
	});*/
}

function onNextStep(height, weight) {
	if(g_utils.isEmpty(height)) {
		g_mui.alert("请选择身高！");
	} else if(g_utils.isEmpty(weight)) {
		g_mui.alert("请选择体重！");
	} else {
		//先拉取缓存在存入
		var info = g_storage.getActivateStorage(type, activateInfo);
		if(!g_utils.isEmpty(info)) {
			personInfo = JSON.parse(info);
		}
		personInfo['height'] = height;
		personInfo['weight'] = weight;
		var infoStr = JSON.stringify(personInfo);
		g_storage.setActivateStorage(type, infoStr, activateInfo);
		g_mui.openPage(g_module.improvePersonalData, 'improveHealthInfo.html', {
			type: type,
			activateInfo: activateInfo,
			titleStr: mdata["title"]
		});

	}
}

function saveChange(height, weight) {
	if(g_utils.isEmpty(height)) {
		height = "";
	} else if(g_utils.isEmpty(weight)) {
		weight = ""
	}
	//先拉取缓存在存入
	var info = g_storage.getActivateStorage(type, activateInfo);
	if(!g_utils.isEmpty(info)) {
		personInfo = JSON.parse(info);
	}
	personInfo['height'] = height;
	personInfo['weight'] = weight;
	var infoStr = JSON.stringify(personInfo);
	g_storage.setActivateStorage(type, infoStr, activateInfo);
}

/*
 * 根据最大值和最小值生成picker用身高Datas数组
 */
function creatHeightDatas(min, max) {
	var datas = [];
	for(var i = 0; i < max - min + 1; i++) {
		var data = {};
		data.value = min + i;
		data.text = min + i + "厘米";
		datas.push(data);
	}

	return datas;
}
/*
 * 根据最大值和最小值生成picker用体重Datas数组
 */
function creatWeightDatas(minInteger, maxInteger, minDecimal, maxDecimal) {
	var datas = [];
	var children = [];
	var secondchildren = [{
		value: 0,
		text: "kg"
	}]
	for(var i = 0; i < maxDecimal - minDecimal + 1; i++) {
		var childrenData = {};
		childrenData.value = (minDecimal + i);
		childrenData.text = "." + (minDecimal + i);
		childrenData.children = secondchildren;
		children.push(childrenData);
	}

	for(var j = 0; j < maxInteger - minInteger + 1; j++) {
		var data = {};
		data.value = minInteger + j;
		data.text = minInteger + j;
		data.children = children;
		datas.push(data);
	}

	return datas;
}

/**
 * 敬语
 * @param {Object} name
 * @param {Object} identityCard
 */
function getHonorific(name, identityCard) {
	return name + (getSexbyIdentityCard(identityCard) == 0 ? "女士" : "先生");
}
/**
 * 根据身份证号判断性别 0：女，1：男
 * @param {Object} identityCard
 */
function getSexbyIdentityCard(identityCard) {
	return identityCard.substring(16, 17) % 2 == 0 ? "0" : "1";
}