var areaPicker;
var titleDom = document.getElementById("title");
var type;
var activateInfo = "";
var personInfo = {}; //缓存的人物信息
//进入实名认证时的3种类型
var TYPE_MY = 0; //自己激活伙伙
var TYPE_NEW_OTHER = 1; //帮助他人时未提交实名认证
var TYPE_OTHER = 2; //帮助他人时提交了实名认证

//model
mdata = {};
mdata['honorific'] = "";
mdata["homePhone"] = "";
mdata["area"] = "";
mdata["detailAddr"] = "";

//methods
mMethods = {};
mMethods["onAreaPicker"] = onAreaPicker;
mMethods["onNextStep"] = onNextStep;

//vue加载完加载mui,当用到plus时先加载完plus基座再初始化mui
var vm = new Vue({
	el: '#main',
	data: mdata,
	methods: mMethods,
	mounted:function() {
		//pulsReady
		mui.plusReady(function() {
			mui.init();
			initAreaPicker();
			var self = plus.webview.currentWebview();
			type = self.type;
			activateInfo = self.activateInfo;
            titleDom.innerHTML = self.titleStr;
			var info = g_storage.getActivateStorage(type, activateInfo);
			if(!g_utils.isEmpty(info)) {
				personInfo = JSON.parse(info);
				if(!g_utils.isEmpty(personInfo.homePhone)) {
					mdata.homePhone = personInfo.homePhone;
				}
				if(!g_utils.isEmpty(personInfo.address)) {
					mdata.area = personInfo.address.split("-")[0];
					mdata.detailAddr = personInfo.address.split("-")[1];
				}
			}
			refreshTip();
		});
	}
});

function refreshTip() {
	if(type == TYPE_OTHER) {
		mdata.honorific = getHonorific(activateInfo.name, activateInfo.identityCard);
		document.getElementById("call").classList.add("highlight");
	} else if(type == TYPE_MY) {
		mdata.honorific = '您';
	}
}

function initAreaPicker() {
	areaPicker = new mui.PopPicker({
		layer: 3
	});
	areaPicker.setData(cityData3);
}

function onAreaPicker() {
	areaPicker.show(function(items) {
		if(g_utils.isEmpty((items[2] || {}).text)) {
			mdata.area = (items[0] || {}).text + " " + (items[1] || {}).text;
		} else {
			mdata.area = (items[0] || {}).text + " " + (items[1] || {}).text + " " + (items[2] || {}).text;  
		}
        saveChange(mdata.homePhone, mdata.area, mdata.detailAddr);
	});
}

function saveChange(homePhone, area, detailAddr)
{
    //先拉取缓存在存入
    var info = g_storage.getActivateStorage(type, activateInfo);
    if(!g_utils.isEmpty(info)) {
        personInfo = JSON.parse(info);
    }
    
    if (g_utils.isEmpty(homePhone)){
        homePhone = mdata.homePhone;
    }
 
    if (g_utils.isEmpty(area)){
        area= mdata.area;
    }
    if (g_utils.isEmpty(detailAddr)){
        detailAddr = mdata.detailAddr;
    }
    
    var address = null;
    if(!g_utils.isEmpty(area) && !g_utils.isEmpty(detailAddr)) {
        address = area + "-" + detailAddr;
    } else if(!g_utils.isEmpty(area)) {
        address = area;
    } else if(!g_utils.isEmpty(detailAddr)) {
        address = "-" + detailAddr;
    }
    personInfo['address'] = address;
    
    var infoStr = JSON.stringify(personInfo);
 //   alert(infoStr);
    g_storage.setActivateStorage(type, infoStr, activateInfo);
}

function onNextStep(homePhone, area, detailAddr) {
	/*if(!g_utils.isEmpty(homePhone)) {
		if(!g_utils.validateTel(homePhone)) {
			g_mui.alert("输入的家庭电话格式错误");
			return;
		}
	}*/
	var address = null;
	if(!g_utils.isEmpty(area) && !g_utils.isEmpty(detailAddr)) {
		address = area + "-" + detailAddr;
	} else if(!g_utils.isEmpty(area)) {
		address = area;
	} else if(!g_utils.isEmpty(detailAddr)) {
		address = "-" + detailAddr;
	}
	//先拉取缓存在存入
	var info = g_storage.getActivateStorage(type, activateInfo);
	if(!g_utils.isEmpty(info)) {
		personInfo = JSON.parse(info);
	}

	personInfo['homePhone'] = homePhone;
	personInfo['address'] = address;

	var infoStr = JSON.stringify(personInfo);
	g_storage.setActivateStorage(type, infoStr, activateInfo);

	var extras=getModifyInfoExtras(homePhone, address);
	
	g_tools.postCMD('modifyUserInfo',extras, function(result) {
		if(result.code == 0) {
			g_mui.openPage(g_module.improvePersonalData, 'emergencyContactList.html', {
				type: type,
				activateInfo: activateInfo,
                titleStr:titleDom.innerHTML
			});
		} else {
			g_mui.toast(result.tip);
		}
	}, g_tools.MODE_WEB, {
		noNetworkMode: g_tools.TIP_MODE_TOAST
	});
}

function getModifyInfoExtras(homePhone, address) {
	var extras = {};

	if(!g_utils.isEmpty(activateInfo.phone)) {
		extras['targetMonitorPhone'] = activateInfo.phone;
	}

	if(!g_utils.isEmpty(personInfo.height)) {
		extras['height'] = parseFloat(personInfo.height.replace("厘米", "")).toFixed(1);
	}
	if(!g_utils.isEmpty(personInfo.weight)) {
		extras['weight'] =parseFloat(personInfo.weight.replace("kg", "")).toFixed(2);
	}
	if(!g_utils.isEmpty(homePhone)) {
		extras['homePhone'] = homePhone;
	}
	if(!g_utils.isEmpty(address)) {
		extras['address'] = address;
	}
	if(!g_utils.isEmpty(personInfo.bloodTypeAbo)) {
		extras['bloodTypeAbo'] = personInfo.bloodTypeAbo;
	}
	if(!g_utils.isEmpty(personInfo.bloodTypeRh)) {
		extras['bloodTypeRh'] = personInfo.bloodTypeRh;
	}
	if(!g_utils.isEmpty(personInfo.medicalHistory)) {
		extras['medicalHistory'] = personInfo.medicalHistory;
	}
	if(!g_utils.isEmpty(activateInfo.identityCard)) {
		extras['sex'] = getSexbyIdentityCard(activateInfo.identityCard);
	}
	if(!g_utils.isEmpty(activateInfo.identityCard)) {
		extras['birthday'] = getBirthdayByIdentityCard(activateInfo.identityCard);
	}

	return extras;
}
/**
 * 敬语
 * @param {Object} name
 * @param {Object} identityCard
 */
function getHonorific(name, identityCard) {
	return name + (getSexbyIdentityCard(identityCard) == 0 ? "女士" : "先生");
}
/**
 * 根据身份证号判断性别 0：女，1：男
 * @param {Object} identityCard
 */
function getSexbyIdentityCard(identityCard) {
	return identityCard.substring(16, 17) % 2 == 0 ? "0" : "1";
}
/**
 * 根据身份证号获取生日
 * @param {Object} identityCard
 */
function getBirthdayByIdentityCard(identityCard) {
	birth=identityCard.substring(6, 10) + "-" + identityCard.substring(10, 12) + "-" + identityCard.substring(12, 14);
	return g_utils.stringToDate(birth).getTime();
}
