var aboPicker, rhPicker;
var aboDatas = [{
	value: "A型",
	text: "A型"
}, {
	value: "B型",
	text: "B型"
}, {
	value: "AB型",
	text: "AB型"
}, {
	value: "O型",
	text: "O型"
}];

var rhDatas = [{
	value: "RH阳性",
	text: "RH阳性"
}, {
	value: "RH阴性",
	text: "RH阴性"
}];

var type;
var activateInfo = "";
var personInfo = {}; //缓存的人物信息

var titleDom = document.getElementById("title");

//进入实名认证时的3种类型
var TYPE_MY = 0; //自己激活伙伙
var TYPE_NEW_OTHER = 1; //帮助他人时未提交实名认证
var TYPE_OTHER = 2; //帮助他人时提交了实名认证
//model
mdata = {};
mdata['honorific'] = "";
mdata["bloodTypeAbo"] = "";
mdata["bloodTypeRh"] = "";
mdata["medicalHistory"] =null;

//methods
mMethods = {};
mMethods["onAboPicker"] = onAboPicker;
mMethods["onRhPicker"] = onRhPicker;
mMethods["onNextStep"] = onNextStep;
//vue加载完加载mui,当用到plus时先加载完plus基座再初始化mui
var vm = new Vue({
	el: '#main',
	data: mdata,
	methods: mMethods,
	mounted:function() {
		//pulsReady
		mui.plusReady(function() {
			mui.init();
			initPickers();
			var self = plus.webview.currentWebview();
			type = self.type;
			activateInfo = self.activateInfo;
                      titleDom.innerHTML = self.titleStr;

			var info = g_storage.getActivateStorage(type, activateInfo);
			if(!g_utils.isEmpty(info)) {
				personInfo = JSON.parse(info);
				if(!g_utils.isEmpty(personInfo.bloodTypeAbo)) {
					mdata.bloodTypeAbo = personInfo.bloodTypeAbo;
				}
				if(!g_utils.isEmpty(personInfo.bloodTypeRh)) {
					mdata.bloodTypeRh = personInfo.bloodTypeRh;
				}
				if(!g_utils.isEmpty(personInfo.medicalHistory)) {
					mdata.medicalHistory = personInfo.medicalHistory;
				}
			}
			refreshTip();
		});
	}
});

function refreshTip() {
	if(type == TYPE_OTHER) {
		mdata.honorific =  getHonorific(activateInfo.name, activateInfo.identityCard);
		document.getElementById("call").classList.add("highlight");
	} else if(type == TYPE_MY) {
		mdata.honorific = '您';
	}
}

function initPickers() {
	aboPicker = new mui.PopPicker();
	aboPicker.setData(aboDatas);
	rhPicker = new mui.PopPicker();
	rhPicker.setData(rhDatas);
}

function onAboPicker(bloodTypeAbo) {
	if(bloodTypeAbo != "") {
		aboPicker.pickers[0].setSelectedValue(bloodTypeAbo);
	}
	aboPicker.show(function(items) {
		mdata.bloodTypeAbo = items[0].text;
        saveChange(mdata.bloodTypeAbo,null,null);
	});
}

function onRhPicker(bloodTypeRh) {
	if(bloodTypeRh != "") {
		rhPicker.pickers[0].setSelectedValue(bloodTypeRh);
	}
	rhPicker.show(function(items) {
		mdata.bloodTypeRh = items[0].text;
        saveChange(null,mdata.bloodTypeRh,null);
	});
}

function saveChange(bloodTypeAbo, bloodTypeRh, medicalHistory)
{
    var info = g_storage.getActivateStorage(type, activateInfo);
    if(!g_utils.isEmpty(info)) {
        personInfo = JSON.parse(info);
    }
    if (bloodTypeAbo){
        personInfo['bloodTypeAbo'] = bloodTypeAbo;
    }
    if (bloodTypeRh){
        personInfo['bloodTypeRh'] = bloodTypeRh;
    }
    if (medicalHistory){
        personInfo['medicalHistory'] = medicalHistory;
    }
    var infoStr = JSON.stringify(personInfo);
    g_storage.setActivateStorage(type, infoStr, activateInfo);
}

function onNextStep(bloodTypeAbo, bloodTypeRh, medicalHistory) {
	//先拉取缓存在存入
	var info = g_storage.getActivateStorage(type, activateInfo);
	if(!g_utils.isEmpty(info)) {
		personInfo = JSON.parse(info);
	}
	personInfo['bloodTypeAbo'] = bloodTypeAbo;
	personInfo['bloodTypeRh'] = bloodTypeRh;
	personInfo['medicalHistory'] = medicalHistory;
	var infoStr = JSON.stringify(personInfo);
	g_storage.setActivateStorage(type, infoStr, activateInfo);
	g_mui.openPage(g_module.improvePersonalData, 'improveFamilyInfo.html', {
		type: type,
		activateInfo: activateInfo,
        titleStr:titleDom.innerHTML
	});
}

/**
 * 敬语
 * @param {Object} name
 * @param {Object} identityCard
 */
function getHonorific(name, identityCard) {
	return name + (getSexbyIdentityCard(identityCard) == 0 ? "女士" : "先生");
}
/**
 * 根据身份证号判断性别 0：女，1：男
 * @param {Object} identityCard
 */
function getSexbyIdentityCard(identityCard) {
	return identityCard.substring(16, 17) % 2 == 0 ? "0" : "1";
}
