var type;
var titleDom = document.getElementById("title");
var activateInfo = "";
var personInfo = {}; //缓存的人物信息
//进入实名认证时的3种类型
var TYPE_MY = 0; //自己激活伙伙
var TYPE_NEW_OTHER = 1; //帮助他人时未提交实名认证
var TYPE_OTHER = 2; //帮助他人时提交了实名认证
var NORMAL_PRIORITY = 100;

//model
mdata = {};
mdata['honorific'] = "";
mdata["normalContacts"] = [];

//methods
mMethods = {};
mMethods["goAddNormalContact"] = goAddNormalContact;
mMethods["addContactByMail"] = addContactByMail;
mMethods["onNextStep"] = onNextStep;

var emergencyContacts=new Array();

//vue加载完加载mui,当用到plus时先加载完plus基座再初始化mui
var vm = new Vue({
	el: '#main',
	data: mdata,
	methods: mMethods,
	mounted:function() {
		//pulsReady
		mui.plusReady(function() {
			mui.init();
			//隐藏掉滚动条
			mui('.mui-scroll-wrapper').scroll({
				indicators: false
			});
			var self = plus.webview.currentWebview();
			type = self.type;
			activateInfo = self.activateInfo;
            titleDom.innerHTML = self.titleStr;
			
			var info = g_storage.getActivateStorage(type, activateInfo);
			
			if(!g_utils.isEmpty(info)) {
				personInfo = JSON.parse(info);
				if(!g_utils.isEmpty(personInfo.normalContacts)) {
					mdata.normalContacts = personInfo.normalContacts;
				}
				if(!g_utils.isEmpty(personInfo.emergencyContacts)) {
					emergencyContacts = personInfo.emergencyContacts;
				}
				
			}
			refreshTip();
			window.addEventListener('saveContact', function(event) {
				//通过event.detail可获得传递过来的参数内容
				var contacts = event.detail.normalContacts;
				mdata.normalContacts = contacts;
				saveChange(contacts);
			});

			window.addEventListener('exportContacts', function(event) {
				//通过event.detail可获得传递过来的参数内容
				var contacts = event.detail.chooseContacts;
				if(contacts!=null){
					for(var i=0;i<contacts.length;i++){
						var obj=new Object();
						obj.name=contacts[i].name;
						obj.phone=contacts[i].phone;
						obj.priority=NORMAL_PRIORITY;
						obj.relation='';
						mdata.normalContacts.push(obj);							
					}
					saveChange(mdata.normalContacts);
				}
			});

			scrollTopFixed('addTap', 'topAdd');
			swipeDeleteContact();
		});
	}
});

function refreshTip() {
	if(type == TYPE_OTHER) {
		mdata.honorific = getHonorific(activateInfo.name, activateInfo.identityCard);
		document.getElementById("call").classList.add("highlight");
	} else if(type == TYPE_MY) {
		mdata.honorific = '您';
	}
}
function swipeDeleteContact() {
	//左右滑出现删除按钮
	var btnArray = ['确认', '取消'];
	mui('#nList').on('tap', '.mui-btn', function(event) {
		var elem = this;
		var li = elem.parentNode.parentNode;
		g_mui.confirm('确认删除该联系人？', '确定删除', btnArray, function(e) {
			if(e.index == 0) {
				var index = li.firstChild.innerText;
				mdata.normalContacts.splice(index, 1);
				saveChange(mdata.normalContacts);
				setTimeout(function() {
					mui.swipeoutClose(li);
				}, 0);
				
			} else {
				setTimeout(function() {
					mui.swipeoutClose(li);
				}, 0);
			}
		});
	});
}

function goAddNormalContact(normalContacts) {
	var selectedContacts=normalContacts.slice();
	//选中号码中同时加入紧急联系人的号码
	for(var i=0;i<emergencyContacts.length;i++){
		selectedContacts.push(emergencyContacts[i]);
	}
	
	g_mui.openPage(g_module.improvePersonalData, 'addNormalContact.html', {
		'normalContacts': normalContacts,
		'selectedContacts': selectedContacts,  //所有选中的联系人（含紧急联系人）
          titleStr:titleDom.innerHTML
	});
}

function addContactByMail(normalContacts) {
	var selectedContacts=normalContacts.slice();
	//选中号码中同时加入紧急联系人的号码
	for(var i=0;i<emergencyContacts.length;i++){
		selectedContacts.push(emergencyContacts[i]);
	}
	
	g_mui.openSelectContacts({
    	selectedContacts: selectedContacts,
    	hearderTitle: '请从通讯录中选择（多选）',
    	isSingleMode: false
    });
}

function onNextStep(normalContacts) {
	if(!g_utils.isEmpty(normalContacts)) {
		//先拉取缓存在存入
		var info = g_storage.getActivateStorage(type, activateInfo);
		if(!g_utils.isEmpty(info)) {
			personInfo = JSON.parse(info);
		}
		
		personInfo['normalContacts'] = normalContacts;
		var infoStr = JSON.stringify(personInfo);
		g_storage.setActivateStorage(type, infoStr, activateInfo);
	}
	
	g_mui.openPage(g_module.improvePersonalData, 'requestFamilyCareList.html', {
		type: type,
		activateInfo: activateInfo,
        titleStr:titleDom.innerHTML
	});
}

function scrollTopFixed(id1, id2) {
	var obj1 = document.getElementById(id1);
	var height = obj1.offsetTop;

	var obj2 = document.getElementById(id2);
	var scroll = mui('.mui-scroll-wrapper').scroll();
	document.querySelector('.mui-scroll-wrapper').addEventListener('scroll', function(e) {
		var scrollTop = -scroll.y;
		if(scrollTop < height) {
			obj2.classList.add('mui-hidden');
		} else {
			obj2.classList.remove('mui-hidden');
		}
	});
}

/**
 * 敬语
 * @param {Object} name
 * @param {Object} identityCard
 */
function getHonorific(name, identityCard) {
	return name + (getSexbyIdentityCard(identityCard) == 0 ? "女士" : "先生");
}
/**
 * 根据身份证号判断性别 0：女，1：男
 * @param {Object} identityCard
 */
function getSexbyIdentityCard(identityCard) {
	return identityCard.substring(16, 17) % 2 == 0 ? "0" : "1";
}

function saveChange(normalContacts)
{
    //先拉取缓存在存入
    var info = g_storage.getActivateStorage(type, activateInfo);
    if(!g_utils.isEmpty(info)) {
        personInfo = JSON.parse(info);
    }
    personInfo['normalContacts'] = normalContacts;
    var infoStr = JSON.stringify(personInfo);
    g_storage.setActivateStorage(type, infoStr, activateInfo);
}
