var type;
var titleDom = document.getElementById("title");
var activateInfo = "";
var personInfo = {}; //缓存的人物信息
//进入实名认证时的3种类型
var TYPE_MY = 0; //自己激活伙伙
var TYPE_NEW_OTHER = 1; //帮助他人时未提交实名认证
var TYPE_OTHER = 2; //帮助他人时提交了实名认证

//model
mdata = {};
mdata["careMeList"] = [];
mdata['honorific'] = "";
mdata['person'] = "他";

//methods
mMethods = {};
mMethods["addCareMeByPhone"] = addCareMeByPhone;
mMethods["addCareMeByMail"] = addCareMeByMail;
mMethods["onFinish"] = onFinish;

//vue加载完加载mui,当用到plus时先加载完plus基座再初始化mui
var vm = new Vue({
	el: '#main',
	data: mdata,
	methods: mMethods,
	mounted: function() {
		//pulsReady
		mui.plusReady(function() {
			mui.init();
			//隐藏掉滚动条
			mui('.mui-scroll-wrapper').scroll({
				indicators: false
			});

			var self = plus.webview.currentWebview();
			type = self.type;
			activateInfo = self.activateInfo;
            titleDom.innerHTML = self.titleStr;
                      
			var info = g_storage.getActivateStorage(type, activateInfo);

			if(!g_utils.isEmpty(info)) {
				personInfo = JSON.parse(info);
				if(!g_utils.isEmpty(personInfo.careMeList)) {
					mdata.careMeList = personInfo.careMeList;
				}
				if(!g_utils.isEmpty(activateInfo.name) && !g_utils.isEmpty(activateInfo.identityCard)) {
					refreshTip(activateInfo.name, activateInfo.identityCard);
				}
			}
			window.addEventListener('saveCareMe', function(event) {
				//通过event.detail可获得传递过来的参数内容
				var careMeList = event.detail.careMeList;
                var isExist=false;
				if(careMeList!=null&&careMeList.length>0){
                    for (var i=0;i<mdata.careMeList.length;i++){
                        if (mdata.careMeList[i].phone == careMeList[careMeList.length-1].phone){
                                    isExist = true;
                        }
                    }
                    if (!isExist){
                        mdata.careMeList.push(careMeList[careMeList.length-1]);
                        saveChange(mdata.careMeList);
                    }else{
                        g_mui.toast('您所邀请的家人已存在于邀请列表中');
                    }
                    isExist=false;
				}
			});

			window.addEventListener('exportContacts', function(event) {
				//通过event.detail可获得传递过来的参数内容
				var contacts = event.detail.chooseContacts;
                var isExist=false;
				if(contacts!=null){
					for(var i=0;i<contacts.length;i++){
                        for (var j=0;j<mdata.careMeList.length;j++){
                            if (contacts[i].phone == mdata.careMeList[j].phone){
                                    isExist = true;
                            }
                        }
                        if (!isExist){
                            var obj=new Object();
                            obj.name=contacts[i].name;
                            obj.phone=contacts[i].phone;
                            mdata.careMeList.push(obj);
                        }
                        isExist=false;
					}
					saveChange(mdata.careMeList);
				}
			});
			scrollTopFixed('addTap', 'topAdd');
			swipeDeleteContact();
		});
	}
});

function refreshTip(name, identityCard) {
	if(type == TYPE_OTHER) {
		mdata.honorific = getHonorific(name, identityCard);
		mdata.person = getPerson(identityCard);
		document.getElementById("call").classList.add("highlight");
	} else if(type == TYPE_MY) {
		mdata.honorific = "您";
		mdata.person = "您";
	}
}

function addCareMeByPhone(careMeList) {
	g_mui.openPage(g_module.improvePersonalData, 'addFamilyCare.html', {
		'careMeList': careMeList
	});
}

function addCareMeByMail(careMeList) {
	g_mui.openSelectContacts({
    	selectedContacts: careMeList,
    	hearderTitle: '请选择多位家人（多选）',
    	isSingleMode: false
    });
}

function onFinish(careMeList) {
	var tip=mdata.honorific+'的个人资料即将提交，确定继续吗？';
	g_mui.confirm(tip, '温馨提示', ['取消', '确定'], function(e) {
        if(e.index == 1) {
        	confirmList(careMeList);
        }
   });
}

function confirmList(careMeList) {
	var emergencyContacts = personInfo.emergencyContacts;
	var normalContacts = personInfo.normalContacts;
	var contactArr = emergencyContacts.concat(normalContacts);
	var params={
		contactArr: JSON.stringify(contactArr)+''
	}
	
	if(type!=TYPE_MY){
		params.targetMonitorPhone=activateInfo.phone;
	}	
	g_tools.postCMD('addContactList', params, function(result) { 
		if(result.code == 0) {
			var params2={
				userArr: JSON.stringify(careMeList) + '' 
			}
			if(type!=TYPE_MY){
				params2.targetMonitorPhone=activateInfo.phone;
			}
			g_tools.postCMD('addCareMeList', params2, function(result1) {
				if(result1.code == 0) {
					g_tools.postCMD('setCompleteUserInfo', { //设置用户信息是否完善
						phone: activateInfo.phone,
						ifComplete: 1
					}, function(result2) {
						if(result2.code == 0) {
							//提交后状态发生改变，需重新拉取信息
							g_tools.postCMD('getActivateInfoList', null, function(result3) {
								if(result3.code == 0) {
									var activateInfoList = result3.data;
									//刷新
									var wObj = plus.webview.getWebviewById('insertMyCareGuide');
									if(wObj != null) {
										mui.fire(wObj, 'allFinish', {
											activateInfoList: activateInfoList
										});
									}
									var resultList1 = plus.webview.getWebviewById('waitingResult.html');
									var resultList2 = plus.webview.getWebviewById('registerSuccess.html');
									var resultList3 = plus.webview.getWebviewById(g_module.insertMyCareGuide.ID+':otherActiveInfoList.html');

									if(resultList1 != null) {
										//无动画效果
										plus.webview.close(resultList1, "none");
									}
									if(resultList2 != null) {
										//无动画效果
										plus.webview.close(resultList2, "none");
									}
									if(resultList3 != null) {
										//无动画效果
										plus.webview.close(resultList3, "none");
									}
									
									g_mui.closeModule(g_module.improvePersonalData);
								} else {
									g_mui.toast(result3.tip);
								}
							});
						}
					});

				} else {
					g_mui.toast(result1.tip);
				}
			});
		} else {
			g_mui.toast(result.tip);
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE, {
		noNetworkMode: g_tools.TIP_MODE_TOAST
	});
}

function swipeDeleteContact() {
	//左右滑出现删除按钮
	var btnArray = ['确认', '取消'];
	mui('#cList').on('tap', '.mui-btn', function(event) {
		var elem = this;
		var li = elem.parentNode.parentNode;
		g_mui.confirm('确认删除该关爱人？', '确定删除', btnArray, function(e) {
			if(e.index == 0) {
				var index = li.firstChild.innerText;
				mdata.careMeList.splice(index, 1);
				setTimeout(function() {
					mui.swipeoutClose(li);
				}, 0);
				/*li.parentNode.removeChild(li);*/
			} else {
				setTimeout(function() {
					mui.swipeoutClose(li);
				}, 0);
			}
		});
	});
}

function scrollTopFixed(id1, id2) {
	var obj1 = document.getElementById(id1);
	var height = obj1.offsetTop;

	var obj2 = document.getElementById(id2);
	var scroll = mui('.mui-scroll-wrapper').scroll();
	document.querySelector('.mui-scroll-wrapper').addEventListener('scroll', function(e) {
		var scrollTop = -scroll.y;
		if(scrollTop < height) {
			obj2.classList.add('mui-hidden');
		} else {
			obj2.classList.remove('mui-hidden');
		}
	});
}

/**
 * 人称 (她/他)
 * @param {Object} name
 * @param {Object} identityCard
 */
function getPerson(identityCard) {
	return getSexbyIdentityCard(identityCard) == 0 ? "她" : "他";
}
/**
 * 敬语
 * @param {Object} name
 * @param {Object} identityCard
 */
function getHonorific(name, identityCard) {
	return name + (getSexbyIdentityCard(identityCard) == 0 ? "女士" : "先生");
}
/**
 * 根据身份证号判断性别 0：女，1：男
 * @param {Object} identityCard
 */
function getSexbyIdentityCard(identityCard) {
	return identityCard.substring(16, 17) % 2 == 0 ? "0" : "1";
}

/**
 * 根据人物类型取数据
 */
function getStorage() {
	if(personType == PERSON_TYPE_OTHER) {
		return g_storage.get(g_storage.USER_ACTIVATE_INFO_OTHER);
	} else if(personType == PERSON_TYPE_MY) {
		return g_storage.get(g_storage.USER_ACTIVATE_INFO_MY);
	}
	return null;
}
/**
 * 根据任务类型存数据
 * @param {Object} value
 */
function setStorage(value) {
	if(personType == PERSON_TYPE_OTHER) {
		g_storage.set(g_storage.USER_ACTIVATE_INFO_OTHER, value);
	} else if(personType == PERSON_TYPE_MY) {
		g_storage.set(g_storage.USER_ACTIVATE_INFO_MY, value);
	}
}

/**
 * 进入模块的指定页
 * @param {Object} url
 * @param {Object} id
 * @param {Object} extras
 * @param {Object} aniShow
 */
function openModuleByUrl(path, id, extras, aniShow) {
	if(aniShow == null || aniShow == undefined) aniShow = 'slide-in-right';
	if(extras == null || extras == undefined) extras = {};
	var url = g_formatPathToUrl(path);
	return g_mui.openWindow({
		url: url,
		id: id,
		show: {
			autoShow: true, //页面loaded事件发生后自动显示，默认为true
			aniShow: aniShow,
			duration: 300
		},
		extras: extras,
		waiting: {
			autoShow: false, //自动显示等待框，默认为true
		},
		styles: {
			render: 'always',
			scrollIndicator: 'none'
		}
	})
}

function saveChange(careMeList){
    //先拉取缓存在存入
    var info = g_storage.getActivateStorage(type, activateInfo);
    if(!g_utils.isEmpty(info)) {
        personInfo = JSON.parse(info);
    }
    personInfo['careMeList'] = careMeList;
    var infoStr = JSON.stringify(personInfo);
    g_storage.setActivateStorage(type, infoStr, activateInfo);
}
