var activateInfo = "";
//进入实名认证时的3种类型
var TYPE_MY = 0; //自己激活伙伙
var TYPE_NEW_OTHER = 1; //帮助他人时未提交实名认证
var TYPE_OTHER = 2; //帮助他人时提交了实名认证

//model
mdata = {};
mdata['activateInfoList'] = [];

//mMethods
mMethods = {};
mMethods["getOtherTip"] = getOtherTip;
mMethods["onTapList"] = onTapList;
mMethods["newOther"] = newOther;

//vue加载完加载mui,当用到plus时先加载完plus基座再初始化mui
var vm = new Vue({
	el: '#main',
	data: mdata,
	methods: mMethods,
	mounted: function() {
		//pulsReady
		mui.plusReady(function() {
			//mui初始化
			mui.init();
			getActivateInfoList();
			document.addEventListener('otherChange', function(e) {
				mdata.activateInfoList = e.detail.activateInfoList;
//				console.log('otherChange:' + JSON.stringify(mdata.activateInfoList));
			}, false);
		});
	}
});

/**
 * 得到他人的激活伙伙信息列表
 * @param {Object} activateInfoList
 */
function getOtherActivateList(activateInfoList) {
	var otherList = [];
   // alert(JSON.stringify(activateInfoList));
	var loginUserId = g_storage.get(g_storage.DEVICE_USER_ID);
	if(!g_utils.isEmptyArray(activateInfoList)) {
		for(var i = 0; i < activateInfoList.length; i++) {
			if(activateInfoList[i].userId != loginUserId) {
				otherList.push(activateInfoList[i]);
			}
		}
	}
	return otherList;
}

function getActivateInfoList() {
	g_tools.postCMD('getActivateInfoList', null, function(result) {
		if(result.code == 0) {
			mdata.activateInfoList = result.data;
			removeOtherCacheHaveFinish(mdata.activateInfoList);
		} else {
//			console.log(JSON.stringify(result));
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE, {
		noNetworkMode:g_tools.TIP_MODE_INTERFACE, //界面显示断网提示内容的模式
		contentDomId:'mainContent',  //显示数据内容的dom元素id
		tipDomId:'noNetworkTip'  //显示断网提示的dom元素id
	});
}

function getOtherTip(otherActivateInfo) {
	var tip = "";
	if(otherActivateInfo.realNameAuthStatus == 1) { //审核中
		if(otherActivateInfo.userId == "") {
			tip = "实名审核中，请注册账号";
		} else if(otherActivateInfo.isCompleteUserInfo == 0) {
			tip = "实名审核中，请完善资料";
		} else {
			tip = "实名认证审核中";
		}
	} else if(otherActivateInfo.realNameAuthStatus == 2) { //未通过
		tip = "实名审核未通过，请重新提交";
	} else if(otherActivateInfo.realNameAuthStatus == 3) { //已通过
		if(otherActivateInfo.userId == "") {
			tip = "实名审核已通过，请注册账号";
		} else if(otherActivateInfo.isCompleteUserInfo == 0) {
			tip = "实名审核已通过，请完善资料";
		} else if(otherActivateInfo.userId != "" && otherActivateInfo.isCompleteUserInfo == 1) {
			tip = "实名认证已通过";
		}
	}
	return tip;
}

function getOtherClass(otherActivateInfo)
{
    var class_vue = "mui-navigate";
    if(otherActivateInfo.realNameAuthStatus == 3) {
        if(otherActivateInfo.userId != "" && otherActivateInfo.isCompleteUserInfo == 1)
        {
            class_vue =  "mui-navigate";
        }else{
            class_vue =  "mui-navigate-right";
        }
    }else if (otherActivateInfo.realNameAuthStatus == 2 || otherActivateInfo.realNameAuthStatus == 3)
    {
        class_vue =  "mui-navigate-right";
    }
    return class_vue;
}

function newOther() {
	g_mui.openModule(g_module.certification, {
		type: TYPE_NEW_OTHER,
		activateInfo: activateInfo
	});
}

function onTapList(otherActivateInfo) {
	if(!(otherActivateInfo.realNameAuthStatus == 3 && otherActivateInfo.userId != "" && otherActivateInfo.isCompleteUserInfo == 1)) {
		if(otherActivateInfo.realNameAuthStatus == 0) {
			g_mui.openModule(g_module.certification, {
				type: TYPE_OTHER,
				activateInfo: otherActivateInfo
			});
		/*} else if(otherActivateInfo.realNameAuthStatus == 2) { //未通过
			//此状态有可能缓存被删掉，这里根据网上信息重置下缓存
			var info = g_storage.getActivateStorage(TYPE_OTHER, otherActivateInfo);
			if(g_utils.isEmpty(info)) {
				reSetNoPassStorage(TYPE_OTHER, otherActivateInfo);
			}

			g_mui.openModule(g_module.certification, {
				type: TYPE_OTHER,
				activateInfo: otherActivateInfo
			});
			openModuleByUrl('moduleLocal/certification/waitingResult.html', 'waitingResult.html', {
				type: TYPE_OTHER,
				activateInfo: otherActivateInfo,
				activateInfoList: mdata.activateInfoList
			});*/
		} else if(otherActivateInfo.realNameAuthStatus == 1 || otherActivateInfo.realNameAuthStatus == 2||otherActivateInfo.realNameAuthStatus == 3) {
			openModuleByUrl('moduleLocal/certification/waitingResult.html', 'waitingResult.html', {
				type: TYPE_OTHER,
				activateInfo: otherActivateInfo,
				activateInfoList: mdata.activateInfoList
			});
		}
	}
}

function isFinishOther(otherActivateInfo) {
	if(g_utils.isEmpty(otherActivateInfo.realNameAuthStatus) && g_utils.isEmpty(otherActivateInfo.isCompleteUserInfo)) {
		return false;
	} else {
		if(otherActivateInfo.realNameAuthStatus == 3 && otherActivateInfo.userId != "" && otherActivateInfo.isCompleteUserInfo == 1) {
			return true;
		}
		return false;
	}
}

//如果帮他人激活伙伙的实名认证通过并且其它流程进行完毕，这里把对应缓存删除掉，因为以后都不会用到
function removeOtherCacheHaveFinish(activateInfoList) {
	var otherActivateList = getOtherActivateList(activateInfoList);
	for(var i in activateInfoList) {
		var otherActivateInfo= activateInfoList[i];
		if(isFinishOther(otherActivateInfo)) {
			g_storage.removeActivateStorage(TYPE_OTHER, otherActivateInfo);
		}
	}
}


/**
 * 进入模块的指定页
 * @param {Object} url
 * @param {Object} id
 * @param {Object} extras
 * @param {Object} aniShow
 */
function openModuleByUrl(path, id, extras, aniShow) {
	if(aniShow == null || aniShow == undefined) aniShow = 'slide-in-right';
	if(extras == null || extras == undefined) extras = {};
	var url = g_formatPathToUrl(path);
	return g_mui.openWindow({
		url: url,
		id: id,
		show: {
			autoShow: true, //页面loaded事件发生后自动显示，默认为true
			aniShow: aniShow,
			duration: 300
		},
		extras: extras,
		waiting: {
			autoShow: false, //自动显示等待框，默认为true
		},
		styles: {
			render: 'always',
			scrollIndicator: 'none'
		}
	})
}
