var sexPicker, birthdayPicker, heightPicker, weightPicker;
var MIN_HEIGHT = 90;
var MAX_HEIGHT = 250;
var MIN_WEIGHT_INTEGER = 25; //体重整数部分
var MAX_WEIGHT_INTEGER = 150;
var MIN_WEIGHT_DECIMAL = 0; //体重小数部分
var MAX_WEIGHT_DECIMAL = 9;

//mui初始化
mui.init();
mui.plusReady(function() {
	var currentWebview = plus.webview.currentWebview();
	if(currentWebview.id == g_module.insertMyHealthCard2.ID) {
		plus.navigator.closeSplashscreen();
		mui.back = function() {
			g_tools.logout();
		}
	}
	//model
	mdata = {};
	mdata["sex"] = "";
	mdata["birthday"] = "";
	mdata["height"] = "170厘米";
	mdata["weight"] = "65kg";
	mdata["birthdayMills"] = 0;

	//methods
	mMethods = {};

	mMethods["onSexPicker"] = onSexPicker;
	mMethods["onBirthdayPicker"] = onBirthdayPicker;
	mMethods["onHeightPicker"] = onHeightPicker;
	mMethods["onWeightPicker"] = onWeightPicker;
	mMethods["onNextStep"] = onNextStep;

	var vm = new Vue({
		el: '#main',
		data: mdata,
		methods: mMethods,
		mounted: function() {
			getParamAndInitDom();
		}
	});

	initPicker();
});

function getParamAndInitDom() {
	var self = plus.webview.currentWebview();
	if(!g_utils.isEmpty(self.userInfo)) {
		var userInfo = JSON.parse(self.userInfo);
		if(!g_utils.isEmpty(userInfo.sex)) {
			if(userInfo.sex == 1) {
				mdata["sex"] = "男";
			} else if(userInfo.sex == 0) {
				mdata["sex"] = "女";
			}
		}
		if(!g_utils.isEmpty(userInfo.birthday)) {
			var birthday_str = g_utils.dateFormat(userInfo.birthday, "yyyy年MM月dd日");
			mdata["birthday"] = birthday_str;
			mdata["birthdayMills"] = userInfo.birthday;
		}
		if(!g_utils.isEmpty(userInfo.height)) {
			if(userInfo.height == 0) {
				userInfo.height = 170;
			}
			mdata["height"] = userInfo.height + "厘米";
		}
		if(!g_utils.isEmpty(userInfo.weight)) {
			if(userInfo.weight == 0) {
				userInfo.weight = 65;
			}
			mdata["weight"] = userInfo.weight + "kg";
		}
	}
}

function initPicker() {
	//性别
	sexPicker = new mui.PopPicker();
	sexPicker.setData([{
		value: "1",
		text: '男'
	}, {
		value: "0",
		text: '女'
	}]);
	//生日
	var nowDate = new Date();
	var nowYear = nowDate.getFullYear() - 1;
	var beginYear = nowYear - 100;
	var optionsJson = '{"type":"date","beginYear":' + beginYear + ',"endYear":' + nowYear + ',"value":"1990-10-10"}';
	var options = JSON.parse(optionsJson);
	birthdayPicker = new mui.DtPicker(options);
	/*//身高
	heightPicker = new mui.PopPicker();
	heightPicker.setData(creatHeightDatas(MIN_HEIGHT, MAX_HEIGHT));
	//体重
	weightPicker = new mui.PopPicker({
		layer: 3
	});
	weightPicker.setData(creatWeightDatas(MIN_WEIGHT_INTEGER, MAX_WEIGHT_INTEGER, MIN_WEIGHT_DECIMAL, MAX_WEIGHT_DECIMAL));*/
}

function onSexPicker(sex) {
	if(sex != "") {
		var sexValue = 0;
		if(sex == '男') {
			sexValue = 1;
		}
		sexPicker.pickers[0].setSelectedValue(sexValue);
	}
	sexPicker.show(function(items) {
		mdata.sex = items[0].text;
	});
}

function onBirthdayPicker(birthday) {
	if(birthday != "") {
		birthday = birthday.replace(/(\d{4}).(\d{1,2}).(\d{1,2}).+/mg, '$1-$2-$3');
		birthdayPicker.setSelectedValue(birthday);
	}
	birthdayPicker.show(function(items) {
		var year = items.y.text;
		var month = items.m.text;
		var day = items.d.text;
		mdata.birthdayMills = Date.parse(month + "/" + day + "/" + year);
		mdata.birthday = g_utils.dateFormat(mdata.birthdayMills, "yyyy年MM月dd日");
		//      alert(JSON.stringify(items));
	});
}

function onHeightPicker(height) {
	/*if(height != "") {
		heightPicker.pickers[0].setSelectedValue(height.replace("厘米", ""));
	}
	heightPicker.show(function(items) {
		mdata.height = items[0].text;
	});*/

	new KeyBoard(null, 0, {
		title: "身高",
		unit: "厘米",
		isInput: true,
		okCallback: function(backValue) {
			mdata.height = backValue+"厘米";
		},
		range:"90-250"
	});

}

function onWeightPicker(weight) {
	/*if(weight != "") {
		wValue = weight.replace("kg", "").split(".");
		weightPicker.pickers[0].setSelectedValue(wValue[0]);
		weightPicker.pickers[1].setSelectedValue(wValue[1]);
	}
	weightPicker.show(function(items) {
		mdata.weight = items[0].text + "" + items[1].text + "kg";
	});*/
	new KeyBoard(null, 1, {
		title: "体重",
		unit: "kg",
		isInput: true,
		okCallback: function(backValue) {
			mdata.weight = backValue+"kg";
		},
		range:"25.0-150.9"
	});
}

function onNextStep(sex, birthdayMills, height, weight) {
	if(g_utils.isEmpty(sex)) {
		g_mui.alert("请选择性别！");
	} else if(g_utils.isEmpty(birthdayMills)) {
		g_mui.alert("请选择生日！");
	} else if(g_utils.isEmpty(height)) {
		g_mui.alert("请选择身高！");
	} else if(g_utils.isEmpty(weight)) {
		g_mui.alert("请选择体重！");
	} else {

		var personInfo = {};
		var sexInt = "0";
		if(sex == "男") {
			sexInt = "1";
		}
		var heightStr = "" + height;
		heightStr = heightStr.replace('厘米', '');
		var weightStr = "" + weight;
		weightStr = weightStr.replace('kg', '');
		personInfo['sex'] = sexInt;
		personInfo['birthdayMills'] = "" + birthdayMills;
		personInfo['height'] = heightStr;
		personInfo['weight'] = weightStr;
		var baseInfo = JSON.stringify(personInfo);
		//alert(baseInfo);
		g_mui.openPage(g_module.insertMyHealthCard, 'selectDataSource.html', {
			baseInfo: baseInfo
		});

	}
}

/*
 * 根据最大值和最小值生成picker用身高Datas数组
 */
function creatHeightDatas(min, max) {
	var datas = [];
	for(var i = 0; i < max - min + 1; i++) {
		var data = {};
		data.value = min + i;
		data.text = min + i + "厘米";
		datas.push(data);
	}

	return datas;
}
/*
 * 根据最大值和最小值生成picker用体重Datas数组
 */
function creatWeightDatas(minInteger, maxInteger, minDecimal, maxDecimal) {
	var datas = [];
	var children = [];
	var secondchildren = [{
		value: 0,
		text: "kg"
	}]
	for(var i = 0; i < maxDecimal - minDecimal + 1; i++) {
		var childrenData = {};
		childrenData.value = (minDecimal + i);
		childrenData.text = "." + (minDecimal + i);
		childrenData.children = secondchildren;
		children.push(childrenData);
	}

	for(var j = 0; j < maxInteger - minInteger + 1; j++) {
		var data = {};
		data.value = minInteger + j;
		data.text = minInteger + j;
		data.children = children;
		datas.push(data);
	}

	return datas;
}