var scale;
var userInfo;
var sex = 1;			   //默认 1：男
var height = 170;
var danceEveryHour = 150; //跳舞每小时消耗卡路里
var rideEveryHour = 510; //骑车每小时消耗卡路里
var getEnergy = 200;
var START_ENERGY = 10;
//mui初始化
mui.init();
mui.plusReady(function() {
	var self = plus.webview.currentWebview();
	var userInfo = self.userInfo;
	if(userInfo.sex>=0){
		sex =userInfo.sex;
	}
	if(!g_utils.isEmpty(userInfo.height)){
		height=userInfo.height;
	}
	
	scale = new scale('progress_btn', 'progress', 'kcalValue');
	scale.setValue();
	getDailyTargetByDay();
	var saveBtn=document.getElementById('saveBtn');
	saveBtn.addEventListener('tap', function(e) {
		saveDailyTarget();
	});
	
	document.getElementById('targetArea').addEventListener('tap', function(e) {
		var kcalValue=document.getElementById('kcalValue');
		new KeyBoard(kcalValue,0,{
			isInput: false,
			okCallback:function(backValue){
				getEnergy =backValue;
				scale.setValue();
			},
			range:"10-1000",
		});
	});
	
});

function getDailyTargetByDay() {
	var currDate = g_utils.todayFormat();
	g_tools.postCMD('getDailyTargetByDay', {
		date: currDate
	}, function(result) {
		if(result.code == 0) {
			var energy = result.data.energy;
			if(!g_utils.isEmpty(energy)) {
				getEnergy = energy;
			}
			scale.setValue();
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE);
}


function saveDailyTarget() {
	var currDate = g_utils.todayFormat();
	var saveEnergy = document.getElementById('kcalValue').innerHTML;
	var data = {
		date: currDate,
		energy: saveEnergy
	};
	g_tools.postCMD('saveDailyTarget', {
		date: currDate,
		energy: saveEnergy
	}, function(result) {
		if(result.code == 0) {
			g_mui.toast("每日目标修改成功");
			getDailyTargetByDay();
			closeme();
		}else{
			g_mui.toast("每日目标修改失败");
		}
		
	}, g_tools.MODE_WEB_LOCAL_CACHE);
}

// 关闭自身窗口
function closeme(){
	var ws=plus.webview.currentWebview();
	plus.webview.close(ws);
}
var scale = function(btn, bar, title) {
	this.btn = document.getElementById(btn);
	this.bar = document.getElementById(bar);
	this.title = document.getElementById(title);
	this.init();
};
scale.prototype = {
	init: function() {
		var f = this,
			g = document,
			b = window,
			m = Math;
		f.btn.ontouchstart = function(e) {
			var x = (e || b.event).touches[0].clientX;
			var l = this.offsetLeft;
			var max = f.bar.offsetWidth - this.offsetWidth;
			f.bar.ontouchmove = function(e) {
				var thisX = (e || b.event).touches[0].clientX;
				var to = m.min(max, m.max(0, l + (thisX - x)));
				f.btn.style.left = to + 'px';
				var pos = m.round(m.max(0, to / max) * 990);
				f.ondrag(pos, to);
				b.getSelection ? b.getSelection().removeAllRanges() : g.selection.empty();
			};
			f.bar.ontouchend = new Function('this.onmousemove = null');
		};
	},
	setValue: function() {
		var f = this,
			b = window,
			m = Math;
		var sValue = getEnergy - START_ENERGY;
		var max = f.bar.offsetWidth - f.btn.offsetWidth;
		var btnLeftValue = Math.round(Math.max(0, sValue / 990) * max);
		f.btn.style.left = btnLeftValue + 'px';
		f.title.innerHTML = getEnergy;
		setSportShow(getEnergy);
		b.getSelection ? b.getSelection().removeAllRanges() : g.selection.empty();
	},
	ondrag: function(pos, x) {
		setSportShow(pos + START_ENERGY);
		this.title.innerHTML = pos + START_ENERGY;
	}
}

/**
 * 计算走路步幅大小
 */
function getWalkStepStride() {
	var mHeight = height / 100;
	if(sex == 1) // 男
		return(mHeight * 0.415);
	else if(sex == 0) { // 女
		return(mHeight * 0.413);
	}
}

/**
 * 根据卡路里目标计算走路需要的步数
 * 
 * @param target
 * @return
 */
function walkTargetStep(target) {
	var step = 0; // 步数
	var stepStride = getWalkStepStride(); // 步幅
	step = (target / (0.045 * stepStride));

	return Math.round(step);
}

/**
 * 根据卡路里目标计算跳舞分钟数
 */
function danceTargetMinutes(target) {
	var danceEveryMinute = danceEveryHour / 60;
	return Math.round(target / danceEveryMinute);
}

/**
 * 根据卡路里目标计算骑车分钟数
 */
function rideTargetMinutes(target) {
	var rideEveryMinute = rideEveryHour / 60;
	return Math.round(target / rideEveryMinute);
}

function setSportShow(target) {
	var walkStep = walkTargetStep(target);
	var danceMinutes = danceTargetMinutes(target);
	var rideMinutes = rideTargetMinutes(target);
	document.getElementById('walkStep').innerHTML = walkStep + '步';
	document.getElementById('danceMinutes').innerHTML = danceMinutes + '分钟';
	document.getElementById('rideMinutes').innerHTML = rideMinutes + '分钟';
}