var _tipContentDom = document.getElementById('tipContent');
var _missionContentDom = document.getElementById('missionContent');
var _rewardNumDom = document.getElementById('rewardNum');
var _btnDom = document.getElementById('bottomBtn');

var _missionData;
var _isComplete = 0;
var _missionIdArr = '';
var _missionId = '';

var _planId = '';
var _startTime = 0;
var _endTime = 0;

var _inPost = false;

mui.plusReady(function() {
    getParamAndInitDom();
    initBtn();
              
    initProcessDom(_missionData.currentExecuteCount,_missionData.mission.count);
                        
    if (_missionData.mission.day != 1){
        _tipContentDom.classList.remove('mui-hidden');
        getLastTimeForRecord();
    }
    if (_missionData.mission.count > 1){
        _btnDom.innerHTML = '打卡';
    }
});

function getParamAndInitDom() {
    _self = plus.webview.currentWebview();
    if(!g_utils.isEmpty(_self.missionData)) {
        _missionData = JSON.parse(_self.missionData);
        //alert(JSON.stringify(_missionData));
    }
    if(!g_utils.isEmpty(_self.isComplete)) {
        _isComplete = _self.isComplete;
        if (_isComplete == 1){
            var completeIconDom = document.getElementById('completeIcon');
            completeIconDom.classList.add('img-loaded');
            completeIconDom.classList.remove('mui-hidden');
            _btnDom.classList.add('mui-hidden');
        }
    }
    if(!g_utils.isEmpty(_self.missionIdArr)) {
        _missionIdArr = _self.missionIdArr;
    }
    if(!g_utils.isEmpty(_self.missionId)) {
        _missionId = _self.missionId;
    }
    
    var mission = _missionData.mission;
    var typeName = mission.typeName;  //运动名
    var min = mission.min;
    var day = mission.day;
    var count = mission.count;

    _missionContentDom.innerHTML = '完成' + typeName +'：' + day + '日' + count + '次，每次' + min + '分钟';

    var limitPoints = _missionData.limitPoints;
    _rewardNumDom.innerHTML = limitPoints + '积分';
}

function initBtn(){
    _btnDom.addEventListener('tap', function() {
        if (!_inPost){
            _inPost = true;
                             
            g_tools.postCMD('missionUpdate', {
                id: _missionId,
                code: 'PM_007'
            }, function(res) {
                if(res.code == 0) {
                    reGetData();
                                                                                 
                    g_fire.updateAllMission({
                        missionIdArr: _missionIdArr
                    });
                } else {
                    g_mui.alert(res.tip);
                }
            });
        }
        
    });
}


function getLastTimeForRecord(){
    g_tools.postCMD('getCurrentMissionInfo', {
        idArr:_missionIdArr
    }, function(res) {
        if(res.code == 0) {
            var planMissionList = res.data;
            for (var i = 0;i < planMissionList.length;i++){
                if (_missionId == planMissionList[i].id){
                    _planId = planMissionList[i].planId;
                }
            }
                    
            if (!g_utils.isEmpty(_planId)){
                g_tools.postCMD('getPlanInfoByPlanId2', {
                    planId: _planId
                }, function(res) {
                            //    alert('getPlanInfoByPlanId2:' + JSON.stringify(res));
                    if(res.code == 0) {
                        _startTime = res.data.startTime;
                        _endTime = res.data.endTime;
                                
                        g_tools.postCMD('getCompletedPlanMissionByUserId', {
                            code: _missionData.code,
                            userId: g_tools.getUserId,
                            typeName: _missionData.mission.typeName
                        }, function(res) {
                             //  alert('getCompletedPlanMissionByUserId:' + JSON.stringify(res));
                            if(res.code == 0) {
                                var missionList = res.data;
                                var lastCompleteTime = 0;
                                for (var j = 0;j < missionList.length;j++){
                                    if (!g_utils.isEmpty(missionList[j].completeTime)){
                                        if (missionList[j].completeTime >= _startTime && missionList[j].completeTime<= _endTime){
                                            if (missionList[j].completeTime > lastCompleteTime){
                                                lastCompleteTime = missionList[j].completeTime
                                        
                                                var time = new Date(lastCompleteTime);
                                                time.setHours(0);
                                                time.setMinutes(0);
                                                time.setSeconds(0);
                                                lastCompleteTime = time.getTime();
                                            }
                                        }
                                    }
                                }
                                        
                                //如果存在lastCompleteTime则显示
                                if (lastCompleteTime != 0){
                                    var nowTime = new Date();
                                    var nDays = Math.abs(parseInt((nowTime.getTime() - lastCompleteTime)/1000/3600/24));
                                        
                                    var lastTimeStr = g_printTools.printDateStrByTimeMillis(lastCompleteTime);
                                                                                        
                                    var dayGoStr = '';
                                    if (nDays != 0){
                                        dayGoStr = '（' + nDays + '天前）'
                                    }
                                    _tipContentDom.innerHTML = '上次打卡日期：' + lastTimeStr + dayGoStr;
                                }else{
                                    _tipContentDom.innerHTML = '上次打卡日期：无';
                                }
                                
                            }
                        });
                    }
                });
                
            }

        }
    });
}

function initProcessDom(currentExecuteCount,count){
    var processContentDom = document.getElementById('processContent');
                                
    if (_isComplete == 1){
        processContentDom.innerHTML = '今天的任务已完成';
        var todayMissionProcessDone = document.getElementById('todayMissionProcessDone');
        var todayMissionProcessDoneTipContainer = document.getElementById('todayMissionProcessDoneTipContainer');
        var userPoits = document.getElementById('userPoits');
        var percent = Math.min(parseInt((count / count) * 100), 100);
        todayMissionProcessDone.style.width = percent + '%';
        todayMissionProcessDoneTipContainer.style.width = percent + '%';
        userPoits.innerHTML = count+'/'+count;
        userPoits.className = 'mission_complete';
        return;
    }
    
    if (currentExecuteCount != count){
        processContentDom.innerHTML = '今天还有' + (count-currentExecuteCount) + '次需要完成';
    }else{
        processContentDom.innerHTML = '今天的任务已完成';
    }
            
    var todayMissionProcessDone = document.getElementById('todayMissionProcessDone');
    var todayMissionProcessDoneTipContainer = document.getElementById('todayMissionProcessDoneTipContainer');
    var userPoits = document.getElementById('userPoits');
    var percent = Math.min(parseInt((currentExecuteCount / count) * 100), 100);
    todayMissionProcessDone.style.width = percent + '%';
    todayMissionProcessDoneTipContainer.style.width = percent + '%';
    userPoits.innerHTML = currentExecuteCount+'/'+count;
    if (currentExecuteCount == count){
       userPoits.className = 'mission_complete';
    }
}

function reGetData(){
    g_tools.postCMD('getCurrentMissionInfo',{
        idArr:_missionIdArr
    },function(result) {
        _inPost = false;
        if(result.code == 0) {
        //刷新计划任务数据
            var planMissionList = result.data;
            for (var i = 0;i < planMissionList.length;i++){
                if (_missionId == planMissionList[i].id){
                    _isComplete = planMissionList[i].isComplete;
                    if (planMissionList[i].isComplete == 1){
                        _btnDom.classList.add('mui-hidden');
                        
                        var completeIconDom = document.getElementById('completeIcon');
                            completeIconDom.classList.remove('mui-hidden');
                            setTimeout(function () {
                                completeIconDom.classList.add('img-loaded');
                            }, 300);
                        initProcessDom(planMissionList[i].currentExecuteCount,planMissionList[i].mission.count);
                                
                        g_fire.updateAllMission({
                            missionIdArr: _missionIdArr
                        });
                        g_fire.showToast({
                            missionIdArr: _missionIdArr
                        });
                    }else{
                        initProcessDom(planMissionList[i].currentExecuteCount,planMissionList[i].mission.count);
                    }
                }
            }
        }
    }, g_tools.MODE_WEB, {
        disableWait: true //禁止显示wait框
    });
}
