//mui初始化
mui.init({
	pullRefresh: {
		container: '#refreshContainer',
		down: {
			//下拉成功回调函数
			callback: pullfreshDown
		}
	}
});

//0【脉搏，bpm】、1【血氧，%】、2【血糖，mmol/L】、5【体重，kg】、6【体温，℃】、7【血压，mmHg】
function healthRange() {
	var pluse = {
		low: 62,
		height: 120
	};
	var height_pressure = {
		low: 120,
		height: 140
	};
	var low_pressure = {
		low: 60,
		height: 100
	};
	var weight = {
		low: 46,
		height: 60
	};
	var beforeMealGlucose = {
		low: 3.9,
		height: 11.1
	};
	var limosisGlucose = {
		low: 3.9,
		height: 6.1
	};
	var afterMealGlucose = {
		low: 4.4,
		height: 7.8
	};
	var oxygen = {
		low: 93,
		height: 100
	};
	var heat = {
		low: 36,
		height: 37.5
	};
	this.setRange = function(type, numBig, numSmall) {
		switch (type) {
			case 0:
				pluse.height = numBig;
				pluse.low = numSmall;
				break;
			case 1:
				oxygen.height = numBig;
				oxygen.low = numSmall;
				break;
			case 2:
				beforeMealGlucose.height = numBig;
				beforeMealGlucose.low = numSmall;
				break;
			case 5:
				weight.height = numBig;
				weight.low = numSmall;
				break;
			case 6:
				heat.height = numBig;
				heat.low = numSmall;
				break;
			case 3:
				height_pressure.height = numBig;
				height_pressure.low = numSmall;

				break;
			case 4:
				low_pressure.height = numBig;
				low_pressure.low = numSmall;
				break;
			case 8:
				limosisGlucose.height = numBig;
				limosisGlucose.low = numSmall;
				break;
			case 9:
				afterMealGlucose.height = numBig;
				afterMealGlucose.low = numSmall;
				break;
			default:
				break;
		}
	}
	this.getRange = function(type) {
		var rangHeigth = null;
		var rangLow = null;
		switch (type) {
			case 0:
				rangHeigth = pluse.height;
				rangLow = pluse.low;
				break;
			case 1:
				rangHeigth = oxygen.height;
				rangLow = oxygen.low;
				break;
			case 2:
				rangHeigth = beforeMealGlucose.height;
				rangLow = beforeMealGlucose.low;
				break;
			case 5:
				rangHeigth = weight.height;
				rangLow = weight.low;
				break;
			case 6:
				rangHeigth = heat.height;
				rangLow = heat.low;
				break;
			case 3:
				rangHeigth = height_pressure.height;
				rangLow = height_pressure.low;
				break;
			case 4:
				rangHeigth = low_pressure.height;
				rangLow = low_pressure.low;
				break;
			case 8:
				rangHeigth = limosisGlucose.height;
				rangLow = limosisGlucose.low;
				break;
			case 9:
				rangHeigth = afterMealGlucose.height;
				rangLow = afterMealGlucose.low;
				break;
			default:
				break;
		}
		return {
			low: rangLow,
			height: rangHeigth
		};
	}
}

function airQuality(pm25) {
	var rank = Math.floor(parseInt(pm25) / 50);
	var SUPER = 0; //0~50优
	var WELL = 1; //50~100良
	var MILD = 2; //100~150轻度
	var MEDIUM = 3; //150~200中度
	var BADLY_1 = 4; //200~250严重
	var BADLY_2 = 5; //250~300严重
	var SEVERE = 6; // >300重度
	var color;
	switch (rank) {
		case SUPER:
			color = '#65B3DF';
			break;
		case WELL:
			color = '#63A500';
			break;
		case MILD:
			color = '#FCC43D';
			break;
		case MEDIUM:
			color = '#F9820F';
			break;
		case BADLY_1:
			color = '#F7421A';
			break;
		case BADLY_2:
			color = '#F7421A';
			break;
		default:
			color = '#91002D';
			break;
	}
	return color;
}


var careId, careImg, thisTime;
var self;
var isLoginUser;
var HEALTH_RANGE = new healthRange();
var isRefresh = false;

//图片网络地址url
var SERVER_IMG_ADDRESS = g_tools.IP_FILE;
var DEFAULT_HEAD_IMG = '../../global/img/default_portrait_msg.png';
var isReload = false;
mui.plusReady(function() {
	self = plus.webview.currentWebview();
	thisTime = self.chooseTime;
	recentEventTime = thisTime;

	if (thisTime.indexOf('NaN') != -1) thisTime = g_utils.dateFormat(new Date().getTime(), 'yyyy-MM-dd');
	careId = self.careId;
	careImg = self.headImg;
	addCalendar();
	window.addEventListener("tabReload", function(event) {
		if (!isReload) {
			isReload = true;
			init();
		}
	})

	document.addEventListener('deleteHealthData', function() {
		isRefresh = false;
		setHealthRange();
	});
              
    var web = plus.webview.getWebviewById(g_module.myCareState.ID);
    mui.fire(web,'subPagePlusReady', {});
});

function pullfreshDown() {
	setTimeout(function() {
		setHealthRange();
	}, 500);
}


function addCalendar() {
	window.addEventListener('healthItemAddListener', function(event) {
		var addType = event.detail.addType;
		var refreshDom = document.querySelector('[health="' + addType + '"]');
		refreshDom.removeEventListener('tap', manualInputHealth);
		refreshDom.addEventListener('tap', openHealthChart);
	});
	window.addEventListener('refreshHealth', function(event) {
		isRefresh = true;
		setHealthRange();
	});
}


function init() {
	var userId = g_tools.getUserId();
	isLoginUser = (userId != '' && userId == careId);
	setHealthRange();
}

function setHealthRange() {
	g_tools.postCMD('getMyCareSettings', {
			careId: careId
		},
		function(setData) {
			if (setData.code == 0) {
				var set = setData.data.normalValue;
				mui.each(set, function(index, item) {
					HEALTH_RANGE.setRange(item.type, item.maxValue, item.minValue);
				});
				var healthSwitch = setData.data.healthSwitch;
				var healthFrom = setData.data.healthFrom;
				if (g_utils.isEmpty(healthSwitch)) {
					healthSwitch = 1;
				}
				if (g_utils.isEmpty(healthFrom)) {
					healthFrom = 0;
				}
				refreshHealth(healthSwitch, healthFrom);
				//结束下拉刷新
				mui('#refreshContainer').pullRefresh().endPulldownToRefresh();
			} else {
				//网络状态不好
			}
		},
		g_tools.MODE_WEB_LOCAL_CACHE
	);
}

function refreshHealth(healthSwitch, healthFrom) {
	if (isLoginUser) {
		g_tools.postCMD('getRecentHealthDataList', {},
			function(healthList) {
				if (healthList.code == 0) {
					//刷新健康测量数据
					healthShow(healthList.data);
					if (healthFrom == 1 && plus.os.name == g_config.IOS) {
						var userId = g_tools.getUserId();
						// alert("userId:"+userId);
						g_healthNative.getHealthWithList(healthList.data,
							healthSwitch,
							userId,
							function(res) {
								//alert(JSON.stringify(res));
								if (res.length > 1) {
									var type = res[0];
									var list = [];
									list = res.slice();
									list.splice(0, 1);
									g_tools.postCMD('addHealthData', {
											type: type,
											dataList: JSON.stringify(list)
										},
										function(result) {
											//alert(JSON.stringify(result));
											if (result.code == 0) {
												//刷新首页积分数据
												g_fire.updateAllMission();

												g_tools.postCMD('getRecentHealthDataList', {},
													function(healthList) {
														if (healthList.code == 0) {
															//重新刷新健康测量数据
															healthShow(healthList.data);
														}
													});
											}
										}, g_tools.MODE_WEB);
								}
							},
							function(err) {

							});
					}
				}
			}, g_tools.MODE_WEB_LOCAL);
	} else {
		g_tools.postCMD('getMyCareRecentHealthDataList', {
				careId: careId
			},
			function(healthList) {
				if (healthList.code == 0) {
					//刷新健康测量数据
					healthShow(healthList.data);
				}
			},
			g_tools.MODE_WEB_LOCAL
		);
	}
}
//0【脉搏，bpm】、1【血氧，%】、2【血糖，mmol/L】、5【体重，kg】、6【体温，℃】、7【血压，mmHg】
function healthShow(healthData) {
	var pluse = document.getElementById('pluse-data');
	var height_pressure = document.getElementById('height-pressure');
	var low_pressure = document.getElementById('low-pressure');
	var weight = document.getElementById('weight-data');
	var glucose = document.getElementById('glucose-data');
	var oxygen = document.getElementById('oxygen-data');
	var heat = document.getElementById('heat-data');
	var pluse_mark = document.getElementById('pluse-mark');
	var height_pressure_mark = document.getElementById('height-pressure-mark');
	var low_pressure_mark = document.getElementById('low-pressure-mark');
	var weight_mark = document.getElementById('weight-mark');
	var glucose_mark = document.getElementById('glucose-mark');
	var oxygen_mark = document.getElementById('oxygen-mark');
	var heat_mark = document.getElementById('heat-mark');
	var pluse_time = document.getElementById('pluse-time');
	var pressure_time = document.getElementById('pressure-time');
	var weight_time = document.getElementById('weight-time');
	var glucose_time = document.getElementById('glucose-time');
	var oxygen_time = document.getElementById('oxygen-time');
	var heat_time = document.getElementById('heat-time');
	var healthBook = [1, 1, 1, 0, 0, 1, 1, 1];
	mui.each(healthData, function(index, item) {
		var type = item.type;
		var values = item.value.split(',');
		var value = parseFloat(values[0]);
		var value1;
		var status = item.status.split(',');
		var statue = parseInt(status[0]);
		var statue1;
		var time = item.time;
		var mark = null;
		var mark1 = null;
		var rang, rang1;
		var max, min, max1, min1;
		healthBook[type] = 0;
		if (type != 7) {
			rang = HEALTH_RANGE.getRange(type);
			max = rang.height;
			min = rang.low;
			if (value > max) {
				mark = 'health-arrow-up';
			}
			if (value < min) {
				mark = 'health-arrow-down';
			}
		} else {
			rang = HEALTH_RANGE.getRange(3);
			rang1 = HEALTH_RANGE.getRange(4);
			max = rang.height;
			min = rang.low;
			max1 = rang1.height;
			min1 = rang1.low;
			value1 = parseFloat(values[1]);
			statue1 = parseInt(status[1]);
			if (value > max) {
				mark = 'health-arrow-up';
			}
			if (value < min) {
				mark = 'health-arrow-down';
			}
			if (value1 > max1) {
				mark1 = 'health-arrow-up';
			}
			if (value1 < min1) {
				mark1 = 'health-arrow-down';
			}
		}
		switch (type) {
			case 0:
				pluse_time.innerHTML = g_printTools.printDateAndTimeStrByTimeMillis(time);
				pluse_mark.classList.add(mark);
				pluse.innerHTML = value;
				pluse.style.color = statusColor(statue);
				break;
			case 1:
				oxygen_time.innerHTML = g_printTools.printDateAndTimeStrByTimeMillis(time);
				oxygen_mark.classList.add(mark);
				oxygen.innerHTML = value;
				oxygen.style.color = statusColor(statue);
				break;
			case 2:
				document.getElementById("blood-classification").innerHTML = "血糖" + '-' + getBloodClassification(item);
				document.querySelector('[health="2"]').setAttribute('classification', item.classification);
				glucose_time.innerHTML = g_printTools.printDateAndTimeStrByTimeMillis(time);;
				glucose_mark.classList.add(mark);
				glucose.innerHTML = value;
				glucose.style.color = statusColor(statue);
				break;
			case 5:
				weight_time.innerHTML = g_printTools.printDateAndTimeStrByTimeMillis(time);
				weight_mark.classList.add(mark);
				weight.innerHTML = value;
				weight.style.color = statusColor(statue);
				break;
			case 6:
				heat_time.innerHTML = g_printTools.printDateAndTimeStrByTimeMillis(time);
				heat_mark.classList.add(mark);
				heat.innerHTML = value;
				heat.style.color = statusColor(statue);
				break;
			case 7:
				pressure_time.innerHTML = g_printTools.printDateAndTimeStrByTimeMillis(time);
				height_pressure_mark.classList.add(mark);
				low_pressure_mark.classList.add(mark1);
				height_pressure.innerHTML = value;
				low_pressure.innerHTML = value1;
				height_pressure.style.color = statusColor(statue);
				low_pressure.style.color = statusColor(statue1);
				break;
			default:
				break;
		}
	});
	for (var i = 0; i < 8; i++) {
		var emptyMark;
		var emptyString = '没有测量数据';
		if (healthBook[i] == 1) {
			emptyMark = i;
			switch (emptyMark) {
				case 0:
					var pluseItem = document.querySelector("[health='0']");
					pluseItem.setAttribute('healthEmpty', '1');
					pluse_time.innerHTML = emptyString;
					pluse.innerHTML = '--';
					pluse.style.color = '#666666';
					break;
				case 1:
					var oxygenItem = document.querySelector("[health='1']");
					oxygenItem.setAttribute('healthEmpty', '1');
					oxygen_time.innerHTML = emptyString;
					oxygen.innerHTML = '--';
					oxygen.style.color = '#666666';
					break;
				case 2:
					var glucoseItem = document.querySelector("[health='2']");
					document.getElementById("blood-classification").innerHTML = "血糖"
					glucoseItem.setAttribute('healthEmpty', '1');
					glucose_time.innerHTML = emptyString;
					glucose.innerHTML = '--';
					glucose.style.color = '#666666';
					break;
				case 5:
					var weightItem = document.querySelector("[health='5']");
					weightItem.setAttribute('healthEmpty', '1');
					weight_time.innerHTML = emptyString;
					weight.innerHTML = '--';
					weight.style.color = '#666666';
					break;
				case 6:
					var heatItem = document.querySelector("[health='6']");
					heatItem.setAttribute('healthEmpty', '1');
					heat_time.innerHTML = emptyString;
					heat.innerHTML = '--';
					heat.style.color = '#666666';
					break;
				case 7:
					var pressureItem = document.querySelector("[health='7']");
					pressureItem.setAttribute('healthEmpty', '1');
					pressure_time.innerHTML = emptyString;
					height_pressure.innerHTML = '--';
					low_pressure.innerHTML = '--';
					height_pressure.style.color = '#666666';
					low_pressure.style.color = '#666666';
					break;
				default:
					break;
			}
		}
	}
	if (!isRefresh) {
		addHealthListener();
	}
}

function getBloodClassification(item) {
	var name = '';
	switch (item.classification) {
		case 0:
			name = '餐前';
			break;
		case 1:
			name = '空腹';
			break;
		case 2:
			name = '餐后';
			break;
		case 3:
			name = '餐前';
			break;
		case 4:
			name = '餐后';
			break;
		case 5:
			name = '餐前';
			break;
		case 6:
			name = '餐后';
			break;
		case 7:
			name = '餐前';
			break;
		default:
			break;
	}
	return name
}

function addHealthListener() {
	var healthCard = document.querySelectorAll('[health]');
	mui.each(healthCard, function(index, item) {
		var isEmpty = this.getAttribute('healthEmpty');
		item.removeEventListener('tap', openHealthChart);
		item.removeEventListener('tap', manualInputHealth);
		if (isEmpty == null || isEmpty == undefined) {
			item.addEventListener('tap', openHealthChart);
		} else {
			if (isLoginUser) {
				item.addEventListener('tap', manualInputHealth);
			}
		}
	});

}

function openHealthChart() {
	var inputType = this.getAttribute('health');
	var classification = this.getAttribute('classification');
	g_mui.openPage(g_module.myCareState,
		'healthChart.html', {
			getId: careId,
			getType: inputType,
			classification: classification
		}
	);
}

function manualInputHealth() {
	var inputType = this.getAttribute('health');
	var btnArray = ['去添加', '取消'];
	var typeName = g_printTools.printHealthTypeName(inputType);
	var title = '没有' + typeName + '数据';
	var content = '您还没有' + typeName + '数据，需要添加一条吗？';
	mui.confirm(content, title, btnArray, function(e) {
		if (e.index == 0) {
			g_mui.openPage(g_module.myCareState,
				'manualInputHealth.html', {
					kind: inputType,
				}
			);
		}
	});
}

function statusColor(status) {
	var m = parseInt(status);
	var color;
	var txt;
	//	0【正常】、1【预警】、2【异常】）
	switch (m) {
		case 0:
			color = "#666666";
			break;
		case 1:
			color = "#666666";
			break;
		case 2:
			color = "#FF8080";
			break;
		default:
			break;
	}
	return color;
}
