mui.init();
var _self, careId;
//当前webview
var sportMsg; //上个页面的传值
var thisSportName;
var thisSportIconPath;

mui.plusReady(function() {
	init();
});

//初始化数据
function init() {
	_self = plus.webview.currentWebview();
	sportMsg = _self.sendMsg;
	careId = _self.careId;
    var sportType = sportMsg.type;
//  thisSportName = sportProperty.getSportName(sportType);
//  thisSportIconPath = sportProperty.getSportCircleIcon(sportType);
    thisSportName = sportProperty.getSportNameTemp(sportMsg.type,sportMsg.endTime,sportMsg.startTime,sportMsg.totalStep);
    thisSportIconPath = sportProperty.getSportCircleIconTemp(sportMsg.type,sportMsg.endTime,sportMsg.startTime,sportMsg.totalStep);
    
	setSportDetail(sportType);
	setSportTime();
	setSportGrade();
}

function setSportDetail(type) {
	var energyDom = document.getElementById('energy');
	var stepDom = document.getElementById('step');
	var energy = sportMsg.energy;
	var stepData = 0;
	var distanceData = 0;
	energyDom.innerHTML = energy;
	if(type == 3 || type == 4) {
		var distanceDom = document.getElementById('distance');
		var distanceUnit = document.getElementById('distance-unit');
		var stepTitleDom = document.getElementById('step-title');
		var distance = document.querySelector('.special-box');
		if(sportMsg.totalDistance) {
			distanceData = sportMsg.totalDistance;
		}
		distance.classList.remove('special-box');
		if(sportMsg.totalStep) {
			stepData = sportMsg.totalStep;
		}
		if(distanceData < 1000) {
			distanceDom.innerHTML = Math.round(distanceData);
			distanceUnit.innerHTML = '(米)';
		} else {
			distanceDom.innerHTML = Math.round(distanceData / 100) / 10;
			distanceUnit.innerHTML = '(公里)';
		}

		stepTitleDom.innerHTML = "步行";
		stepDom.innerHTML = stepData;
	}else if(type == 21){
		var stepTitleDom = document.getElementById('step-title');
		var stepUnitDom = document.getElementById('step-unit');
		stepTitleDom.innerHTML='次数';
		stepUnitDom.innerHTML='(次)'
		if(sportMsg.totalStep) {
			stepData = sportMsg.totalStep;
		}
		stepDom.innerHTML = stepData;
	} else {
		energyToStep(energy);
	}
}

function setSportTime() {
	var sportIcon = document.querySelector('.sport-icon');
	var sportName = document.querySelector('.item1');
	var sportTimeDate = document.querySelector('.item2');
	var sportTime = document.querySelector('.item3');
	var sportStartTime = sportMsg.startTime;
	var sportEndTime = sportMsg.endTime;
	sportIcon.style.backgroundImage = "url(" + thisSportIconPath + ")";
	sportName.innerHTML = thisSportName;
	var dateStr='';
	if(g_utils.dateFormat(sportStartTime,'yyyy-MM-dd')==g_utils.dateFormat(sportEndTime,'yyyy-MM-dd')){  //同一天
		dateStr=g_printTools.printDateAndTimeStrByTimeMillis(sportStartTime)+' - '+g_utils.dateFormat(sportEndTime,'HH:mm');
	}else{ //不同天
		dateStr=g_printTools.printDateAndTimeStrByTimeMillis(sportStartTime)+' - '+g_printTools.printDateAndTimeStrByTimeMillis(sportEndTime);	
	}	
	sportTimeDate.innerHTML = dateStr;
	var timeStr = setSportLong(sportEndTime - sportStartTime);
	sportTime.innerHTML = timeStr;
}

function setSportLong(ms) {
	var hour = Math.floor(ms / 3600000);
	var minute = Math.floor(ms % 3600000 / 60000);
	var second = Math.floor(ms % 60000 / 1000);
	return timeUse(hour) + ':' + timeUse(minute) + ':' + timeUse(second);
}

function timeUse(i) {
	return(i < 10 ? '0' : '') + i
}

function setSportGrade() {
	var chartCanvas = document.getElementById('grade-canvas');
	var correction, unitWidth, unitHeight;
	var maxEnergy = 2;
	var centreWidth;
	var tx = chartCanvas.getContext('2d');
	var deviceWidth = document.documentElement.clientWidth;
	var maxWidth = Math.floor(deviceWidth * 1.84);
	var maxHeight = Math.floor(0.9 * deviceWidth);
	chartCanvas.width = maxWidth;
	chartCanvas.height = maxHeight;
	var startTime = sportMsg.startTime;
	var endTime = sportMsg.endTime;
	var timeDiff = endTime - startTime;
	var dataList = sportMsg.dataList;
	var dataLength = dataList.length;
	var leftTimeDom = document.querySelector('.time-left');
	var rightTimeDom = document.querySelector('.time-right');
	if(timeDiff < 60000) {
		leftTimeDom.innerHTML = '0分钟';
		rightTimeDom.innerHTML = '1分钟';
	} else if(timeDiff <= 60000*60){
		var str = Math.floor(timeDiff / 60000);
		leftTimeDom.innerHTML = '0分钟';
		rightTimeDom.innerHTML = str + '分钟';
    }else{
        var allmin = Math.floor(timeDiff / 60000);
        var hour = Math.floor(allmin / 60);
        var min = allmin- hour*60;
        leftTimeDom.innerHTML = '0分钟';
        rightTimeDom.innerHTML = hour +'小时'+min + '分钟';
    }
	for(var i = 0; i < dataLength; i++) {
		var item = dataList[i].energy;
		if(item > maxEnergy) {
			maxEnergy = item;
		}
	}
	correction = maxEnergy / 0.8;
	unitWidth = maxWidth / 59;
	centreWidth = (maxWidth - dataLength * unitWidth) / (dataLength - 1);
	unitHeight = maxHeight / maxEnergy;
	tx.beginPath();
	tx.moveTo(0, maxHeight);
	tx.lineTo(maxWidth, maxHeight);
	tx.strokeStyle = '#DADADA';
	tx.lineWidth = 3;
	tx.stroke();
	for(var j = 0; j < dataLength; j++) {
		tx.beginPath();
		var item = dataList[j].energy;
		var x = Math.floor(j * (unitWidth + centreWidth) + 0.5 * unitWidth);
		var y = Math.floor(maxHeight - unitHeight * item);
		tx.moveTo(x, maxHeight);
		tx.lineTo(x, y);
		var color = getSportEnergyColor(item);
		tx.strokeStyle = color;
		tx.lineWidth = unitWidth;
		tx.stroke();
	}
}

function energyToStep(energy) {
	var stepDom = document.getElementById('step');
	var changeFunction = function(sex, height) {
		var rate = 0.414;
		var heightDefault;
		if(sex == 0) {
			rate = 0.413;
			heightDefault = 160;
		} else {
			rate = 0.415;
			heightDefault = 170;
		}
		heightDefault = height;
		return Math.ceil(energy * 100 / (0.045 * rate * heightDefault));
	}
	g_tools.postCMD('getMyCareList3', {},
		function(careList) {
			if(careList.code == 0) {
				var data = careList.data;
				var length = data.length;
				for(var i = 0; i < length; i++) {
					var item = data[i];
					if(item.careId == careId) {
						var userSex = null;
						var userHeight = null;
						if(item.sex) {
							userSex = item.sex;
						}
						if(item.height) {
							userHeight = item.height;
						}
						stepDom.innerHTML = changeFunction(userSex, userHeight);
						break;
					}
				}
			}
		}, g_tools.MODE_CACHE_WEB_LOCAL, {
			disableWait: true //禁止显示wait框
		}
	);
}

function getSportEnergyColor(energy) {
	var color;
	if(energy < 2) {
		color = '#B0D65C';
		return color;
	}
	if(energy < 5) {
		color = '#FCC43D';
		return color;
	}
	if(energy >= 5) {
		color = '#F86745';
		return color;
	}
}
