var _self;
var healthKind;
var pageType = 0;
var missionIdArr = '';
var PULSE = 0;
var OXYGEN = 1;
var BLOOD_GLUCOSE = 2;
var WEIGHT = 5;
var ANIMAL_HEAT = 6;
var BLOOD_PRESSURE = 7;
var isSaveSuccess = false;
var loading;
var userHeight = 170;
var userName, normalValue;
var item0 = document.getElementById('item0');
var item2 = document.getElementById('item2');
var item1 = document.getElementById('item1');
var dataItem = document.getElementById('data-item');
var affiliate = document.getElementById('affiliate');
var saveButton = document.getElementById('save-button');
var measuringDate = document.getElementById('measuring-date');
var measuringTime = document.getElementById('measuring-time');
var heightValue = document.getElementById('height-data');
var healthValue = document.getElementById('health-data');
var affiliateValue = document.getElementById('affiliate-data');
var bloodTypeDom;
var numberOpts = {};
var classficationType = [2, 8, 9, 2, 9, 2, 9, 2]
var classficationTypeStr = ["餐前", "空腹", "餐后", "餐前", "餐后", "餐前", "餐后", "餐前"]
var defaultMap = [0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 2, 3, 3, 4, 4, 4, 5, 5, 6, 6, 6, 6, 7, 7]
var timeMap = [
	[0, 6, 7],
	[0],
	[0],
	[0],
	[0, 1, 2],
	[0, 1, 2],
	[0, 1, 2],
	[0, 1, 2],
	[1, 2, 3],
	[1, 2, 3],
	[1, 2, 3],
	[2, 3, 4],
	[2, 3, 4],
	[3, 4, 5],
	[3, 4, 5],
	[3, 4, 5],
	[4, 5],
	[4, 5],
	[5, 6],
	[5, 6],
	[5, 6],
	[5, 6],
	[6, 7],
	[6, 7]
]
var healthRange = healthRange || {
	getRange: function(kind) {
		var maxValue, minValue, unit, name, defaultData;
		switch(parseInt(kind)) {
			case PULSE:
				//"脉搏";
				maxValue = 200;
				minValue = 40;
				defaultData = 20;
				unit = "bpm";
				name = "脉搏";
				numberOpts.title = name;
				numberOpts.unit = unit;
				numberOpts.range = "40-200";
				dataItem.innerHTML = "脉搏";
				break;
			case OXYGEN:
				//"血氧";
				maxValue = 100;
				minValue = 80;
				defaultData = 18;
				unit = "%";
				name = "血氧";
				numberOpts.title = name;
				numberOpts.unit = unit;
				numberOpts.range = "80-100";
				item2.classList.remove('hide');
				dataItem.innerHTML = "血氧";
				break;
			case BLOOD_GLUCOSE:
				//"血糖";
				maxValue = 12;
				minValue = 1;
				defaultData = 3;
				unit = "mmol/L";
				name = "血糖";
				numberOpts.title = name;
				numberOpts.unit = unit;
				numberOpts.range = "1-12";
				item1.classList.remove('mui-hidden');
				dataItem.innerHTML = "血糖";
				break;
			case WEIGHT:
				//"体重";
				maxValue = 200;
				minValue = 25;
				defaultData = 35;
				unit = "kg";
				name = "体重";
				numberOpts.title = name;
				numberOpts.unit = unit;
				numberOpts.range = "25-200";
				dataItem.innerHTML = "体重";
				break;
			case ANIMAL_HEAT:
				//"体温";
				maxValue = 44;
				minValue = 30;
				defaultData = 6;
				unit = "℃";
				name = "体温";
				numberOpts.title = name;
				numberOpts.unit = unit;
				numberOpts.range = "30-44";
				dataItem.innerHTML = "体温";
				break;
			case BLOOD_PRESSURE:
				//"血压" 低压，高压
				maxValue = 200;
				minValue = 40;
				defaultData = 30;
				unit = "mmHg";
				name = "血压";
				numberOpts.title = "低压";
				numberOpts.unit = unit;
				numberOpts.range = "40-200";
				dataItem.innerHTML = "低压（舒张压）";
				item2.classList.remove('hide');
				item0.classList.remove('hide');
				break;
			default:
				break;
		}
		return {
			maxValue: maxValue,
			minValue: minValue,
			unit: unit,
			name: name,
			defaultData: defaultData
		};
	}
}
var datePicker;
var timePicker;
var healthDataPicker;
var affiliateDataPicker;
var heightPicker;
var postValue;
mui.init();
mui.plusReady(function() {
	init();
});

function init() {
	_self = plus.webview.currentWebview();
	healthKind = _self.kind;
	if(!g_utils.isEmpty(_self.pageType)) {
		pageType = _self.pageType;
	}

	if(!g_utils.isEmpty(_self.missionIdArr)) {
		missionIdArr = _self.missionIdArr;
	}

	var thisRange = healthRange.getRange(healthKind);
	saveButton.classList.remove('hide');
	var date = new Date();
	measuringDate.value = g_utils.dateFormat(date, 'yyyy年MM月dd日');
	measuringTime.value = g_utils.dateFormat(date, 'HH:mm');
	datePicker = new mui.DtPicker({
		type: "date",
	});
	timePicker = new mui.DtPicker({
		type: "time",
	});
	if(healthKind == BLOOD_PRESSURE || healthKind == OXYGEN) {
		affiliateValue.addEventListener('tap', function() {
			new KeyBoard(this, 0, {
				title: "脉搏",
				unit: "bpm",
				okCallback: function(backValue) {
					affiliateValue.value = backValue + "bpm";
				},
				range: "40-200"
			});
		});
		if(healthKind == BLOOD_PRESSURE) {
			heightValue.addEventListener('tap', function() {
				new KeyBoard(this, 0, {
					title: "高压",
					unit: "mmHg",
					okCallback: function(backValue) {
						heightValue.value = backValue + "mmHg";
					},
					range: "40-200",
				});
			});
		}
	}
	if(healthKind == BLOOD_GLUCOSE) {
		typeList = document.querySelectorAll('[classification]');
		for(var k = 0; k < typeList.length; k++) {
			setOptionalScope();
			typeList[k].addEventListener('tap', function() {
				if(!this.classList.contains('blood-nooption')) {
					bloodTypeDom.classList.remove('blood-active')
					this.classList.add('blood-active');
					bloodTypeDom = this;
				}
			});
		}
	}
	getUserSetting();
	addPicker();
}
//获取可选范围
function setOptionalScope() {
	var time = parseInt(measuringTime.value.split(":")[0]);
	var optionalScope = timeMap[time];
	var defaultOption = defaultMap[time];
	var typeList = document.querySelectorAll('[classification]');
	for(var k = 0; k < typeList.length; k++) {
		var classification = parseInt(typeList[k].getAttribute('classification'));
		if(optionalScope.indexOf(classification) != -1) {
			typeList[k].classList.remove('blood-nooption');
		} else {
			typeList[k].classList.add('blood-nooption');
		}
	}
	if(bloodTypeDom) {
		bloodTypeDom.classList.remove('blood-active')
	}
	bloodTypeDom = document.querySelector('[classification="' + defaultOption + '"]');
	bloodTypeDom.classList.add('blood-active');
}

function getUserSetting() {
	g_tools.postCMD("getUserInfoByUserId", {
		userId: g_tools.getUserId()
	}, function(res) {
		if(res.code == 0) {
			if(!g_utils.isEmpty(res.data.height)) {
				userHeight = res.data.height;
				userName = getUserName(res.data);
			}
			g_tools.postCMD("getSettings", {}, function(result) {
				if(result.code == 0) {
					normalValue = result.data.normalValue;
					addSaveButton();
				}
			})

		}
	});
}

function getUserName(userInfo) {
	var name = ''
	if(!g_utils.isEmpty(userInfo.doctorNote)) {
		name = userInfo.doctorNote
	} else if(!g_utils.isEmpty(userInfo.name)) {
		name = userInfo.name
	} else if(!g_utils.isEmpty(userInfo.nickname)) {
		name = userInfo.nickname
	}
	return name
}

function addSaveButton() {
	saveButton.addEventListener('tap', function() {
		if(healthKind == WEIGHT || healthKind == BLOOD_GLUCOSE || healthKind == ANIMAL_HEAT || healthKind == PULSE) {
			if(healthValue.value == "") {
				var name = healthRange.getRange(healthKind).name;
				mui.confirm("请选择" + name + "值", "温馨提示", ['是'], function(e) {});
			} else {
				var str = new RegExp("\\d*.?\\d+");
				var postValue = healthValue.value.match(str);
				var str2 = measuringDate.value.match(/\d+/g);
				var postLong = str2[0] + '-' + str2[1] + '-' + str2[2] + ' ' + measuringTime.value + ":" + (new Date().getSeconds());
				postLong = postLong.replace(new RegExp("-", "gm"), "/");
				var time = new Date(postLong).getTime() + new Date().getMilliseconds();;
				var nowTime = new Date().getTime();
				if(time > nowTime) {
					mui.confirm("您选择的时间已经穿越到未来啦，请重新输入一个正确的测量时间", "温馨提示", ['是'], function(e) {});
				} else {
					var data = {
						value: parseFloat(postValue[0]),
						time: time
					}
					if(healthKind == PULSE) {
						data = {
							value: parseInt(postValue[0]),
							time: time
						}
					}
					if(healthKind == WEIGHT) {
						var bmi = postValue[0] * 10000 / userHeight / userHeight;
						data.bmi = bmi;
					}
					if(healthKind == BLOOD_GLUCOSE) {
						var classification = parseInt(bloodTypeDom.getAttribute("classification"));
						data.classification = classification;
					}
					var parameters = {
						type: healthKind,
						data: JSON.stringify(data)
					}
					loading = plus.nativeUI.showWaiting('保存中，请稍候……', {
						loading: {
							display: 'inline'
						},
						modal: false
					});
					postHealthData(parameters);
				}
			}
		} else {
			if(healthKind == BLOOD_PRESSURE) {
				if(heightValue.value == "") {
					mui.confirm("请选择高压（收缩压）值", "伙伙", ['是'], function(e) {});
				} else if(healthValue.value == "") {
					mui.confirm("请选择低压（舒张压）值", "伙伙", ['是'], function(e) {});
				} else {
					var parameters1, parameters2, data1, data2;
					var str = new RegExp("\\d*.?\\d+");
					var sp = heightValue.value.match(str);
					var dp = healthValue.value.match(str);
					var postValue = affiliateValue.value.match(str);
					var str2 = measuringDate.value.match(/\d+/g);
					var postLong = str2[0] + '-' + str2[1] + '-' + str2[2] + ' ' + measuringTime.value + ":" + (new Date().getSeconds());
					postLong = postLong.replace(new RegExp("-", "gm"), "/");
					var time = (new Date(postLong)).getTime() + new Date().getMilliseconds();
					var nowTime = (new Date()).getTime();
					if(time > nowTime) {
						mui.confirm("您选择的时间已经穿越到未来啦，请重新输入一个正确的测量时间", "温馨提示", ['是'], function(e) {});
					} else if(parseFloat(dp[0]) >= parseFloat(sp[0])) {
						mui.confirm("高压不能小于低压，请重新输入", "温馨提示", ['是'], function(e) {});
					} else {
						data1 = {
							sp: parseFloat(sp[0]),
							dp: parseFloat(dp[0]),
							time: time
						}
						parameters1 = {
							type: healthKind,
							data: JSON.stringify(data1)
						}

						loading = plus.nativeUI.showWaiting('保存中，请稍候……', {
							loading: {
								display: 'inline'
							},
							modal: false
						});
						if(!g_utils.isEmpty(postValue)) {
							data2 = {
								value: parseInt(postValue[0]),
								time: time
							}
							parameters2 = {
								type: PULSE,
								data: JSON.stringify(data2)
							}
							g_tools.postCMD('addHealthData', parameters2, function(result) {
								loading.close();
								if(result.code == 0) {
									//刷新首页积分数据
									g_fire.updateAllMission();
									mui.toast("脉搏数据上传成功");
									sendAbnormalHealthDataByAdmin(PULSE, data2);
									postHealthData(parameters1);
								} else {
									mui.toast("脉搏数据上传失败");
								}
							});
						} else {
							loading.close();
							postHealthData(parameters1);
						}
					}
				}
			} else {
				if(healthValue.value == "") {
					mui.confirm("请选择血氧值", "伙伙", ['是'], function(e) {});
				} else {
					var parameters1, parameters2, data1, data2;
					var str = new RegExp("\\d*.?\\d+");
					var postValue1 = affiliateValue.value.match(str);
					var postValue2 = healthValue.value.match(str);
					var str2 = measuringDate.value.match(/\d+/g);
					var postLong = str2[0] + '-' + str2[1] + '-' + str2[2] + ' ' + measuringTime.value + ":" + (new Date().getSeconds());
					postLong = postLong.replace(new RegExp("-", "gm"), "/");
					var time = (new Date(postLong)).getTime() + new Date().getMilliseconds();;
					var nowTime = (new Date()).getTime();
					if(time > nowTime) {
						mui.confirm("您选择的时间已经穿越到未来啦，请重新输入一个正确的测量时间", "温馨提示", ['是'], function(e) {});
					} else {
						data2 = {
							value: parseInt(postValue2[0]),
							time: time
						}
						parameters2 = {
							type: healthKind,
							data: JSON.stringify(data2)
						}
						loading = plus.nativeUI.showWaiting('保存中，请稍候……', {
							loading: {
								display: 'inline'
							},
							modal: false
						});
						if(!g_utils.isEmpty(postValue1)) {
							data1 = {
								value: parseInt(postValue1[0]),
								time: time
							}
							parameters1 = {
								type: PULSE,
								data: JSON.stringify(data1)
							}
							g_tools.postCMD('addHealthData', parameters1, function(result) {
								loading.close();
								if(result.code == 0) {
									//刷新首页积分数据
									g_fire.updateAllMission();
									sendAbnormalHealthDataByAdmin(PULSE, data1);
									mui.toast("脉搏数据上传成功");
									postHealthData(parameters2);
								} else {

									mui.toast("脉搏数据上传失败");
								}
							});
						} else {
							loading.close();
							postHealthData(parameters2);
						}
					}
				}
			}
		}
	});
}

function getDecRange(items) {
	return items.y.text + items.m.text + items.d.text;
}

function addPicker() {
	measuringDate.addEventListener('tap', function() {
		datePicker.show(function(e) {
			measuringDate.value = e.y.text + "年" + e.m.text + "月" + e.d.text + "日";
		});
	});
	measuringTime.addEventListener('tap', function() {
		timePicker.show(function(e) {
			measuringTime.value = e.h.text + ":" + e.i.text;
			setOptionalScope();
		});
	});
	healthValue.addEventListener('tap', function() {
		/*healthDataPicker.show(function(e) {
			healthValue.value = getPickerData(e);
		});*/

		new KeyBoard(this, 1, {
			title: numberOpts.title,
			unit: numberOpts.unit,
			okCallback: function(backValue) {
				healthValue.value = backValue + numberOpts.unit;
			},
			range: numberOpts.range
		});
	});
}

function thirdOrder(rang) {
	var maxValue = rang.maxValue;
	var minValue = rang.minValue;
	var unit = rang.unit;
	var firstData = new Array();
	var secondData = new Array();
	var thirdData = new Array();
	var str = {
		value: unit,
		text: unit
	}
	thirdData.push(str);
	for(var j = 0; j < 10; j++) {
		var secondItem = {
			value: j,
			text: '.' + j,
			children: thirdData
		}
		secondData.push(secondItem);
	}
	for(var i = minValue; i <= maxValue; i++) {
		var item = {
			value: i,
			text: i + '',
			children: secondData
		}
		firstData.push(item);
	}
	return firstData;
}

function firstOrder(rang) {
	var maxValue = rang.maxValue;
	var minValue = rang.minValue;
	var unit = rang.unit;
	var firstData = new Array();
	for(var i = minValue; i <= maxValue; i++) {
		var item = {
			value: i,
			text: i + unit
		}
		firstData.push(item);
	}
	return firstData;
}

function getPickerData(event) {
	var length = event.length;
	var value = "";
	for(var i = 0; i < length; i++) {
		value += event[i].text
	}
	return value
}

function postHealthData(set) {
	g_tools.postCMD('addHealthData', set, function(result) {
		loading.close();
		if(result.code == 0) {
			sendAbnormalHealthDataByAdmin(set.type, JSON.parse(set.data));
			//刷新首页积分数据
			var codeArr = ['DM_004', 'PM_003'];
			//g_fire.updateAllMission({missionIdArr:missionIdArr});
			g_fire.updateAllMission({
				codeArr: JSON.stringify(codeArr)
			});
			g_fire.showToast({
				codeArr: JSON.stringify(codeArr)
			});

			mui.toast(healthRange.getRange(healthKind).name + "数据上传成功");
			if(pageType == 1) {
				setTimeout(function() { //设置延迟,为了updateAllMission里面的plus插件不会挂掉
					mui.back();
				}, 1500)
			} else {
				var refreshPage1 = plus.webview.getWebviewById('myCareState:healthChart.html');
				var refreshPage2 = plus.webview.getWebviewById('healthRecordSub.html');
				if(refreshPage1 != null) {
					mui.fire(refreshPage1, "refreshHealth", {
						classification: JSON.parse(set.data).classification
					});
					mui.fire(refreshPage2, "refreshHealth", {});
					setTimeout(function() { //设置延迟,为了updateAllMission里面的plus插件不会挂掉
						mui.back();
					}, 1500)
				} else {
					mui.fire(refreshPage2, "refreshHealth", {});
					mui.fire(refreshPage2, "healthItemAddListener", {
						addType: healthKind
					});
					//					var str = 'g_mui.closePage("myCareState:manualInputHealth.html");'
					var data = JSON.parse(set.data);
					var classification;
					if(!g_utils.isEmpty(data.classification)) {
						classification = data.classification
					}
					g_mui.openPage(g_module.myCareState,
						'healthChart.html', {
							getId: g_tools.getUserId(),
							getType: healthKind,
							classification: (classification ? classification : undefined)
							//							callbackJS: str
						}
					);
				}
			}
		} else {
			mui.toast(healthRange.getRange(healthKind).name + "数据上传失败");
		}
	});
}

function sendAbnormalHealthDataByAdmin(type, data) {
	//【用户】【测量时间】【测量方式】【测量类型】【测量结果数据】【测量类型】正常值范围【对应的用户正常值范围】
	//方方 2019.8.28 16:04 手动上传空腹血糖8mmol/L，空腹血糖正常值范围3.9~6.1mmol/L 
	type = parseInt(type);
	var timeStr = g_printTools.printDateAndTimeStrByTimeMillis(data.time);
	var normalStr = "";
	var messageText = "【预警消息】"+'“'+userName +'”' + '于' + timeStr;
	
	switch(type) {
		case PULSE:
			var normal = getNormalValue(type);
			if(data.value < normal.minValue || data.value > normal.maxValue) {
				normalStr = normal.minValue + "~" + normal.maxValue;
				messageText += "上传脉搏" + data.value + "bpm，" + "已超出脉搏正常值范围" + normalStr + "bpm";
				sendMessage(messageText);
			}
			break;
		case OXYGEN:
			var normal = getNormalValue(type);
			if(data.value < normal.minValue || data.value > normal.maxValue) {
				normalStr = normal.minValue + "~" + normal.maxValue;
				messageText += "上传血氧" + data.value + "%，" + "已超出血氧正常值范围" + normalStr + "%";
				sendMessage(messageText);
			}

			break;
		case BLOOD_GLUCOSE:
			var classification = data.classification;
			var normal = getNormalValue(classficationType[classification]);			
			if(data.value < normal.minValue || data.value > normal.maxValue) {
				normalStr = normal.minValue + "~" + normal.maxValue;
				messageText += "上传" + bloodTypeDom.innerHTML + "血糖" + data.value + "mmol/L，" + classficationTypeStr[classification] + "已超出血糖正常值范围" + normalStr + "mmol/L";
				sendMessage(messageText);
			}
			break;
		case WEIGHT:
			var normal = getNormalValue(type);
			if(data.value < normal.minValue || data.value > normal.maxValue) {
				normalStr = normal.minValue + "~" + normal.maxValue;
				messageText += "上传体重" + data.value + "kg，" + "已超出体重正常值范围" + normalStr + "kg";
				sendMessage(messageText);
			}
			break;
		case ANIMAL_HEAT:
			var normal = getNormalValue(type);
			if(data.value < normal.minValue || data.value > normal.maxValue) {
				normalStr = normal.minValue + "~" + normal.maxValue;
				messageText += "上传体温" + data.value + "℃，" + "已超出体温正常值范围" + normalStr + "℃";
				sendMessage(messageText);
			}

			break;
		case BLOOD_PRESSURE:
			var normal_dp = getNormalValue(3);
			var normal_sp = getNormalValue(4);
			if(data.dp < normal_dp.minValue || data.dp > normal_dp.maxValue || data.sp < normal_sp.minValue || data.sp > normal_sp.maxValue) {
				normalStr = "血压高压" + normal_dp.minValue + "~" + normal_dp.maxValue + "mmHg" + "血压低压" + normal_sp.minValue + "~" + normal_sp.maxValue + "mmHg"
				messageText += "上传" + "血压高压" + data.sp + "mmHg" + "血压低压" + data.dp + "mmHg，" + "已超出血压正常值范围" + normalStr;
				sendMessage(messageText);
			}
			break;
	}
}

function getNormalValue(type) {
	var length = normalValue.length;
	for(var i = 0; i < length; i++) {
		if(normalValue[i].type == type) {
			return normalValue[i]
		}
	}
}

function sendMessage(messageText) {
	g_tools.postCMD("sendAbnormalHealthDataByAdmin",{
		userId:g_tools.getUserId(),
		msgContent:messageText
	},function(res){
	})
}
