mui.init();
var map = null;
var Id, recentTime, photo, magnTrack;
var TRACK = true;
var pointList = new Array();
var touchCenterPoint = null;
var isLoad = false;

function SquareOverlay(center, img) {
	this._center = center;
	this._img = img;
}

function StartOverlay(center) {
	this._center = center;
}

function CircleOverlay(center, randius) {
	this._center = center;
	this._randius = randius;
}

function changeProperty() {
	SquareOverlay.prototype = new BMap.Overlay();
	SquareOverlay.prototype.initialize = function(map) {
		this._map = map;
		var div = document.createElement("img");
		div.className = "magnify-photo";
		div.setAttribute('onload', 'load(this)');
		div.setAttribute('src', 'image/default_portrait_msg.png');
		div.setAttribute('data-src', this._img);
		map.getPanes().markerPane.appendChild(div);
		this._div = div;
		return div;
	}
	SquareOverlay.prototype.draw = function() {
		var position = this._map.pointToOverlayPixel(this._center);
		this._div.style.left = position.x - 17 + "px";
		this._div.style.top = position.y - 17 + "px";
	}
	StartOverlay.prototype = new BMap.Overlay();

	StartOverlay.prototype.initialize = function(map) {
		this._map = map;
		var div = document.createElement("div");
		div.className = "magnify-start";
		div.innerHTML = '起';
		map.getPanes().markerPane.appendChild(div);
		this._div = div;
		return div;
	}
	StartOverlay.prototype.draw = function() {
		var position = this._map.pointToOverlayPixel(this._center);
		this._div.style.left = position.x - 15 + "px";
		this._div.style.top = position.y - 15 + "px";
	}
	CircleOverlay.prototype = new BMap.Overlay();
	CircleOverlay.prototype.initialize = function() {
		this._map = map;
		var div = document.createElement("div");
		div.className = "magnify-circle";
		map.getPanes().markerPane.appendChild(div);
		this._div = div;
		return div;
	}
	CircleOverlay.prototype.draw = function() {
		//获取点
		var point = this._center;
		//当前点的px坐标
		var position = this._map.pointToOverlayPixel(point);
		//获取定位模式类
		var r = this._randius;
		//计算变化后的坐标
		var newLongitude = point.lng + r;
		var newLatitude = point.lat;
		var newpoint = new BMap.Point(newLongitude, newLatitude);
		var differ = this._map.pointToOverlayPixel(newpoint);
		//位置偏移在当前地图上的像素值为width
		var width = Math.abs(differ.x - position.x);
		this._div.style.width = 2 * width + "px";
		this._div.style.height = 2 * width + "px";
		this._div.style.borderRadius = 2 * width + "px";
		//地图上图像尺寸为2*width，设置偏移量为width
		this._div.style.left = position.x - width + "px";
		this._div.style.top = position.y - width + "px";
	}
}

function airQuality(pm) {
	var rank = Math.floor(parseInt(pm) / 50);
	var SUPER = 0; //0~50优
	var WELL = 1; //50~100良
	var MILD = 2; //100~150轻度
	var MEDIUM = 3; //150~200中度
	var BADLY_1 = 4; //200~250严重
	var BADLY_2 = 5; //250~300严重
	var SEVERE = 6; // >300重度
	var color;
	switch(rank) {
		case SUPER:
			color = '#65B3DF';
			break;
		case WELL:
			color = '#63A500';
			break;
		case MILD:
			color = '#FCC43D';
			break;
		case MEDIUM:
			color = '#F9820F';
			break;
		case BADLY_1:
			color = '#F7421A';
			break;
		case BADLY_2:
			color = '#F7421A';
			break;
		default:
			color = '#91002D';
			break;
	}
	return color;
}

function overlayMode(mode) {
	var BASE_STATION = 0;
	var GPS = 1;
	var OFF_LINE = 2;
	var WIFI = 3;
	var PHONE = -1;
	var differLongitude, level;
	var md = parseInt(mode);
	switch(md) {
		case BASE_STATION:
			differLongitude = 0.009009;
			level = 11;
			break;
		case GPS:
			differLongitude = 0.000045;
			level = 11;
			break;
		case OFF_LINE:
			differLongitude = 0.000270;
			level = 11;
			break;
		case WIFI:
			differLongitude = 0.000270;
			level = 11;
			break;
		case PHONE:
			differLongitude = 0.009009;
			level = 11;
			break;
	}
	return {
		differLongitude: differLongitude,
		level: level
	}
}
mui.plusReady(function() {
	init();
});

function loadScript(url, callback) {　　
	var script = document.createElement('script');　　　　
	script.type = 'text/javascript';　　　　
	script.async = 'async';　　　　
	script.src = url;　　　　
	document.body.appendChild(script);　　　
	if(script.readyState) {　　　　　　
		script.onreadystatechange = function() {　　　　　　　　
			if(script.readyState == 'complete' || script.readyState == 'loaded') {　　　　　　　　　　
				script.onreadystatechange = null;　　　　　　　　　　
				callback();　　　　　　　　
			}　　　　　　
		}　　　　
	} else {　　　　　　
		script.onload = function() {
			callback();
		}　　　　
	}
}

function init() {
	if(!isLoad) {
		loadScript("http://api.map.baidu.com/getscript?v=2.0&ak=bTVwPQE7P3yTtl52LZAExqhVDgOyHyiz&services=&t=20180529182003", function() {
			isLoad = true;
			mapInit();
		});
	}

}

function mapInit() {
	var _self = plus.webview.currentWebview();
	Id = _self.getId;
	recentTime = _self.getTime;
	photo = _self.getPhoto;
	pointList = [];
	map = new BMap.Map("map");
	map.enableDragging();
	map.enableContinuousZoom();
	var point = new BMap.Point(116.404, 39.915);
	map.centerAndZoom(point, 15);
	map.addEventListener("tilesloaded",
		function() { //修改百度logo的样式以使用我们的地图
			var anchorBL = document.querySelector('.anchorBL');
			if(anchorBL != null) {
				var aObj = anchorBL.querySelector('a');
				var imgObj = anchorBL.querySelector('img');
				anchorBL.style.display = 'block';
				anchorBL.style.left = '5px';
				anchorBL.style.bottom = '0px';
				imgObj.style.width = '40px';
				imgObj.style.height = 'auto';
				aObj.href = 'javascript:void(0)';
			}
		}
	);
	map.addEventListener('touchstart', function(e) {
		if(e.touches.length >= 2) {
			var now = e.touches;
			var x1 = now[0].pageX;
			var y1 = now[0].pageY;
			var x2 = now[1].pageX;
			var y2 = now[1].pageY;
			touchCenterX = (x1 + x2) / 2;
			touchCenterY = (y1 + y2) / 2;
			touchCenterPoint = map.pixelToPoint({
				x: touchCenterX,
				y: touchCenterY
			});
		}
	});
	map.addEventListener('touchend', function(e) {
		if(touchCenterPoint != null) {
			map.panBy(1, 0);
		}
		touchCenterPoint = null;
	});
	changeProperty();
	setWeather();
	getLocationMsg();
}

function setWeather() {
	var parent = document.querySelector('.magn-weather');
	var content = document.querySelector('.weather-msg');
	var time = document.querySelector('.msg-time');
	var careLocation = document.querySelector('.msg-location');
	var temp = document.querySelector('.msg-temp');
	var wide = document.querySelector('.msg-range');
	var type = document.querySelector('.msg-type');
	var pm = document.querySelector('.msg-pm25');
	var quality = document.querySelector('.msg-quality');
	var userId = g_tools.getUserId();
	var isLoginUser = (userId != '' && userId == Id);
	if(isLoginUser) {
		g_tools.postCMD('getWeatherData', {
				date: recentTime
			},
			function(weatherdata) {
				if(weatherdata.code == 0) {
					var data = weatherdata.data;
					if(isEmptyObject(data)) {
						content.innerHTML = '<span class="test-item">没有天气数据</span>';
					} else {
						if(data.pm25 == -1) {
							data.pm25 = ''
						}
						var flag = false
						for(key in data) {
							if(!g_utils.isEmpty(data[key])) {
								flag = true
							}
						}
						if(!flag) {
							str = '<span class="test-item">没有天气数据</span>';
							content.innerHTML = str;
						} else {
							var airquality = airQuality(data.pm25);
							careLocation.innerHTML = (data.city ? data.city + ':' : "");
							temp.innerHTML = data.realtimeTemp;
							wide.innerHTML = data.tempRange;
							type.innerHTML = data.weatherCondition;
							pm.innerHTML = 'PM2.5:';
							quality.innerHTML = data.pm25 + ' ' + data.pollutionLevel;
							quality.style.color = airquality;
						}

					}
				}
			}, g_tools.MODE_WEB_LOCAL_CACHE, {
				disableWait: true
			}
		);
	} else {
		g_tools.postCMD('getWeatherData', {
				date: recentTime,
				careId: Id
			},
			function(weatherdata) {
				if(weatherdata.code == 0) {
					var data = weatherdata.data;
					if(isEmptyObject(data)) {
						content.innerHTML = '<span class="test-item">没有天气数据</span>';
					} else {
						if(data.pm25 == -1) {
							data.pm25 = ''
						}
						var flag = false
						for(key in data) {
							if(!g_utils.isEmpty(data[key])) {
								flag = true
							}
						}
						if(!flag) {
							str = '<span class="test-item">没有天气数据</span>';
							content.innerHTML = str;
						} else {
							var airquality = airQuality(data.pm25);
							careLocation.innerHTML = (data.city ? data.city + ':' : "");
							temp.innerHTML = data.realtimeTemp;
							wide.innerHTML = data.tempRange;
							type.innerHTML = data.weatherCondition;
							pm.innerHTML = 'PM2.5:';
							quality.innerHTML = data.pm25 + ' ' + data.pollutionLevel;
							quality.style.color = airquality;
						}

					}
				}
			}, g_tools.MODE_WEB_LOCAL_CACHE, {
				disableWait: true
			}
		);
	}
}

function isEmptyObject(obj) {
	for(var key in obj) {
		return false;
	}
	return true;
}

function getLocationMsg() {
	var userId = g_tools.getUserId();
	var isLoginUser = (Id != '' && Id == userId);
	var timeList = recentTime.split('-');
	var date = new Date();
	date.setFullYear(timeList[0]);
	date.setMonth(timeList[1] - 1);
	date.setDate(timeList[2]);
	date.setHours(0);
	date.setMinutes(0);
	var startTime = date.getTime();
	var endTime = startTime + 24 * 3600000;
	if(isLoginUser) {
		g_tools.postCMD('getLocationList', {
				startTime: startTime,
				endTime: endTime,
				isFilter: 1
			},
			function(locationList) {
				if(locationList.code == 0) {
					var data = locationList.data;
					mui.each(data, function(index, item) {
						var latitude = item.latitude;
						var longitude = item.longitude;
						var point = new BMap.Point(longitude, latitude);
						pointList.push(point);
					});
					var length = data.length;
					if(length > 0) {
						var mode = data[length - 1].mode;
						var radius = overlayMode(mode).differLongitude;
						var level = overlayMode(mode).level;
						var point = pointList[length - 1];
						var startPoint = pointList[0];
						locationShow(point, photo);
						locationRange(point, radius);
						locationPath(startPoint);
						//map.centerAndZoom(point, level);
						map.setViewport(pointList, {
							margins: [40, 15, 15, 15]
						});
						addMapListener(point, level);
					} else {
						showMapMask();
					}
				}
			}, g_tools.MODE_WEB_LOCAL_CACHE, {
				disableWait: true
			}
		);
	} else {
		g_tools.postCMD('getMyCareLocationList', {
				startTime: startTime,
				endTime: endTime,
				careId: Id,
				isFilter: 1
			},
			function(locationList) {
				if(locationList.code == 0) {
					var data = locationList.data;
					mui.each(data, function(index, item) {
						var latitude = item.latitude;
						var longitude = item.longitude;
						var point = new BMap.Point(longitude, latitude);
						pointList.push(point);
					});
					var length = data.length;
					if(length > 0) {
						var mode = data[length - 1].mode;
						var radius = overlayMode(mode).differLongitude;
						var level = overlayMode(mode).level;
						var point = pointList[length - 1];
						var startPoint = pointList[0];
						locationShow(point, photo);
						locationRange(point, radius);
						locationPath(startPoint);
						map.centerAndZoom(point, level);
						map.setViewport(pointList, {
							margins: [40, 15, 15, 15]
						});
						addMapListener(point, level);
					} else {
						showMapMask();
					}
				}
			}, g_tools.MODE_WEB_LOCAL_CACHE, {
				disableWait: true
			}
		);
	}
}

function showMapMask() {
	var markContent = document.querySelector('.mark-content');
	markContent.style.display = 'none';
	var mask = document.getElementById('map-mask');
	mask.style.display = 'block';
}

function locationRange(point, radius) {
	var rangeCircle = new CircleOverlay(point, radius);
	map.addOverlay(rangeCircle);
}

function locationShow(point, img) {
	var mySquare = new SquareOverlay(point, img);
	map.addOverlay(mySquare);
}

function locationPath(start) {
	magnTrack = new BMap.Polyline(pointList, {
		strokeColor: '#F78215',
		strokeWeight: 6,
		strokeOpacity: 0.9
	});
	map.addOverlay(magnTrack);
	var startPoint = new StartOverlay(start);
	map.addOverlay(startPoint);
}

function addMapListener(point, level) {
	var trackButton = document.getElementById('track-map');
	var backButton = document.getElementById('location-back');
	var magn = document.querySelector('.magnify');
	var shrink = document.querySelector('.shrink');
	magn.addEventListener('tap', function() {
		var level = map.getZoom();
		if(level < 19) {
			map.setZoom(level + 1);
			setLevelIcon(level + 1);
		}
	});
	shrink.addEventListener('tap', function() {
		var level = map.getZoom();
		if(level > 3) {
			map.setZoom(level - 1);
			setLevelIcon(level - 1);
		}
	});
	trackButton.addEventListener('tap', function() {
		var startPoint = document.querySelector('.magnify-start');
		if(TRACK) {
			TRACK = false;
			this.classList.remove('track-light');
			this.classList.add('track-dark');
			startPoint.style.display = 'none';
			map.removeOverlay(magnTrack);
		} else {
			TRACK = true;
			this.classList.remove('track-dark');
			this.classList.add('track-light');
			startPoint.style.display = 'block';
			map.addOverlay(magnTrack);
			map.setViewport(pointList, {
				margins: [40, 15, 15, 15]
			});
		}
	});
	backButton.addEventListener('tap', function() {
		map.panTo(point, true);
	});
}

function setLevelIcon(level) {
	var magn = document.querySelector('.magnify');
	var shrink = document.querySelector('.shrink');
	if(level == 19) {
		magn.classList.remove('normal-active');
		magn.classList.add('magnify-lim');
	}
	if(level == 3) {
		shrink.classList.remove('normal-active');
		shrink.classList.add('shrink-lim');
	}
	if(level < 19 && level > 3) {
		shrink.classList.remove('shrink-lim');
		magn.classList.remove('magnify-lim');
		magn.classList.add('normal-active');
		shrink.classList.add('normal-active');
	}
}