mui.init();
var _self, careId;
//当前webview
var sleepMsg; //上个页面的传值
var thisSleepIcon;
var sportType;
mui.plusReady(function() {
	init();
});

//初始化数据
function init() {
	_self = plus.webview.currentWebview();
	sleepMsg = _self.sendMsg;
	careId = _self.careId;
	sportType = sleepMsg.type;
	thisSleepIcon = sportProperty.getSportCircleIcon(sportType);
	setSportDetail();
	setSportTime();
	setSportGrade();
}

function setSportDetail() {
	var sober = document.getElementById("sober");
	var latentSleep = document.getElementById('latentSleep');
	var deepSleep = document.getElementById('deepSleep');
	var description = sleepMsg.description.split(',');
	var soberTime,latentSleepTime,deepSleepTime;
	for(var j = 0;j<description.length;j++){
		if(description[j].indexOf('awakeSleepTime')!=-1){
			soberTime = description[j].match(/\d+/);
			continue;
		}
		if(description[j].indexOf('lightSleepTime')!=-1){
			latentSleepTime = description[j].match(/\d+/);
			continue;
		}
		if(description[j].indexOf('deepSleepTime')!=-1){
			deepSleepTime = description[j].match(/\d+/);
			continue;
		}
	}
	soberTime = getSleepTime(soberTime);
	latentSleepTime = getSleepTime(latentSleepTime);
	deepSleepTime = getSleepTime(deepSleepTime);
	sober.innerHTML = soberTime;
	latentSleep.innerHTML = latentSleepTime;
	deepSleep.innerHTML = deepSleepTime;
}
function getSleepTime(ms){
	var hour = Math.floor(ms/3600000);
	var min = Math.floor(ms%3600000/60000);
	var str='';
	if(hour == 0&&min>=0){
		str = min+'<span class="sleep-time">分钟</span>';
	}
	if(hour>0&&min==0){
		str = hour+'<span class="sleep-time">小时</span>';
	}
	if(hour>0&&min>0){
		str = hour+'<span class="sleep-time">小时</span>'+min+'<span class="sleep-time">分钟</span>';
	}
	return str;
}
function setSportTime() {
	var sportIcon = document.querySelector('.sport-icon');
	var sportTimeDate = document.querySelector('.item2');
	var sportTime = document.querySelector('.item3');
	var sportStartTime = sleepMsg.startTime;
	var sportEndTime = sleepMsg.endTime;
	sportIcon.style.backgroundImage = "url("+thisSleepIcon+")";
	var dateStr='';
	if(g_utils.dateFormat(sportStartTime,'yyyy-MM-dd')==g_utils.dateFormat(sportEndTime,'yyyy-MM-dd')){  //同一天
		dateStr=g_printTools.printDateAndTimeStrByTimeMillis(sportStartTime)+' - '+g_utils.dateFormat(sportEndTime,'HH:mm');
	}else{ //不同天
		dateStr=g_printTools.printDateAndTimeStrByTimeMillis(sportStartTime)+' - '+g_printTools.printDateAndTimeStrByTimeMillis(sportEndTime);	
	}
	sportTimeDate.innerHTML = dateStr;
	var timeStr = setSportLong(sportEndTime - sportStartTime);
	sportTime.innerHTML = timeStr;
}

function setSportLong(ms) {
	var hour = Math.floor(ms / 3600000);
	var minute = Math.floor(ms % 3600000 / 60000);
	var second = Math.floor(ms % 60000 / 1000);
	return timeUse(hour) + ':' + timeUse(minute) + ':' + timeUse(second);
}

function timeUse(i) {
	return(i < 10 ? '0' : '') + i
}

function setSportGrade() {
	var chartCanvas = document.getElementById('grade-canvas');
	var correction, unitWidth, unitHeight;
	var maxEnergy = 2;
	var tx = chartCanvas.getContext('2d');
	var deviceWidth = document.documentElement.clientWidth;
	var maxWidth = Math.floor(deviceWidth * 1.84);
	var centreWidth;
	var maxHeight = Math.floor(0.9 * deviceWidth);
	chartCanvas.width = maxWidth;
	chartCanvas.height = maxHeight;
	var startTime = sleepMsg.startTime;
	var endTime = sleepMsg.endTime;
	var timeDiff = endTime - startTime;
	var dataList = sleepMsg.dataList;
	var dataLength = dataList.length;
	var leftTimeDom = document.querySelector('.time-left');
	var rightTimeDom = document.querySelector('.time-right');
	if(timeDiff < 60000) {
		leftTimeDom.innerHTML = '0分钟';
		rightTimeDom.innerHTML = '1分钟';
	} else if(timeDiff <= 60000*60){
		var str = Math.floor(timeDiff / 60000);
		leftTimeDom.innerHTML = '0分钟';
		rightTimeDom.innerHTML = str + '分钟';
    }else{
        var allmin = Math.floor(timeDiff / 60000);
        var hour = Math.floor(allmin / 60);
        var min = allmin- hour*60;
        leftTimeDom.innerHTML = '0分钟';
        rightTimeDom.innerHTML = hour +'小时'+min + '分钟';
    }
	for(var i = 0; i < dataLength; i++) {
		var item = dataList[i].sleepValue;
		if(item > maxEnergy) {
			maxEnergy = item;
		}
	}
	
	correction = maxEnergy / 0.8;
	unitWidth = maxWidth / 59;
	centreWidth = (maxWidth-dataLength*unitWidth)/(dataLength-1);
	unitHeight = maxHeight / maxEnergy;
	tx.beginPath();
	tx.moveTo(0, maxHeight);
	tx.lineTo(maxWidth, maxHeight);
	tx.strokeStyle = '#DADADA';
	tx.lineWidth = 3;
	tx.stroke();	
	for(var j = 0;j<dataLength;j++){
		tx.beginPath();
		var item = dataList[j].sleepValue;
		var x = Math.floor(j*(unitWidth +centreWidth)+0.5*unitWidth);
		var y = Math.floor(maxHeight-unitHeight*item);
		tx.moveTo(x,maxHeight);
		tx.lineTo(x,y);
		var color = getSleepTypeColor(dataList[j].sleepType);
		tx.strokeStyle = color;
		tx.lineWidth = unitWidth;
		tx.stroke();
	}
}

function getSleepTypeColor(type) {
	var color;
	switch(parseInt(type)){
		case 0:
			color = '#4EDBA7';
			break;
		case 1:
			color = '#43A9EC';
			break;
		case 2:
			color = '#6F2FAA';
			break;
		default:
			break;
	}
	return color;
}
