mui.init();
var careId;
var choseTime;
var myChart;
var width;
mui.plusReady(function() {
	//获取页面传值
	var _self = plus.webview.currentWebview();
	careId = _self.getId;
	choseTime = _self.getTime;
	//获取页面宽度
	width = document.documentElement.clientWidth;
	//设置list位置
	var listcontent = document.querySelector('.list-content');
	listcontent.style.top = 0.64 * width + 45 + 'px';
	//初始化图表
	//initChart();
	initList()
});

function initChose(data) {
	var firstItem = document.querySelector('.sport-item');
	if(!firstItem) return;
	firstItem.classList.add('sport-item-active');
	animationChart(data, 0);
	//获取滚动控件DOM
	var scroll = mui('.mui-scroll-wrapper').scroll();
	var scrollDom = document.querySelector('.mui-scroll-wrapper');
	var cardList = document.querySelectorAll('[rank]');
	var behind = 0;
	var next = 0;
	var fixedLength = width * 1.64 / 3.75;
	var maxLength = document.querySelectorAll('[rank]').length;
	scrollDom.addEventListener('scroll', function(e) {
		var chose = document.querySelector('.sport-item-active');
		var choseRank = chose.getAttribute('rank');
		var distance = scroll.y - behind;
		if(Math.abs(distance) < fixedLength - 24) {
			return;
		} else {
			if(distance < 0) {
				var i = Math.floor(distance / fixedLength * (-1));
				if(distance * (-1) - (fixedLength * i) > fixedLength - 24) {
					i++;
				}
				if(parseInt(choseRank) + i > maxLength - 1) {
					choseRank = maxLength - 1;
					behind = (-1) * (maxLength - 1) * fixedLength;
				} else {
					choseRank = parseInt(choseRank) + i;
					behind = (-1) * (choseRank) * fixedLength;
				}
				chose.classList.remove('sport-item-active');
				document.querySelector('[rank="' + choseRank + '"]').classList.add('sport-item-active');
			} else {
				var i = Math.floor(distance / fixedLength);
				if(distance - (fixedLength * i) > fixedLength - 24) {
					i++;
				}
				if(parseInt(choseRank) - i < 0) {
					choseRank = 0
					behind = 0;
				} else {
					choseRank = parseInt(choseRank) - i;
					behind = (-1) * (choseRank) * fixedLength;
				}
				chose.classList.remove('sport-item-active');
				document.querySelector('[rank="' + choseRank + '"]').classList.add('sport-item-active');
			}
		}
		animationChart(data, choseRank);
	});
}

function initList() {
	var userId = g_tools.getUserId();
	var isLoginUser = (userId != '' && userId == careId);
	mui('.mui-scroll-wrapper').scroll({
		deceleration: 0.0005,
		scrollY: true,
		indicators: false
	});
	if(isLoginUser) {
		g_tools.postCMD('getSportEventByDay2', {
				date: choseTime
			},
			function(sportevent) {
				if(sportevent.code == 0) {
					var sportEventData = sportevent.data;
					sportEventData = quickSort(sportEventData);
					chartDrawTest(sportEventData)
					listDraw(sportEventData);
				}
			},
			g_tools.MODE_WEB, {
				noNetworkMode: g_tools.TIP_MODE_INTERFACE,
				contentDomId: 'mainContent',
				tipDomId: 'noNetworkTip'
			}
		);
	} else {
		g_tools.postCMD('getSportEventByDay2', {
				date: choseTime,
				careId: careId
			},
			function(sportevent) {
				if(sportevent.code == 0) {
					var sportEventData = sportevent.data;
					sportEventData = quickSort(sportEventData);
					chartDrawTest(sportEventData)
					listDraw(sportEventData);
				}
			},
			g_tools.MODE_WEB, {
				noNetworkMode: g_tools.TIP_MODE_INTERFACE,
				contentDomId: 'mainContent',
				tipDomId: 'noNetworkTip'
			}
		);
	}

}

function quickSort(arr) {
	//如果数组<=1,则直接返回
	if(arr.length <= 1) {
		return arr;
	}
	var pivotIndex = Math.floor(arr.length / 2);
	//找基准，并把基准从原数组删除
	var pivot = arr.splice(pivotIndex, 1)[0];
	//定义左右数组
	var left = [];
	var right = [];
	//比基准小的放在left，比基准大的放在right
	for(var i = 0; i < arr.length; i++) {
		if(arr[i].endTime <= pivot.endTime) {
			right.push(arr[i]);
		} else {
			left.push(arr[i]);
		}
	}
	//递归
	return quickSort(left).concat([pivot], quickSort(right));
}

function listDraw(sportEvent) {
	var parent = document.querySelector('.mui-scroll');
    
	mui.each(sportEvent, function(index, sportevent) {

		var startTime = sportevent.startTime;
		var endTime = sportevent.endTime;

		var sportStart = getAccurate(startTime, endTime);
		var type = sportevent.type;
		var energy = Math.floor(sportevent.energy);
		var totalStep = sportevent.totalStep;
		var totalDistance = Math.floor(sportevent.totalDistance);
	//	var sport = sportProperty.getSportInfo(type);
        var sport = sportProperty.getSportInfoTemp(type,endTime,startTime,sportevent.totalStep);
		var icon = sport.img;
		var name = sport.name;
		var showSub = sport.showSub;
		var unit = sport.unit;
		var countType = sport.countType;
		var timeformat = timeFormat(endTime - startTime);
		var formatHour = timeformat.hour;
		var formatMin = timeformat.minute;
		var time = '';
		if(energy == 0) {
			energy = '<1';
		}
		if(formatHour != 0 && formatMin != 0) {
			time = '<a class="msg-main">' + formatHour + '<a class="msg-unit">小时</a>' +
				'<a class="msg-main">' + formatMin + '</a><a class="msg-unit">分钟</a></a>';
		}
		if(formatHour == 0 && formatMin != 0) {
			time = '<a class="msg-main">' + formatMin + '<a class="msg-unit">分钟</a></a>';
		}
		if(formatHour != 0 && formatMin == 0) {
			time = '<a class="msg-main">' + formatHour + '<a class="msg-unit">小时</a>';
		}
		if(formatHour == 0 && formatMin == 0) {
			time = '<a class="msg-main">' + '<1' + '<a class="msg-unit">分钟</a></a>';
		}

		var div = document.createElement('div');
		var inputHTML = '';
		div.className = 'sport-item';
		div.setAttribute('rank', index);
		inputHTML = '<div class="item-title">' +
			'<div class="event-icon" style="background-image:url(' + icon + ')"></div>' +
			'<div class="event-name">' + name + '</div>' +
			'</div>' +
			'<div class="item-run-duration">' +
			'<div class="link-line"></div>' +
			'<div class="time-box">' +
			'<div class="time-dot"></div>' +
			'<font class="time-num">' + sportStart + '</font>' +
			'</div>'
		if(index == 0) {
			inputHTML = inputHTML + '<div class="first-line"></div>'
		}
		for(var i = 0; i < showSub.length; i++) {
			if(i == 0) {
				inputHTML = inputHTML + '<div class="event-msg-item0">' +
					'<div class="item-name">' + showSub[0] + '</div>' +
					'<div class="item-msg">' + time +
					'</div></div>';
				continue;
			}
			if(i == 1) {
				inputHTML = inputHTML + '<div class="event-msg-item1">' +
					'<div class="item-name">' + showSub[1] + '</div>' +
					'<div class="item-msg">' +
					'<a class="msg-main">' + energy + '<a class="msg-unit">卡路里</a></a>' +
					'</div></div>';
				continue;
			}
			if(i == 2) {
				var count = 0;
				if(countType == SP_TOTAL_STEP) {					
					count = totalStep;
				}
				if(countType == SP_TOTAL_DISTANCE) {
					count = totalDistance;
					if(count>1000){
						count = Math.floor(count/100)/10;
					}else{
						unit = "米";
					}
				}
				inputHTML = inputHTML + '<div class="event-msg-item2">' +
					'<div class="item-name">' + showSub[2] + '</div>' +
					'<div class="item-msg">' +
					'<a class="msg-main">' + count + '<a class="msg-unit">' + unit + '</a></a>' +
					'</div></div>';
				continue;
			}
		}
		inputHTML = inputHTML + '</div>';
		div.innerHTML = inputHTML;
		parent.appendChild(div);
	});
	if(sportEvent.length > 1) {
		var addLinkList = document.querySelectorAll('.link-line');
		var length = addLinkList.length;
		addLinkList[length - 1].style.display = 'none';
	} else {
		var firstLink = document.querySelector('.link-line');
		if(firstLink) {
			firstLink.style.display = 'none';
		}
	}
	if(sportEvent.length > 1) {
		var emptyDiv = document.createElement('div');
		emptyDiv.className = 'empty-div';
		parent.appendChild(emptyDiv);
	}

	initChose(sportEvent);
}

function chartDrawTest(sportList) {
	var maxEnergy = 0;
	var division = 0;
	var xZero = new Date(choseTime);
	var maxEnergy = 0;
	var division = 0;
	var dataList = new Array();
	var mergePointList = new Array();
	for(var p = 0 ;p<49;p++){
		mergePointList.push(0);
	}
	mergePointAdd = function(startTime,endTime,energy,zero){
		var averageEnergy = energy* 10/ (endTime - startTime);
		if(startTime<zero){
			mergePointList[0] = averageEnergy;
			startTime = zero;
		}
		if(endTime>zero + 86400000){
			mergePointList[48] = averageEnergy;
			endTime = zero + 86400000;
		}
		var indexStart = Math.ceil((startTime-zero)/1800000);
		var indexEnd = Math.ceil((endTime-zero)/1800000);
		if(indexStart == indexEnd){
			mergePointList[indexStart] = mergePointList[indexStart]+averageEnergy*(endTime-startTime);
		}else{
			mergePointList[indexStart] = mergePointList[indexStart]+averageEnergy*(zero+1800000*indexStart-startTime);
			mergePointList[indexEnd] = mergePointList[indexEnd]+averageEnergy*(endTime-(indexEnd-1)*1800000-zero);			
		}
	}
	xZero.setHours(0);
	xZero.setMinutes(0);
	xZero.setSeconds(0);
	xZero = xZero.getTime();
	var eventLength = sportList.length;
	for(var i = 0; i < eventLength; i++) {
		var startTime = sportList[i].startTime;
		var endTime = sportList[i].endTime;
		var itemEnergy = sportList[i].energy;
		if(endTime - startTime == 0) continue;
		mergePointAdd(startTime,endTime,itemEnergy,xZero);
	}
	for(i in mergePointList){
		if(i == 0){
			dataList.push([0,mergePointList[0]]);
			continue
		}
		if(i == 48){
			dataList.push([24,mergePointList[48]]);
			continue
		}
		var averageEnergy = mergePointList[i]/3;
		dataList.push([i/2,averageEnergy]);
		if(averageEnergy>maxEnergy)maxEnergy = averageEnergy;
	}
	maxEnergy = Math.floor(Math.max(maxEnergy, 24) * 5 / 4);
	division = maxEnergy / 4;
	myChart = echarts.init(document.getElementById('chart'));
	var myTitle = getTitle(choseTime);
	var option = {
		backgroundColor: '#FFFFFF',
		grid: {
			x: '16px',
			y: '23px',
			x2: '16px',
			y2: '30px',
			borderWidth: 0
		},
		title: {
			x: 'center',
			y: 5,
			text: myTitle,
			textStyle: {
				color: '#CCCCCC',
				fontSize: 12
			},
		},
		xAxis: [{
			type: 'value',
			max: 24,
			min: 0,
			splitNumber: 12,
			axisLine: {
				lineStyle: {
					width: 1,
					color: '#CCCCCC'
				},
			},
			axisLabel: {
				margin: 5,
				textStyle: {
					fontSize: 9.7,
					color: '#CCCCCC'
				}
			},
			axisTick: {
				show: false
			},
			splitLine: {
				show: false,
			},
		}, ],
		yAxis: [{
			type: 'value',
			max: maxEnergy,
			min: 0,
			interval: division,
			axisLabel: {
				show: false
			},
			axisLine: {
				show: false,
			},
			splitLine: {
				show: true,
				lineStyle: {
					color: ['rgba(0,0,0,0)', 'rgba(48,180,134,0.2)', 'rgba(48,180,134,0.2)', 'rgba(48,180,134,0.2)']
				}
			},
			axisTick: {
				show: false
			},
		}, ],
		series: [{
			name: '卡路里',
			type: 'line',
			smooth: true,
			smoothMonotone: 'x',
			symbol: 'none',
			itemStyle: {
				normal: {
					color: 'rgba(48,180,134,1)',
					areaStyle: {
						color: 'rgba(48,180,134,0.2)'
					}
				}
			},
			areaStyle: {
				normal: {

				},
			},
			markArea: {
				itemStyle: {
					normal: {
						color: 'rgba(205,242,149,0.4)'
					}
				}
			},
			data: dataList
		}, ]
	}
	myChart.setOption(option);
}

function getTitle(str) {
	var time = g_utils.stringToDate(str).getTime();
	return g_printTools.printDateStrByTimeMillis(time);
}

function getAccurate(msStart, msEnd) {
	var now = new Date(choseTime);
	now.setHours(0);
	now.setMinutes(0);
	var nowDay = now.getTime();
	if(msEnd > nowDay + 86400000) {
		return g_utils.dateFormat(msStart, 'HH:mm') + ' - 次日' + g_utils.dateFormat(msEnd, 'HH:mm');;
	}
	if(msStart >= nowDay) {
		return g_utils.dateFormat(msEnd, 'HH:mm');
	}
	if(msStart < nowDay && msStart >= nowDay - 25920000000) {
		var dif = nowDay - msStart;
		var n = Math.floor(dif / 86400000);
		if(n == 0) {
			return '昨天' + g_utils.dateFormat(msStart, 'HH:mm') + ' - ' + g_utils.dateFormat(msEnd, 'HH:mm');
		} else {
			return n + '天前' + g_utils.dateFormat(msStart, 'HH:mm') + ' - ' + g_utils.dateFormat(msEnd, 'HH:mm');
		}
	}
	if(msStart < nowDay - 25920000000) {
		return "很久以前";
	}
}

function animationChart(data, num) {
	if(!data) return;
	var timeZero = new Date();
	var zero = data[data.length - 1].endTime;
	var startTiem = data[num].startTime;
	var endTime = data[num].endTime;
	timeZero.setTime(zero);
	timeZero.setHours(0);
	timeZero.setMinutes(0);
	timeZero.setSeconds(0);
	var xStart, xEnd;
	var startLeadTime = startTiem - timeZero;
	var endLeadTime = endTime - timeZero;
	if(endLeadTime < 0) {
		return
	} else {
		if(endLeadTime > (3600000 * 24)) {
			xEnd = 24;
		} else {
			xEnd = (endLeadTime / 3600000);
		}
	}
	if(startTiem - timeZero < 0) {
		xStart = 0;
	} else {
		if(startLeadTime > (3600000 * 24)) {
			xStart = 24;
		} else {
			xStart = (startLeadTime / 3600000);
		}
	}
	if(xEnd - xStart < 0.2) {
		xEnd = xStart + 0.2;
		xStart = Math.min(23.8, xStart);
	}
	myChart.setOption({
		series: [{
			markArea: {
				data: [
					[{
						xAxis: xStart
					}, {
						xAxis: xEnd
					}]
				]
			}
		}]
	});
}