//mui初始化
mui.init({
	pullRefresh: {
		container: '#refreshContainer',
		down: {
			//下拉成功回调函数
			callback: pullfreshDown
		}
	}
});

//0【脉搏，bpm】、1【血氧，%】、2【血糖，mmol/L】、5【体重，kg】、6【体温，℃】、7【血压，mmHg】
function healthRange() {
	var pluse = {
		low: 62,
		height: 120
	};
	var height_pressure = {
		low: 120,
		height: 140
	};
	var low_pressure = {
		low: 60,
		height: 100
	};
	var weight = {
		low: 46,
		height: 60
	};
	var beforeMealGlucose = {
		low: 3.9,
		height: 11.1
	};
	var limosisGlucose = {
		low: 3.9,
		height: 6.1
	};
	var afterMealGlucose = {
		low: 4.4,
		height: 7.8
	};
	var oxygen = {
		low: 93,
		height: 100
	};
	var heat = {
		low: 36,
		height: 37.5
	};
	this.setRange = function(type, numBig, numSmall) {
		switch (type) {
			case 0:
				pluse.height = numBig;
				pluse.low = numSmall;
				break;
			case 1:
				oxygen.height = numBig;
				oxygen.low = numSmall;
				break;
			case 2:
				beforeMealGlucose.height = numBig;
				beforeMealGlucose.low = numSmall;
				break;
			case 5:
				weight.height = numBig;
				weight.low = numSmall;
				break;
			case 6:
				heat.height = numBig;
				heat.low = numSmall;
				break;
			case 3:
				height_pressure.height = numBig;
				height_pressure.low = numSmall;

				break;
			case 4:
				low_pressure.height = numBig;
				low_pressure.low = numSmall;
				break;
			case 8:
				limosisGlucose.height = numBig;
				limosisGlucose.low = numSmall;
				break;
			case 9:
				afterMealGlucose.height = numBig;
				afterMealGlucose.low = numSmall;
				break;
			default:
				break;
		}
	}
	this.getRange = function(type) {
		var rangHeigth = null;
		var rangLow = null;
		switch (type) {
			case 0:
				rangHeigth = pluse.height;
				rangLow = pluse.low;
				break;
			case 1:
				rangHeigth = oxygen.height;
				rangLow = oxygen.low;
				break;
			case 2:
				rangHeigth = beforeMealGlucose.height;
				rangLow = beforeMealGlucose.low;
				break;
			case 5:
				rangHeigth = weight.height;
				rangLow = weight.low;
				break;
			case 6:
				rangHeigth = heat.height;
				rangLow = heat.low;
				break;
			case 3:
				rangHeigth = height_pressure.height;
				rangLow = height_pressure.low;
				break;
			case 4:
				rangHeigth = low_pressure.height;
				rangLow = low_pressure.low;
				break;
			case 8:
				rangHeigth = limosisGlucose.height;
				rangLow = limosisGlucose.low;
				break;
			case 9:
				rangHeigth = afterMealGlucose.height;
				rangLow = afterMealGlucose.low;
				break;
			default:
				break;
		}
		return {
			low: rangLow,
			height: rangHeigth
		};
	}
}

function airQuality(pm25) {
	var rank = Math.floor(parseInt(pm25) / 50);
	var SUPER = 0; //0~50优
	var WELL = 1; //50~100良
	var MILD = 2; //100~150轻度
	var MEDIUM = 3; //150~200中度
	var BADLY_1 = 4; //200~250严重
	var BADLY_2 = 5; //250~300严重
	var SEVERE = 6; // >300重度
	var color;
	switch (rank) {
		case SUPER:
			color = '#65B3DF';
			break;
		case WELL:
			color = '#63A500';
			break;
		case MILD:
			color = '#FCC43D';
			break;
		case MEDIUM:
			color = '#F9820F';
			break;
		case BADLY_1:
			color = '#F7421A';
			break;
		case BADLY_2:
			color = '#F7421A';
			break;
		default:
			color = '#91002D';
			break;
	}
	return color;
}

function isEmptyObject(obj) {
	for (var key in obj) {
		return false;
	}
	return true;
}

function SquareOverlay(center, img) {
	this._center = center;
	this._img = img;
}

function StartPoint(center) {
	this._center = center;
}

function mapOverlayInit() {
	//继承map覆盖物类
	SquareOverlay.prototype = new BMap.Overlay();
	//初始化覆盖物
	SquareOverlay.prototype.initialize = function(map) {
		this._map = map;
		var div = document.createElement("img");
		div.className = "map-photo";
		div.setAttribute('onload', 'load(this)');
		div.setAttribute('src', 'image/default_portrait_msg.png');
		div.setAttribute('data-src', this._img + "&tb=1");
		map.getPanes().markerPane.appendChild(div);
		this._div = div;
		return div;
	}
	//覆盖物重绘函数
	SquareOverlay.prototype.draw = function() {
		var position = this._map.pointToOverlayPixel(this._center);
		this._div.style.left = position.x - 17 + "px";
		this._div.style.top = position.y - 17 + "px";
	}
	StartPoint.prototype = new BMap.Overlay();
	StartPoint.prototype.initialize = function(map) {
		this._map = map;
		var div = document.createElement("div");
		div.className = "start-point";
		div.innerHTML = "起";
		map.getPanes().markerPane.appendChild(div);
		this._div = div;
		return div;
	}
	StartPoint.prototype.draw = function() {
		var position = this._map.pointToOverlayPixel(this._center);
		this._div.style.left = position.x - 13 + "px";
		this._div.style.top = position.y - 13 + "px";
	}
}

var careId, careImg, thisTime, _top;
var self;
var baiduMap;
var isLoginUser;
/*var HEALTH_RANGE = new healthRange();*/
var pointList = new Array();
var activeSportList;
var isRefresh = false;
var timeInterval = null;
var recentEventTime = null;
//图片网络地址url
var SERVER_IMG_ADDRESS = g_tools.IP_FILE;
var DEFAULT_HEAD_IMG = '../../global/img/default_portrait_msg.png';
var isLoad = false;
var isUpLoad = false;
var isReload = false;
var _canlendar;
mui.plusReady(function() {
	var clientWidth = document.documentElement.clientWidth;
	if (clientWidth && clientWidth != 0 && clientWidth != '0') document.documentElement.style.fontSize = clientWidth /
		3.75 + 'px';
	self = plus.webview.currentWebview();
	thisTime = self.chooseTime;
	recentEventTime = thisTime;
	if (thisTime.indexOf('NaN') != -1) thisTime = g_utils.dateFormat(new Date().getTime(), 'yyyy-MM-dd');
	careId = self.careId;
	careImg = self.headImg;
	_top = self.top;
	var userId = g_tools.getUserId();
	isLoginUser = (userId != '' && userId == careId);
	_canlendar = g_mui.createWebview('calendar.html', 'canlendar', {
		background: "transparent",
		popGesture: 'none'
	}, {
		getId: careId,
		checkTime: thisTime,
		pageType:"sport"
	});
	window.addEventListener('changeday', function(event) {
		var chooseDay = event.detail.view;
		hideCanlendar();
		if (chooseDay == null) {
			return;
		}
		var month = chooseDay.month + 1;
		var day = chooseDay.day;
		if (month < 10) {
			month = "0" + month;
		}
		if (day < 10) {
			day = "0" + day;
		}
		var _dateStr = chooseDay.year + '-' + month + '-' + day;
		document.getElementById("chooseTime").innerHTML = "&emsp;" + getFormatChoose(_dateStr);
		refreshSub(_dateStr);
	});
	window.addEventListener("tabReload", function(event) {
		isReload = true;
	})
	document.getElementById("chooseTime").innerHTML = "&emsp;" + getFormatChoose(thisTime);
	document.getElementById("chooseTime").addEventListener("tap", function() {
		//显示canlendar
		plus.webview.show(_canlendar, 'slide-in-bottom', 300, function(e) {});
		// self.setStyle({
		// 	mask: 'rgba(0,0,0,0.5)'
		// });
	})
              
    var web = plus.webview.getWebviewById(g_module.myCareState.ID);
    mui.fire(web,'subPagePlusReady', {});
});

function getFormatChoose(timeStr) {
	var now = new Date();
	var list = timeStr.split("-");
	if (now.getFullYear() == list[0] && now.getMonth() + 1 == list[1] && now.getDate() == list[2]) {
		return "今天"
	} else if (now.getFullYear() == list[0]) {
		return list[1] + "月"+ list[2] + "日"
	} else {
		return list[0] + "年" + list[1] + "月"+ list[2] + "日"
	}	
}


function hideCanlendar() {
	//显示遮罩
	plus.webview.hide(_canlendar, 'auto', 300);
	// self.setStyle({
	// 	mask: 'none'
	// });
}

function loadMap() {
	if (!isLoad) {
		loadScript(
			"http://api.map.baidu.com/getscript?v=3.0&ak=bTVwPQE7P3yTtl52LZAExqhVDgOyHyiz&services=&t=20180529182003",
			function() {
				isLoad = true;
				baiduMapInit();
				refreshSub(null);
				changePage();
				setNewSport();
			});
	} else {
		refreshSub(null);
	}
}

function pullfreshDown() {
	setTimeout(function() {
		refreshSub(null);
	}, 500);
	setTimeout(function() {
		//结束下拉刷新
		mui('#refreshContainer').pullRefresh().endPulldownToRefresh();
	}, 1000);
}

function pullfreshUp() {}

function baiduMapInit() {
	baiduMap = new BMap.Map("map-track"); //获取地图
	baiduMap.disableDragging(); //禁用地图拖拽
	baiduMap.disableDoubleClickZoom(); //禁用双击放大        
	baiduMap.disablePinchToZoom(); //禁用双指操作
	baiduMap.addEventListener("tilesloaded",
		function() { //修改百度logo的样式以使用我们的地图
			var anchorBL = document.querySelector('.anchorBL');
			if (!g_utils.isEmpty(anchorBL)) {
				var aObj = anchorBL.querySelector('a');
				var imgObj = anchorBL.querySelector('img');
				anchorBL.style.display = 'block';
				anchorBL.style.left = '2px';
				anchorBL.style.bottom = '-8px';
				imgObj.style.width = '40px';
				imgObj.style.height = 'auto';
				aObj.href = 'javascript:void(0)';
			}
		}
	);
	mapOverlayInit();
}

function init() {

}

function loadScript(url, callback) {
	var script = document.createElement('script');
	script.type = 'text/javascript';
	script.async = 'async';
	script.src = url;
	document.body.appendChild(script);
	if (script.readyState) {
		script.onreadystatechange = function() {
			if (script.readyState == 'complete' || script.readyState == 'loaded') {
				script.onreadystatechange = null;
				callback();
			}
		}
	} else {
		script.onload = function() {
			callback();
		}
	}
}

//chooseTime选择刷新
function refreshSub(chooseTime) {
	if (thisTime != chooseTime || chooseTime == null) {
		if (chooseTime != null) {
			thisTime = chooseTime;
		}
		if (g_config.DEV_PLATFORM == g_config.IOS) { //IOS无法识别YYYY-MM-DD的格式字符串转date
			thisTime = thisTime.replace(/-/g, "/");
		}
		var thisTimeMills = new Date(thisTime + " 00:00:00").getTime();
		refreshLocation();
		refreshSport();
		refreshActiveSport();
		refreshStatisticalSportEvent();
	} else {
		return
	}
}

function refreshLocation() {
	setWeather();
	setMap();
}

function refreshSport() {
	setSportData();
}

function refreshActiveSport() {
	setActiveData();
}

function getImgUrl(img) {
	var imgUrl = DEFAULT_HEAD_IMG;
	if (!g_utils.isEmpty(img)) {
		imgUrl = SERVER_IMG_ADDRESS + img;
	}
	return imgUrl;
}

function refreshStatisticalSportEvent() {
	if (isLoginUser) {
		g_tools.postCMD('getStatisticalSportEvent', {
			date: g_utils.dateFormat(new Date(thisTime), 'yyyy-MM-dd')
		}, function(res) {
			if (res.code == 0) {
				setStatisticalSportEvent(res.data);
			}
		}, g_tools.MODE_WEB);
	} else {
		g_tools.postCMD('getStatisticalSportEvent', {
			date: g_utils.dateFormat(new Date(thisTime), 'yyyy-MM-dd'),
			careId: careId
		}, function(res) {
			if (res.code == 0) {
				setStatisticalSportEvent(res.data);
			}
		}, g_tools.MODE_WEB);
	}
}

function setStatisticalSportEvent(sportList) {
	var eventListDom = document.getElementById("sportScroll");
	var hideDom = document.querySelector(".this-all-sport-box");
	while (eventListDom.hasChildNodes()) {
		eventListDom.removeChild(eventListDom.firstChild);
	}
	if (sportList == null || sportList.length == 0) {
		hideDom.classList.add("hide");
	} else {
		hideDom.classList.remove("hide");
		for (x in sportList) {
			var eventDom = document.createElement("div");
			eventDom.className = "all-sport-item";
			//            var eventType = sportList[x].type;
			//            var eventName = sportProperty.getSportName(eventType);
			//            var eventPath = "url(" + sportProperty.getSportCircleIcon(eventType) + ")";
			var eventName = sportProperty.getSportNameTemp(sportList[x].type, sportList[x].endTime, sportList[x].startTime,
				sportList[x].totalStep);
			var eventPath = "url(" + sportProperty.getSportCircleIconTemp(sportList[x].type, sportList[x].endTime, sportList[x].startTime,
				sportList[x].totalStep) + ")";
			eventDom.innerHTML = '<div class = "all-sport-item-icon" style="background-image:' + eventPath + '"></div>' +
				'<font class = "all-sport-item-name">' + eventName + '</font>';
			eventListDom.appendChild(eventDom);
		}
		var emptyDom = document.createElement("div");
		emptyDom.className = "all-sport-item-empty";
		eventListDom.appendChild(emptyDom);
	}
}

function setWeather() {
	if (isLoginUser) {
		g_tools.postCMD('getWeatherData', {
				date: g_utils.dateFormat(new Date(thisTime), 'yyyy-MM-dd')
			},
			function(weatherData) {
				if (weatherData.code == 0) {
					weatherShow(weatherData.data);
				}
			},
			g_tools.MODE_WEB_LOCAL_CACHE
		);
	} else {
		g_tools.postCMD('getWeatherData', {
				date: g_utils.dateFormat(new Date(thisTime), 'yyyy-MM-dd'),
				careId: careId
			},
			function(weatherData) {
				if (weatherData.code == 0) {
					weatherShow(weatherData.data);
				}
			},
			g_tools.MODE_WEB_LOCAL_CACHE
		);
	}
}

function weatherShow(weatherData) {
	var parent = document.querySelector('.weather-play');
	parent.innerHTML = '';
	var str;
	var contentOne = document.createElement('p');
	contentOne.className = 'weather-msg';
	var contentTwo = document.createElement('p');
	contentTwo.className = 'weather-msg';
	contentTwo.style.left = '120%';
	if (weatherData.pm25 == -1) {
		weatherData.pm25 = ''
	}
	var flag = false
	for (key in weatherData) {
		if (!g_utils.isEmpty(weatherData[key])) {
			flag = true
		}
	}
	if (!flag) {
		str = '<span class="test-item">没有天气数据</span>';
		contentOne.innerHTML = str;
		parent.appendChild(contentOne);
	} else {
		var airqualityColor = airQuality(weatherData.pm25);
		var careLocation = (weatherData.city ? weatherData.city + '：' : "");
		var temp = (weatherData.realtimeTemp ? weatherData.realtimeTemp + "&nbsp&nbsp&nbsp&nbsp" : "");
		var wide = (weatherData.tempRange ? weatherData.tempRange + "&nbsp&nbsp&nbsp&nbsp" : ""); + "&nbsp&nbsp&nbsp&nbsp";
		var type = (weatherData.weatherCondition ? weatherData.weatherCondition + "&nbsp&nbsp&nbsp&nbsp" : "");
		var pm = 'PM2.5：';
		var quality = weatherData.pm25 + ' ' + weatherData.pollutionLevel;
		str = '<span class = "test-item msg-location" >' + careLocation + '</span>' +
			'<span class = "test-item msg-temp" >' + temp + '</span>' +
			'<span class = "test-item msg-range">' + wide + '</span>' +
			'<span class = "test-item msg-type" >' + type + '</span>' +
			'<span class = "test-item msg-pm25" >' + pm + '</span>' +
			'<span class = "test-item msg-quality" style="color:' + airqualityColor + '">' + quality + '</span>'
		contentOne.innerHTML = str;
		//contentTwo.innerHTML = str;
		parent.appendChild(contentOne)
		//parent.appendChild(contentTwo);
		//        setTimeout(function() {
		//            contentOne.classList.add('first-move');
		//            contentTwo.classList.add('second-move');
		//        }, 3000);
	}
}

function setNewSport() {
	if (isLoginUser) {
		g_tools.postCMD('getRecentSportEvent', {
				isGetDataList: 0
			},
			function(sportEvent) {
				if (sportEvent.code == 0) {
					//刷新运动事件
					newSportShow(sportEvent.data);
				}
			}, g_tools.MODE_WEB_LOCAL_CACHE, {
				disableWait: true
			}
		);
	} else {
		g_tools.postCMD('getRecentSportEvent', {
				isGetDataList: 0,
				careId: careId
			},
			function(sportEvent) {
				if (sportEvent.code == 0) {
					//刷新运动事件
					newSportShow(sportEvent.data);
				}
			}, g_tools.MODE_WEB_LOCAL_CACHE, {
				disableWait: true
			}
		);
	}
}

function newSportShow(eventData) {
	var finallyEventNameDom = document.querySelector(".recent-sport-type");
	var finallyEventTimeDom = document.querySelector(".recent-time");
	var finallyEventIconDom = document.querySelector(".recent-sport-icon");
	var finallyEventTitleTimeDom = document.getElementById("recent-sport-time");
	if (g_utils.dateFormat(eventData.startTime, 'yyyy-MM-dd') == g_utils.dateFormat(new Date().getTime(), 'yyyy-MM-dd') &&
		eventData.type != '25') {
		document.querySelector(".part0").classList.remove("hide");
	}
	if (g_utils.isEmpty(eventData.type)) {
		finallyEventNameDom.innerHTML = "没有事件";
		finallyEventTimeDom.innerHTML = "";
		var emptyImageSrc = "url(" + sportProperty.getSportCircleIcon(-1) + ")";
		finallyEventIconDom.style.backgroundImage = emptyImageSrc;
	} else {
		var finallyEvent = eventData;
		var finallyEventType = finallyEvent.type;
		var finallyEventEndTime = finallyEvent.endTime;
		var fianllyEventStartTime = finallyEvent.startTime;
		finallyEventTitleTimeDom.innerHTML = g_printTools.printDateStrByTimeMillis(finallyEventEndTime) + " " + g_utils.dateFormat(
			finallyEventEndTime, "HH:mm");
		var timeDiff = finallyEventEndTime - fianllyEventStartTime;
		var nowDate = new Date().getTime();
		if (nowDate - finallyEventEndTime < 300000) {
			setFinallyEventTime(timeDiff);
			timeInterval = setInterval(function() {
				timeDiff += 1000;
				setFinallyEventTime(timeDiff);
			}, 1000);
		} else {
			timeInterval = null;
			finallyEventTimeDom.innerHTML = getTimeText(timeDiff);
		}

		//        finallyEventNameDom.innerHTML = sportProperty.getSportName(finallyEventType);
		//        finallyEventIconDom.style.backgroundImage = "url(" + sportProperty.getSportCircleIcon(finallyEventType) + ")";
		finallyEventNameDom.innerHTML = sportProperty.getSportNameTemp(finallyEventType, finallyEventEndTime,
			fianllyEventStartTime, finallyEvent.totalStep);
		finallyEventIconDom.style.backgroundImage = "url(" + sportProperty.getSportCircleIconTemp(finallyEventType,
			finallyEventEndTime, fianllyEventStartTime, finallyEvent.totalStep) + ")";
	}
}

function setFinallyEventTime(timeDiff) {
	var finallyEventTimeDom = document.querySelector(".recent-time");
	finallyEventTimeDom.innerHTML = getTimeText(timeDiff);
}

function getTimeText(ms) {
	var hour;
	var minute;
	var second;
	var timeText;
	hour = Math.floor(ms / 3600000);
	minute = Math.floor(ms % 3600000 / 60000);
	second = Math.floor(ms % 60000 / 1000);
	if (hour == 0 && minute == 0) {
		timeText = second + '<font class="recent-sport-unit">秒</font>';
	} else if (hour == 0 && minute != 0) {
		timeText = minute + '<font class="recent-sport-unit">分钟</font>' + second + '<font class="recent-sport-unit">秒</font>';
	} else if (hour != 0) {
		timeText = hour + '<font class="recent-sport-unit">小时</font>' + minute + '<font class="recent-sport-unit">分钟</font>' +
			second + '<font class="recent-sport-unit">秒</font>';
	}
	return timeText;
}

function getTimeDiff(ms) {
	var hour;
	var minute;
	hour = Math.floor(ms / 3600000);
	minute = Math.floor(ms % 3600000 / 60000);
	return {
		hour: hour,
		minute: minute
	}
}

function setMap() {
	baiduMap.clearOverlays();
	var nowTime = g_utils.stringToDate(thisTime);
	var startTime = nowTime.getTime();
	var endTime = startTime + 24 * 3600000 - 1;
	if (isLoginUser) {
		g_tools.postCMD('getLocationList', {
				startTime: startTime,
				endTime: endTime,
				isFilter: 1
			},
			function(locationData) {

				if (locationData.code == 0) {
					mapShow(locationData.data)
				}
			}, g_tools.MODE_WEB_LOCAL_CACHE, {
				disableWait: true
			}
		);
	} else {
		g_tools.postCMD('getMyCareLocationList', {
				startTime: startTime,
				endTime: endTime,
				careId: careId,
				isFilter: 1
			},
			function(locationData) {
				if (locationData.code == 0) {
					mapShow(locationData.data)
				}
			},
			g_tools.MODE_WEB_LOCAL_CACHE, {
				disableWait: true
			}
		);
	}

}

function mapShow(locationData) {
	var point = new BMap.Point(116.404, 39.915);
	var mask = document.querySelector('.map-mask');
	baiduMap.centerAndZoom(point, 15);
	var weatherTime = document.getElementById("weather-time");
	if (isEmptyObject(locationData)) {
		mask.style.display = 'block';
		var weatherTimeData = g_utils.stringToDate(thisTime);
		var time = new Date();
		time.setMonth(0);

		time.setDate(0);
		time.setHours(0);
		time.setMinutes(0);
		var ms = weatherTimeData.getTime()
		var str = g_printTools.printDateStrByTimeMillis(ms);
		weatherTime.innerHTML = str;
	} else {
		pointList = [];
		var weatherTimeData = locationData[locationData.length - 1].time;
		var weatherInner = g_printTools.printDateAndTimeStrByTimeMillis(weatherTimeData);;
		weatherTime.innerHTML = weatherInner;
		mask.style.display = 'none';
		mui.each(locationData, function(index, item) {
			//将地图上坐标点添加到list中存储
			var newpoint = new BMap.Point(item.longitude, item.latitude);
			pointList.push(newpoint);
		});
		var img = careImg;
		//把最后一个点添加到地图作为头像显示
		var mySquare = new SquareOverlay(pointList[pointList.length - 1], img);
		var myPoint = new StartPoint(pointList[0]);
		//将头像添加到地图上
		baiduMap.addOverlay(mySquare);
		setTimeout(function() {
			baiduMap.addOverlay(myPoint);
			//绘制地图上矢量直线
			var polyline = new BMap.Polyline(pointList, {
				strokeColor: "#F78215",
				strokeWeight: 6,
				strokeOpacity: 0.9
			});
			//允许地图clearOverlay清除直线
			polyline.enableMassClear();
			//添加直线到地图
			baiduMap.addOverlay(polyline);
		}, 500);
		//将所有点全部显示在地图中央
		baiduMap.setViewport(pointList, {
			margins: [40, 15, 15, 15]
		});
	}
}

function setSportData() {
	var lastDate = g_utils.stringToDate(thisTime);
	var lastTime = lastDate.getTime() - 3600000 * 24;
	lastTime = g_utils.dateFormat(lastTime, 'yyyy-MM-dd');
	if (isLoginUser) {
		g_tools.postCMD('getSportDataByDay2', {
				date: g_utils.dateFormat(new Date(thisTime), 'yyyy-MM-dd'),
				isGetDataList: 1,
				count: 12
			},
			function(thisSportData) {
				if (thisSportData.code == 0) {
					g_tools.postCMD('getSportDataByDay2', {
							date: lastTime,
							isGetDataList: 1,
							count: 12
						},
						function(lastSportData) {
							if (lastSportData.code == 0) {
								sportShow(thisSportData.data, lastSportData.data);
							}
						},
						g_tools.MODE_WEB
					);
				}
			},
			g_tools.MODE_WEB
		);

	} else {
		g_tools.postCMD('getSportDataByDay2', {
				date: g_utils.dateFormat(new Date(thisTime), 'yyyy-MM-dd'),
				isGetDataList: 1,
				count: 12,
				careId: careId
			},
			function(thisSportData) {
				if (thisSportData.code == 0) {
					g_tools.postCMD('getSportDataByDay2', {
							date: lastTime,
							isGetDataList: 1,
							count: 12,
							careId: careId
						},
						function(lastSportData) {
							if (lastSportData.code == 0) {
								sportShow(thisSportData.data, lastSportData.data);
							}
						},
						g_tools.MODE_WEB
					);
				}
			},
			g_tools.MODE_WEB
		);
	}
}

function sportShow(thisSportData, lastSportData) {
	var energy = document.getElementById('energy');
	var process = document.getElementById('process');
	var totalStep = document.getElementById('totalStep');
	var totalDistance = document.getElementById('totalDistance');
	var totalDistanceUnit = document.getElementById('total-distance-unit');
	var energy_compare = document.getElementById('energy-compare');
	var process_compare = document.getElementById('process-compare');
	var totalStep_compare = document.getElementById('totalStep-compare');
	var totalDistance_compare = document.getElementById('totalDistance-compare');
	var energy_mark = document.getElementById('energy-mark');
	var process_mark = document.getElementById('process-mark');
	var totalStep_mark = document.getElementById('totalStep-mark');
	var totalDistance_mark = document.getElementById('totalDistance-mark');
	var energy_text = document.getElementById('energy-text');
	var process_text = document.getElementById('process-text');
	var totalStep_text = document.getElementById('totalStep-text');
	var totalDistance_text = document.getElementById('totalDistance-text');
	var energy_unit = document.getElementById('energy-unit');
	var process_unit = document.getElementById('process-unit');
	var totalStep_unit = document.getElementById('totalStep-unit');
	var totalDistance_unit = document.getElementById('totalDistance-unit');
	var sportTime = document.getElementById("sport-time");
	var sportTimeData = g_utils.stringToDate(thisTime);
	var time = new Date();
	time.setHours(0);
	time.setMinutes(0);
	var todayTime = time.getTime();
	time.setMonth(0);
	time.setDate(0);
	var ms = sportTimeData.getTime();
	var sportTimeStr = '';
	sportTimeStr = g_printTools.printDateStrByTimeMillis(ms);
	//    if(ms > todayTime) {
	//        sportTimeStr = "今天";
	//    } else {
	//        if(ms < time.getTime()) {
	//            sportTimeStr = "一年前";
	//        } else {
	//            sportTimeStr = g_printTools.printDateStrByTimeMillis(ms);
	//        }
	//    }
	sportTime.innerHTML = sportTimeStr;
	var sportFlag = thisSportData.energy;
	if (sportFlag == null || sportFlag == undefined) {
		energy.innerHTML = 0;
		process.innerHTML = 0;
		totalStep.innerHTML = 0;
		totalDistance.innerHTML = 0;
		energy_mark.parentNode.classList.add('compare-hide');
		process_mark.parentNode.classList.add('compare-hide');
		totalStep_mark.parentNode.classList.add('compare-hide');
		totalDistance_mark.parentNode.classList.add('compare-hide');
		eChartShow();
	} else {
		energy_mark.parentNode.classList.remove('compare-hide');
		process_mark.parentNode.classList.remove('compare-hide');
		totalStep_mark.parentNode.classList.remove('compare-hide');
		totalDistance_mark.parentNode.classList.remove('compare-hide');
		var thisEnergy = thisSportData.energy;
		var lastEnergy = lastSportData.energy;
		var thisProcess = thisSportData.process;
		var lastProcess = lastSportData.process;
		var thisTotalDistance = thisSportData.totalDistance;
		var lastTotalDistance = lastSportData.totalDistance;
		var thisTotalStep = thisSportData.totalStep;
		var lastTotalStep = lastSportData.totalStep;
		var energyCompare = compareSport(thisEnergy, lastEnergy);
		var processCompare = compareSport(thisProcess, lastProcess);
		var totalDistanceCompare = compareSport(thisTotalDistance, lastTotalDistance);
		var totalStepCompare = compareSport(thisTotalStep, lastTotalStep);
		energy_mark.classList.remove("compare-arrow-equl", "compare-arrow-up", "compare-arrow-down");
		energy_mark.classList.add(energyCompare.mark);
		energy_text.innerHTML = energyCompare.cText + "消耗了";
		if (energyCompare.diff == 0) {
			energy_compare.innerHTML = '';
			energy_unit.innerHTML = '';
			energy_text.innerHTML = energyCompare.cText;
		} else {
			energy_text.innerHTML = energyCompare.cText + "消耗了";
			energy_compare.innerHTML = energyCompare.diff;
			energy_unit.innerHTML = '卡路里';
		}
		process_mark.classList.remove("compare-arrow-equl", "compare-arrow-up", "compare-arrow-down");
		process_mark.classList.add(processCompare.mark);
		process_text.innerHTML = processCompare.cText + "完成";
		if (processCompare.diff == 0) {
			process_compare.innerHTML = '';
			process_unit.innerHTML = '';
			process_text.innerHTML = processCompare.cText;
		} else {
			process_compare.innerHTML = processCompare.diff;
			process_text.innerHTML = processCompare.cText + "完成";
			process_unit.innerHTML = '%';
		}
		totalStep_mark.classList.remove("compare-arrow-equl", "compare-arrow-up", "compare-arrow-down");
		totalStep_mark.classList.add(totalStepCompare.mark);
		totalStep_text.innerHTML = totalStepCompare.cText + "走了";
		if (totalStepCompare.diff == 0) {
			totalStep_compare.innerHTML = '';
			totalStep_unit.innerHTML = '';
			totalStep_text.innerHTML = totalStepCompare.cText;
		} else {
			totalStep_compare.innerHTML = totalStepCompare.diff;
			totalStep_text.innerHTML = totalStepCompare.cText + "走了";
			totalStep_unit.innerHTML = '步'
		}
		totalDistance_mark.classList.remove("compare-arrow-equl", "compare-arrow-up", "compare-arrow-down");
		totalDistance_mark.classList.add(totalDistanceCompare.mark);
		totalDistance_text.innerHTML = totalDistanceCompare.cText + "步行";
		if (totalDistanceCompare.diff == 0) {
			totalDistance_compare.innerHTML = '';
			totalDistance_unit.innerHTML = '';
			totalDistance_text.innerHTML = totalDistanceCompare.cText;
		} else {
			var dis = totalDistanceCompare.diff;

			if (dis < 1000) {
				dis = Math.round(dis);
				totalDistance_unit.innerHTML = '米';
			} else {
				dis = Math.round(dis / 100) / 10;
				totalDistance_unit.innerHTML = '公里';
			}
			totalDistance_compare.innerHTML = dis;
			totalDistance_text.innerHTML = totalDistanceCompare.cText + "步行";
		}
		var sportList = thisSportData.dataList;
		eChartShow();
		energy.innerHTML = thisEnergy;
		process.innerHTML = thisProcess;
		totalStep.innerHTML = thisTotalStep;
		if (thisTotalDistance < 1000) {
			totalDistanceUnit.innerHTML = '米';
			totalDistance.innerHTML = Math.floor(thisTotalDistance);
		} else {
			totalDistance.innerHTML = Math.round(thisTotalDistance / 100) / 10;
			totalDistanceUnit.innerHTML = '公里';
		}
	}
}

function compareSport(thisData, lastData) {
	var lessText = "比前一天少";
	var moreText = "比前一天多";
	var equlText = "和前一天一样";
	var hide = "compare-hide"
	var show = "compare-show"
	var diff = thisData - lastData;
	if (diff == 0) {
		return {
			mark: "compare-arrow-equl",
			cText: equlText,
			diff: diff
		};
	}
	if (diff > 0) {
		return {
			mark: "compare-arrow-up",
			cText: moreText,
			diff: diff
		};
	}
	if (diff < 0) {
		return {
			mark: "compare-arrow-down",
			cText: lessText,
			diff: -diff
		};
	}
}

function eChartShow() {
	if (isLoginUser) {
		g_tools.postCMD('getSportEventByDay2', {
			date: g_utils.dateFormat(new Date(thisTime), 'yyyy-MM-dd'),
		}, function(sportevent) {
			if (sportevent.code == 0) {
				var sportEventData = sportevent.data;
				sportEventData = quickSort(sportEventData);
				drawEChart(sportEventData)
			}
		}, g_tools.MODE_WEB);
	} else {
		g_tools.postCMD('getSportEventByDay2', {
			date: g_utils.dateFormat(new Date(thisTime), 'yyyy-MM-dd'),
			careId: careId
		}, function(sportevent) {
			if (sportevent.code == 0) {
				var sportEventData = sportevent.data;
				sportEventData = quickSort(sportEventData);
				drawEChart(sportEventData)
			}
		}, g_tools.MODE_WEB);
	}
}

function drawEChart(sportList) {
	var maxEnergy = 0;
	var division = 0;
	var xZero = new Date(thisTime);
	var dataList = new Array();
	var mergePointList = new Array();
	for (var p = 0; p < 49; p++) {
		mergePointList.push(0);
	}
	mergePointAdd = function(startTime, endTime, energy, zero) {
		var averageEnergy = 10 * energy / (endTime - startTime);
		if (startTime < zero) {
			mergePointList[0] = averageEnergy;
			startTime = zero;
		}
		if (endTime > zero + 86400000) {
			mergePointList[48] = averageEnergy;
			endTime = zero + 86400000;
		}
		var indexStart = Math.ceil((startTime - zero) / 1800000);
		var indexEnd = Math.ceil((endTime - zero) / 1800000);
		if (indexStart == indexEnd) {
			mergePointList[indexStart] = mergePointList[indexStart] + averageEnergy * (endTime - startTime);
		} else {
			mergePointList[indexStart] = mergePointList[indexStart] + averageEnergy * (zero + 1800000 * indexStart - startTime);
			mergePointList[indexEnd] = mergePointList[indexEnd] + averageEnergy * (endTime - (indexEnd - 1) * 1800000 - zero);
		}
	}
	xZero.setHours(0);
	xZero.setMinutes(0);
	xZero.setSeconds(0);
	xZero = xZero.getTime();
	var eventLength = sportList.length;
	for (var i = 0; i < eventLength; i++) {
		var startTime = sportList[i].startTime;
		var endTime = sportList[i].endTime;
		var itemEnergy = sportList[i].energy;
		if (endTime - startTime == 0) continue;
		mergePointAdd(startTime, endTime, itemEnergy, xZero);
	}
	for (i in mergePointList) {
		if (i == 0) {
			dataList.push([0, mergePointList[0]]);
			continue
		}
		if (i == 48) {
			dataList.push([24, mergePointList[48]]);
			continue
		}
		var averageEnergy = mergePointList[i] / 3;
		dataList.push([i / 2, averageEnergy]);
		if (averageEnergy > maxEnergy) maxEnergy = averageEnergy;
	}
	maxEnergy = Math.ceil(Math.max(maxEnergy, 16) * 5 / 4);
	division = maxEnergy / 4;
	myChart = echarts.init(document.getElementById('chart'));
	var option = {
		backgroundColor: '#FFFFFF',
		grid: {
			x: '15px',
			y: '5px',
			x2: '15px',
			y2: '15px',
			borderWidth: 0
		},
		xAxis: [{
			type: 'value',
			max: 24,
			min: 0,
			splitNumber: 12,
			axisLine: {
				lineStyle: {
					width: 1,
					color: '#CCCCCC'
				},
			},
			axisLabel: {
				margin: 5,
				textStyle: {
					fontSize: 9.7,
					color: '#CCCCCC'
				}
			},
			axisTick: {
				show: false
			},
			splitLine: {
				show: false,
			},
		}, ],
		yAxis: [{
			type: 'value',
			max: maxEnergy,
			min: 0,
			show: false,
			axisLabel: {
				show: false
			},
			axisLine: {
				show: false,
			},
			axisTick: {
				show: false
			},
		}, ],
		series: [{
			name: '卡路里',
			type: 'line',
			smooth: true,
			smoothMonotone: 'x',
			symbol: 'none',
			itemStyle: {
				normal: {
					color: 'rgba(48,180,134,1)',
					areaStyle: {
						color: 'rgba(48,180,134,0.2)'
					}
				}
			},
			areaStyle: {
				normal: {

				},
			},
			data: dataList
		}, ]
	}
	myChart.setOption(option);
}

function setActiveData() {
	if (isLoginUser) {
		g_tools.postCMD('getActiveSportEventByDay', {
				date: g_utils.dateFormat(new Date(thisTime), 'yyyy-MM-dd'),
				isGetDataList: 1
			},
			function(activeList) {
				if (activeList.code == 0) {
					activeSportList = activeList.data;
					activeSportShow(activeList.data);
				}
			},
			g_tools.MODE_WEB
		);
	} else {
		g_tools.postCMD('getActiveSportEventByDay', {
				date: g_utils.dateFormat(new Date(thisTime), 'yyyy-MM-dd'),
				isGetDataList: 1,
				careId: careId
			},
			function(activeList) {
				if (activeList.code == 0) {
					activeSportList = activeList.data;
					activeSportShow(activeList.data);
				}
			},
			g_tools.MODE_WEB
		);
	}
}

function activeSportShow(activeList) {
	var length = activeList.length;
	var parent = document.getElementById('activeSportContent');
	var item = document.querySelectorAll('case-item');
	var itemLength = item.length;
	parent.innerHTML = '';
	if (length == 0) {
		parent.classList.add("hide");
		return;
	} else {
		parent.classList.remove("hide");
		var title = document.createElement('div');
		title.className = "case-title";
		title.innerHTML = "<div class='case-icon sport-icon'></div>" +
			"<font class='title-text'>主动记录</font>" +
			"<font class='title-time'></font>"
		parent.appendChild(title);
	}
	for (var i = 0; i < length; i++) {
		//{path:img,type:type,show:showSub,unit:unit,countType:countType}
		var type = activeList[i].type;

		var startTime = activeList[i].startTime;
		var endTime = activeList[i].endTime;
		var totalStep = activeList[i].totalStep;
		if (totalStep == null || totalStep == undefined) {
			totalStep = 0;
		}
		var energy = activeList[i].energy;

		//        var imgSrc = sportProperty.getSportCircleIcon(type);
		//        var sportName = sportProperty.getSportName(type);
		var imgSrc = sportProperty.getSportCircleIconTemp(type, endTime, startTime, totalStep);
		var sportName = sportProperty.getSportNameTemp(type, endTime, startTime, totalStep);

		var timeUtil = getTimeDiff(endTime - startTime);
		var hour = timeUtil.hour;
		var minute = timeUtil.minute;
		var div = document.createElement('div');
		div.className = 'case-item';
		div.setAttribute('sport-item', i);
		div.setAttribute('sportType', type);
		var str = "<div class='case-item-icon' style='background-image: url(" + imgSrc + ");'></div>" +
			"<div class='case-item-type'>" + sportName + "</div>" +
			"<img src='image/icon_serve_boult.png' class='chose-detail-icon'/>" +
			"<div class='case-item-time-content'>"

		var timeStr = '';
		if (hour == 0 && minute != 0) {
			timeStr = "<div class='case-item-time-unit'>分钟</div>" +
				"<div class='case-item-time-data'>" + minute + "</div>"

		}
		if (minute == 0 && hour != 0) {
			timeStr = "<div class='case-item-time-unit'>小时</div>" +
				"<div class='case-item-time-data'>" + hour + "</div>"
		}
		if (hour != 0 && minute != 0) {
			timeStr = "<div class='case-item-time-unit'>分钟</div>" +
				"<div class='case-item-time-data'>" + minute + "</div>" +
				"<div class='case-item-time-unit'>小时</div>" +
				"<div class='case-item-time-data'>" + hour + "</div>"
		}
		if (hour == 0 && minute == 0) {
			timeStr = "<div class='case-item-time-unit'>分钟</div>" +
				"<div class='case-item-time-data'>" + "<1" + "</div>"

		}
		str = str + timeStr + "</div></div>";
		div.innerHTML = str;
		div.addEventListener("tap", function() {
			var sportType = this.getAttribute('sportType');
			var chooseIndex = this.getAttribute("sport-item");
			var sendMsg = activeSportList[chooseIndex];
			if (sportType == "13") {
				g_mui.openPage(g_module.myCareState,
					'sleepActiveSport.html', {
						sendMsg: sendMsg,
						careId: careId
					}
				);
			} else {
				g_mui.openPage(g_module.myCareState,
					'initActiveSport.html', {
						sendMsg: sendMsg,
						careId: careId
					}
				);
			}

		});
		parent.appendChild(div);
	}

}

function addHealthListener() {
	var healthCard = document.querySelectorAll('[health]');
	mui.each(healthCard, function(index, item) {
		var isEmpty = this.getAttribute('healthEmpty');
		if (isEmpty == null || isEmpty == undefined) {
			item.addEventListener('tap', openHealthChart);
		} else {
			if (isLoginUser) {
				item.addEventListener('tap', manualInputHealth);
			}
		}
	});

}

function openHealthChart() {
	var inputType = this.getAttribute('health');
	g_mui.openPage(g_module.myCareState,
		'healthChart.html', {
			getId: careId,
			getType: inputType
		}
	);
}

function manualInputHealth() {
	var inputType = this.getAttribute('health');
	var btnArray = ['去添加', '取消'];
	var typeName = g_printTools.printHealthTypeName(inputType);
	var title = '没有' + typeName + '数据';
	var content = '您还没有' + typeName + '数据，需要添加一条吗？';
	mui.confirm(content, title, btnArray, function(e) {
		if (e.index == 0) {
			g_mui.openPage(g_module.myCareState,
				'manualInputHealth.html', {
					kind: inputType,
				}
			);
		}
	});
}

function changePage() {
	var locationPage = document.getElementById('locationContent');
	var sportPage = document.getElementById('sportContent');
	locationPage.addEventListener('tap', function() {
		g_mui.openPage(g_module.myCareState,
			'mapMagnify.html', {
				getId: careId,
				getTime: g_utils.dateFormat(new Date(thisTime), 'yyyy-MM-dd'),
				getPhoto: careImg
			}
		);
	});
	sportPage.addEventListener('tap', function() {
		g_mui.openPage(g_module.myCareState,
			"sportMagnify.html", {
				getId: careId,
				getTime: g_utils.dateFormat(new Date(thisTime), 'yyyy-MM-dd'),
				getPhoto: careImg
			}
		);
	});
}

function statusColor(status) {
	var m = parseInt(status);
	var color;
	var txt;
	//    0【正常】、1【预警】、2【异常】）
	switch (m) {
		case 0:
			color = "#666666";
			break;
		case 1:
			color = "#666666";
			break;
		case 2:
			color = "#FF8080";
			break;
		default:
			break;
	}
	return color;
}

function quickSort(arr) {
	//如果数组<=1,则直接返回
	if (arr.length <= 1) {
		return arr;
	}
	var pivotIndex = Math.floor(arr.length / 2);
	//找基准，并把基准从原数组删除
	var pivot = arr.splice(pivotIndex, 1)[0];
	//定义左右数组
	var left = [];
	var right = [];
	//比基准小的放在left，比基准大的放在right
	for (var i = 0; i < arr.length; i++) {
		if (arr[i].endTime <= pivot.endTime) {
			right.push(arr[i]);
		} else {
			left.push(arr[i]);
		}
	}
	//递归
	return quickSort(left).concat([pivot], quickSort(right));
}

//定义一个比较器
function compare(propertyName) {
	return function(object1, object2) {
		var value1 = object1[propertyName];
		var value2 = object2[propertyName];
		if (value2 < value1) {
			return 1;
		} else if (value2 > value1) {
			return -1;
		} else {
			return 0;
		}
	}
}
