var myContact = {};
var emergencyContacts = [];
var editStatus = false;

var eId, eName, ePhone, ePriority, eRelation;
//所有的紧急联系人优先级
var allPriority = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10];

var editName = document.getElementById('editName');
var editEmg = document.getElementById('editEmg');
var editPhone = document.getElementById('editPhone');
var eidtRelation = document.getElementById('eidtRelation');

var eDelBtn = document.getElementById('eDelBtn');
var eSaveBtn = document.getElementById('eSaveBtn');

//mui初始化
mui.init();
mui.plusReady(function() {
	var self = plus.webview.currentWebview();
	myContact = self.contact;
	emergencyContacts = self.emergencyContacts;
	eDomInit();
	refreshInput();
	
	//默认直接显示编辑状态
	setEditStatus(true);
});

function eDomInit() {
	//-----------------------------------------
	//紧急联系人设定
	selectPicker = new mui.PopPicker();
	selectPicker.setData(creatPickerData());
	editEmg.addEventListener('tap', function(e) {
		selectPicker.pickers[0].setSelectedValue(parseInt(editEmg.value == "普通联系人" ? "100" : editEmg.value.substring(5)));
		selectPicker.show(function(items) {
			editEmg.value = items[0].text;
			ePriority = parseInt(items[0].value);
		});
	});

	eDelBtn.addEventListener('tap', function(e) {
		if(!g_utils.isEmptyArray(emergencyContacts) && emergencyContacts.length == 1) {
			g_mui.alert('为保证紧急情况时能及时通知您的家人，您必须保留一名紧急联系人。', '无法删除', function() {
			});
		} else {
			g_mui.confirm('删除后，该号码拨打伙伙时被自动拦截无法接通。确定要删除吗？', '删除联系人', ['取消', '确定'], function(e) {
				if(e.index == 1) {
					deleteContact();
				}
			});
		}
	});

	eSaveBtn.addEventListener('tap', function(e) {
		if(editStatus) { //如果是编辑状态，执行保存操作
			saveEdit();
		} else {
			setEditStatus(true);
		}
	});
}

function refreshInput() {
	eId = myContact.id;
	eName = myContact.name;
	ePhone = myContact.phone;
	ePriority = myContact.priority;
	eRelation = myContact.relation;

	if(!g_utils.isEmpty(eName)) {
		editName.value = eName;
	}
	if(!g_utils.isEmpty(ePhone)) {
		editPhone.value = ePhone;
	}
	if(!g_utils.isEmpty(ePriority)) {
		if(ePriority == 100) {
			editEmg.value = "普通联系人";
		} else {
			editEmg.value = "紧急联系人" + ePriority;
		}
	}
	if(!g_utils.isEmpty(eRelation)) {
		eidtRelation.value = eRelation;
	}
}

function saveEdit() {
	eName = editName.value;
	ePhone = editPhone.value;

	eRelation = eidtRelation.value;
	if(g_utils.isEmpty(eName)) {
		g_mui.alert('姓名不能为空！');
	} else if(g_utils.isEmpty(ePhone)) {
		g_mui.alert('电话号码不能为空！');
	} else if(g_utils.isEmpty(ePriority)) {
		g_mui.alert('请选择联系人优先级！');
	} else {
        if (eName.length > 10){
            g_mui.alert('输入姓名不能超过10个字');
        }
        else if (!g_utils.isEmpty(eidtRelation.value) && eidtRelation.value.length > 10){
            g_mui.alert('输入备注不能超过10个字');
        }else{
            modifyContact();
        }
	}
}

function modifyContact() {
	var parameters1 = {
		"id": eId,
		"name": eName,
		"phone": ePhone,
		"priority": ePriority,
		"relation": eRelation
	};
	g_tools.postCMD("modifyContact", parameters1, function(result) {
		if(result.code == 0) {
			g_mui.toast(result.tip);
			var wobj = plus.webview.getWebviewById("myHuoHuo:contactList.html");
			wobj.reload(true);
			setTimeout('mui.back();', 500);
			
		}
	})
}

function deleteContact() {
	var parameters2 = {
		"id": eId
	};
	g_tools.postCMD("deleteContact", parameters2, function(result) {
		if(result.code == 0) {
			g_mui.toast(result.tip);
			var wobj = plus.webview.getWebviewById("myHuoHuo:contactList.html");
			wobj.reload(true);
			setTimeout('mui.back();', 500);
		}
	})
}

/**
 * 根据编辑状态处理
 * @param {Boolean} isNot 是否为编辑状态
 */
function setEditStatus(isNot) {
	editStatus = isNot;
	var allInput = document.getElementsByTagName('input');
	for(var i = 0; i < allInput.length; i++) {
		if(isNot) {
			allInput[i].disabled = "";
		} else {
			allInput[i].disabled = "disabled";
		}
	}
	eSaveBtn.innerHTML = isNot ? "保存" : "编辑";
	eDelBtn.style.display = isNot ? "block" : "none";
}

function getUsePriority() {
	var priority = [];
	if(!g_utils.isEmpty(emergencyContacts)) {
		for(var i = 0; i < emergencyContacts.length; i++) {
			priority.push(emergencyContacts[i].priority);
		}
	}
	return priority;
}

function getUnUsePriority() {
	var usePriority = getUsePriority();
	var priority = [];
	for(var i = 0; i < allPriority.length; i++) {
		var isHave = false;
		if(!g_utils.isEmpty(usePriority)) {
			for(var j = 0; j < usePriority.length; j++) {
				if(allPriority[i] == usePriority[j]) {
					isHave = true;
				}
				if(allPriority[i] == myContact.priority) { //包含编辑的优先级
					isHave = false;
				}
			}
		}
		if(!isHave) {
			priority.push(allPriority[i]);
		}
	}
	return priority;
}

function creatPickerData() {
	var unusePriority = getUnUsePriority();
	var datas = [];

	for(var i = 0; i < unusePriority.length; i++) {
		var data = {};
		data.value = unusePriority[i];
		data.text = "紧急联系人" + unusePriority[i];
		datas.push(data);
	}
	var data = {};
	data.value = 100;
	data.text = "普通联系人";
	datas.push(data);
	return datas;
}
