var serviceCodes = ["SP001", "SP002", "SP003", "SP005"]; /*sp001 基础服务包 sp002跌倒及紧急情况帮助服务包 sp003电子围栏服务包 sp005 通讯服务包*/
mui.init();
mui.plusReady(function() {
	var self = plus.webview.currentWebview();
	var package = self.package;

	//model
	mdata = {};
	mdata["package"] = package;

	//mMethods
	mMethods = {};
	mMethods["getTimeFormat"] = getTimeFormat;
	mMethods["isBase"] = isBase;
	mMethods["isTumble"] = isTumble;
	mMethods["isFence"] = isFence;
	mMethods["isCommunication"] = isCommunication;
	mMethods["fomatBalance"] = fomatBalance;
	mMethods["onTapClause"] = onTapClause;
	//vue
	new Vue({
		el: '#main',
		data: mdata,
		methods: mMethods,

	});

	//隐藏掉滚动条
	mui('.mui-scroll-wrapper').scroll({
		indicators: false
	});
});

function getTimeFormat(timeMills) {
	if(!g_utils.isEmpty(timeMills)) {
		return g_utils.dateFormat(timeMills, "yyyy年MM月dd日");
	}else{
		return '未获取';
	}
}
/**
 * 是否是基础服务包
 * @param {Object} code
 */
function isBase(code) {
	return serviceCodes[0] == code;
}
/**
 * 是否是跌倒服务包
 * @param {Object} code
 */
function isTumble(code) {
	return serviceCodes[1] == code;
}

/**
 * 是否是安全围栏服务包
 * @param {Object} code
 */
function isFence(code) {
	return serviceCodes[2] == code;
}

/**
 * 是否是通讯服务包
 * @param {Object} code
 */
function isCommunication(code) {
	return serviceCodes[3] == code;
}

/**
 * 处理显示的话费余额
 * @param {Object} balance
 */
function fomatBalance(balance) {
	if(g_utils.isEmpty(balance)) {
		return "0.00";
	}
	return balance.toFixed(2);
}

function onTapClause(url) {
	g_mui.openPage(g_module.servicesPackageList, url);
}