var STATUS_ACTIVATE = 0; //即将生效
var STATUS_INLINE = 1; //即将到期
var STATUS_NORMAL = 2; //正在使用
var STATUS_FAILED= 3;         //已失效*/
var ENABLE = 0; //未禁用

mui.init({
	pullRefresh: {
		container: "#refreshContainer", //下拉刷新容器标识，querySelector能定位的css选择器均可，比如：id、.class等
		down: {
			height: 50, //可选,默认50.触发下拉刷新拖动距离,
			auto: true, //可选,默认false.自动下拉刷新一次
			contentdown: "下拉可以刷新", //可选，在下拉可刷新状态时，下拉刷新控件上显示的标题内容
			contentover: "释放立即刷新", //可选，在释放可刷新状态时，下拉刷新控件上显示的标题内容
			contentrefresh: "正在刷新...", //可选，正在刷新状态时，下拉刷新控件上显示的标题内容
			callback: pullfresh //必选，刷新函数，根据具体业务来编写，比如通过ajax从服务器获取新数据；
		},
		up: {
			height: 50, //可选.默认50.触发上拉加载拖动距离
			auto: false, //可选,默认false.自动上拉加载一次
			contentrefresh: "正在加载...", //可选，正在加载状态时，上拉加载控件上显示的标题内容
			contentnomore: '没有更多数据了', //可选，请求完毕若没有更多数据时显示的提醒内容；
			callback: pullfreshUp //必选，刷新函数，根据具体业务来编写，比如通过ajax从服务器获取新数据；
		}
	}
});


mui.plusReady(function() {
	//隐藏掉滚动条
	plus.webview.currentWebview().setStyle({
		scrollIndicator: 'none'
	});
	//model
	mdata = {};
	mdata['myPackages'] = [];

	//methods
	mMethods = {};
	mMethods["isHaveMyPackages"] = isHaveMyPackages;
	mMethods["getTimeFormat"] = getTimeFormat;
	mMethods["getImgUrlByStatusDisable"] = getImgUrlByStatusDisable;
	mMethods["onTapMyPackage"] = onTapMyPackage;

	new Vue({
		el: '#my',
		data: mdata,
		methods: mMethods,
	});
});
/**
 * 是否有人关爱我   true为空 false非空
 * @param {Object} careMeList
 */
function isHaveMyPackages(myPackages){
	return !g_utils.isEmptyArray(myPackages);
}

function getTimeFormat(timeMills) {
	return g_utils.dateFormat(timeMills, "yyyy年MM月dd日");
}

function getImgUrlByStatusDisable(status, disable) {
	if(disable == ENABLE) {
		if(status == STATUS_ACTIVATE) {
			return 'img/icon_serve_ativate.png';
		} else if(status == STATUS_INLINE) {
			return 'img/icon_serve_in_line.png';
		} else if(status == STATUS_NORMAL) {
			return 'img/icon_serve_normal.png';
		}
	} else {
		return 'img/icon_serve_failure.png';
	}
}

function onTapMyPackage(package){
	g_mui.openPage(g_module.servicesPackageList,'myPackageDetail.html',{package:package})
}

function pullfresh() {
	setTimeout(function() {
        //得到我的服务包列表
		g_tools.postCMD('getServicesPackageList2', {}, function(data) {
			if(data.code == 0) {
				mdata['myPackages'] = data.data;
			}
		},g_tools.MODE_CACHE_THEN_WEB_LOCAL);
		mui('#refreshContainer').pullRefresh().endPulldownToRefresh();
    }, 100);
	
}

function pullfreshUp() {
	//业务逻辑代码，比如通过ajax从服务器获取新数据；
	//注意：
	//1、加载完新数据后，必须执行如下代码，true表示没有更多数据了：
	//2、若为ajax请求，则需将如下代码放置在处理完ajax响应数据之后
	this.endPullupToRefresh(true | false);
}