var serviceCodes = ["SP001", "SP002", "SP003", "SP005", "SP006"]; /*sp001 基础服务包 sp002跌倒及紧急情况帮助服务包 sp003电子围栏服务包 sp005 通讯服务包*/
var baseImgs = ['img/icon_serve_base_1.png', 'img/icon_serve_base_2.png', 'img/icon_serve_base_3.png'];
var trumbleImgs = ['img/icon_serve_tumble_1.png', 'img/icon_serve_tumble_2.png', 'img/icon_serve_tumble_3.png'];
var fenceImgs = ['img/icon_serve_fence_1.png', 'img/icon_serve_fence_2.png'];
var communicateImgs = ['img/icon_serve_communicate_1.png', 'img/icon_serve_communicate_2.png'];
var insuranceImgs=['img/icon_insurance_new_1.png','img/icon_insurance_new_2.png','img/icon_insurance_new_3.png']
var headImgs = ['img/serve_img_base_details.png', 'img/serve_img_tumble_details.png', 'img/serve_img_fence_details.png', 'img/serve_img_communicate_details.png', 'img/serve_img_insurance_details.png'];
var clauseUrls = ['clause/base_clause.html', 'clause/tumble_clause.html', 'clause/fence_clause.html', 'clause/communication_clause.html', 'clause/insurance_clause.html'];

mui.init();
mui.ready(function() {
	mui.plusReady(function() {
		var self = plus.webview.currentWebview();
		var package = self.package;

		//model
		mdata = {};
		mdata["package"] = package;
		mdata["servePersonName"] = "未获取";
		mdata["devPhone"] = "未获取";
		mdata['myPackages'] = [];
		mdata['show'] = false;

		//mMethods
		mMethods = {};
		mMethods['getHeadImgByCode'] = getHeadImgByCode;
		mMethods['getIntroImgBycode'] = getIntroImgBycode;
		mMethods["getTimeFormat"] = getTimeFormat;
		mMethods["isHaveInsurance"] = isHaveInsurance;
		mMethods["getAmount"] = getAmount;
		mMethods["onTapClauseByCode"] = onTapClauseByCode;
		mMethods["onTapClause"] = onTapClause;
		mMethods["getStartEndTime"] = getStartEndTime;

		//vue
		new Vue({
			el: '#main',
			data: mdata,
			methods: mMethods,
		});

		//得到我的服务包列表
		g_tools.postCMD('getServicesPackageList2', {}, function(data) {
			if(data.code == 0) {
				mdata['myPackages'] = data.data;
			}
		}, g_tools.MODE_CACHE_THEN_WEB_LOCAL);
		//隐藏掉滚动条
		mui('.mui-scroll-wrapper').scroll({
			indicators: false
		});

		document.getElementById('topTab1').addEventListener('tap', function() {
			setTabTap('default1', 'defaultTab');
		});
		document.getElementById('topTab2').addEventListener('tap', function() {
			setTabTap('default2', 'defaultTab');
		});
		document.getElementById('default1').addEventListener('tap', function() {
			setTabTap('topTab1', 'topTab');
		});
		document.getElementById('default2').addEventListener('tap', function() {
			setTabTap('topTab2', 'topTab');
		});

		setTimeout("scrollTabFixed('defaultTab', 'topTab')", 500);
		getRealName(package);
		getDevList(package);
	});
});

function getStartEndTime(package) {
	var startEndTime = "未获取";
	var myPackages = mdata['myPackages'];
	for(var i in myPackages) {
		var myPackage = myPackages[i];
		if(myPackage.code == package.code) {
			startEndTime = getTimeFormat(myPackage.startTime) + " 至 " + getTimeFormat(myPackage.endTime);
		}
	}
	return startEndTime;
}
/**
 * 实名认证真实名字
 */
function getRealName(package) {
	//得到对象真实姓名
	g_tools.postCMD('getRealNameAuth', {}, function(data) {
		if(data.code == 0) {
			var realName = data.data.name;
			if(!g_utils.isEmpty(realName)) {
				if(!isAboutPhone(package)) {
					mdata['servePersonName'] = realName;
				}
			}
		}
	}, g_tools.MODE_CACHE_THEN_WEB_LOCAL);
}

function getDevList() {
	//获得设备信息
	g_tools.postCMD('getDeviceList', {}, function(data) {
		if(data.code == 0) {
			var devList = data.data;
			if(!g_utils.isEmptyArray(devList)) {
				var phoneName = devList[0].phoneName;
				var phone = devList[0].phone;
				if(!g_utils.isEmpty(phoneName)) {
					if(isAboutPhone(mdata["package"]))
						mdata['servePersonName'] = phoneName;
				}
				if(!g_utils.isEmpty(phone)) {
					mdata['devPhone'] = phone;
				}
			}
		}
	}, g_tools.MODE_CACHE_THEN_WEB_LOCAL);
}

/**
 * 是否是包含保险的服务包
 * @param {Object} code
 */
function isHaveInsurance(code) {
	return code == serviceCodes[1];
}
/**
 * 是否是与电话相关的服务
 * @param {Object} package
 */
function isAboutPhone(package) {
	return package.isPhoneSP == 1;
}

/**
 * 得到显示的保障金额
 */
function getAmount(package) {
	return package.jsonData.insurance.calAmount / 10000 + "万元起";
}

/**
 * 模拟点击选项卡切换
 * @param {Object} tapId  点击的选项id
 * @param {Object} tabId  选项卡id
 */
function setTabTap(tapId, tabId) {
	var tapTab = document.getElementById(tapId);

	var tabShowId = tapTab.getAttribute('href').substring(1);
	var tabShow = document.getElementById(tabShowId);

	//切换选项卡高亮
	var current = document.getElementById(tabId).getElementsByClassName('mui-active')[0];
	var curShowId = current.getAttribute('href').substring(1);
	var curShow = document.getElementById(curShowId);

	if(tapTab !== current) {
		current.classList.remove('mui-active');
		curShow.classList.remove('mui-active');
		tapTab.classList.add('mui-active');
		tabShow.classList.add('mui-active');
	}
}

function scrollTabFixed(id1, id2) {
	var obj1 = document.getElementById(id1);
	var height = obj1.offsetTop;
	var obj2 = document.getElementById(id2);

	var scroll = mui('.mui-scroll-wrapper').scroll();
	document.querySelector('.mui-scroll-wrapper').addEventListener('scroll', function(e) {
		var scrollTop = -scroll.y;
		if(scrollTop < height) {
			obj2.className = 'mui-hidden';
		} else {
			obj2.className = '';
		}
	});
}

function getHeadImgByCode(code) {
	var headImg = headImgs[0];
	for(var i = 0; i < serviceCodes.length; i++) {
		if(code == serviceCodes[i]) {
			headImg = headImgs[i];
		}
	}
	return headImg;
}

function getIntroImgBycode(code, index) {
	if(code == serviceCodes[0]) {
		return baseImgs[index];
	} else if(code == serviceCodes[1]) {
		return trumbleImgs[index];
	} else if(code == serviceCodes[2]) {
		return fenceImgs[index];
	} else if(code == serviceCodes[3]) {
		return communicateImgs[index];
	} else if(code == serviceCodes[4]) {
		return insuranceImgs[index];
	}
}

function getTimeFormat(timeMills) {
	return g_utils.dateFormat(timeMills, "yyyy-MM-dd");
}

function onTapClauseByCode(code) {
	var url = "";
	if(code == serviceCodes[0]) {
		url = clauseUrls[0];
	} else if(code == serviceCodes[1]) {
		url = clauseUrls[1];
	} else if(code == serviceCodes[2]) {
		url = clauseUrls[2];
	} else if(code == serviceCodes[3]) {
		url = clauseUrls[3];
	} else if(code == serviceCodes[4]) {
		url = clauseUrls[4];
	}
	g_mui.openPage(g_module.servicesPackageList, url);
}

function onTapClause(url) {
	g_mui.openPage(g_module.servicesPackageList, url);
}
