/*sp001 基础服务包 sp002跌倒及紧急情况帮助服务包 sp003电子围栏服务包 sp005 通讯服务包*/
var serviceCodes = ["SP001", "SP002", "SP003", "SP005", "SP006"];
var imgUrls = ["img/serve_img_base.png", "img/serve_img_tumble.png", "img/serve_img_fence.png", "img/serve_img_communicate.png", "img/serve_img_insurance.png"];
var imgNoBoughtUrl="img/serve_icon.png";
var imgBoughtUrl ="img/serve_icon_bought.png" ;
var imgFailureUrl ="img/serve_icon_failure.png" ;

mui.init({
	pullRefresh: {
		container: "#refreshContainer", //下拉刷新容器标识，querySelector能定位的css选择器均可，比如：id、.class等
		down: {
			height: 50, //可选,默认50.触发下拉刷新拖动距离,
			auto: false, //可选,默认false.自动下拉刷新一次
			contentdown: "下拉可以刷新", //可选，在下拉可刷新状态时，下拉刷新控件上显示的标题内容
			contentover: "释放立即刷新", //可选，在释放可刷新状态时，下拉刷新控件上显示的标题内容
			contentrefresh: "正在刷新...", //可选，正在刷新状态时，下拉刷新控件上显示的标题内容
			callback: pullfresh //必选，刷新函数，根据具体业务来编写，比如通过ajax从服务器获取新数据；
		},
		up: {
			height: 50, //可选.默认50.触发上拉加载拖动距离
			auto: false, //可选,默认false.自动上拉加载一次
			contentrefresh: "正在加载...", //可选，正在加载状态时，上拉加载控件上显示的标题内容
			contentnomore: '没有更多数据了', //可选，请求完毕若没有更多数据时显示的提醒内容；
			callback: pullfreshUp //必选，刷新函数，根据具体业务来编写，比如通过ajax从服务器获取新数据；
		}
	},
	gestureConfig: {
		tap: true, //默认为true
		doubletap: true, //默认为false
		longtap: true, //默认为false
		swipe: true, //默认为true
		drag: true, //默认为true
		hold: false, //默认为false，不监听
		release: false //默认为false，不监听
	}
});

mui.ready(function() {
	//    alert('sublist ready');
	mui.plusReady(function() {
		//隐藏掉滚动条
		plus.webview.currentWebview().setStyle({
			scrollIndicator: 'none'
		});

		//model
		mdata = {};
		mdata['servicesPackages'] = [];
		mdata['boughtServicesPackages'] = [];

		//methods
		mMethods = {};
		mMethods["onTapList"] = onTapList;
		mMethods["getImgUrl"] = getImgUrl;
		mMethods["getImgStatusUrl"] = getImgStatusUrl;

		new Vue({
			el: '#main',
			data: mdata,
			methods: mMethods,

		});

		getData();
	});
});

function onTapList(package) {
	g_mui.openPage(g_module.servicesPackageList, 'packageIntro.html', {
		package: package,
	});
};

function pullfresh() {
	setTimeout(function() {
		getData();
	}, 100);
}

function getData() {
	//得到所有可购买的服务包列表
	g_tools.postCMD('getALLServicesPackageList', {}, function(data) {
		if(data.code == 0) {
			mdata['servicesPackages'] = data.data;
			//得到我的服务包列表
			g_tools.postCMD('getServicesPackageList2', {}, function(data) {
				if(data.code == 0) {
					mdata['boughtServicesPackages'] = data.data;
				}
			}, g_tools.MODE_WEB_LOCAL_CACHE);
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE, { //！！！！！！！！！重点代码！！！！！！！！！
		noNetworkMode: g_tools.TIP_MODE_INTERFACE, //界面显示断网提示内容的模式
		contentDomId: 'mainContent', //显示数据内容的dom元素id
		tipDomId: 'noNetworkTip' //显示断网提示的dom元素id
	});

	mui('#refreshContainer').pullRefresh().endPulldownToRefresh();

}

function pullfreshUp() {
	//业务逻辑代码，比如通过ajax从服务器获取新数据；
	//注意：
	//1、加载完新数据后，必须执行如下代码，true表示没有更多数据了：
	//2、若为ajax请求，则需将如下代码放置在处理完ajax响应数据之后
	this.endPullupToRefresh(true);
}

/**
 * 根据code判断服务包是否已购买
 * @param {Object} code 服务包编号
 */
function isNotBoughtServiceByPackName(code) {
	var isNotBought = false;
	var boughtServicesPackages = mdata.boughtServicesPackages;
	if(boughtServicesPackages.length > 0) {
		for(var i = 0; i < boughtServicesPackages.length; i++) {
			var bPackage = boughtServicesPackages[i];
			if(code == bPackage.code) {
				isNotBought = true;
			}
		}
	}
	return isNotBought;
}

/**
 * 根据code判断服务包是否已失效
 * @param {Object} code
 */
function isNotDisableServiceByPackName(code) {
	var ENABLE = 0; //未禁用
	var isNotDisable = false;
	var boughtServicesPackages = mdata.boughtServicesPackages;

	if(boughtServicesPackages.length > 0) {
		for(var i = 0; i < boughtServicesPackages.length; i++) {
			var bPackage = boughtServicesPackages[i];
			if(bPackage.disabled != ENABLE && code == bPackage.code) {
				isNotDisable = true;
			}
		}
	}
	return isNotDisable;
}
/**
 * 根据code得到显示img地址
 * @param {Object} code 服务包编号
 */
function getImgUrl(code) {
	var imgUrl = null;
	for(var i = 0; i < serviceCodes.length; i++) {
		if(serviceCodes[i] == code) {
			imgUrl = imgUrls[i];
		}
	}	
	return imgUrl;
}

function getImgStatusUrl(code) {
	var imgUrl = null;

	if(isNotBoughtServiceByPackName(code)) {
		if(isNotDisableServiceByPackName(code)) {
			imgUrl = imgFailureUrl;
		} else {
			imgUrl = imgBoughtUrl;
			
		}
	} else {
		imgUrl = imgNoBoughtUrl;
	}
	return imgUrl;
}
