var showSportSrcPicker = document.getElementById('showSportSrcPicker');
var showLocationSrcPicker = document.getElementById('showLocationSrcPicker');
var showHealthSrcPicker = document.getElementById('showHealthSrcPicker');
var sportSrcResult = document.getElementById('sportSrcResult');
var locationSrcResult = document.getElementById('locationSrcResult');
var healthSrcResult = document.getElementById('healthSrcResult');
var dataSrcTip = document.getElementById('dataSrcTip');
var indexPage;

//设置类
var set;
var sportSrcPicker, locationSrcPicker, healthSrcPicker;
var os;
mui.init();
mui.plusReady(function() {
	os = plus.os.name; //平台
	indexPage = plus.webview.getWebviewById('index');
	if(os == g_config.ANDROID) { //如果是android平台
		showHealthSrcPicker.classList.add('mui-hidden');
		dataSrcTip.innerHTML = "数据来源设置为手机后，APP与伙伙的显示内容可能会不一致。";
	} else if(os == g_config.IOS) { //如果是ios平台
		showHealthSrcPicker.classList.remove('mui-hidden');
		dataSrcTip.innerHTML = "数据来源设置为手机后，APP与伙伙的显示内容可能会不一致。若您已连接过苹果应用“健康”，请到“健康”中修改设置。";
	}
	initPicker();
	getSetting();
});

function initPicker() {
	var pickerData = [{
		value: "0",
		text: '伙伙'
	}, {
		value: "1",
		text: '手机'
	}];

	var pickerData2 = [{
		value: "0",
		text: '健康测量设备'
	}, {
		value: "1",
		text: '健康测量设备和苹果"健康"'
	}];
	//运动数据来源
	sportSrcPicker = new mui.PopPicker();
	sportSrcPicker.setData(pickerData);
	showSportSrcPicker.addEventListener('tap', function(event) {
		var sportSrcValue = sportSrcResult.innerHTML;
		if(sportSrcValue !== "未获取") {
			sportSrcPicker.pickers[0].setSelectedValue(sportSrcValue == "伙伙" ? "0" : "1");
		}
		sportSrcPicker.show(function(items) {
			sportSrcResult.className = 'selected';
			var selectSportValue = parseInt(items[0].value);
			if(selectSportValue == 0) {
				//触发首页停止记步
				mui.fire(indexPage, 'stopPhoneStep');
			} else if(selectSportValue == 1) {
				//触发首页开始记步
				mui.fire(indexPage, 'startPhoneStep');
				if(plus.os.name == g_config.IOS) {
					g_healthNative.getPermission(function(data) {
						var result = data[0];
						if(result == "该设备不支持HealthKit" || result == "获取权限失败") {
							g_mui.alert(result);
							//        }else if (result == "获取权限成功"){
							//            alert("ok");
						}
					}, function(err) {});
				}
			}
			modifyDataFrom('stepFrom', selectSportValue);
		});
	}, false);
	//-----------------------------------------
	//位置数据来源
	locationSrcPicker = new mui.PopPicker();
	locationSrcPicker.setData(pickerData);
	showLocationSrcPicker.addEventListener('tap', function(event) {
		var locationSrcValue = locationSrcResult.innerHTML;
		if(locationSrcValue !== "未获取") {
			locationSrcPicker.pickers[0].setSelectedValue(locationSrcValue == "伙伙" ? "0" : "1");
		}
		locationSrcPicker.show(function(items) {
			locationSrcResult.className = 'selected';
			var selectLocationValue = parseInt(items[0].value);
			if(selectLocationValue == 0) {
				//触发首页停止手机定位
				mui.fire(indexPage, 'stopPhoneLocation');
			} else if(selectLocationValue == 1) {
				//触发首页开始发送手机位置
				mui.fire(indexPage, 'startPhoneLocation');
			}
			modifyDataFrom('locationFrom', selectLocationValue);
		});
	}, false);

	//-----------------------------------------
	//健康数据来源
	healthSrcPicker = new mui.PopPicker();
	healthSrcPicker.setData(pickerData2);
	showHealthSrcPicker.addEventListener('tap', function(event) {
		var healthSrcValue = healthSrcResult.innerHTML;
		if(healthSrcValue !== "未获取") {
			healthSrcPicker.pickers[0].setSelectedValue(healthSrcValue == "健康测量设备" ? "0" : "1");
		}
		healthSrcPicker.show(function(items) {
			healthSrcResult.className = 'selected';
			var selectHealthValue = parseInt(items[0].value);
			if(selectHealthValue == 1) {
				if(plus.os.name == g_config.IOS) {
					g_healthNative.getPermission(function(data) {
						var result = data[0];
						if(result == "该设备不支持HealthKit" || result == "获取权限失败") {
							g_mui.alert(result);
						//        }else if (result == "获取权限成功"){
						//            alert("ok");
						}
					}, function(err) {});
				}
			}
			modifyDataFrom('healthFrom', selectHealthValue);
		});
		
	}, false);
}

function getSetting() {
	g_tools.postCMD("getSettings", null, function(result) {
		if(result.code == 0) {
			set = result.data;
			refreshDataFrom();
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE);
}

/**
 * 刷新数据来源信息
 */
function refreshDataFrom() {
	if(!g_utils.isEmpty(set)) {
		sportSrcResult.innerHTML = (set.stepFrom == 0 ? "伙伙" : "手机");
		sportSrcResult.className = 'selected';

		locationSrcResult.innerHTML = (set.locationFrom == 0 ? "伙伙" : "手机");
		locationSrcResult.className = 'selected';

		healthSrcResult.innerHTML = (set.healthFrom == 0 ? "健康测量设备" : '健康测量设备和苹果"健康"');
		healthSrcResult.className = 'selected';
	}
}

/*
 * 更改设置数据来源信息
 * @param ｛String｝属性名
 * @param ｛｝属性值
 */
function modifyDataFrom(key, value) {
	var parameters = {};
	addParameter("healthSwitch", set.healthSwitch, parameters);
	addParameter("sportSwitch", set.sportSwitch, parameters);
	addParameter("noticeSwitch", set.noticeSwitch, parameters);
	addParameter("locateSwitch", set.locateSwitch, parameters);
	key == "stepFrom" ? addParameter(key, value, parameters) : addParameter("stepFrom", set.stepFrom, parameters);
	key == "locationFrom" ? addParameter(key, value, parameters) : addParameter("locationFrom", set.locationFrom, parameters);
	key == "healthFrom" ? addParameter(key, value, parameters) : addParameter("healthFrom", set.healthFrom, parameters);
	g_tools.postCMD("modifySettings", parameters, function(result) {
		if(result.code == 0) {
			getSetting();
		}
	});
}

/*
 * 插入请求参数
 */
function addParameter(key, value, parameters) {
	parameters[key] = value;
}