//设置类
var set;
//switch on
var g_SWITCH_ON = 1;
var g_SWITCH_OFF = 0;



var shareHealth = document.getElementById('shareHealth');
var shareSport = document.getElementById('shareSport');
var sharePosition = document.getElementById('sharePosition');
//mui初始化
mui.init();
mui.plusReady(function() {
	initDom();
	getSetting();
});

function initDom() {
	shareHealth.addEventListener("toggle", function(event) {
		modifySwitch();
	});

	shareSport.addEventListener("toggle", function(event) {
		modifySwitch();
	});

	sharePosition.addEventListener("toggle", function(event) {
		modifySwitch();
	});
}

function getSetting() {
	g_tools.postCMD("getSettings", null, function(result) {
		if(result.code == 0) {
			set = result.data;
			refreshSwitch();
		}
	}, g_tools.MODE_WEB_LOCAL_CACHE);
}

function refreshSwitch() {
	if(!g_utils.isEmpty(set)) {
		setSwitch(shareHealth, set.healthSwitch == g_SWITCH_ON);
		setSwitch(shareSport, set.sportSwitch == g_SWITCH_ON);
		setSwitch(sharePosition, set.locateSwitch == g_SWITCH_ON);
	}
}

/**
 * 更改共享数据
 */
function modifySwitch() {
	var parameters = {};
	addParameter("healthSwitch", getSwitchValue(shareHealth), parameters);
	addParameter("sportSwitch", getSwitchValue(shareSport), parameters);
	addParameter("noticeSwitch",set.noticeSwitch, parameters);
	addParameter("locateSwitch", getSwitchValue(sharePosition), parameters);
	addParameter("stepFrom",set.stepFrom, parameters);
	addParameter("locationFrom",set.locationFrom, parameters);
	addParameter("healthFrom",set.healthFrom, parameters);
	g_tools.postCMD("modifySettings", parameters, function(result) {
		if(result.code == 0) {
			getSetting();
		}
	})
}

/*
 * 插入请求参数
 */
function addParameter(key, value, parameters) {
	parameters[key] = value;
}
/**
 * 设置switch
 * @param {Object} obj
 * @param {boolean} isON
 */
function setSwitch(obj, isOn) {
	if(isOn) {
		if(!hasClass(obj, "mui-active")) {
			addClass(obj, "mui-active");
		}
	} else {
		if(hasClass(obj, "mui-active")) {
			removeClass(obj, "mui-active");
		}
	}
}

/**
 * 返回switch的值     0：关闭 ，1：打开
 * @param {Object} obj swicth对象
 */
function getSwitchValue(obj) {
	return obj.classList.contains("mui-active") ? g_SWITCH_ON : g_SWITCH_OFF;
}

function hasClass(obj, cls) {
	return obj.className.match(new RegExp('(\\s|^)' + cls + '(\\s|$)'));
}

function addClass(obj, cls) {
	if(!this.hasClass(obj, cls)) obj.className += " " + cls;
}

function removeClass(obj, cls) {
	if(hasClass(obj, cls)) {
		var reg = new RegExp('(\\s|^)' + cls + '(\\s|$)');
		obj.className = obj.className.replace(reg, ' ');
	}
}