//mui初始化
mui.init();
var rights = document.getElementById("rights");
var dataSrc = document.getElementById("dataSrc");
var modiftyPassword = document.getElementById("modiftyPassword");
var about = document.getElementById("about");
var logOut = document.getElementById("logOut");

var haveBindId = document.getElementById("haveBindId");
var toBindId = document.getElementById("toBindId");
var goBindBtn = document.getElementById("goBindBtn");

var NO_BIND_WEIXIN=0; //手机号未绑定过微信
var BINDED_WEIXIN=1;  //手机号已绑定过微信

var userInfo;
 
mui.plusReady(function() {
    var self = plus.webview.currentWebview();
   userInfo = self.userInfo;
    rights.addEventListener('tap', function() {
        g_mui.openPage(g_module.setting, 'privacyRights.html');
    });
    modiftyPassword.addEventListener('tap', function() {
        g_mui.openPage(g_module.setting, 'modifyPassword1.html');
    });
    about.addEventListener('tap', function() {
        g_mui.openPage(g_module.setting, 'about.html');
    });
    logOut.addEventListener('tap', function() {
        logout();
    });
    refreshLay(userInfo);
    getWeiXinService();
    checkPhoneBindWeiXin(userInfo);
});

//检查手机号是否已被微信绑定
function checkPhoneBindWeiXin(userInfo){
	var sParameters = {};
	addParameter('phone', userInfo.userName, sParameters);
	g_tools.postURL("checkPhoneBindWeiXin", sParameters, function(result) {
		Debugger.log("checkPhoneBindWeiXin->:"+JSON.stringify(result));
		if(result.code == 0) {
			var _isBindWeiXin=result.data.isBindWeiXin;
			if(_isBindWeiXin==NO_BIND_WEIXIN){
				haveBindId.classList.add('mui-hidden');
				toBindId.classList.remove('mui-hidden');
				goBindBtn.addEventListener('tap', function() {
				    authWeiXinLogin();
				},false);
			}else if(_isBindWeiXin==BINDED_WEIXIN){
				haveBindId.classList.remove('mui-hidden');
				toBindId.classList.add('mui-hidden');
			}
		} else {
			g_mui.toast(result.tip);
		}
	});
}

function getWeiXinService(){
	plus.oauth.getServices(function(services){
		auths = services;
		for(var i = 0; i < auths.length; i++) {
            if(auths[i].id == 'weixin') {
                aweixin = auths[i];
                break;
            }
       }
	}, function(e){
		g_mui.toast("获取登录授权服务列表失败："+JSON.stringify(e));
	} );
}

// 微信登录操作
function authWeiXinLogin() {
	var waiting = plus.nativeUI.showWaiting();
    if (!aweixin.authResult) {
        aweixin.login(function(e) {
        	waiting.close();
            g_mui.toast("登录认证成功！");
            authWeiXinUserInfo();
        }, function(e) {
        	waiting.close();
            if(e.code!==-2){//用户取消时不提示
        		g_mui.toast("登录认证失败！" + e.message);
        	}     
        });
    } else {
        g_mui.toast("已经登录认证！");
    }
}
//微信注销
function authWeiXinLogout() {
    if (aweixin.authResult) {
        aweixin.logout(function(e) {
            Debugger.log("微信注销登录认证成功！");
        }, function(e) {
            Debugger.log("微信注销登录认证失败！");
        });
    }
    
}
// 微信登录认证信息
function authWeiXinUserInfo() {
    if (!aweixin.authResult) {
        g_mui.toast("未授权登录！");
    } else {
        aweixin.getUserInfo(function(e) {
            var weiXinUserInfo=aweixin.userInfo;
			checkWeiXinBindPhone(weiXinUserInfo);
            authWeiXinLogout();
        }, function(e) {
            g_mui.toast("获取用户信息失败：" + e.message + " - " + e.code);
        });
    }
}

var WEIXIN_HAVED_BIND_PHONE=1;	//第三方登录已绑定过手机号
var WEIXIN_NO_BIND_PHONE=0;		//第三方登录未绑定过手机号

//验证微信第三方登录是否绑定过手机号
function checkWeiXinBindPhone(weiXinUserInfo){
	var sParameters = {};
	addParameter('unionId', weiXinUserInfo.unionid, sParameters);
	g_tools.postURL("checkWeiXinBindPhone", sParameters, function(result) {
		Debugger.log("checkWeiXinBindPhone->:"+JSON.stringify(result));
		if(result.code == 0) { //验证成功
			var _isBindPhone=result.data.isBindPhone;
			var _userName=result.data.userName;
			if(_isBindPhone==WEIXIN_HAVED_BIND_PHONE){
				g_mui.alert("该微信账号已绑定过其它手机号，请登录未被绑定微信账号进行绑定！")
			}else if(_isBindPhone==WEIXIN_NO_BIND_PHONE){
				var _authInfo={};
				_authInfo["unionId"]=weiXinUserInfo.unionid;	
				_authInfo["weixinHeadImg"]=weiXinUserInfo.headimgurl;
				_authInfo["nickname"]=weiXinUserInfo.nickname;
				weiXinBindOldUser(_authInfo);
			}	
		} else {
			g_mui.toast(result.tip);
		}
	});
}

function weiXinBindOldUser(_authInfo){
	var sParameters = {};
	var _userId = g_tools.getUserId();
	addParameter('userId', _userId, sParameters);
	addParameter('authInfo', JSON.stringify(_authInfo), sParameters);
	Debugger.log("sParameters->:"+JSON.stringify(sParameters));
	g_tools.postURL("weiXinBindOldUser", sParameters, function(result) {
		Debugger.log("weiXinBindOldUser->:"+JSON.stringify(result));
		if(result.code == 0) { //绑定成功
			checkPhoneBindWeiXin(userInfo);
			g_mui.toast("微信绑定成功！");
		} else {
			g_mui.toast(result.tip);
		}
	});
}
 
/*
 * 获取用户信息
 */
function getUserInfoById() {
    var parameters = {};
    var userId = g_tools.getUserId(); //TO-DO 这里后面应该换成按id来获取
    addParameter('userId', userId, parameters);
    g_tools.postCMD("getUserInfoByUserId", parameters, function(result) {
        if(result.code == 0) {
            var userInfo = result.data;
            refreshLay(userInfo);
        }
    }, g_tools.MODE_WEB_LOCAL_CACHE);
}
 
function refreshLay(userInfo) {
    if(!g_utils.isEmpty(userInfo)) {
        if(!g_utils.isEmpty(userInfo.isAddMyCard)) {
            if(userInfo.isAddMyCard == 1) {
                dataSrc.classList.remove('mui-hidden');
 
            } else if(userInfo.isBinded == 1) {
                dataSrc.classList.remove('mui-hidden');
            }
            dataSrc.addEventListener('tap', function() {
                g_mui.openPage(g_module.setting, 'dataSrc.html');
            });
        }
    }
}
 
function logout() {
    var btnArray = ['取消', '确定'];
    g_mui.confirm('您确定退出此账号？', '温馨提示', btnArray, function(e) {
        if(e.index == 1) {
            g_tools.logout();
        } else {}
    });
}
 

/*
 * 插入请求参数
 */
function addParameter(key, value, parameters) {
    parameters[key] = value;
}